////////////////////////////////////////////////////
// Windows types & definitons for lite-C
////////////////////////////////////////////////////
#ifndef windows_h
#define windows_h
#define WINAPI __stdcall
#define CALLBACK __stdcall

#define PRAGMA_WARN OFF 
////////////////////////////////////////////////////
//Window Const
////////////////////////////////////////////////////
#define COLOR_SCROLLBAR         0
#define COLOR_BACKGROUND        1
#define COLOR_ACTIVECAPTION     2
#define COLOR_INACTIVECAPTION   3
#define COLOR_MENU              4
#define COLOR_WINDOW            5
#define COLOR_WINDOWFRAME       6
#define COLOR_MENUTEXT          7
#define COLOR_WINDOWTEXT        8
#define COLOR_CAPTIONTEXT       9
#define COLOR_ACTIVEBORDER      10
#define COLOR_INACTIVEBORDER    11
#define COLOR_APPWORKSPACE      12
#define COLOR_HIGHLIGHT         13
#define COLOR_HIGHLIGHTTEXT     14
#define COLOR_BTNFACE           15
#define COLOR_BTNSHADOW         16
#define COLOR_GRAYTEXT          17
#define COLOR_BTNTEXT           18
#define COLOR_INACTIVECAPTIONTEXT 19
#define COLOR_BTNHIGHLIGHT      20
#define COLOR_3DDKSHADOW        21
#define COLOR_3DLIGHT           22
#define COLOR_INFOTEXT          23
#define COLOR_INFOBK            24
#define COLOR_HOTLIGHT                  26
#define COLOR_GRADIENTACTIVECAPTION     27
#define COLOR_GRADIENTINACTIVECAPTION   28
#define COLOR_DESKTOP           COLOR_BACKGROUND
#define COLOR_3DFACE            COLOR_BTNFACE
#define COLOR_3DSHADOW          COLOR_BTNSHADOW
#define COLOR_3DHIGHLIGHT       COLOR_BTNHIGHLIGHT
#define COLOR_3DHILIGHT         COLOR_BTNHIGHLIGHT
#define COLOR_BTNHILIGHT        COLOR_BTNHIGHLIGHT
#define ANYSIZE_ARRAY 1
#define DELETE 0x10000
#define READ_CONTROL 0x20000
#define WRITE_DAC 0x40000
#define WRITE_OWNER 0x80000
#define SYNCHRONIZE 0x100000
#define STANDARD_RIGHTS_READ (READ_CONTROL)
#define STANDARD_RIGHTS_WRITE (READ_CONTROL)
#define STANDARD_RIGHTS_EXECUTE (READ_CONTROL)
#define STANDARD_RIGHTS_REQUIRED 0xF0000
#define STANDARD_RIGHTS_ALL 0x1F0000
#define SPECIFIC_RIGHTS_ALL 0xFFFF
#define SID_REVISION (1)
#define SID_MAX_SUB_AUTHORITIES (15)
#define SID_RECOMMENDED_SUB_AUTHORITIES (1)
#define SidTypeUser 1
#define SidTypeGroup 2
#define SidTypeDomain 3
#define SidTypeAlias 4
#define SidTypeWellKnownGroup 5
#define SidTypeDeletedAccount 6
#define SidTypeInvalid 7
#define SidTypeUnknown 8
#define SECURITY_NULL_RID 0x0
#define SECURITY_WORLD_RID 0x0
#define SECURITY_LOCAL_RID 0x0
#define SECURITY_CREATOR_OWNER_RID 0x0
#define SECURITY_CREATOR_GROUP_RID 0x1
#define SECURITY_DIALUP_RID 0x1
#define SECURITY_NETWORK_RID 0x2
#define SECURITY_BATCH_RID 0x3
#define SECURITY_INTERACTIVE_RID 0x4
#define SECURITY_SERVICE_RID 0x6
#define SECURITY_ANONYMOUS_LOGON_RID 0x7
#define SECURITY_LOGON_IDS_RID 0x5
#define SECURITY_LOCAL_SYSTEM_RID 0x12
#define SECURITY_NT_NON_UNIQUE 0x15
#define SECURITY_BUILTIN_DOMAIN_RID 0x20
#define DOMAIN_USER_RID_ADMIN 0x1F4
#define DOMAIN_USER_RID_GUEST 0x1F5
#define DOMAIN_GROUP_RID_ADMINS 0x200
#define DOMAIN_GROUP_RID_USERS 0x201
#define DOMAIN_GROUP_RID_GUESTS 0x202
#define DOMAIN_ALIAS_RID_ADMINS 0x220
#define DOMAIN_ALIAS_RID_USERS 0x221
#define DOMAIN_ALIAS_RID_GUESTS 0x222
#define DOMAIN_ALIAS_RID_POWER_USERS 0x223
#define DOMAIN_ALIAS_RID_ACCOUNT_OPS 0x224
#define DOMAIN_ALIAS_RID_SYSTEM_OPS 0x225
#define DOMAIN_ALIAS_RID_PRINT_OPS 0x226
#define DOMAIN_ALIAS_RID_BACKUP_OPS 0x227
#define DOMAIN_ALIAS_RID_REPLICATOR 0x228
#define SE_GROUP_MANDATORY 0x1
#define SE_GROUP_ENABLED_BY_DEFAULT 0x2
#define SE_GROUP_ENABLED 0x4
#define SE_GROUP_OWNER 0x8
#define SE_GROUP_LOGON_ID 0xC0000000
#define FILE_BEGIN 0
#define FILE_CURRENT 1
#define FILE_END 2
#define FILE_FLAG_WRITE_THROUGH 0x80000000
#define FILE_FLAG_OVERLAPPED 0x40000000
#define FILE_FLAG_NO_BUFFERING 0x20000000
#define FILE_FLAG_RANDOM_ACCESS 0x10000000
#define FILE_FLAG_SEQUENTIAL_SCAN 0x8000000
#define FILE_FLAG_DELETE_ON_CLOSE 0x4000000
#define FILE_FLAG_BACKUP_SEMANTICS 0x2000000
#define FILE_FLAG_POSIX_SEMANTICS 0x1000000
#define CREATE_NEW 1
#define CREATE_ALWAYS 2
#define OPEN_EXISTING 3
#define OPEN_ALWAYS 4
#define TRUNCATE_EXISTING 5
#define PIPE_ACCESS_INBOUND 0x1
#define PIPE_ACCESS_OUTBOUND 0x2
#define PIPE_ACCESS_DUPLEX 0x3
#define PIPE_CLIENT_END 0x0
#define PIPE_SERVER_END 0x1
#define PIPE_WAIT 0x0
#define PIPE_NOWAIT 0x1
#define PIPE_READMODE_BYTE 0x0
#define PIPE_READMODE_MESSAGE 0x2
#define PIPE_TYPE_BYTE 0x0
#define PIPE_TYPE_MESSAGE 0x4
#define PIPE_UNLIMITED_INSTANCES 255
#define SECURITY_CONTEXT_TRACKING 0x40000
#define SECURITY_EFFECTIVE_ONLY 0x80000
#define SECURITY_SQOS_PRESENT 0x100000
#define SECURITY_VALID_SQOS_FLAGS 0x1F0000
#define SP_SERIALCOMM 0x1
#define PST_UNSPECIFIED 0x0
#define PST_RS232 0x1
#define PST_PARALLELPORT 0x2
#define PST_RS422 0x3
#define PST_RS423 0x4
#define PST_RS449 0x5
#define PST_FAX 0x21
#define PST_SCANNER 0x22
#define PST_NETWORK_BRIDGE 0x100
#define PST_LAT 0x101
#define PST_TCPIP_TELNET 0x102
#define PST_X25 0x103
#define PCF_DTRDSR 0x1
#define PCF_RTSCTS 0x2
#define PCF_RLSD 0x4
#define PCF_PARITY_CHECK 0x8
#define PCF_XONXOFF 0x10
#define PCF_SETXCHAR 0x20
#define PCF_TOTALTIMEOUTS 0x40
#define PCF_INTTIMEOUTS 0x80
#define PCF_SPECIALCHARS 0x100
#define PCF_16BITMODE 0x200
#define SP_PARITY 0x1
#define SP_BAUD 0x2
#define SP_DATABITS 0x4
#define SP_STOPBITS 0x8
#define SP_HANDSHAKING 0x10
#define SP_PARITY_CHECK 0x20
#define SP_RLSD 0x40
#define BAUD_075 0x1
#define BAUD_110 0x2
#define BAUD_134_5 0x4
#define BAUD_150 0x8
#define BAUD_300 0x10
#define BAUD_600 0x20
#define BAUD_1200 0x40
#define BAUD_1800 0x80
#define BAUD_2400 0x100
#define BAUD_4800 0x200
#define BAUD_7200 0x400
#define BAUD_9600 0x800
#define BAUD_14400 0x1000
#define BAUD_19200 0x2000
#define BAUD_38400 0x4000
#define BAUD_56K 0x8000
#define BAUD_128K 0x10000
#define BAUD_115200 0x20000
#define BAUD_57600 0x40000
#define BAUD_USER 0x10000000
#define DATABITS_5 0x1
#define DATABITS_6 0x2
#define DATABITS_7 0x4
#define DATABITS_8 0x8
#define DATABITS_16 0x10
#define DATABITS_16X 0x20
#define STOPBITS_10 0x1
#define STOPBITS_15 0x2
#define STOPBITS_20 0x4
#define PARITY_NONE 0x100
#define PARITY_ODD 0x200
#define PARITY_EVEN 0x400
#define PARITY_MARK 0x800
#define PARITY_SPACE 0x1000
#define DTR_CONTROL_DISABLE 0x0
#define DTR_CONTROL_ENABLE 0x1
#define DTR_CONTROL_HANDSHAKE 0x2
#define RTS_CONTROL_DISABLE 0x0
#define RTS_CONTROL_ENABLE 0x1
#define RTS_CONTROL_HANDSHAKE 0x2
#define RTS_CONTROL_TOGGLE 0x3
#define GMEM_FIXED 0x0
#define GMEM_MOVEABLE 0x2
#define GMEM_NOCOMPACT 0x10
#define GMEM_NODISCARD 0x20
#define GMEM_ZEROINIT 0x40
#define GMEM_MODIFY 0x80
#define GMEM_DISCARDABLE 0x100
#define GMEM_NOT_BANKED 0x1000
#define GMEM_SHARE 0x2000
#define GMEM_DDESHARE 0x2000
#define GMEM_NOTIFY 0x4000
#define GMEM_LOWER GMEM_NOT_BANKED
#define GMEM_VALID_FLAGS 0x7F72
#define GMEM_INVALID_HANDLE 0x8000
#define GHND (GMEM_MOVEABLE|GMEM_ZEROINIT)
#define GPTR (GMEM_FIXED|GMEM_ZEROINIT)
#define GMEM_DISCARDED 0x4000
#define GMEM_LOCKCOUNT 0xFF
#define LMEM_FIXED 0x0
#define LMEM_MOVEABLE 0x2
#define LMEM_NOCOMPACT 0x10
#define LMEM_NODISCARD 0x20
#define LMEM_ZEROINIT 0x40
#define LMEM_MODIFY 0x80
#define LMEM_DISCARDABLE 0xF00
#define LMEM_VALID_FLAGS 0xF72
#define LMEM_INVALID_HANDLE 0x8000
#define LHND (LMEM_MOVEABLE + LMEM_ZEROINIT)
#define LPTR (LMEM_FIXED + LMEM_ZEROINIT)
#define NONZEROLHND (LMEM_MOVEABLE)
#define NONZEROLPTR (LMEM_FIXED)
#define LMEM_DISCARDED 0x4000
#define LMEM_LOCKCOUNT 0xFF
#define DEBUG_PROCESS 0x1
#define DEBUG_ONLY_THIS_PROCESS 0x2
#define CREATE_SUSPENDED 0x4
#define DETACHED_PROCESS 0x8
#define CREATE_NEW_CONSOLE 0x10
#define NORMAL_PRIORITY_CLASS 0x20
#define IDLE_PRIORITY_CLASS 0x40
#define HIGH_PRIORITY_CLASS 0x80
#define REALTIME_PRIORITY_CLASS 0x100
#define CREATE_NEW_PROCESS_GROUP 0x200
#define CREATE_NO_WINDOW 0x8000000
#define PROFILE_USER 0x10000000
#define PROFILE_KERNEL 0x20000000
#define PROFILE_SERVER 0x40000000
#define MAXLONG 0x7FFFFFFF
#define THREAD_BASE_PRIORITY_MIN -2
#define THREAD_BASE_PRIORITY_MAX 2
#define THREAD_BASE_PRIORITY_LOWRT 15
#define THREAD_BASE_PRIORITY_IDLE -15
#define THREAD_PRIORITY_LOWEST THREAD_BASE_PRIORITY_MIN
#define THREAD_PRIORITY_BELOW_NORMAL (THREAD_PRIORITY_LOWEST + 1)
#define THREAD_PRIORITY_NORMAL 0
#define THREAD_PRIORITY_HIGHEST THREAD_BASE_PRIORITY_MAX
#define THREAD_PRIORITY_ABOVE_NORMAL (THREAD_PRIORITY_HIGHEST - 1)
#define THREAD_PRIORITY_ERROR_RETURN (MAXLONG)
#define THREAD_PRIORITY_TIME_CRITICAL THREAD_BASE_PRIORITY_LOWRT
#define THREAD_PRIORITY_IDLE THREAD_BASE_PRIORITY_IDLE
#define APPLICATION_ERROR_MASK 0x20000000
#define ERROR_SEVERITY_SUCCESS 0x0
#define ERROR_SEVERITY_INFORMATIONAL 0x40000000
#define ERROR_SEVERITY_WARNING 0x80000000
#define ERROR_SEVERITY_ERROR 0xC0000000
#define MINCHAR 0x80
#define MAXCHAR 0x7F
#define MINSHORT 0x8000
#define MAXSHORT 0x7FFF
#define MINLONG 0x80000000
#define MAXByte 0xFF
#define MAXWORD 0xFFFF
#define MAXDWORD 0xFFFF
#define LANG_NEUTRAL 0x0
#define LANG_BULGARIAN 0x2
#define LANG_CHINESE 0x4
#define LANG_CROATIAN 0x1A
#define LANG_CZECH 0x5
#define LANG_DANISH 0x6
#define LANG_DUTCH 0x13
#define LANG_ENGLISH 0x9
#define LANG_FINNISH 0xB
#define LANG_FRENCH 0xC
#define LANG_GERMAN 0x7
#define LANG_GREEK 0x8
#define LANG_HUNGARIAN 0xE
#define LANG_ICELANDIC 0xF
#define LANG_ITALIAN 0x10
#define LANG_JAPANESE 0x11
#define LANG_KOREAN 0x12
#define LANG_NORWEGIAN 0x14
#define LANG_POLISH 0x15
#define LANG_PORTUGUESE 0x16
#define LANG_ROMANIAN 0x18
#define LANG_RUSSIAN 0x19
#define LANG_SLOVAK 0x1B
#define LANG_SLOVENIAN 0x24
#define LANG_SPANISH 0xA
#define LANG_SWEDISH 0x1D
#define LANG_TURKISH 0x1F
#define SUBLANG_NEUTRAL 0x0
#define SUBLANG_DEFAULT 0x1
#define SUBLANG_SYS_DEFAULT 0x2
#define SUBLANG_CHINESE_TRADITIONAL 0x1
#define SUBLANG_CHINESE_SIMPLIFIED 0x2
#define SUBLANG_CHINESE_HONGKONG 0x3
#define SUBLANG_CHINESE_SINGAPORE 0x4
#define SUBLANG_DUTCH 0x1
#define SUBLANG_DUTCH_BELGIAN 0x2
#define SUBLANG_ENGLISH_US 0x1
#define SUBLANG_ENGLISH_UK 0x2
#define SUBLANG_ENGLISH_AUS 0x3
#define SUBLANG_ENGLISH_CAN 0x4
#define SUBLANG_ENGLISH_NZ 0x5
#define SUBLANG_ENGLISH_EIRE 0x6
#define SUBLANG_FRENCH 0x1
#define SUBLANG_FRENCH_BELGIAN 0x2
#define SUBLANG_FRENCH_CANADIAN 0x3
#define SUBLANG_FRENCH_SWISS 0x4
#define SUBLANG_GERMAN 0x1
#define SUBLANG_GERMAN_SWISS 0x2
#define SUBLANG_GERMAN_AUSTRIAN 0x3
#define SUBLANG_ITALIAN 0x1
#define SUBLANG_ITALIAN_SWISS 0x2
#define SUBLANG_NORWEGIAN_BOKMAL 0x1
#define SUBLANG_NORWEGIAN_NYNORSK 0x2
#define SUBLANG_PORTUGUESE 0x2
#define SUBLANG_PORTUGUESE_BRAZILIAN 0x1
#define SUBLANG_SPANISH 0x1
#define SUBLANG_SPANISH_MEXICAN 0x2
#define SUBLANG_SPANISH_MODERN 0x3
#define SORT_DEFAULT 0x0
#define SORT_JAPANESE_XJIS 0x0
#define SORT_JAPANESE_UNICODE 0x1
#define SORT_CHINESE_BIG5 0x0
#define SORT_CHINESE_UNICODE 0x1
#define SORT_KOREAN_KSC 0x0
#define SORT_KOREAN_UNICODE 0x1
#define FILE_READ_DATA (0x1)
#define FILE_LIST_DIRECTORY (0x1)
#define FILE_WRITE_DATA (0x2)
#define FILE_ADD_FILE (0x2)
#define FILE_APPEND_DATA (0x4)
#define FILE_ADD_SUBDIRECTORY (0x4)
#define FILE_CREATE_PIPE_INSTANCE (0x4)
#define FILE_READ_EA (0x8)
#define FILE_READ_PROPERTIES FILE_READ_EA
#define FILE_WRITE_EA (0x10)
#define FILE_WRITE_PROPERTIES FILE_WRITE_EA
#define FILE_EXECUTE (0x20)
#define FILE_TRAVERSE (0x20)
#define FILE_DELETE_CHILD (0x40)
#define FILE_READ_ATTRIBUTES (0x80)
#define FILE_WRITE_ATTRIBUTES (0x100)
#define FILE_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x1FF)
#define FILE_GENERIC_READ (STANDARD_RIGHTS_READ|FILE_READ_DATA|FILE_READ_ATTRIBUTES|FILE_READ_EA|SYNCHRONIZE)
#define FILE_GENERIC_WRITE (STANDARD_RIGHTS_WRITE|FILE_WRITE_DATA|FILE_WRITE_ATTRIBUTES|FILE_WRITE_EA|FILE_APPEND_DATA|SYNCHRONIZE)
#define FILE_GENERIC_EXECUTE (STANDARD_RIGHTS_EXECUTE|FILE_READ_ATTRIBUTES|FILE_EXECUTE|SYNCHRONIZE)
#define FILE_SHARE_READ 0x1
#define FILE_SHARE_WRITE 0x2
#define FILE_ATTRIBUTE_READONLY 0x1
#define FILE_ATTRIBUTE_HIDDEN 0x2
#define FILE_ATTRIBUTE_SYSTEM 0x4
#define FILE_ATTRIBUTE_DIRECTORY 0x10
#define FILE_ATTRIBUTE_ARCHIVE 0x20
#define FILE_ATTRIBUTE_NORMAL 0x80
#define FILE_ATTRIBUTE_TEMPORARY 0x100
#define FILE_ATTRIBUTE_COMPRESSED 0x800
#define FILE_NOTIFY_CHANGE_FILE_NAME 0x1
#define FILE_NOTIFY_CHANGE_DIR_NAME 0x2
#define FILE_NOTIFY_CHANGE_ATTRIBUTES 0x4
#define FILE_NOTIFY_CHANGE_SIZE 0x8
#define FILE_NOTIFY_CHANGE_LAST_WRITE 0x10
#define FILE_NOTIFY_CHANGE_SECURITY 0x100
#define MAILSLOT_NO_MESSAGE (-1)
#define MAILSLOT_WAIT_FOREVER (-1)
#define FILE_CASE_SENSITIVE_SEARCH 0x1
#define FILE_CASE_PRESERVED_NAMES 0x2
#define FILE_UNICODE_ON_DISK 0x4
#define FILE_PERSISTENT_ACLS 0x8
#define FILE_FILE_COMPRESSION 0x10
#define FILE_VOLUME_IS_COMPRESSED 0x8000
#define IO_COMPLETION_MODIFY_STATE 0x2
#define IO_COMPLETION_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x3)
#define DUPLICATE_CLOSE_SOURCE 0x1
#define DUPLICATE_SAME_ACCESS 0x2
#define ACCESS_SYSTEM_SECURITY 0x1000000
#define MAXIMUM_ALLOWED 0x2000000
#define GENERIC_READ 0x80000000
#define GENERIC_WRITE 0x40000000
#define GENERIC_EXECUTE 0x20000000
#define GENERIC_ALL 0x10000000
#define ACL_REVISION (2)
#define ACL_REVISION1 (1)
#define ACL_REVISION2 (2)
#define ACCESS_ALLOWED_ACE_TYPE 0x0
#define ACCESS_DENIED_ACE_TYPE 0x1
#define SYSTEM_AUDIT_ACE_TYPE 0x2
#define SYSTEM_ALARM_ACE_TYPE 0x3
#define OBJECT_INHERIT_ACE 0x1
#define CONTAINER_INHERIT_ACE 0x2
#define NO_PROPAGATE_INHERIT_ACE 0x4
#define INHERIT_ONLY_ACE 0x8
#define VALID_INHERIT_FLAGS 0xF
#define SUCCESSFUL_ACCESS_ACE_FLAG 0x40
#define FAILED_ACCESS_ACE_FLAG 0x80
#define AclRevisionInformation 1
#define AclSizeInformation 2
#define SECURITY_DESCRIPTOR_REVISION (1)
#define SECURITY_DESCRIPTOR_REVISION1 (1)
#define SECURITY_DESCRIPTOR_MIN_LENGTH (20)
#define SE_OWNER_DEFAULTED 0x1
#define SE_GROUP_DEFAULTED 0x2
#define SE_DACL_PRESENT 0x4
#define SE_DACL_DEFAULTED 0x8
#define SE_SACL_PRESENT 0x10
#define SE_SACL_DEFAULTED 0x20
#define SE_SELF_RELATIVE 0x8000
#define SE_PRIVILEGE_ENABLED_BY_DEFAULT 0x1
#define SE_PRIVILEGE_ENABLED 0x2
#define SE_PRIVILEGE_USED_FOR_ACCESS 0x80000000
#define PRIVILEGE_SET_ALL_NECESSARY (1)
#define SE_CREATE_TOKEN_NAME "SeCreateTokenPrivilege"
#define SE_ASSIGNPRIMARYTOKEN_NAME "SeAssignPrimaryTokenPrivilege"
#define SE_LOCK_MEMORY_NAME "SeLockMemoryPrivilege"
#define SE_INCREASE_QUOTA_NAME "SeIncreaseQuotaPrivilege"
#define SE_UNSOLICITED_INPUT_NAME "SeUnsolicitedInputPrivilege"
#define SE_MACHINE_ACCOUNT_NAME "SeMachineAccountPrivilege"
#define SE_TCB_NAME "SeTcbPrivilege"
#define SE_SECURITY_NAME "SeSecurityPrivilege"
#define SE_TAKE_OWNERSHIP_NAME "SeTakeOwnershipPrivilege"
#define SE_LOAD_DRIVER_NAME "SeLoadDriverPrivilege"
#define SE_SYSTEM_PROFILE_NAME "SeSystemProfilePrivilege"
#define SE_SYSTEMTIME_NAME "SeSystemtimePrivilege"
#define SE_PROF_SINGLE_PROCESS_NAME "SeProfileSingleProcessPrivilege"
#define SE_INC_BASE_PRIORITY_NAME "SeIncreaseBasePriorityPrivilege"
#define SE_CREATE_PAGEFILE_NAME "SeCreatePagefilePrivilege"
#define SE_CREATE_PERMANENT_NAME "SeCreatePermanentPrivilege"
#define SE_BACKUP_NAME "SeBackupPrivilege"
#define SE_RESTORE_NAME "SeRestorePrivilege"
#define SE_SHUTDOWN_NAME "SeShutdownPrivilege"
#define SE_DEBUG_NAME "SeDebugPrivilege"
#define SE_AUDIT_NAME "SeAuditPrivilege"
#define SE_SYSTEM_ENVIRONMENT_NAME "SeSystemEnvironmentPrivilege"
#define SE_CHANGE_NOTIFY_NAME "SeChangeNotifyPrivilege"
#define SE_REMOTE_SHUTDOWN_NAME "SeRemoteShutdownPrivilege"
#define SecurityAnonymous 1
#define SecurityIdentification 2
#define REG_NONE 0
#define REG_SZ 1
#define REG_EXPAND_SZ 2
#define REG_BINARY 3
#define REG_DWORD 4
#define REG_DWORD_LITTLE_ENDIAN 4
#define REG_DWORD_BIG_ENDIAN 5
#define REG_LINK 6
#define REG_MULTI_SZ 7
#define REG_RESOURCE_LIST 8
#define REG_FULL_RESOURCE_DESCRIPTOR 9
#define REG_RESOURCE_REQUIREMENTS_LIST 10
#define REG_CREATED_NEW_KEY 0x1
#define REG_OPENED_EXISTING_KEY 0x2
#define REG_WHOLE_HIVE_VOLATILE 0x1
#define REG_REFRESH_HIVE 0x2
#define REG_NOTIFY_CHANGE_NAME 0x1
#define REG_NOTIFY_CHANGE_ATTRIBUTES 0x2
#define REG_NOTIFY_CHANGE_LAST_SET 0x4
#define REG_NOTIFY_CHANGE_SECURITY 0x8
#define REG_LEGAL_CHANGE_FILTER (REG_NOTIFY_CHANGE_NAME|REG_NOTIFY_CHANGE_ATTRIBUTES|REG_NOTIFY_CHANGE_LAST_SET|REG_NOTIFY_CHANGE_SECURITY)
#define REG_LEGAL_OPTION (REG_OPTION_RESERVED|REG_OPTION_NON_VOLATILE|REG_OPTION_VOLATILE|REG_OPTION_CREATE_LINK|REG_OPTION_BACKUP_RESTORE)
#define REG_OPTION_RESERVED 0
#define REG_OPTION_NON_VOLATILE 0
#define REG_OPTION_VOLATILE 1
#define REG_OPTION_CREATE_LINK 2
#define REG_OPTION_BACKUP_RESTORE 4
#define KEY_QUERY_VALUE 0x1
#define KEY_SET_VALUE 0x2
#define KEY_CREATE_SUB_KEY 0x4
#define KEY_ENUMERATE_SUB_KEYS 0x8
#define KEY_NOTIFY 0x10
#define KEY_CREATE_LINK 0x20
#define KEY_READ ((STANDARD_RIGHTS_READ|KEY_QUERY_VALUE|KEY_ENUMERATE_SUB_KEYS|KEY_NOTIFY)&(~SYNCHRONIZE))
#define KEY_WRITE ((STANDARD_RIGHTS_WRITE|KEY_SET_VALUE|KEY_CREATE_SUB_KEY)&(~SYNCHRONIZE))
#define KEY_ALL_ACCESS ((STANDARD_RIGHTS_ALL|KEY_QUERY_VALUE|KEY_SET_VALUE|KEY_CREATE_SUB_KEY|KEY_ENUMERATE_SUB_KEYS|KEY_NOTIFY|KEY_CREATE_LINK)&(~SYNCHRONIZE))
#define KEY_EXECUTE ((KEY_READ)&(~SYNCHRONIZE))
#define EXCEPTION_DEBUG_EVENT 1
#define CREATE_THREAD_DEBUG_EVENT 2
#define CREATE_PROCESS_DEBUG_EVENT 3
#define EXIT_THREAD_DEBUG_EVENT 4
#define EXIT_PROCESS_DEBUG_EVENT 5
#define LOAD_DLL_DEBUG_EVENT 6
#define UNLOAD_DLL_DEBUG_EVENT 7
#define OUTPUT_DEBUG_STRING_EVENT 8
#define RIP_EVENT 9
#define EXCEPTION_MAXIMUM_PARAMETERS 15
#define DRIVE_REMOVABLE 2
#define DRIVE_FIXED 3
#define DRIVE_REMOTE 4
#define DRIVE_CDROM 5
#define DRIVE_RAMDISK 6
#define FILE_TYPE_UNKNOWN 0x0
#define FILE_TYPE_DISK 0x1
#define FILE_TYPE_CHAR 0x2
#define FILE_TYPE_PIPE 0x3
#define FILE_TYPE_REMOTE 0x8000
#define STD_INPUT_HANDLE -10
#define STD_OUTPUT_HANDLE -11
#define STD_ERROR_HANDLE -12
#define NOPARITY 0
#define ODDPARITY 1
#define EVENPARITY 2
#define MARKPARITY 3
#define SPACEPARITY 4
#define ONESTOPBIT 0
#define ONE5STOPBITS 1
#define TWOSTOPBITS 2
#define IGNORE 0
#define INFINITE 0xFFFF
#define CBR_110 110
#define CBR_300 300
#define CBR_600 600
#define CBR_1200 1200
#define CBR_2400 2400
#define CBR_4800 4800
#define CBR_9600 9600
#define CBR_14400 14400
#define CBR_19200 19200
#define CBR_38400 38400
#define CBR_56000 56000
#define CBR_57600 57600
#define CBR_115200 115200
#define CBR_128000 128000
#define CBR_256000 256000
#define CE_RXOVER 0x1
#define CE_OVERRUN 0x2
#define CE_RXPARITY 0x4
#define CE_FRAME 0x8
#define CE_BREAK 0x10
#define CE_TXFULL 0x100
#define CE_PTO 0x200
#define CE_IOE 0x400
#define CE_DNS 0x800
#define CE_OOP 0x1000
#define CE_MODE 0x8000
#define IE_BADID (-1)
#define IE_OPEN (-2)
#define IE_NOPEN (-3)
#define IE_MEMORY (-4)
#define IE_DEFAULT (-5)
#define IE_HARDWARE (-10)
#define IE_BYTESIZE (-11)
#define IE_BAUDRATE (-12)
#define EV_RXCHAR 0x1
#define EV_RXFLAG 0x2
#define EV_TXEMPTY 0x4
#define EV_CTS 0x8
#define EV_DSR 0x10
#define EV_RLSD 0x20
#define EV_BREAK 0x40
#define EV_ERR 0x80
#define EV_RING 0x100
#define EV_PERR 0x200
#define EV_RX80FULL 0x400
#define EV_EVENT1 0x800
#define EV_EVENT2 0x1000
#define SETXOFF 1
#define SETXON 2
#define SETRTS 3
#define CLRRTS 4
#define SETDTR 5
#define CLRDTR 6
#define RESETDEV 7
#define SETBREAK 8
#define CLRBREAK 9
#define PURGE_TXABORT 0x1
#define PURGE_RXABORT 0x2
#define PURGE_TXCLEAR 0x4
#define PURGE_RXCLEAR 0x8
#define LPTx 0x80
#define MS_CTS_ON 0x10
#define MS_DSR_ON 0x20
#define MS_RING_ON 0x40
#define MS_RLSD_ON 0x80
#define S_QUEUEEMPTY 0
#define S_THRESHOLD 1
#define S_ALLTHRESHOLD 2
#define S_NORMAL 0
#define S_LEGATO 1
#define S_STACCATO 2
#define S_PERIOD512 0
#define S_PERIOD1024 1
#define S_PERIOD2048 2
#define S_PERIODVOICE 3
#define S_WHITE512 4
#define S_WHITE1024 5
#define S_WHITE2048 6
#define S_WHITEVOICE 7
#define S_SERDVNA (-1)
#define S_SEROFM (-2)
#define S_SERMACT (-3)
#define S_SERQFUL (-4)
#define S_SERBDNT (-5)
#define S_SERDLN (-6)
#define S_SERDCC (-7)
#define S_SERDTP (-8)
#define S_SERDVL (-9)
#define S_SERDMD (-10)
#define S_SERDSH (-11)
#define S_SERDPT (-12)
#define S_SERDFQ (-13)
#define S_SERDDR (-14)
#define S_SERDSR (-15)
#define S_SERDST (-16)
#define NMPWAIT_WAIT_FOREVER 0xFFFF
#define NMPWAIT_NOWAIT 0x1
#define NMPWAIT_USE_DEFAULT_WAIT 0x0
#define FS_CASE_IS_PRESERVED FILE_CASE_PRESERVED_NAMES
#define FS_CASE_SENSITIVE FILE_CASE_SENSITIVE_SEARCH
#define FS_UNICODE_STORED_ON_DISK FILE_UNICODE_ON_DISK
#define FS_PERSISTENT_ACLS FILE_PERSISTENT_ACLS
#define SECTION_QUERY 0x1
#define SECTION_MAP_WRITE 0x2
#define SECTION_MAP_READ 0x4
#define SECTION_MAP_EXECUTE 0x8
#define SECTION_EXTEND_SIZE 0x10
#define SECTION_ALL_ACCESS STANDARD_RIGHTS_REQUIRED|SECTION_QUERY|SECTION_MAP_WRITE|SECTION_MAP_READ|SECTION_MAP_EXECUTE|SECTION_EXTEND_SIZE
#define FILE_MAP_COPY SECTION_QUERY
#define FILE_MAP_WRITE SECTION_MAP_WRITE
#define FILE_MAP_READ SECTION_MAP_READ
#define FILE_MAP_ALL_ACCESS SECTION_ALL_ACCESS
#define OF_READ 0x0
#define OF_WRITE 0x1
#define OF_READWRITE 0x2
#define OF_SHARE_COMPAT 0x0
#define OF_SHARE_EXCLUSIVE 0x10
#define OF_SHARE_DENY_WRITE 0x20
#define OF_SHARE_DENY_READ 0x30
#define OF_SHARE_DENY_NONE 0x40
#define OF_PARSE 0x100
#define OF_DELETE 0x200
#define OF_VERIFY 0x400
#define OF_CANCEL 0x800
#define OF_CREATE 0x1000
#define OF_PROMPT 0x2000
#define OF_EXIST 0x4000
#define OF_REOPEN 0x8000
#define OFS_MAXPATHNAME 128
#define PROCESSOR_INTEL_386 386
#define PROCESSOR_INTEL_486 486
#define PROCESSOR_INTEL_PENTIUM 586
#define PROCESSOR_MIPS_R4000 4000
#define PROCESSOR_ALPHA_21064 21064
#define PROCESSOR_ARCHITECTURE_INTEL 0
#define PROCESSOR_ARCHITECTURE_MIPS 1
#define PROCESSOR_ARCHITECTURE_ALPHA 2
#define PROCESSOR_ARCHITECTURE_PPC 3
#define PROCESSOR_ARCHITECTURE_UNKNOWN hFFFF
#define DFC_CAPTION 1
#define DFC_MENU 2
#define DFC_SCROLL 3
#define DFC_BUTTON 4
#define DFCS_CAPTIONCLOSE 0x0
#define DFCS_CAPTIONMIN 0x1
#define DFCS_CAPTIONMAX 0x2
#define DFCS_CAPTIONRESTORE 0x3
#define DFCS_CAPTIONHELP 0x4
#define DFCS_MENUARROW 0x0
#define DFCS_MENUCHECK 0x1
#define DFCS_MENUBULLET 0x2
#define DFCS_MENUARROWRIGHT 0x4
#define DFCS_SCROLLUP 0x0
#define DFCS_SCROLLDOWN 0x1
#define DFCS_SCROLLLEFT 0x2
#define DFCS_SCROLLRIGHT 0x3
#define DFCS_SCROLLCOMBOBOX 0x5
#define DFCS_SCROLLSIZEGRIP 0x8
#define DFCS_SCROLLSIZEGRIPRIGHT 0x10
#define DFCS_BUTTONCHECK 0x0
#define DFCS_BUTTONRADIOIMAGE 0x1
#define DFCS_BUTTONRADIOMASK 0x2
#define DFCS_BUTTONRADIO 0x4
#define DFCS_BUTTON3STATE 0x8
#define DFCS_BUTTONPUSH 0x10
#define DFCS_INACTIVE 0x100
#define DFCS_PUSHED 0x200
#define DFCS_CHECKED 0x400
#define DFCS_ADJUSTRECT 0x2000
#define DFCS_FLAT 0x4000
#define DFCS_MONO 0x8000
#define DONT_RESOLVE_DLL_REFERENCES 0x1
#define TF_FORCEDRIVE 0x80
#define LOCKFILE_FAIL_IMMEDIATELY 0x1
#define LOCKFILE_EXCLUSIVE_LOCK 0x2
#define LNOTIFY_OUTOFMEM 0
#define LNOTIFY_MOVE 1
#define LNOTIFY_DISCARD 2
#define SLE_ERROR 0x1
#define SLE_MINORERROR 0x2
#define SLE_WARNING 0x3
#define SEM_FAILCRITICALERRORS 0x1
#define SEM_NOGPFAULTERRORBOX 0x2
#define SEM_NOOPENFILEERRORBOX 0x8000
#define RT_CURSOR 1
#define RT_BITMAP 2
#define RT_ICON 3
#define RT_MENU 4
#define RT_DIALOG 5
#define RT_STRING 6
#define RT_FONTDIR 7
#define RT_FONT 8
#define RT_ACCELERATOR 9
#define RT_RCDATA 10
#define DDD_RAW_TARGET_PATH 0x1
#define DDD_REMOVE_DEFINITION 0x2
#define DDD_EXACT_MATCH_ON_REMOVE 0x4
#define MAX_PATH 260
#define MOVEFILE_REPLACE_EXISTING 0x1
#define MOVEFILE_COPY_ALLOWED 0x2
#define MOVEFILE_DELAY_UNTIL_REBOOT 0x4
#define TokenUser 1
#define TokenGroups 2
#define TokenPrivileges 3
#define TokenOwner 4
#define TokenPrimaryGroup 5
#define TokenDefaultDacl 6
#define TokenSource 7
#define TokenType 8
#define TokenImpersonationLevel 9
#define TokenStatistics 10
#define GET_TAPE_MEDIA_INFORMATION 0
#define GET_TAPE_DRIVE_INFORMATION 1
#define SET_TAPE_MEDIA_INFORMATION 0
#define SET_TAPE_DRIVE_INFORMATION 1
#define FORMAT_MESSAGE_ALLOCATE_BUFFER 0x100
#define FORMAT_MESSAGE_IGNORE_INSERTS 0x200
#define FORMAT_MESSAGE_FROM_STRING 0x400
#define FORMAT_MESSAGE_FROM_HMODULE 0x800
#define FORMAT_MESSAGE_FROM_SYSTEM 0x1000
#define FORMAT_MESSAGE_ARGUMENT_ARRAY 0x2000
#define FORMAT_MESSAGE_MAX_WIDTH_MASK 0xFF
#define TLS_OUT_OF_INDEXES 0xFFFF
#define BACKUP_DATA 0x1
#define BACKUP_EA_DATA 0x2
#define BACKUP_SECURITY_DATA 0x3
#define BACKUP_ALTERNATE_DATA 0x4
#define BACKUP_LINK 0x5
#define STREAM_MODIFIED_WHEN_READ 0x1
#define STREAM_CONTAINS_SECURITY 0x2
#define STARTF_USESHOWWINDOW 0x1
#define STARTF_USESIZE 0x2
#define STARTF_USEPOSITION 0x4
#define STARTF_USECOUNTCHARS 0x8
#define STARTF_USEFILLATTRIBUTE 0x10
#define STARTF_RUNFULLSCREEN 0x20
#define STARTF_FORCEONFEEDBACK 0x40
#define STARTF_FORCEOFFFEEDBACK 0x80
#define STARTF_USESTDHANDLES 0x100
#define SHUTDOWN_NORETRY 0x1
#define TC_NORMAL 0
#define TC_HARDERR 1
#define TC_GP_TRAP 2
#define TC_SIGNAL 3
#define MAX_LEADBYTES 12
#define MB_PRECOMPOSED 0x1
#define MB_COMPOSITE 0x2
#define MB_USEGLYPHCHARS 0x4
#define WC_DEFAULTCHECK 0x100
#define WC_COMPOSITECHECK 0x200
#define WC_DISCARDNS 0x10
#define WC_SEPCHARS 0x20
#define WC_DEFAULTCHAR 0x40
#define CT_CTYPE1 0x1
#define CT_CTYPE2 0x2
#define CT_CTYPE3 0x4
#define C1_UPPER 0x1
#define C1_LOWER 0x2
#define C1_DIGIT 0x4
#define C1_SPACE 0x8
#define C1_PUNCT 0x10
#define C1_CNTRL 0x20
#define C1_BLANK 0x40
#define C1_XDIGIT 0x80
#define C1_ALPHA 0x100
#define C2_LEFTTORIGHT 0x1
#define C2_RIGHTTOLEFT 0x2
#define C2_EUROPENUMBER 0x3
#define C2_EUROPESEPARATOR 0x4
#define C2_EUROPETERMINATOR 0x5
#define C2_ARABICNUMBER 0x6
#define C2_COMMONSEPARATOR 0x7
#define C2_BLOCKSEPARATOR 0x8
#define C2_SEGMENTSEPARATOR 0x9
#define C2_WHITESPACE 0xA
#define C2_OTHERNEUTRAL 0xB
#define C2_NOTAPPLICABLE 0x0
#define C3_NONSPACING 0x1
#define C3_DIACRITIC 0x2
#define C3_VOWELMARK 0x4
#define C3_SYMBOL 0x8
#define C3_NOTAPPLICABLE 0x0
#define NORM_IGNORECASE 0x1
#define NORM_IGNORENONSPACE 0x2
#define NORM_IGNORESYMBOLS 0x4
#define MAP_FOLDCZONE 0x10
#define MAP_PRECOMPOSED 0x20
#define MAP_COMPOSITE 0x40
#define MAP_FOLDDIGITS 0x80
#define LCMAP_LOWERCASE 0x100
#define LCMAP_UPPERCASE 0x200
#define LCMAP_SORTKEY 0x400
#define LCMAP_BYTEREV 0x800
#define SORT_STRINGSORT 0x1000
#define CP_ACP 0
#define CP_OEMCP 1
#define CTRY_DEFAULT 0
#define CTRY_AUSTRALIA 61
#define CTRY_AUSTRIA 43
#define CTRY_BELGIUM 32
#define CTRY_BRAZIL 55
#define CTRY_CANADA 2
#define CTRY_DENMARK 45
#define CTRY_FINLAND 358
#define CTRY_FRANCE 33
#define CTRY_GERMANY 49
#define CTRY_ICELAND 354
#define CTRY_IRELAND 353
#define CTRY_ITALY 39
#define CTRY_JAPAN 81
#define CTRY_MEXICO 52
#define CTRY_NETHERLANDS 31
#define CTRY_NEW_ZEALAND 64
#define CTRY_NORWAY 47
#define CTRY_PORTUGAL 351
#define CTRY_PRCHINA 86
#define CTRY_SOUTH_KOREA 82
#define CTRY_SPAIN 34
#define CTRY_SWEDEN 46
#define CTRY_SWITZERLAND 41
#define CTRY_TAIWAN 886
#define CTRY_UNITED_KINGDOM 44
#define CTRY_UNITED_STATES 1
#define LOCALE_NOUSEROVERRIDE 0x80000000
#define LOCALE_ILANGUAGE 0x1
#define LOCALE_SLANGUAGE 0x2
#define LOCALE_SENGLANGUAGE 0x1001
#define LOCALE_SABBREVLANGNAME 0x3
#define LOCALE_SNATIVELANGNAME 0x4
#define LOCALE_ICOUNTRY 0x5
#define LOCALE_SCOUNTRY 0x6
#define LOCALE_SENGCOUNTRY 0x1002
#define LOCALE_SABBREVCTRYNAME 0x7
#define LOCALE_SNATIVECTRYNAME 0x8
#define LOCALE_IDEFAULTLANGUAGE 0x9
#define LOCALE_IDEFAULTCOUNTRY 0xA
#define LOCALE_IDEFAULTCODEPAGE 0xB
#define LOCALE_SLIST 0xC
#define LOCALE_IMEASURE 0xD
#define LOCALE_SDECIMAL 0xE
#define LOCALE_STHOUSAND 0xF
#define LOCALE_SGROUPING 0x10
#define LOCALE_IDIGITS 0x11
#define LOCALE_ILZERO 0x12
#define LOCALE_SNATIVEDIGITS 0x13
#define LOCALE_SCURRENCY 0x14
#define LOCALE_SINTLSYMBOL 0x15
#define LOCALE_SMONDECIMALSEP 0x16
#define LOCALE_SMONTHOUSANDSEP 0x17
#define LOCALE_SMONGROUPING 0x18
#define LOCALE_ICURRDIGITS 0x19
#define LOCALE_IINTLCURRDIGITS 0x1A
#define LOCALE_ICURRENCY 0x1B
#define LOCALE_INEGCURR 0x1C
#define LOCALE_SDATE 0x1D
#define LOCALE_STIME 0x1E
#define LOCALE_SSHORTDATE 0x1F
#define LOCALE_SLONGDATE 0x20
#define LOCALE_STIMEFORMAT 0x1003
#define LOCALE_IDATE 0x21
#define LOCALE_ILDATE 0x22
#define LOCALE_ITIME 0x23
#define LOCALE_ICENTURY 0x24
#define LOCALE_ITLZERO 0x25
#define LOCALE_IDAYLZERO 0x26
#define LOCALE_IMONLZERO 0x27
#define LOCALE_S1159 0x28
#define LOCALE_S2359 0x29
#define LOCALE_SDAYNAME1 0x2A
#define LOCALE_SDAYNAME2 0x2B
#define LOCALE_SDAYNAME3 0x2C
#define LOCALE_SDAYNAME4 0x2D
#define LOCALE_SDAYNAME5 0x2E
#define LOCALE_SDAYNAME6 0x2F
#define LOCALE_SDAYNAME7 0x30
#define LOCALE_SABBREVDAYNAME1 0x31
#define LOCALE_SABBREVDAYNAME2 0x32
#define LOCALE_SABBREVDAYNAME3 0x33
#define LOCALE_SABBREVDAYNAME4 0x34
#define LOCALE_SABBREVDAYNAME5 0x35
#define LOCALE_SABBREVDAYNAME6 0x36
#define LOCALE_SABBREVDAYNAME7 0x37
#define LOCALE_SMONTHNAME1 0x38
#define LOCALE_SMONTHNAME2 0x39
#define LOCALE_SMONTHNAME3 0x3A
#define LOCALE_SMONTHNAME4 0x3B
#define LOCALE_SMONTHNAME5 0x3C
#define LOCALE_SMONTHNAME6 0x3D
#define LOCALE_SMONTHNAME7 0x3E
#define LOCALE_SMONTHNAME8 0x3F
#define LOCALE_SMONTHNAME9 0x40
#define LOCALE_SMONTHNAME10 0x41
#define LOCALE_SMONTHNAME11 0x42
#define LOCALE_SMONTHNAME12 0x43
#define LOCALE_SABBREVMONTHNAME1 0x44
#define LOCALE_SABBREVMONTHNAME2 0x45
#define LOCALE_SABBREVMONTHNAME3 0x46
#define LOCALE_SABBREVMONTHNAME4 0x47
#define LOCALE_SABBREVMONTHNAME5 0x48
#define LOCALE_SABBREVMONTHNAME6 0x49
#define LOCALE_SABBREVMONTHNAME7 0x4A
#define LOCALE_SABBREVMONTHNAME8 0x4B
#define LOCALE_SABBREVMONTHNAME9 0x4C
#define LOCALE_SABBREVMONTHNAME10 0x4D
#define LOCALE_SABBREVMONTHNAME11 0x4E
#define LOCALE_SABBREVMONTHNAME12 0x4F
#define LOCALE_SABBREVMONTHNAME13 0x100F
#define LOCALE_SPOSITIVESIGN 0x50
#define LOCALE_SNEGATIVESIGN 0x51
#define LOCALE_IPOSSIGNPOSN 0x52
#define LOCALE_INEGSIGNPOSN 0x53
#define LOCALE_IPOSSYMPRECEDES 0x54
#define LOCALE_IPOSSEPBYSPACE 0x55
#define LOCALE_INEGSYMPRECEDES 0x56
#define LOCALE_INEGSEPBYSPACE 0x57
#define TIME_NOMINUTESORSECONDS 0x1
#define TIME_NOSECONDS 0x2
#define TIME_NOTIMEMARKER 0x4
#define TIME_FORCE24HOURFORMAT 0x8
#define DATE_SHORTDATE 0x1
#define DATE_LONGDATE 0x2
#define MAX_DEFAULTCHAR 2
#define CAL_ICALINTVALUE 0x1
#define CAL_SCALNAME 0x2
#define CAL_IYEAROFFSETRANGE 0x3
#define CAL_SERASTRING 0x4
#define CAL_SSHORTDATE 0x5
#define CAL_SLONGDATE 0x6
#define CAL_SDAYNAME1 0x7
#define CAL_SDAYNAME2 0x8
#define CAL_SDAYNAME3 0x9
#define CAL_SDAYNAME4 0xA
#define CAL_SDAYNAME5 0xB
#define CAL_SDAYNAME6 0xC
#define CAL_SDAYNAME7 0xD
#define CAL_SABBREVDAYNAME1 0xE
#define CAL_SABBREVDAYNAME2 0xF
#define CAL_SABBREVDAYNAME3 0x10
#define CAL_SABBREVDAYNAME4 0x11
#define CAL_SABBREVDAYNAME5 0x12
#define CAL_SABBREVDAYNAME6 0x13
#define CAL_SABBREVDAYNAME7 0x14
#define CAL_SMONTHNAME1 0x15
#define CAL_SMONTHNAME2 0x16
#define CAL_SMONTHNAME3 0x17
#define CAL_SMONTHNAME4 0x18
#define CAL_SMONTHNAME5 0x19
#define CAL_SMONTHNAME6 0x1A
#define CAL_SMONTHNAME7 0x1B
#define CAL_SMONTHNAME8 0x1C
#define CAL_SMONTHNAME9 0x1D
#define CAL_SMONTHNAME10 0x1E
#define CAL_SMONTHNAME11 0x1F
#define CAL_SMONTHNAME12 0x20
#define CAL_SMONTHNAME13 0x21
#define CAL_SABBREVMONTHNAME1 0x22
#define CAL_SABBREVMONTHNAME2 0x23
#define CAL_SABBREVMONTHNAME3 0x24
#define CAL_SABBREVMONTHNAME4 0x25
#define CAL_SABBREVMONTHNAME5 0x26
#define CAL_SABBREVMONTHNAME6 0x27
#define CAL_SABBREVMONTHNAME7 0x28
#define CAL_SABBREVMONTHNAME8 0x29
#define CAL_SABBREVMONTHNAME9 0x2A
#define CAL_SABBREVMONTHNAME10 0x2B
#define CAL_SABBREVMONTHNAME11 0x2C
#define CAL_SABBREVMONTHNAME12 0x2D
#define CAL_SABBREVMONTHNAME13 0x2E
#define ENUM_ALL_CALENDARS 0xFFFF
#define CAL_GREGORIAN 1
#define CAL_GREGORIAN_US 2
#define CAL_JAPAN 3
#define CAL_TAIWAN 4
#define CAL_KOREA 5
#define RIGHT_ALT_PRESSED 0x1
#define LEFT_ALT_PRESSED 0x2
#define RIGHT_CTRL_PRESSED 0x4
#define LEFT_CTRL_PRESSED 0x8
#define SHIFT_PRESSED 0x10
#define NUMLOCK_ON 0x20
#define SCROLLLOCK_ON 0x40
#define CAPSLOCK_ON 0x80
#define ENHANCED_KEY 0x100
#define FROM_LEFT_1ST_BUTTON_PRESSED 0x1
#define RIGHTMOST_BUTTON_PRESSED 0x2
#define FROM_LEFT_2ND_BUTTON_PRESSED 0x4
#define FROM_LEFT_3RD_BUTTON_PRESSED 0x8
#define FROM_LEFT_4TH_BUTTON_PRESSED 0x10
#define MOUSE_MOVED 0x1
#define DOUBLE_CLICK 0x2
#define KEY_EVENT 0x1
#define mouse_eventC 0x2
#define WINDOW_BUFFER_SIZE_EVENT 0x4
#define MENU_EVENT 0x8
#define FOCUS_EVENT 0x10
#define FOREGROUND_BLUE 0x1
#define FOREGROUND_GREEN 0x2
#define FOREGROUND_RED 0x4
#define FOREGROUND_INTENSITY 0x8
#define BACKGROUND_BLUE 0x10
#define BACKGROUND_GREEN 0x20
#define BACKGROUND_RED 0x40
#define BACKGROUND_INTENSITY 0x80
#define CTRL_C_EVENT 0
#define CTRL_BREAK_EVENT 1
#define CTRL_CLOSE_EVENT 2
#define CTRL_LOGOFF_EVENT 5
#define CTRL_SHUTDOWN_EVENT 6
#define ENABLE_PROCESSED_INPUT 0x1
#define ENABLE_LINE_INPUT 0x2
#define ENABLE_ECHO_INPUT 0x4
#define ENABLE_WINDOW_INPUT 0x8
#define ENABLE_MOUSE_INPUT 0x10
#define ENABLE_PROCESSED_OUTPUT 0x1
#define ENABLE_WRAP_AT_EOL_OUTPUT 0x2
#define CONSOLE_TEXTMODE_BUFFER 1
#define R2_BLACK 1
#define R2_NOTMERGEPEN 2
#define R2_MASKNOTPEN 3
#define R2_NOTCOPYPEN 4
#define R2_MASKPENNOT 5
#define R2_NOT 6
#define R2_XORPEN 7
#define R2_NOTMASKPEN 8
#define R2_MASKPEN 9
#define R2_NOTXORPEN 10
#define R2_NOP 11
#define R2_MERGENOTPEN 12
#define R2_COPYPEN 13
#define R2_MERGEPENNOT 14
#define R2_MERGEPEN 15
#define R2_WHITE 16
#define R2_LAST 16
#define SRCCOPY 0xCC0020
#define SRCPAINT 0xEE0086
#define SRCAND 0x8800C6
#define SRCINVERT 0x660046
#define SRCERASE 0x440328
#define NOTSRCCOPY 0x330008
#define NOTSRCERASE 0x1100A6
#define MERGECOPY 0xC000CA
#define MERGEPAINT 0xBB0226
#define PATCOPY 0xF00021
#define PATPAINT 0xFB0A09
#define PATINVERT 0x5A0049
#define DSTINVERT 0x550009
#define BLACKNESS 0x42
#define WHITENESS 0xFF0062
#define GDI_ERROR 0xFFFF
#define HGDI_ERROR 0xFFFF
#define ERRORAPI 0
#define NULLREGION 1
#define SIMPLEREGION 2
#define COMPLEXREGION 3
#define RGN_AND 1
#define RGN_OR 2
#define RGN_XOR 3
#define RGN_DIFF 4
#define RGN_COPY 5
#define RGN_MIN RGN_AND
#define RGN_MAX RGN_COPY
#define BLACKONWHITE 1
#define WHITEONBLACK 2
#define COLORONCOLOR 3
#define HALFTONE 4
#define MAXSTRETCHBLTMODE 4
#define ALTERNATE 1
#define WINDING 2
#define POLYFILL_LAST 2
#define TA_NOUPDATECP 0
#define TA_UPDATECP 1
#define TA_LEFT 0
#define TA_RIGHT 2
#define TA_CENTER 6
#define TA_TOP 0
#define TA_BOTTOM 8
#define TA_BASELINE 24
#define TA_MASK (TA_BASELINE + TA_CENTER + TA_UPDATECP)
#define VTA_BASELINE TA_BASELINE
#define VTA_LEFT TA_BOTTOM
#define VTA_RIGHT TA_TOP
#define VTA_CENTER TA_CENTER
#define VTA_BOTTOM TA_RIGHT
#define VTA_TOP TA_LEFT
#define ETO_GRAYED 1
#define ETO_OPAQUE 2
#define ETO_CLIPPED 4
#define ASPECT_FILTERING 0x1
#define DCB_RESET 0x1
#define DCB_ACCUMULATE 0x2
#define DCB_DIRTY DCB_ACCUMULATE
#define DCB_SET (DCB_RESET|DCB_ACCUMULATE)
#define DCB_ENABLE 0x4
#define DCB_DISABLE 0x8
#define META_SETBKCOLOR 0x201
#define META_SETBKMODE 0x102
#define META_SETMAPMODE 0x103
#define META_SETROP2 0x104
#define META_SETRELABS 0x105
#define META_SETPOLYFILLMODE 0x106
#define META_SETSTRETCHBLTMODE 0x107
#define META_SETTEXTCHAREXTRA 0x108
#define META_SETTEXTCOLOR 0x209
#define META_SETTEXTJUSTIFICATION 0x20A
#define META_SETWINDOWORG 0x20B
#define META_SETWINDOWEXT 0x20C
#define META_SETVIEWPORTORG 0x20D
#define META_SETVIEWPORTEXT 0x20E
#define META_OFFSETWINDOWORG 0x20F
#define META_SCALEWINDOWEXT 0x410
#define META_OFFSETVIEWPORTORG 0x211
#define META_SCALEVIEWPORTEXT 0x412
#define META_LINETO 0x213
#define META_MOVETO 0x214
#define META_EXCLUDECLIPRECT 0x415
#define META_INTERSECTCLIPRECT 0x416
#define META_ARC 0x817
#define META_ELLIPSE 0x418
#define META_FLOODFILL 0x419
#define META_PIE 0x81A
#define META_RECTANGLE 0x41B
#define META_ROUNDRECT 0x61C
#define META_PATBLT 0x61D
#define META_SAVEDC 0x1E
#define META_SETPIXEL 0x41F
#define META_OFFSETCLIPRGN 0x220
#define META_TEXTOUT 0x521
#define META_BITBLT 0x922
#define META_STRETCHBLT 0xB23
#define META_POLYGON 0x324
#define META_POLYLINE 0x325
#define META_ESCAPE 0x626
#define META_RESTOREDC 0x127
#define META_FILLREGION 0x228
#define META_FRAMEREGION 0x429
#define META_INVERTREGION 0x12A
#define META_PAINTREGION 0x12B
#define META_SELECTCLIPREGION 0x12C
#define META_SELECTOBJECT 0x12D
#define META_SETTEXTALIGN 0x12E
#define META_CHORD 0x830
#define META_SETMAPPERFLAGS 0x231
#define META_EXTTEXTOUT 0xA32
#define META_SETDIBTODEV 0xD33
#define META_SELECTPALETTE 0x234
#define META_REALIZEPALETTE 0x35
#define META_ANIMATEPALETTE 0x436
#define META_SETPALENTRIES 0x37
#define META_POLYPOLYGON 0x538
#define META_RESIZEPALETTE 0x139
#define META_DIBBITBLT 0x940
#define META_DIBSTRETCHBLT 0xB41
#define META_DIBCREATEPATTERNBRUSH 0x142
#define META_STRETCHDIB 0xF43
#define META_EXTFLOODFILL 0x548
#define META_DELETEOBJECT 0x1F0
#define META_CREATEPALETTE 0xF7
#define META_CREATEPATTERNBRUSH 0x1F9
#define META_CREATEPENINDIRECT 0x2FA
#define META_CREATEFONTINDIRECT 0x2FB
#define META_CREATEBRUSHINDIRECT 0x2FC
#define META_CREATEREGION 0x6FF
#define NEWFRAME 1
#define AbortDocC 2
#define NEXTBAND 3
#define SETCOLORTABLE 4
#define GETCOLORTABLE 5
#define FLUSHOUTPUT 6
#define DRAFTMODE 7
#define QUERYESCSUPPORT 8
#define SETABORTPROC 9
#define StartDocC 10
#define EndDocC 11
#define GETPHYSPAGESIZE 12
#define GETPRINTINGOFFSET 13
#define GETSCALINGFACTOR 14
#define MFCOMMENT 15
#define GETPENWIDTH 16
#define SETCOPYCOUNT 17
#define SELECTPAPERSOURCE 18
#define DEVICEDATA 19
#define PASSTHROUGH 19
#define GETTECHNOLGY 20
#define GETTECHNOLOGY 20
#define SETLINECAP 21
#define SETLINEJOIN 22
#define SetMiterLimitC 23
#define BANDINFO 24
#define DRAWPATTERNRECT 25
#define GETVECTORPENSIZE 26
#define GETVECTORBRUSHSIZE 27
#define ENABLEDUPLEX 28
#define GETSETPAPERBINS 29
#define GETSETPRINTORIENT 30
#define ENUMPAPERBINS 31
#define SETDIBSCALING 32
#define EPSPRINTING 33
#define ENUMPAPERMETRICS 34
#define GETSETPAPERMETRICS 35
#define POSTSCRIPT_DATA 37
#define POSTSCRIPT_IGNORE 38
#define MOUSETRAILS 39
#define GETDEVICEUNITS 42
#define GETEXTENDEDTEXTMETRICS 256
#define GETEXTENTTABLE 257
#define GETPAIRKERNTABLE 258
#define GETTRACKKERNTABLE 259
#define ExtTextOutC 512
#define GETFACENAME 513
#define DOWNLOADFACE 514
#define ENABLERELATIVEWIDTHS 768
#define ENABLEPAIRKERNING 769
#define SETKERNTRACK 770
#define SETALLJUSTVALUES 771
#define SETCHARSET 772
#define StretchBltC 2048
#define GETSETSCREENPARAMS 3072
#define BEGIN_PATH 4096
#define CLIP_TO_PATH 4097
#define END_PATH 4098
#define EXT_DEVICE_CAPS 4099
#define RESTORE_CTM 4100
#define SAVE_CTM 4101
#define SET_ARC_DIRECTION 4102
#define SET_BACKGROUND_COLOR 4103
#define SET_POLY_MODE 4104
#define SET_SCREEN_ANGLE 4105
#define SET_SPREAD 4106
#define TRANSFORM_CTM 4107
#define SET_CLIP_BOX 4108
#define SET_BOUNDS 4109
#define SET_MIRROR_MODE 4110
#define OPENCHANNEL 4110
#define DOWNLOADHEADER 4111
#define CLOSECHANNEL 4112
#define POSTSCRIPT_PASSTHROUGH 4115
#define ENCAPSULATED_POSTSCRIPT 4116
#define SP_NOTREPORTED 0x4000
#define SP_ERROR (-1)
#define SP_APPABORT (-2)
#define SP_USERABORT (-3)
#define SP_OUTOFDISK (-4)
#define SP_OUTOFMEMORY (-5)
#define PR_JOBSTATUS 0x0
#define OBJ_PEN 1
#define OBJ_BRUSH 2
#define OBJ_DC 3
#define OBJ_METADC 4
#define OBJ_PAL 5
#define OBJ_FONT 6
#define OBJ_BITMAP 7
#define OBJ_REGION 8
#define OBJ_METAFILE 9
#define OBJ_MEMDC 10
#define OBJ_EXTPEN 11
#define OBJ_ENHMETADC 12
#define OBJ_ENHMETAFILE 13
#define MWT_IDENTITY 1
#define MWT_LEFTMULTIPLY 2
#define MWT_RIGHTMULTIPLY 3
#define MWT_MIN MWT_IDENTITY
#define MWT_MAX MWT_RIGHTMULTIPLY
#define BI_RGB 0
#define BI_RLE8 1
#define BI_RLE4 2
#define BI_bitfields 3
#define NTM_REGULAR 0x40
#define NTM_BOLD 0x20
#define NTM_ITALIC 0x1
#define TMPF_FIXED_PITCH 0x1
#define TMPF_VECTOR 0x2
#define TMPF_DEVICE 0x8
#define TMPF_TRUETYPE 0x4
#define LF_FACESIZE 32
#define LF_FULLFACESIZE 64
#define OUT_DEFAULT_PRECIS 0
#define OUT_STRING_PRECIS 1
#define OUT_CHARACTER_PRECIS 2
#define OUT_STROKE_PRECIS 3
#define OUT_TT_PRECIS 4
#define OUT_DEVICE_PRECIS 5
#define OUT_RASTER_PRECIS 6
#define OUT_TT_ONLY_PRECIS 7
#define OUT_OUTLINE_PRECIS 8
#define CLIP_DEFAULT_PRECIS 0
#define CLIP_CHARACTER_PRECIS 1
#define CLIP_STROKE_PRECIS 2
#define CLIP_MASK 0xF
#define CLIP_LH_ANGLES 16
#define CLIP_TT_ALWAYS 32
#define CLIP_EMBEDDED 128
#define DEFAULT_QUALITY 0
#define DRAFT_QUALITY 1
#define PROOF_QUALITY 2
#define DEFAULT_PITCH 0
#define FIXED_PITCH 1
#define VARIABLE_PITCH 2
#define ANSI_CHARSET 0
#define DEFAULT_CHARSET 1
#define SYMBOL_CHARSET 2
#define SHIFTJIS_CHARSET 128
#define HANGEUL_CHARSET 129
#define CHINESEBIG5_CHARSET 136
#define OEM_CHARSET 255
#define FF_DONTCARE 0
#define FF_ROMAN 16
#define FF_SWISS 32
#define FF_MODERN 48
#define FF_SCRIPT 64
#define FF_DECORATIVE 80
#define FW_DONTCARE 0
#define FW_THIN 100
#define FW_EXTRALIGHT 200
#define FW_LIGHT 300
#define FW_NORMAL 400
#define FW_MEDIUM 500
#define FW_SEMIBOLD 600
#define FW_BOLD 700
#define FW_EXTRABOLD 800
#define FW_HEAVY 900
#define FW_ULTRALIGHT FW_EXTRALIGHT
#define FW_REGULAR FW_NORMAL
#define FW_DEMIBOLD FW_SEMIBOLD
#define FW_ULTRABOLD FW_EXTRABOLD
#define FW_BLACK FW_HEAVY
#define PANOSE_COUNT 10
#define PAN_FAMILYTYPE_INDEX 0
#define PAN_SERIFSTYLE_INDEX 1
#define PAN_WEIGHT_INDEX 2
#define PAN_PROPORTION_INDEX 3
#define PAN_CONTRAST_INDEX 4
#define PAN_STROKEVARIATION_INDEX 5
#define PAN_ARMSTYLE_INDEX 6
#define PAN_LETTERFORM_INDEX 7
#define PAN_MIDLINE_INDEX 8
#define PAN_XHEIGHT_INDEX 9
#define PAN_CULTURE_LATIN 0
#define PAN_ANY 0
#define PAN_NO_FIT 1
#define PAN_FAMILY_TEXT_DISPLAY 2
#define PAN_FAMILY_SCRIPT 3
#define PAN_FAMILY_DECORATIVE 4
#define PAN_FAMILY_PICTORIAL 5
#define PAN_SERIF_COVE 2
#define PAN_SERIF_OBTUSE_COVE 3
#define PAN_SERIF_SQUARE_COVE 4
#define PAN_SERIF_OBTUSE_SQUARE_COVE 5
#define PAN_SERIF_SQUARE 6
#define PAN_SERIF_THIN 7
#define PAN_SERIF_BONE 8
#define PAN_SERIF_EXAGGERATED 9
#define PAN_SERIF_TRIANGLE 10
#define PAN_SERIF_NORMAL_SANS 11
#define PAN_SERIF_OBTUSE_SANS 12
#define PAN_SERIF_PERP_SANS 13
#define PAN_SERIF_FLARED 14
#define PAN_SERIF_ROUNDED 15
#define PAN_WEIGHT_VERY_LIGHT 2
#define PAN_WEIGHT_LIGHT 3
#define PAN_WEIGHT_THIN 4
#define PAN_WEIGHT_BOOK 5
#define PAN_WEIGHT_MEDIUM 6
#define PAN_WEIGHT_DEMI 7
#define PAN_WEIGHT_BOLD 8
#define PAN_WEIGHT_HEAVY 9
#define PAN_WEIGHT_BLACK 10
#define PAN_WEIGHT_NORD 11
#define PAN_PROP_OLD_STYLE 2
#define PAN_PROP_MODERN 3
#define PAN_PROP_EVEN_WIDTH 4
#define PAN_PROP_EXPANDED 5
#define PAN_PROP_CONDENSED 6
#define PAN_PROP_VERY_EXPANDED 7
#define PAN_PROP_VERY_CONDENSED 8
#define PAN_PROP_MONOSPACED 9
#define PAN_CONTRAST_NONE 2
#define PAN_CONTRAST_VERY_LOW 3
#define PAN_CONTRAST_LOW 4
#define PAN_CONTRAST_MEDIUM_LOW 5
#define PAN_CONTRAST_MEDIUM 6
#define PAN_CONTRAST_MEDIUM_HIGH 7
#define PAN_CONTRAST_HIGH 8
#define PAN_CONTRAST_VERY_HIGH 9
#define PAN_STROKE_GRADUAL_DIAG 2
#define PAN_STROKE_GRADUAL_TRAN 3
#define PAN_STROKE_GRADUAL_VERT 4
#define PAN_STROKE_GRADUAL_HORZ 5
#define PAN_STROKE_RAPID_VERT 6
#define PAN_STROKE_RAPID_HORZ 7
#define PAN_STROKE_INSTANT_VERT 8
#define PAN_STRAIGHT_ARMS_HORZ 2
#define PAN_STRAIGHT_ARMS_WEDGE 3
#define PAN_STRAIGHT_ARMS_VERT 4
#define PAN_STRAIGHT_ARMS_SINGLE_SERIF 5
#define PAN_STRAIGHT_ARMS_DOUBLE_SERIF 6
#define PAN_BENT_ARMS_HORZ 7
#define PAN_BENT_ARMS_WEDGE 8
#define PAN_BENT_ARMS_VERT 9
#define PAN_BENT_ARMS_SINGLE_SERIF 10
#define PAN_BENT_ARMS_DOUBLE_SERIF 11
#define PAN_LETT_NORMAL_CONTACT 2
#define PAN_LETT_NORMAL_WEIGHTED 3
#define PAN_LETT_NORMAL_BOXED 4
#define PAN_LETT_NORMAL_FLATTENED 5
#define PAN_LETT_NORMAL_ROUNDED 6
#define PAN_LETT_NORMAL_OFF_CENTER 7
#define PAN_LETT_NORMAL_SQUARE 8
#define PAN_LETT_OBLIQUE_CONTACT 9
#define PAN_LETT_OBLIQUE_WEIGHTED 10
#define PAN_LETT_OBLIQUE_BOXED 11
#define PAN_LETT_OBLIQUE_FLATTENED 12
#define PAN_LETT_OBLIQUE_ROUNDED 13
#define PAN_LETT_OBLIQUE_OFF_CENTER 14
#define PAN_LETT_OBLIQUE_SQUARE 15
#define PAN_MIDLINE_STANDARD_TRIMMED 2
#define PAN_MIDLINE_STANDARD_POINTED 3
#define PAN_MIDLINE_STANDARD_SERIFED 4
#define PAN_MIDLINE_HIGH_TRIMMED 5
#define PAN_MIDLINE_HIGH_POINTED 6
#define PAN_MIDLINE_HIGH_SERIFED 7
#define PAN_MIDLINE_CONSTANT_TRIMMED 8
#define PAN_MIDLINE_CONSTANT_POINTED 9
#define PAN_MIDLINE_CONSTANT_SERIFED 10
#define PAN_MIDLINE_LOW_TRIMMED 11
#define PAN_MIDLINE_LOW_POINTED 12
#define PAN_MIDLINE_LOW_SERIFED 13
#define PAN_XHEIGHT_CONSTANT_SMALL 2
#define PAN_XHEIGHT_CONSTANT_STD 3
#define PAN_XHEIGHT_CONSTANT_LARGE 4
#define PAN_XHEIGHT_DUCKING_SMALL 5
#define PAN_XHEIGHT_DUCKING_STD 6
#define PAN_XHEIGHT_DUCKING_LARGE 7
#define ELF_VENDOR_SIZE 4
#define ELF_VERSION 0
#define ELF_CULTURE_LATIN 0
#define RASTER_FONTTYPE 0x1
#define DEVICE_FONTTYPE 0x2
#define TRUETYPE_FONTTYPE 0x4
#define PC_RESERVED 0x1
#define PC_EXPLICIT 0x2
#define PC_NOCOLLAPSE 0x4

//#define TRANSPARENT 1 - removed for avoiding confusion with acknex TRANSPARENT
//#define OPAQUE 2
#define GDI_TRANSPARENT 1
#define GDI_OPAQUE 2

#define BKMODE_LAST 2
#define GM_COMPATIBLE 1
#define GM_ADVANCED 2
#define GM_LAST 2
#define PT_CLOSEFIGURE 0x1
#define PT_LINETO 0x2
#define PT_BEZIERTO 0x4
#define PT_MOVETO 0x6
#define MM_TEXT 1
#define MM_LOMETRIC 2
#define MM_HIMETRIC 3
#define MM_LOENGLISH 4
#define MM_HIENGLISH 5
#define MM_TWIPS 6
#define MM_ISOTROPIC 7
#define MM_ANISOTROPIC 8
#define MM_MIN MM_TEXT
#define MM_MAX MM_ANISOTROPIC
#define MM_MAX_FIXEDSCALE MM_TWIPS
#define ABSOLUTE 1
#define RELATIVE 2
#define WHITE_BRUSH 0
#define LTGRAY_BRUSH 1
#define GRAY_BRUSH 2
#define DKGRAY_BRUSH 3
#define BLACK_BRUSH 4
#define NULL_BRUSH 5
#define HOLLOW_BRUSH NULL_BRUSH
#define WHITE_PEN 6
#define BLACK_PEN 7
#define NULL_PEN 8
#define OEM_FIXED_FONT 10
#define ANSI_FIXED_FONT 11
#define ANSI_VAR_FONT 12
#define SYSTEM_FONT 13
#define DEVICE_DEFAULT_FONT 14
#define DEFAULT_PALETTE 15
#define SYSTEM_FIXED_FONT 16
#define STOCK_LAST 16
#define CLR_INVALID 0xFFFF
#define BS_SOLID 0
#define BS_NULL 1
#define BS_HOLLOW BS_NULL
#define BS_HATCHED 2
#define BS_PATTERN 3
#define BS_INDEXED 4
#define BS_DIBPATTERN 5
#define BS_DIBPATTERNPT 6
#define BS_PATTERN8X8 7
#define BS_DIBPATTERN8X8 8
#define HS_HORIZONTAL 0
#define HS_VERTICAL 1
#define HS_FDIAGONAL 2
#define HS_BDIAGONAL 3
#define HS_CROSS 4
#define HS_DIAGCROSS 5
#define HS_FDIAGONAL1 6
#define HS_BDIAGONAL1 7
#define HS_SOLID 8
#define HS_DENSE1 9
#define HS_DENSE2 10
#define HS_DENSE3 11
#define HS_DENSE4 12
#define HS_DENSE5 13
#define HS_DENSE6 14
#define HS_DENSE7 15
#define HS_DENSE8 16
#define HS_NOSHADE 17
#define HS_HALFTONE 18
#define HS_SOLIDCLR 19
#define HS_DITHEREDCLR 20
#define HS_SOLIDTEXTCLR 21
#define HS_DITHEREDTEXTCLR 22
#define HS_SOLIDBKCLR 23
#define HS_DITHEREDBKCLR 24
#define HS_API_MAX 25
#define PS_SOLID 0
#define PS_DASH 1
#define PS_DOT 2
#define PS_DASHDOT 3
#define PS_DASHDOTDOT 4
#define PS_NULL 5
#define PS_INSIDEFRAME 6
#define PS_USERSTYLE 7
#define PS_ALTERNATE 8
#define PS_STYLE_MASK 0xF
#define PS_ENDCAP_ROUND 0x0
#define PS_ENDCAP_SQUARE 0x100
#define PS_ENDCAP_FLAT 0x200
#define PS_ENDCAP_MASK 0xF00
#define PS_JOIN_ROUND 0x0
#define PS_JOIN_BEVEL 0x1000
#define PS_JOIN_MITER 0x2000
#define PS_JOIN_MASK 0xF000
#define PS_COSMETIC 0x0
#define PS_GEOMETRIC 0x10000
#define PS_TYPE_MASK 0xF0000
#define AD_COUNTERCLOCKWISE 1
#define AD_CLOCKWISE 2
#define DRIVERVERSION 0
#define TECHNOLOGY 2
#define HORZSIZE 4
#define VERTSIZE 6
#define HORZRES 8
#define VERTRES 10
#define BITSPIXEL 12
#define PLANES 14
#define NUMBRUSHES 16
#define NUMPENS 18
#define NUMMARKERS 20
#define NUMFONTS 22
#define NUMCOLORS 24
#define PDEVICESIZE 26
#define CURVECAPS 28
#define LINECAPS 30
#define POLYGONALCAPS 32
#define TEXTCAPS 34
#define CLIPCAPS 36
#define RASTERCAPS 38
#define ASPECTX 40
#define ASPECTY 42
#define ASPECTXY 44
#define LOGPIXELSX 88
#define LOGPIXELSY 90
#define SIZEPALETTE 104
#define NUMRESERVED 106
#define COLORRES 108
#define PHYSICALWIDTH 110
#define PHYSICALHEIGHT 111
#define PHYSICALOFFSETX 112
#define PHYSICALOFFSETY 113
#define SCALINGFACTORX 114
#define SCALINGFACTORY 115
#define DT_PLOTTER 0
#define DT_RASDISPLAY 1
#define DT_RASPRINTER 2
#define DT_RASCAMERA 3
#define DT_CHARSTREAM 4
#define DT_METAFILE 5
#define DT_DISPFILE 6
#define CC_NONE 0
#define CC_CIRCLES 1
#define CC_PIE 2
#define CC_CHORD 4
#define CC_ELLIPSES 8
#define CC_WIDE 16
#define CC_STYLED 32
#define CC_WIDESTYLED 64
#define CC_INTERIORS 128
#define CC_ROUNDRECT 256
#define LC_NONE 0
#define LC_POLYLINE 2
#define LC_MARKER 4
#define LC_POLYMARKER 8
#define LC_WIDE 16
#define LC_STYLED 32
#define LC_WIDESTYLED 64
#define LC_INTERIORS 128
#define PC_NONE 0
#define PC_POLYGON 1
#define PC_RECTANGLE 2
#define PC_WINDPOLYGON 4
#define PC_TRAPEZOID 4
#define PC_SCANLINE 8
#define PC_WIDE 16
#define PC_STYLED 32
#define PC_WIDESTYLED 64
#define PC_INTERIORS 128
#define CP_NONE 0
#define CP_RECTANGLE 1
#define CP_REGION 2
#define TC_OP_CHARACTER 0x1
#define TC_OP_STROKE 0x2
#define TC_CP_STROKE 0x4
#define TC_CR_90 0x8
#define TC_CR_ANY 0x10
#define TC_SF_X_YINDEP 0x20
#define TC_SA_double 0x40
#define TC_SA_INTEGER 0x80
#define TC_SA_CONTIN 0x100
#define TC_EA_double 0x200
#define TC_IA_ABLE 0x400
#define TC_UA_ABLE 0x800
#define TC_SO_ABLE 0x1000
#define TC_RA_ABLE 0x2000
#define TC_VA_ABLE 0x4000
#define TC_RESERVED 0x8000
#define TC_SCROLLBLT 0x10000
#define RC_NONE 0
#define RC_BITBLT 1
#define RC_BANDING 2
#define RC_SCALING 4
#define RC_BITMAP64 8
#define RC_GDI20_OUTPUT 0x10
#define RC_GDI20_STATE 0x20
#define RC_SAVEBITMAP 0x40
#define RC_DI_BITMAP 0x80
#define RC_PALETTE 0x100
#define RC_DIBTODEV 0x200
#define RC_BIGFONT 0x400
#define RC_STRETCHBLT 0x800
#define RC_FLOODFILL 0x1000
#define RC_STRETCHDIB 0x2000
#define RC_OP_DX_OUTPUT 0x4000
#define RC_DEVBITS 0x8000
#define DIB_RGB_COLORS 0
#define DIB_PAL_COLORS 1
#define DIB_PAL_INDICES 2
#define DIB_PAL_PHYSINDICES 2
#define DIB_PAL_LOGINDICES 4
#define SYSPAL_ERROR 0
#define SYSPAL_STATIC 1
#define SYSPAL_NOSTATIC 2
#define CBM_CREATEDIB 0x2
#define CBM_INIT 0x4
#define FLOODFILLBORDER 0
#define FLOODFILLSURFACE 1
#define CCHDEVICENAME 32
#define CCHFORMNAME 32
#define DM_SPECVERSION 0x320
#define DM_ORIENTATION 0x1
#define DM_PAPERSIZE 0x2
#define DM_PAPERLENGTH 0x4
#define DM_PAPERWIDTH 0x8
#define DM_SCALE 0x10
#define DM_COPIES 0x100
#define DM_DEFAULTSOURCE 0x200
#define DM_PRINTQUALITY 0x400
#define DM_COLOR 0x800
#define DM_DUPLEX 0x1000
#define DM_YRESOLUTION 0x2000
#define DM_TTOPTION 0x4000
#define DM_COLLATE 0x8000
#define DM_FORMNAME 0x10000
#define DMORIENT_PORTRAIT 1
#define DMORIENT_LANDSCAPE 2
#define DMPAPER_LETTER 1
#define DMPAPER_FIRST DMPAPER_LETTER
#define DMPAPER_LETTERSMALL 2
#define DMPAPER_TABLOID 3
#define DMPAPER_LEDGER 4
#define DMPAPER_LEGAL 5
#define DMPAPER_STATEMENT 6
#define DMPAPER_EXECUTIVE 7
#define DMPAPER_A3 8
#define DMPAPER_A4 9
#define DMPAPER_A4SMALL 10
#define DMPAPER_A5 11
#define DMPAPER_B4 12
#define DMPAPER_B5 13
#define DMPAPER_FOLIO 14
#define DMPAPER_QUARTO 15
#define DMPAPER_10X14 16
#define DMPAPER_11X17 17
#define DMPAPER_NOTE 18
#define DMPAPER_ENV_9 19
#define DMPAPER_ENV_10 20
#define DMPAPER_ENV_11 21
#define DMPAPER_ENV_12 22
#define DMPAPER_ENV_14 23
#define DMPAPER_CSHEET 24
#define DMPAPER_DSHEET 25
#define DMPAPER_ESHEET 26
#define DMPAPER_ENV_DL 27
#define DMPAPER_ENV_C5 28
#define DMPAPER_ENV_C3 29
#define DMPAPER_ENV_C4 30
#define DMPAPER_ENV_C6 31
#define DMPAPER_ENV_C65 32
#define DMPAPER_ENV_B4 33
#define DMPAPER_ENV_B5 34
#define DMPAPER_ENV_B6 35
#define DMPAPER_ENV_ITALY 36
#define DMPAPER_ENV_MONARCH 37
#define DMPAPER_ENV_PERSONAL 38
#define DMPAPER_FANFOLD_US 39
#define DMPAPER_FANFOLD_STD_GERMAN 40
#define DMPAPER_FANFOLD_LGL_GERMAN 41
#define DMPAPER_LAST DMPAPER_FANFOLD_LGL_GERMAN
#define DMPAPER_USER 256
#define DMBIN_UPPER 1
#define DMBIN_FIRST DMBIN_UPPER
#define DMBIN_ONLYONE 1
#define DMBIN_LOWER 2
#define DMBIN_MIDDLE 3
#define DMBIN_MANUAL 4
#define DMBIN_ENVELOPE 5
#define DMBIN_ENVMANUAL 6
#define DMBIN_AUTO 7
#define DMBIN_TRACTOR 8
#define DMBIN_SMALLFMT 9
#define DMBIN_LARGEFMT 10
#define DMBIN_LARGECAPACITY 11
#define DMBIN_CASSETTE 14
#define DMBIN_LAST DMBIN_CASSETTE
#define DMBIN_USER 256
#define DMRES_DRAFT (-1)
#define DMRES_LOW (-2)
#define DMRES_MEDIUM (-3)
#define DMRES_HIGH (-4)
#define DMCOLOR_MONOCHROME 1
#define DMCOLOR_COLOR 2
#define DMDUP_SIMPLEX 1
#define DMDUP_VERTICAL 2
#define DMDUP_HORIZONTAL 3
#define DMTT_BITMAP 1
#define DMTT_DOWNLOAD 2
#define DMTT_SUBDEV 3
#define DMCOLLATE_FALSE 0
#define DMCOLLATE_TRUE 1
#define DM_GRAYSCALE 0x1
#define DM_INTERLACED 0x2
#define RDH_RECTANGLES 1
#define GGO_METRICS 0
#define GGO_BITMAP 1
#define GGO_NATIVE 2
#define TT_POLYGON_TYPE 24
#define TT_PRIM_LINE 1
#define TT_PRIM_QSPLINE 2
#define TT_AVAILABLE 0x1
#define TT_ENABLED 0x2
#define DM_UPDATE 1
#define DM_COPY 2
#define DM_PROMPT 4
#define DM_MODIFY 8
#define DM_IN_BUFFER DM_MODIFY
#define DM_IN_PROMPT DM_PROMPT
#define DM_OUT_BUFFER DM_COPY
#define DM_OUT_DEFAULT DM_UPDATE
#define DC_FIELDS 1
#define DC_PAPERS 2
#define DC_PAPERSIZE 3
#define DC_MINEXTENT 4
#define DC_MAXEXTENT 5
#define DC_BINS 6
#define DC_DUPLEX 7
#define DC_SIZE 8
#define DC_EXTRA 9
#define DC_VERSION 10
#define DC_DRIVER 11
#define DC_BINNAMES 12
#define DC_ENUMRESOLUTIONS 13
#define DC_FILEDEPENDENCIES 14
#define DC_TRUETYPE 15
#define DC_PAPERNAMES 16
#define DC_ORIENTATION 17
#define DC_COPIES 18
#define DCTT_BITMAP 0x1
#define DCTT_DOWNLOAD 0x2
#define DCTT_SUBDEV 0x4
#define CA_NEGATIVE 0x1
#define CA_LOG_FILTER 0x2
#define ILLUMINANT_DEVICE_DEFAULT 0
#define ILLUMINANT_A 1
#define ILLUMINANT_B 2
#define ILLUMINANT_C 3
#define ILLUMINANT_D50 4
#define ILLUMINANT_D55 5
#define ILLUMINANT_D65 6
#define ILLUMINANT_D75 7
#define ILLUMINANT_F2 8
#define ILLUMINANT_MAX_INDEX ILLUMINANT_F2
#define ILLUMINANT_TUNGSTEN ILLUMINANT_A
#define ILLUMINANT_DAYLIGHT ILLUMINANT_C
#define ILLUMINANT_FLUORESCENT ILLUMINANT_F2
#define ILLUMINANT_NTSC ILLUMINANT_C
#define RGB_GAMMA_MIN 2500
#define RGB_GAMMA_MAX 65000
#define REFERENCE_WHITE_MIN 6000
#define REFERENCE_WHITE_MAX 10000
#define REFERENCE_BLACK_MIN 0
#define REFERENCE_BLACK_MAX 4000
#define COLOR_ADJ_MIN -100
#define COLOR_ADJ_MAX 100
#define FONTMAPPER_MAX 10
#define ENHMETA_SIGNATURE 0x464D4520
#define ENHMETA_STOCK_OBJECT 0x80000000
#define EMR_HEADER 1
#define EMR_POLYBEZIER 2
#define EMR_POLYGON 3
#define EMR_POLYLINE 4
#define EMR_POLYBEZIERTO 5
#define EMR_POLYLINETO 6
#define EMR_POLYPOLYLINE 7
#define EMR_POLYPOLYGON 8
#define EMR_SETWINDOWEXTEX 9
#define EMR_SETWINDOWORGEX 10
#define EMR_SETVIEWPORTEXTEX 11
#define EMR_SETVIEWPORTORGEX 12
#define EMR_SETBRUSHORGEX 13
#define EMR_EOF 14
#define EMR_SETPIXELV 15
#define EMR_SETMAPPERFLAGS 16
#define EMR_SETMAPMODE 17
#define EMR_SETBKMODE 18
#define EMR_SETPOLYFILLMODE 19
#define EMR_SETROP2 20
#define EMR_SETSTRETCHBLTMODE 21
#define EMR_SETTEXTALIGN 22
#define EMR_SETCOLORADJUSTMENT 23
#define EMR_SETTEXTCOLOR 24
#define EMR_SETBKCOLOR 25
#define EMR_OFFSETCLIPRGN 26
#define EMR_MOVETOEX 27
#define EMR_SETMETARGN 28
#define EMR_EXCLUDECLIPRECT 29
#define EMR_INTERSECTCLIPRECT 30
#define EMR_SCALEVIEWPORTEXTEX 31
#define EMR_SCALEWINDOWEXTEX 32
#define EMR_SAVEDC 33
#define EMR_RESTOREDC 34
#define EMR_SETWORLDTRANSFORM 35
#define EMR_MODIFYWORLDTRANSFORM 36
#define EMR_SELECTOBJECT 37
#define EMR_CREATEPEN 38
#define EMR_CREATEBRUSHINDIRECT 39
#define EMR_DELETEOBJECT 40
#define EMR_ANGLEARC 41
#define EMR_ELLIPSE 42
#define EMR_RECTANGLE 43
#define EMR_ROUNDRECT 44
#define EMR_ARC 45
#define EMR_CHORD 46
#define EMR_PIE 47
#define EMR_SELECTPALETTE 48
#define EMR_CREATEPALETTE 49
#define EMR_SETPALETTEENTRIES 50
#define EMR_RESIZEPALETTE 51
#define EMR_REALIZEPALETTE 52
#define EMR_EXTFLOODFILL 53
#define EMR_LINETO 54
#define EMR_ARCTO 55
#define EMR_POLYDRAW 56
#define EMR_SETARCDIRECTION 57
#define EMR_SETMITERLIMIT 58
#define EMR_BEGINPATH 59
#define EMR_ENDPATH 60
#define EMR_CLOSEFIGURE 61
#define EMR_FILLPATH 62
#define EMR_STROKEANDFILLPATH 63
#define EMR_STROKEPATH 64
#define EMR_FLATTENPATH 65
#define EMR_WIDENPATH 66
#define EMR_SELECTCLIPPATH 67
#define EMR_ABORTPATH 68
#define EMR_GDICOMMENT 70
#define EMR_FILLRGN 71
#define EMR_FRAMERGN 72
#define EMR_INVERTRGN 73
#define EMR_PAINTRGN 74
#define EMR_EXTSELECTCLIPRGN 75
#define EMR_BITBLT 76
#define EMR_STRETCHBLT 77
#define EMR_MASKBLT 78
#define EMR_PLGBLT 79
#define EMR_SETDIBITSTODEVICE 80
#define EMR_STRETCHDIBITS 81
#define EMR_EXTCREATEFONTINDIRECTW 82
#define EMR_EXTTEXTOUTA 83
#define EMR_EXTTEXTOUTW 84
#define EMR_POLYBEZIER16 85
#define EMR_POLYGON16 86
#define EMR_POLYLINE16 87
#define EMR_POLYBEZIERTO16 88
#define EMR_POLYLINETO16 89
#define EMR_POLYPOLYLINE16 90
#define EMR_POLYPOLYGON16 91
#define EMR_POLYDRAW16 92
#define EMR_CREATEMONOBRUSH 93
#define EMR_CREATEDIBPATTERNBRUSHPT 94
#define EMR_EXTCREATEPEN 95
#define EMR_POLYTEXTOUTA 96
#define EMR_POLYTEXTOUTW 97
#define EMR_MIN 1
#define EMR_MAX 97
#define STRETCH_ANDSCANS 1
#define STRETCH_ORSCANS 2
#define STRETCH_DELETESCANS 3
#define STRETCH_HALFTONE 4
#define TCI_SRCCHARSET 1
#define TCI_SRCCODEPAGE 2
#define TCI_SRCFONTSIG 3
#define MONO_FONT 8
#define JOHAB_CHARSET 130
#define HEBREW_CHARSET 177
#define ARABIC_CHARSET 178
#define GREEK_CHARSET 161
#define TURKISH_CHARSET 162
#define THAI_CHARSET 222
#define EASTEUROPE_CHARSET 238
#define RUSSIAN_CHARSET 204
#define MAC_CHARSET 77
#define BALTIC_CHARSET 186
#define FS_LATIN1 0x1
#define FS_LATIN2 0x2
#define FS_CYRILLIC 0x4
#define FS_GREEK 0x8
#define FS_TURKISH 0x10
#define FS_HEBREW 0x20
#define FS_ARABIC 0x40
#define FS_BALTIC 0x80
#define FS_THAI 0x10000
#define FS_JISJAPAN 0x20000
#define FS_CHINESESIMP 0x40000
#define FS_WANSUNG 0x80000
#define FS_CHINESETRAD 0x100000
#define FS_JOHAB 0x200000
#define FS_SYMBOL 0x80000000
#define DEFAULT_GUI_FONT 17
#define DM_RESERVED1 0x800000
#define DM_RESERVED2 0x1000000
#define DM_ICMMETHOD 0x2000000
#define DM_ICMINTENT 0x4000000
#define DM_MEDIATYPE 0x8000000
#define DM_DITHERTYPE 0x10000000
#define DMPAPER_ISO_B4 42
#define DMPAPER_JAPANESE_POSTCARD 43
#define DMPAPER_9X11 44
#define DMPAPER_10X11 45
#define DMPAPER_15X11 46
#define DMPAPER_ENV_INVITE 47
#define DMPAPER_RESERVED_48 48
#define DMPAPER_RESERVED_49 49
#define DMPAPER_LETTER_EXTRA 50
#define DMPAPER_LEGAL_EXTRA 51
#define DMPAPER_TABLOID_EXTRA 52
#define DMPAPER_A4_EXTRA 53
#define DMPAPER_LETTER_TRANSVERSE 54
#define DMPAPER_A4_TRANSVERSE 55
#define DMPAPER_LETTER_EXTRA_TRANSVERSE 56
#define DMPAPER_A_PLUS 57
#define DMPAPER_B_PLUS 58
#define DMPAPER_LETTER_PLUS 59
#define DMPAPER_A4_PLUS 60
#define DMPAPER_A5_TRANSVERSE 61
#define DMPAPER_B5_TRANSVERSE 62
#define DMPAPER_A3_EXTRA 63
#define DMPAPER_A5_EXTRA 64
#define DMPAPER_B5_EXTRA 65
#define DMPAPER_A2 66
#define DMPAPER_A3_TRANSVERSE 67
#define DMPAPER_A3_EXTRA_TRANSVERSE 68
#define DMTT_DOWNLOAD_OUTLINE 4
#define DMICMMETHOD_NONE 1
#define DMICMMETHOD_SYSTEM 2
#define DMICMMETHOD_DRIVER 3
#define DMICMMETHOD_DEVICE 4
#define DMICMMETHOD_USER 256
#define DMICM_SATURATE 1
#define DMICM_CONTRAST 2
#define DMICM_COLORMETRIC 3
#define DMICM_USER 256
#define DMMEDIA_STANDARD 1
#define DMMEDIA_GLOSSY 2
#define DMMEDIA_TRANSPARENCY 3
#define DMMEDIA_USER 256
#define DMDITHER_NONE 1
#define DMDITHER_COARSE 2
#define DMDITHER_FINE 3
#define DMDITHER_LINEART 4
#define DMDITHER_GRAYSCALE 5
#define DMDITHER_USER 256
#define GGO_GRAY2_BITMAP 4
#define GGO_GRAY4_BITMAP 5
#define GGO_GRAY8_BITMAP 6
#define GGO_GLYPH_INDEX 0x80
#define GCP_DBCS 0x1
#define GCP_REORDER 0x2
#define GCP_USEKERNING 0x8
#define GCP_GLYPHSHAPE 0x10
#define GCP_LIGATE 0x20
#define GCP_DIACRITIC 0x100
#define GCP_KASHIDA 0x400
#define GCP_ERROR 0x8000
#define FLI_MASK 0x103B
#define GCP_JUSTIFY 0x10000
#define GCP_NODIACRITICS 0x20000
#define FLI_GLYPHS 0x40000
#define GCP_CLASSIN 0x80000
#define GCP_MAXEXTENT 0x100000
#define GCP_JUSTIFYIN 0x200000
#define GCP_DISPLAYZWG 0x400000
#define GCP_SYMSWAPOFF 0x800000
#define GCP_NUMERICOVERRIDE 0x1000000
#define GCP_NEUTRALOVERRIDE 0x2000000
#define GCP_NUMERICSLATIN 0x4000000
#define GCP_NUMERICSLOCAL 0x8000000
#define GCPCLASS_LATIN 1
#define GCPCLASS_HEBREW 2
#define GCPCLASS_ARABIC 2
#define GCPCLASS_NEUTRAL 3
#define GCPCLASS_LOCALNUMBER 4
#define GCPCLASS_LATINNUMBER 5
#define GCPCLASS_LATINNUMERICTERMINATOR 6
#define GCPCLASS_LATINNUMERICSEPARATOR 7
#define GCPCLASS_NUMERICSEPARATOR 8
#define GCPCLASS_PREBOUNDRTL 0x80
#define GCPCLASS_PREBOUNDLTR 0x40
#define DC_BINADJUST 19
#define DC_EMF_COMPLIANT 20
#define DC_DATATYPE_PRODUCED 21
#define DC_COLLATE 22
#define DCTT_DOWNLOAD_OUTLINE 0x8
#define DCBA_FACEUPNONE 0x0
#define DCBA_FACEUPCENTER 0x1
#define DCBA_FACEUPLEFT 0x2
#define DCBA_FACEUPRIGHT 0x3
#define DCBA_FACEDOWNNONE 0x100
#define DCBA_FACEDOWNCENTER 0x101
#define DCBA_FACEDOWNLEFT 0x102
#define DCBA_FACEDOWNRIGHT 0x103
#define ICM_OFF 1
#define ICM_ON 2
#define ICM_QUERY 3
#define EMR_SETICMMODE 98
#define EMR_CREATECOLORSPACE 99
#define EMR_SETCOLORSPACE 100
#define EMR_DELETECOLORSPACE 101
#define SB_HORZ 0
#define SB_VERT 1
#define SB_CTL 2
#define SB_BOTH 3
#define SB_LINEUP 0
#define SB_LINELEFT 0
#define SB_LINEDOWN 1
#define SB_LINERIGHT 1
#define SB_PAGEUP 2
#define SB_PAGELEFT 2
#define SB_PAGEDOWN 3
#define SB_PAGERIGHT 3
#define SB_THUMBPOSITION 4
#define SB_THUMBTRACK 5
#define SB_TOP 6
#define SB_LEFT 6
#define SB_BOTTOM 7
#define SB_RIGHT 7
#define SB_ENDSCROLL 8
#define SW_HIDE 0
#define SW_SHOWNORMAL 1
#define SW_NORMAL 1
#define SW_SHOWMINIMIZED 2
#define SW_SHOWMAXIMIZED 3
#define SW_MAXIMIZE 3
#define SW_SHOWNOACTIVATE 4
#define SW_SHOW 5
#define SW_MINIMIZE 6
#define SW_SHOWMINNOACTIVE 7
#define SW_SHOWNA 8
#define SW_RESTORE 9
#define SW_SHOWDEFAULT 10
#define SW_MAX 10
#define HIDE_WINDOW 0
#define SHOW_OPENWINDOW 1
#define SHOW_ICONWINDOW 2
#define SHOW_FULLSCREEN 3
#define SHOW_OPENNOACTIVATE 4
#define SW_PARENTCLOSING 1
#define SW_OTHERZOOM 2
#define SW_PARENTOPENING 3
#define SW_OTHERUNZOOM 4
#define KF_EXTENDED 0x100
#define KF_DLGMODE 0x800
#define KF_MENUMODE 0x1000
#define KF_ALTDOWN 0x2000
#define KF_REPEAT 0x4000
#define KF_UP 0x8000
#define VK_LBUTTON 0x1
#define VK_RBUTTON 0x2
#define VK_CANCEL 0x3
#define VK_MBUTTON 0x4
#define VK_BACK 0x8
#define VK_TAB 0x9
#define VK_CLEAR 0xC
#define VK_RETURN 0xD
#define VK_SHIFT 0x10
#define VK_CONTROL 0x11
#define VK_MENU 0x12
#define VK_PAUSE 0x13
#define VK_CAPITAL 0x14
#define VK_ESCAPE 0x1B
#define VK_SPACE 0x20
#define VK_PRIOR 0x21
#define VK_NEXT 0x22
#define VK_END 0x23
#define VK_HOME 0x24
#define VK_LEFT 0x25
#define VK_UP 0x26
#define VK_RIGHT 0x27
#define VK_DOWN 0x28
#define VK_SELECT 0x29
#define VK_PRINT 0x2A
#define VK_EXECUTE 0x2B
#define VK_SNAPSHOT 0x2C
#define VK_INSERT 0x2D
#define VK_DELETE 0x2E
#define VK_HELP 0x2F
#define VK_NUMPAD0 0x60
#define VK_NUMPAD1 0x61
#define VK_NUMPAD2 0x62
#define VK_NUMPAD3 0x63
#define VK_NUMPAD4 0x64
#define VK_NUMPAD5 0x65
#define VK_NUMPAD6 0x66
#define VK_NUMPAD7 0x67
#define VK_NUMPAD8 0x68
#define VK_NUMPAD9 0x69
#define VK_MULTIPLY 0x6A
#define VK_ADD 0x6B
#define VK_SEPARATOR 0x6C
#define VK_SUBTRACT 0x6D
#define VK_DECIMAL 0x6E
#define VK_DIVIDE 0x6F
#define VK_F1 0x70
#define VK_F2 0x71
#define VK_F3 0x72
#define VK_F4 0x73
#define VK_F5 0x74
#define VK_F6 0x75
#define VK_F7 0x76
#define VK_F8 0x77
#define VK_F9 0x78
#define VK_F10 0x79
#define VK_F11 0x7A
#define VK_F12 0x7B
#define VK_F13 0x7C
#define VK_F14 0x7D
#define VK_F15 0x7E
#define VK_F16 0x7F
#define VK_F17 0x80
#define VK_F18 0x81
#define VK_F19 0x82
#define VK_F20 0x83
#define VK_F21 0x84
#define VK_F22 0x85
#define VK_F23 0x86
#define VK_F24 0x87
#define VK_NUMLOCK 0x90
#define VK_SCROLL 0x91
#define VK_LSHIFT 0xA0
#define VK_RSHIFT 0xA1
#define VK_LCONTROL 0xA2
#define VK_RCONTROL 0xA3
#define VK_LMENU 0xA4
#define VK_RMENU 0xA5
#define VK_ATTN 0xF6
#define VK_CRSEL 0xF7
#define VK_EXSEL 0xF8
#define VK_EREOF 0xF9
#define VK_PLAY 0xFA
#define VK_ZOOM 0xFB
#define VK_NONAME 0xFC
#define VK_PA1 0xFD
#define VK_OEM_CLEAR 0xFE
#define WH_MIN (-1)
#define WH_MSGFILTER (-1)
#define WH_JOURNALRECORD 0
#define WH_JOURNALPLAYBACK 1
#define WH_KEYBOARD 2
#define WH_GETMESSAGE 3
#define WH_CALLWNDPROC 4
#define WH_CBT 5
#define WH_SYSMSGFILTER 6
#define WH_MOUSE 7
#define WH_HARDWARE 8
#define WH_DEBUG 9
#define WH_SHELL 10
#define WH_FOREGROUNDIDLE 11
#define WH_MAX 11
#define HC_ACTION 0
#define HC_GETNEXT 1
#define HC_SKIP 2
#define HC_NOREMOVE 3
#define HC_NOREM HC_NOREMOVE
#define HC_SYSMODALON 4
#define HC_SYSMODALOFF 5
#define HCBT_MOVESIZE 0
#define HCBT_MINMAX 1
#define HCBT_QS 2
#define HCBT_CREATEWND 3
#define HCBT_DESTROYWND 4
#define HCBT_ACTIVATE 5
#define HCBT_CLICKSKIPPED 6
#define HCBT_KEYSKIPPED 7
#define HCBT_SYSCOMMAND 8
#define HCBT_SETFOCUS 9
#define MSGF_DIALOGBOX 0
#define MSGF_MESSAGEBOX 1
#define MSGF_MENU 2
#define MSGF_MOVE 3
#define MSGF_SIZE 4
#define MSGF_SCROLLBAR 5
#define MSGF_NEXTWINDOW 6
#define MSGF_MAINLOOP 8
#define MSGF_MAX 8
#define MSGF_USER 4096
#define HSHELL_WINDOWCREATED 1
#define HSHELL_WINDOWDESTROYED 2
#define HSHELL_ACTIVATESHELLWINDOW 3
#define HKL_PREV 0
#define HKL_NEXT 1
#define KLF_ACTIVATE 0x1
#define KLF_SUBSTITUTE_OK 0x2
#define KLF_UNLOADPREVIOUS 0x4
#define KLF_REORDER 0x8
#define KL_NAMELENGTH 9
#define DESKTOP_READOBJECTS 0x1
#define DESKTOP_CREATEWINDOW 0x2
#define DESKTOP_CREATEMENU 0x4
#define DESKTOP_HOOKCONTROL 0x8
#define DESKTOP_JOURNALRECORD 0x10
#define DESKTOP_JOURNALPLAYBACK 0x20
#define DESKTOP_ENUMERATE 0x40
#define DESKTOP_WRITEOBJECTS 0x80
#define WINSTA_ENUMDESKTOPS 0x1
#define WINSTA_READATTRIBUTES 0x2
#define WINSTA_ACCESSCLIPBOARD 0x4
#define WINSTA_CREATEDESKTOP 0x8
#define WINSTA_WRITEATTRIBUTES 0x10
#define WINSTA_ACCESSPUBLICATOMS 0x20
#define WINSTA_EXITWINDOWS 0x40
#define WINSTA_ENUMERATE 0x100
#define WINSTA_READSCREEN 0x200
#define GWL_WNDPROC (-4)
#define GWL_HINSTANCE (-6)
#define GWL_HWNDPARENT (-8)
#define GWL_STYLE (-16)
#define GWL_EXSTYLE (-20)
#define GWL_USERDATA (-21)
#define GWL_ID (-12)
#define GCL_MENUNAME (-8)
#define GCL_HBRBACKGROUND (-10)
#define GCL_HCURSOR (-12)
#define GCL_HICON (-14)
#define GCL_HMODULE (-16)
#define GCL_CBWNDEXTRA (-18)
#define GCL_CBCLSEXTRA (-20)
#define GCL_WNDPROC (-24)
#define GCL_STYLE (-26)
#define GCW_ATOM (-32)
#define WM_NULL 0x0
#define WM_CREATE 0x1
#define WM_DESTROY 0x2
#define WM_MOVE 0x3
#define WM_SIZE 0x5
#define WM_ACTIVATE 0x6
#define WA_INACTIVE 0
#define WA_ACTIVE 1
#define WA_CLICKACTIVE 2
#define WM_SETFOCUS 0x7
#define WM_KILLFOCUS 0x8
#define WM_ENABLE 0xA
#define WM_SETREDRAW 0xB
#define WM_SETTEXT 0xC
#define WM_GETTEXT 0xD
#define WM_GETTEXTLENGTH 0xE
#define WM_PAINT 0xF
#define WM_CLOSE 0x10
#define WM_QUERYENDSESSION 0x11
#define WM_QUIT 0x12
#define WM_QUERYOPEN 0x13
#define WM_ERASEBKGND 0x14
#define WM_SYSCOLORCHANGE 0x15
#define WM_ENDSESSION 0x16
#define WM_SHOWWINDOW 0x18
#define WM_WININICHANGE 0x1A
#define WM_DEVMODECHANGE 0x1B
#define WM_ACTIVATEAPP 0x1C
#define WM_FONTCHANGE 0x1D
#define WM_TIMECHANGE 0x1E
#define WM_CANCELMODE 0x1F
#define WM_SETCURSOR 0x20
#define WM_MOUSEACTIVATE 0x21
#define WM_CHILDACTIVATE 0x22
#define WM_QUEUESYNC 0x23
#define WM_GETMINMAXINFO 0x24
#define WM_PAINTICON 0x26
#define WM_ICONERASEBKGND 0x27
#define WM_NEXTDLGCTL 0x28
#define WM_SPOOLERSTATUS 0x2A
#define WM_DRAWITEM 0x2B
#define WM_MEASUREITEM 0x2C
#define WM_DELETEITEM 0x2D
#define WM_VKEYTOITEM 0x2E
#define WM_CHARTOITEM 0x2F
#define WM_SETFONT 0x30
#define WM_GETFONT 0x31
#define WM_SETHOTKEY 0x32
#define WM_GETHOTKEY 0x33
#define WM_QUERYDRAGICON 0x37
#define WM_COMPAREITEM 0x39
#define WM_COMPACTING 0x41
#define WM_OTHERWINDOWCREATED 0x42
#define WM_OTHERWINDOWDESTROYED 0x43
#define WM_COMMNOTIFY 0x44
#define CN_RECEIVE 0x1
#define CN_TRANSMIT 0x2
#define CN_EVENT 0x4
#define WM_WINDOWPOSCHANGING 0x46
#define WM_WINDOWPOSCHANGED 0x47
#define WM_POWER 0x48
#define PWR_OK 1
#define PWR_FAIL (-1)
#define PWR_SUSPENDREQUEST 1
#define PWR_SUSPENDRESUME 2
#define PWR_CRITICALRESUME 3
#define WM_COPYDATA 0x4A
#define WM_CANCELJOURNAL 0x4B
#define WM_NCCREATE 0x81
#define WM_NCDESTROY 0x82
#define WM_NCCALCSIZE 0x83
#define WM_NCHITTEST 0x84
#define WM_NCPAINT 0x85
#define WM_NCACTIVATE 0x86
#define WM_GETDLGCODE 0x87
#define WM_NCMOUSEMOVE 0xA0
#define WM_NCLBUTTONDOWN 0xA1
#define WM_NCLBUTTONUP 0xA2
#define WM_NCLBUTTONDBLCLK 0xA3
#define WM_NCRBUTTONDOWN 0xA4
#define WM_NCRBUTTONUP 0xA5
#define WM_NCRBUTTONDBLCLK 0xA6
#define WM_NCMBUTTONDOWN 0xA7
#define WM_NCMBUTTONUP 0xA8
#define WM_NCMBUTTONDBLCLK 0xA9
#define WM_KEYFIRST 0x100
#define WM_KEYDOWN 0x100
#define WM_KEYUP 0x101
#define WM_CHAR 0x102
#define WM_DEADCHAR 0x103
#define WM_SYSKEYDOWN 0x104
#define WM_SYSKEYUP 0x105
#define WM_SYSCHAR 0x106
#define WM_SYSDEADCHAR 0x107
#define WM_KEYLAST 0x108
#define WM_INITDIALOG 0x110
#define WM_COMMAND 0x111
#define WM_SYSCOMMAND 0x112
#define WM_TIMER 0x113
#define WM_HSCROLL 0x114
#define WM_VSCROLL 0x115
#define WM_INITMENU 0x116
#define WM_INITMENUPOPUP 0x117
#define WM_MENUSELECT 0x11F
#define WM_MENUCHAR 0x120
#define WM_ENTERIDLE 0x121
#define WM_CTLCOLORMSGBOX 0x132
#define WM_CTLCOLOREDIT 0x133
#define WM_CTLCOLORLISTBOX 0x134
#define WM_CTLCOLORBTN 0x135
#define WM_CTLCOLORDLG 0x136
#define WM_CTLCOLORSCROLLBAR 0x137
#define WM_CTLCOLORSTATIC 0x138
#define WM_MOUSEFIRST 0x200
#define WM_MOUSEMOVE 0x200
#define WM_LBUTTONDOWN 0x201
#define WM_LBUTTONUP 0x202
#define WM_LBUTTONDBLCLK 0x203
#define WM_RBUTTONDOWN 0x204
#define WM_RBUTTONUP 0x205
#define WM_RBUTTONDBLCLK 0x206
#define WM_MBUTTONDOWN 0x207
#define WM_MBUTTONUP 0x208
#define WM_MBUTTONDBLCLK 0x209
#define WM_MOUSELAST 0x209
#define WM_PARENTNOTIFY 0x210
#define WM_ENTERMENULOOP 0x211
#define WM_EXITMENULOOP 0x212
#define WM_MDICREATE 0x220
#define WM_MDIDESTROY 0x221
#define WM_MDIACTIVATE 0x222
#define WM_MDIRESTORE 0x223
#define WM_MDINEXT 0x224
#define WM_MDIMAXIMIZE 0x225
#define WM_MDITILE 0x226
#define WM_MDICASCADE 0x227
#define WM_MDIICONARRANGE 0x228
#define WM_MDIGETACTIVE 0x229
#define WM_MDISETMENU 0x230
#define WM_DROPFILES 0x233
#define WM_MDIREFRESHMENU 0x234
#define WM_CUT 0x300
#define WM_COPY 0x301
#define WM_PASTE 0x302
#define WM_CLEAR 0x303
#define WM_UNDO 0x304
#define WM_RENDERFORMAT 0x305
#define WM_RENDERALLFORMATS 0x306
#define WM_DESTROYCLIPBOARD 0x307
#define WM_DRAWCLIPBOARD 0x308
#define WM_PAINTCLIPBOARD 0x309
#define WM_VSCROLLCLIPBOARD 0x30A
#define WM_SIZECLIPBOARD 0x30B
#define WM_ASKCBFORMATNAME 0x30C
#define WM_CHANGECBCHAIN 0x30D
#define WM_HSCROLLCLIPBOARD 0x30E
#define WM_QUERYNEWPALETTE 0x30F
#define WM_PALETTEISCHANGING 0x310
#define WM_PALETTECHANGED 0x311
#define WM_HOTKEY 0x312
#define WM_PENWINFIRST 0x380
#define WM_PENWINLAST 0x38F
#define WM_USER 0x400
#define ST_BEGINSWP 0
#define ST_ENDSWP 1
#define HTERROR (-2)
#define HTTRANSPARENT (-1)
#define HTNOWHERE 0
#define HTCLIENT 1
#define HTCAPTION 2
#define HTSYSMENU 3
#define HTGROWBOX 4
#define HTSIZE HTGROWBOX
#define HTMENU 5
#define HTHSCROLL 6
#define HTVSCROLL 7
#define HTMINBUTTON 8
#define HTMAXBUTTON 9
#define HTLEFT 10
#define HTRIGHT 11
#define HTTOP 12
#define HTTOPLEFT 13
#define HTTOPRIGHT 14
#define HTBOTTOM 15
#define HTBOTTOMLEFT 16
#define HTBOTTOMRIGHT 17
#define HTBORDER 18
#define HTREDUCE HTMINBUTTON
#define HTZOOM HTMAXBUTTON
#define HTSIZEFIRST HTLEFT
#define HTSIZELAST HTBOTTOMRIGHT
#define SMTO_NORMAL 0x0
#define SMTO_BLOCK 0x1
#define SMTO_ABORTIFHUNG 0x2
#define MA_ACTIVATE 1
#define MA_ACTIVATEANDEAT 2
#define MA_NOACTIVATE 3
#define MA_NOACTIVATEANDEAT 4
#define SIZE_RESTORED 0
#define SIZE_MINIMIZED 1
#define SIZE_MAXIMIZED 2
#define SIZE_MAXSHOW 3
#define SIZE_MAXHIDE 4
#define SIZENORMAL SIZE_RESTORED
#define SIZEICONIC SIZE_MINIMIZED
#define SIZEFULLSCREEN SIZE_MAXIMIZED
#define SIZEZOOMSHOW SIZE_MAXSHOW
#define SIZEZOOMHIDE SIZE_MAXHIDE
#define WVR_ALIGNTOP 0x10
#define WVR_ALIGNLEFT 0x20
#define WVR_ALIGNBOTTOM 0x40
#define WVR_ALIGNRIGHT 0x80
#define WVR_HREDRAW 0x100
#define WVR_VREDRAW 0x200
#define WVR_REDRAW (WVR_HREDRAW|WVR_VREDRAW)
#define WVR_VALIDRECTS 0x400
#define MK_LBUTTON 0x1
#define MK_RBUTTON 0x2
#define MK_SHIFT 0x4
#define MK_CONTROL 0x8
#define MK_MBUTTON 0x10
#define WS_OVERLAPPED 0x0
#define WS_POPUP 0x80000000
#define WS_CHILD 0x40000000
#define WS_MINIMIZE 0x20000000
#define WS_VISIBLE 0x10000000
#define WS_DISABLED 0x8000000
#define WS_CLIPSIBLINGS 0x4000000
#define WS_CLIPCHILDREN 0x2000000
#define WS_MAXIMIZE 0x1000000
#define WS_CAPTION 0xC00000
#define WS_BORDER 0x800000
#define WS_DLGFRAME 0x400000
#define WS_VSCROLL 0x200000
#define WS_HSCROLL 0x100000
#define WS_SYSMENU 0x80000
#define WS_THICKFRAME 0x40000
#define WS_GROUP 0x20000
#define WS_TABSTOP 0x10000
#define WS_MINIMIZEBOX 0x20000
#define WS_MAXIMIZEBOX 0x10000
#define WS_TILED WS_OVERLAPPED
#define WS_ICONIC WS_MINIMIZE
#define WS_SIZEBOX WS_THICKFRAME
#define WS_OVERLAPPEDWINDOW (WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX)
#define WS_TILEDWINDOW WS_OVERLAPPEDWINDOW
#define WS_POPUPWINDOW (WS_POPUP|WS_BORDER|WS_SYSMENU)
#define WS_CHILDWINDOW (WS_CHILD)
#define WS_EX_DLGMODALFRAME 0x1
#define WS_EX_NOPARENTNOTIFY 0x4
#define WS_EX_TOPMOST 0x8
#define WS_EX_ACCEPTFILES 0x10
#define WS_EX_TRANSPARENT 0x20
#define WS_EX_CLIENTEDGE 0x200 
#define CS_VREDRAW 0x1
#define CS_HREDRAW 0x2
#define CS_KEYCVTWINDOW 0x4
#define CS_DBLCLKS 0x8
#define CS_OWNDC 0x20
#define CS_CLASSDC 0x40
#define CS_PARENTDC 0x80
#define CS_NOKEYCVT 0x100
#define CS_NOCLOSE 0x200
#define CS_SAVEBITS 0x800
#define CS_BYTEALIGNCLIENT 0x1000
#define CS_BYTEALIGNWINDOW 0x2000
#define CS_PUBLICCLASS 0x4000
#define CF_TEXT 1
#define CF_BITMAP 2
#define CF_METAFILEPICT 3
#define CF_SYLK 4
#define CF_DIF 5
#define CF_TIFF 6
#define CF_OEMTEXT 7
#define CF_DIB 8
#define CF_PALETTE 9
#define CF_PENDATA 10
#define CF_RIFF 11
#define CF_WAVE 12
#define CF_UNICODETEXT 13
#define CF_ENHMETAFILE 14
#define CF_OWNERDISPLAY 0x80
#define CF_DSPTEXT 0x81
#define CF_DSPBITMAP 0x82
#define CF_DSPMETAFILEPICT 0x83
#define CF_DSPENHMETAFILE 0x8E
#define CF_PRIVATEFIRST 0x200
#define CF_PRIVATELAST 0x2FF
#define CF_GDIOBJFIRST 0x300
#define CF_GDIOBJLAST 0x3FF
#define FVIRTKEY True
#define FNOINVERT 0x2
#define FSHIFT 0x4
#define FCONTROL 0x8
#define FALT 0x10
#define WPF_SETMINPOSITION 0x1
#define WPF_RESTORETOMAXIMIZED 0x2
#define ODT_MENU 1
#define ODT_LISTBOX 2
#define ODT_COMBOBOX 3
#define ODT_BUTTON 4
#define ODA_DRAWENTIRE 0x1
#define ODA_SELECT 0x2
#define ODA_FOCUS 0x4
#define ODS_SELECTED 0x1
#define ODS_GRAYED 0x2
#define ODS_DISABLED 0x4
#define ODS_CHECKED 0x8
#define ODS_FOCUS 0x10
#define PM_NOREMOVE 0x0
#define PM_REMOVE 0x1
#define PM_NOYIELD 0x2
#define MOD_ALT 0x1
#define MOD_CONTROL 0x2
#define MOD_SHIFT 0x4
#define IDHOT_SNAPWINDOW (-1)
#define IDHOT_SNAPDESKTOP (-2)
#define EWX_LOGOFF 0
#define EWX_SHUTDOWN 1
#define EWX_REBOOT 2
#define EWX_FORCE 4
#define READAPI 0
#define WRITEAPI 1
#define READ_WRITE 2
#define HWND_BROADCAST 0xFFFF
#define CW_USEDEFAULT 0x80000000
#define HWND_DESKTOP 0
#define SWP_NOSIZE 0x1
#define SWP_NOMOVE 0x2
#define SWP_NOZORDER 0x4
#define SWP_NOREDRAW 0x8
#define SWP_NOACTIVATE 0x10
#define SWP_FRAMECHANGED 0x20
#define SWP_SHOWWINDOW 0x40
#define SWP_HIDEWINDOW 0x80
#define SWP_NOCOPYBITS 0x100
#define SWP_NOOWNERZORDER 0x200
#define SWP_DRAWFRAME SWP_FRAMECHANGED
#define SWP_NOREPOSITION SWP_NOOWNERZORDER
#define HWND_TOP 0
#define HWND_BOTTOM 1
#define HWND_TOPMOST -1
#define HWND_NOTOPMOST -2
#define DLGWINDOWEXTRA 30
#define KEYEVENTF_EXTENDEDKEY 0x1
#define KEYEVENTF_KEYUP 0x2
#define MOUSEEVENTF_MOVE 0x1
#define MOUSEEVENTF_LEFTDOWN 0x2
#define MOUSEEVENTF_LEFTUP 0x4
#define MOUSEEVENTF_RIGHTDOWN 0x8
#define MOUSEEVENTF_RIGHTUP 0x10
#define MOUSEEVENTF_MIDDLEDOWN 0x20
#define MOUSEEVENTF_MIDDLEUP 0x40
#define MOUSEEVENTF_ABSOLUTE 0x8000
#define QS_KEY 0x1
#define QS_MOUSEMOVE 0x2
#define QS_MOUSEBUTTON 0x4
#define QS_POSTMESSAGE 0x8
#define QS_TIMER 0x10
#define QS_PAINT 0x20
#define QS_SENDMESSAGE 0x40
#define QS_HOTKEY 0x80
#define QS_MOUSE (QS_MOUSEMOVE|QS_MOUSEBUTTON)
#define QS_INPUT (QS_MOUSE|QS_KEY)
#define QS_ALLEVENTS (QS_INPUT|QS_POSTMESSAGE|QS_TIMER|QS_PAINT|QS_HOTKEY)
#define QS_ALLINPUT (QS_SENDMESSAGE|QS_PAINT|QS_TIMER|QS_POSTMESSAGE|QS_MOUSEBUTTON|QS_MOUSEMOVE|QS_HOTKEY|QS_KEY)
#define SM_CXSCREEN 0
#define SM_CYSCREEN 1
#define SM_CXVSCROLL 2
#define SM_CYHSCROLL 3
#define SM_CYCAPTION 4
#define SM_CXBORDER 5
#define SM_CYBORDER 6
#define SM_CXDLGFRAME 7
#define SM_CYDLGFRAME 8
#define SM_CYVTHUMB 9
#define SM_CXHTHUMB 10
#define SM_CXICON 11
#define SM_CYICON 12
#define SM_CXCURSOR 13
#define SM_CYCURSOR 14
#define SM_CYMENU 15
#define SM_CXFULLSCREEN 16
#define SM_CYFULLSCREEN 17
#define SM_CYKANJIWINDOW 18
#define SM_MOUSEPRESENT 19
#define SM_CYVSCROLL 20
#define SM_CXHSCROLL 21
#define SM_DEBUG 22
#define SM_SWAPBUTTON 23
#define SM_RESERVED1 24
#define SM_RESERVED2 25
#define SM_RESERVED3 26
#define SM_RESERVED4 27
#define SM_CXMIN 28
#define SM_CYMIN 29
#define SM_CXSIZE 30
#define SM_CYSIZE 31
#define SM_CXFRAME 32
#define SM_CYFRAME 33
#define SM_CXMINTRACK 34
#define SM_CYMINTRACK 35
#define SM_CXDOUBLECLK 36
#define SM_CYDOUBLECLK 37
#define SM_CXICONSPACING 38
#define SM_CYICONSPACING 39
#define SM_MENUDROPALIGNMENT 40
#define SM_PENWINDOWS 41
#define SM_DBCSENABLED 42
#define SM_CMOUSEBUTTONS 43
#define SM_CMETRICS 44
#define SM_CXSIZEFRAME SM_CXFRAME
#define SM_CYSIZEFRAME SM_CYFRAME
#define SM_CXFIXEDFRAME SM_CXDLGFRAME
#define SM_CYFIXEDFRAME SM_CYDLGFRAME
#define TPM_LEFTBUTTON 0x0
#define TPM_RIGHTBUTTON 0x2
#define TPM_LEFTALIGN 0x0
#define TPM_CENTERALIGN 0x4
#define TPM_RIGHTALIGN 0x8
#define DT_TOP 0x0
#define DT_LEFT 0x0
#define DT_CENTER 0x1
#define DT_RIGHT 0x2
#define DT_VCENTER 0x4
#define DT_BOTTOM 0x8
#define DT_WORDBREAK 0x10
#define DT_SINGLELINE 0x20
#define DT_EXPANDTABS 0x40
#define DT_TABSTOP 0x80
#define DT_NOCLIP 0x100
#define DT_EXTERNALLEADING 0x200
#define DT_CALCRECT 0x400
#define DT_NOPREFIX 0x800
#define DT_INTERNAL 0x1000
#define DCX_WINDOW 0x1
#define DCX_CACHE 0x2
#define DCX_NORESETATTRS 0x4
#define DCX_CLIPCHILDREN 0x8
#define DCX_CLIPSIBLINGS 0x10
#define DCX_PARENTCLIP 0x20
#define DCX_EXCLUDERGN 0x40
#define DCX_INTERSECTRGN 0x80
#define DCX_EXCLUDEUPDATE 0x100
#define DCX_INTERSECTUPDATE 0x200
#define DCX_LOCKWINDOWUPDATE 0x400
#define DCX_NORECOMPUTE 0x100000
#define DCX_VALIDATE 0x200000
#define RDW_INVALIDATE 0x1
#define RDW_INTERNALPAINT 0x2
#define RDW_ERASE 0x4
#define RDW_VALIDATE 0x8
#define RDW_NOINTERNALPAINT 0x10
#define RDW_NOERASE 0x20
#define RDW_NOCHILDREN 0x40
#define RDW_ALLCHILDREN 0x80
#define RDW_UPDATENOW 0x100
#define RDW_ERASENOW 0x200
#define RDW_FRAME 0x400
#define RDW_NOFRAME 0x800
#define SW_SCROLLCHILDREN 0x1
#define SW_INVALIDATE 0x2
#define SW_ERASE 0x4
#define ESB_ENABLE_BOTH 0x0
#define ESB_DISABLE_BOTH 0x3
#define ESB_DISABLE_LEFT 0x1
#define ESB_DISABLE_RIGHT 0x2
#define ESB_DISABLE_UP 0x1
#define ESB_DISABLE_DOWN 0x2
#define ESB_DISABLE_LTUP ESB_DISABLE_LEFT
#define ESB_DISABLE_RTDN ESB_DISABLE_RIGHT
#define MB_OK 0x0
#define MB_OKCANCEL 0x1
#define MB_ABORTRETRYIGNORE 0x2
#define MB_YESNOCANCEL 0x3
#define MB_YESNO 0x4
#define MB_RETRYCANCEL 0x5
#define MB_ICONHAND 0x10
#define MB_ICONQUESTION 0x20
#define MB_ICONEXCLAMATION 0x30
#define MB_ICONASTERISK 0x40
#define MB_ICONINFORMATION MB_ICONASTERISK
#define MB_ICONSTOP MB_ICONHAND
#define MB_DEFBUTTON1 0x0
#define MB_DEFBUTTON2 0x100
#define MB_DEFBUTTON3 0x200
#define MB_APPLMODAL 0x0
#define MB_SYSTEMMODAL 0x1000
#define MB_TASKMODAL 0x2000
#define MB_NOFOCUS 0x8000
#define MB_SETFOREGROUND 0x10000
#define MB_DEFAULT_DESKTOP_ONLY 0x20000
#define MB_TYPEMASK 0xF
#define MB_ICONMASK 0xF0
#define MB_DEFMASK 0xF00
#define MB_MODEMASK 0x3000
#define MB_MISCMASK 0xC000
#define CTLCOLOR_MSGBOX 0
#define CTLCOLOR_EDIT 1
#define CTLCOLOR_LISTBOX 2
#define CTLCOLOR_BTN 3
#define CTLCOLOR_DLG 4
#define CTLCOLOR_SCROLLBAR 5
#define CTLCOLOR_STATIC 6
#define CTLCOLOR_MAX 8
#define COLOR_SCROLLBAR 0
#define COLOR_BACKGROUND 1
#define COLOR_ACTIVECAPTION 2
#define COLOR_INACTIVECAPTION 3
#define COLOR_MENU 4
#define COLOR_WINDOW 5
#define COLOR_WINDOWFRAME 6
#define COLOR_MENUTEXT 7
#define COLOR_WINDOWTEXT 8
#define COLOR_CAPTIONTEXT 9
#define COLOR_ACTIVEBORDER 10
#define COLOR_INACTIVEBORDER 11
#define COLOR_APPWORKSPACE 12
#define COLOR_HIGHLIGHT 13
#define COLOR_HIGHLIGHTTEXT 14
#define COLOR_BTNFACE 15
#define COLOR_BTNSHADOW 16
#define COLOR_GRAYTEXT 17
#define COLOR_BTNTEXT 18
#define COLOR_INACTIVECAPTIONTEXT 19
#define COLOR_BTNHIGHLIGHT 20
#define GW_HWNDFIRST 0
#define GW_HWNDLAST 1
#define GW_HWNDNEXT 2
#define GW_HWNDPREV 3
#define GW_OWNER 4
#define GW_CHILD 5
#define GW_MAX 5
#define MF_INSERT 0x0
#define MF_CHANGE 0x80
#define MF_APPEND 0x100
#define MF_DELETE 0x200
#define MF_REMOVE 0x1000
#define MF_BYCOMMAND 0x0
#define MF_BYPOSITION 0x400
#define MF_SEPARATOR 0x800
#define MF_ENABLED 0x0
#define MF_GRAYED 0x1
#define MF_DISABLED 0x2
#define MF_UNCHECKED 0x0
#define MF_CHECKED 0x8
#define MF_USECHECKBITMAPS 0x200
#define MF_STRING 0x0
#define MF_BITMAP 0x4
#define MF_OWNERDRAW 0x100
#define MF_POPUP 0x10
#define MF_MENUBARBREAK 0x20
#define MF_MENUBREAK 0x40
#define MF_UNHILITE 0x0
#define MF_HILITE 0x80
#define MF_SYSMENU 0x2000
#define MF_HELP 0x4000
#define MF_MOUSESELECT 0x8000
#define MF_END 0x80
#define SC_SIZE 0xF000
#define SC_MOVE 0xF010
#define SC_MINIMIZE 0xF020
#define SC_MAXIMIZE 0xF030
#define SC_NEXTWINDOW 0xF040
#define SC_PREVWINDOW 0xF050
#define SC_CLOSE 0xF060
#define SC_VSCROLL 0xF070
#define SC_HSCROLL 0xF080
#define SC_MOUSEMENU 0xF090
#define SC_KEYMENU 0xF100
#define SC_ARRANGE 0xF110
#define SC_RESTORE 0xF120
#define SC_TASKLIST 0xF130
#define SC_SCREENSAVE 0xF140
#define SC_HOTKEY 0xF150
#define SC_ICON SC_MINIMIZE
#define SC_ZOOM SC_MAXIMIZE
#define IDC_ARROW 32512
#define IDC_IBEAM 32513
#define IDC_WAIT 32514
#define IDC_CROSS 32515
#define IDC_UPARROW 32516
#define IDC_SIZE 32640
#define IDC_ICON 32641
#define IDC_SIZENWSE 32642
#define IDC_SIZENESW 32643
#define IDC_SIZEWE 32644
#define IDC_SIZENS 32645
#define IDC_SIZEALL 32646
#define IDC_NO 32648
#define IDC_APPSTARTING 32650
#define OBM_CLOSE 32754
#define OBM_UPARROW 32753
#define OBM_DNARROW 32752
#define OBM_RGARROW 32751
#define OBM_LFARROW 32750
#define OBM_REDUCE 32749
#define OBM_ZOOM 32748
#define OBM_RESTORE 32747
#define OBM_REDUCED 32746
#define OBM_ZOOMD 32745
#define OBM_RESTORED 32744
#define OBM_UPARROWD 32743
#define OBM_DNARROWD 32742
#define OBM_RGARROWD 32741
#define OBM_LFARROWD 32740
#define OBM_MNARROW 32739
#define OBM_COMBO 32738
#define OBM_UPARROWI 32737
#define OBM_DNARROWI 32736
#define OBM_RGARROWI 32735
#define OBM_LFARROWI 32734
#define OBM_OLD_CLOSE 32767
#define OBM_SIZE 32766
#define OBM_OLD_UPARROW 32765
#define OBM_OLD_DNARROW 32764
#define OBM_OLD_RGARROW 32763
#define OBM_OLD_LFARROW 32762
#define OBM_BTSIZE 32761
#define OBM_CHECK 32760
#define OBM_CHECKBOXES 32759
#define OBM_BTNCORNERS 32758
#define OBM_OLD_REDUCE 32757
#define OBM_OLD_ZOOM 32756
#define OBM_OLD_RESTORE 32755
#define OCR_NORMAL 32512
#define OCR_IBEAM 32513
#define OCR_WAIT 32514
#define OCR_CROSS 32515
#define OCR_UP 32516
#define OCR_SIZE 32640
#define OCR_ICON 32641
#define OCR_SIZENWSE 32642
#define OCR_SIZENESW 32643
#define OCR_SIZEWE 32644
#define OCR_SIZENS 32645
#define OCR_SIZEALL 32646
#define OCR_ICOCUR 32647
#define OCR_NO 32648
#define OIC_SAMPLE 32512
#define OIC_HAND 32513
#define OIC_QUES 32514
#define OIC_BANG 32515
#define OIC_NOTE 32516
#define ORD_LANGDRIVER 1
#define IDI_APPLICATION 32512
#define IDI_HAND 32513
#define IDI_QUESTION 32514
#define IDI_EXCLAMATION 32515
#define IDI_ASTERISK 32516
#define IDOK 1
#define IDCANCEL 2
#define IDABORT 3
#define IDRETRY 4
#define IDIGNORE 5
#define IDYES 6
#define IDNO 7
#define ES_LEFT 0x0
#define ES_CENTER 0x1
#define ES_RIGHT 0x2
#define ES_MULTILINE 0x4
#define ES_UPPERCASE 0x8
#define ES_LOWERCASE 0x10
#define ES_PASSWORD 0x20
#define ES_AUTOVSCROLL 0x40
#define ES_AUTOHSCROLL 0x80
#define ES_NOHIDESEL 0x100
#define ES_OEMCONVERT 0x400
#define ES_READONLY 0x800
#define ES_WANTRETURN 0x1000
#define EN_SETFOCUS 0x100
#define EN_KILLFOCUS 0x200
#define EN_CHANGE 0x300
#define EN_UPDATE 0x400
#define EN_ERRSPACE 0x500
#define EN_MAXTEXT 0x501
#define EN_HSCROLL 0x601
#define EN_VSCROLL 0x602
#define EM_GETSEL 0xB0
#define EM_SETSEL 0xB1
#define EM_GETRECT 0xB2
#define EM_SETRECT 0xB3
#define EM_SETRECTNP 0xB4
#define EM_SCROLL 0xB5
#define EM_LINESCROLL 0xB6
#define EM_SCROLLCARET 0xB7
#define EM_GETMODIFY 0xB8
#define EM_SETMODIFY 0xB9
#define EM_GETLINECOUNT 0xBA
#define EM_LINEINDEX 0xBB
#define EM_SETHANDLE 0xBC
#define EM_GETHANDLE 0xBD
#define EM_GETTHUMB 0xBE
#define EM_LINELENGTH 0xC1
#define EM_REPLACESEL 0xC2
#define EM_GETLINE 0xC4
#define EM_LIMITTEXT 0xC5
#define EM_CANUNDO 0xC6
#define EM_UNDO 0xC7
#define EM_FMTLINES 0xC8
#define EM_LINEFROMCHAR 0xC9
#define EM_SETTABSTOPS 0xCB
#define EM_SETPASSWORDCHAR 0xCC
#define EM_EMPTYUNDOBUFFER 0xCD
#define EM_GETFIRSTVISIBLELINE 0xCE
#define EM_SETREADONLY 0xCF
#define EM_SETWORDBREAKPROC 0xD0
#define EM_GETWORDBREAKPROC 0xD1
#define EM_GETPASSWORDCHAR 0xD2
#define WB_LEFT 0
#define WB_RIGHT 1
#define WB_ISDELIMITER 2
#define BS_PUSHBUTTON 0x0
#define BS_DEFPUSHBUTTON 0x1
#define BS_CHECKBOX 0x2
#define BS_AUTOCHECKBOX 0x3
#define BS_RADIOBUTTON 0x4
#define BS_3STATE 0x5
#define BS_AUTO3STATE 0x6
#define BS_GROUPBOX 0x7
#define BS_USERBUTTON 0x8
#define BS_AUTORADIOBUTTON 0x9
#define BS_OWNERDRAW 0xB
#define BS_LEFTTEXT 0x20
#define BN_CLICKED 0
#define BN_PAINT 1
#define BN_HILITE 2
#define BN_UNHILITE 3
#define BN_DISABLE 4
#define BN_DOUBLECLICKED 5
#define BM_GETCHECK 0xF0
#define BM_SETCHECK 0xF1
#define BM_GETSTATE 0xF2
#define BM_SETSTATE 0xF3
#define BM_SETSTYLE 0xF4
#define SS_LEFT 0x0
#define SS_CENTER 0x1
#define SS_RIGHT 0x2
#define SS_ICON 0x3
#define SS_BLACKRECT 0x4
#define SS_GRAYRECT 0x5
#define SS_WHITERECT 0x6
#define SS_BLACKFRAME 0x7
#define SS_GRAYFRAME 0x8
#define SS_WHITEFRAME 0x9
#define SS_USERITEM 0xA
#define SS_SIMPLE 0xB
#define SS_LEFTNOWORDWRAP 0xC
#define SS_NOPREFIX 0x80
#define STM_SETICON 0x170
#define STM_GETICON 0x171
#define STM_MSGMAX 0x172
#define WC_DIALOG 8002
#define DWL_MSGRESULT 0
#define DWL_DLGPROC 4
#define DWL_USER 8
#define DDL_READWRITE 0x0
#define DDL_READONLY 0x1
#define DDL_HIDDEN 0x2
#define DDL_SYSTEM 0x4
#define DDL_DIRECTORY 0x10
#define DDL_ARCHIVE 0x20
#define DDL_POSTMSGS 0x2000
#define DDL_DRIVES 0x4000
#define DDL_EXCLUSIVE 0x8000
#define DS_ABSALIGN 0x1
#define DS_SYSMODAL 0x2
#define DS_LOCALEDIT 0x20
#define DS_SETFONT 0x40
#define DS_MODALFRAME 0x80
#define DS_NOIDLEMSG 0x100
#define DS_SETFOREGROUND 0x200
#define DM_GETDEFID WM_USER + 0
#define DM_SETDEFID WM_USER + 1
#define DC_HASDEFID 0x534
#define DLGC_WANTARROWS 0x1
#define DLGC_WANTTAB 0x2
#define DLGC_WANTALLKEYS 0x4
#define DLGC_WANTMESSAGE 0x4
#define DLGC_HASSETSEL 0x8
#define DLGC_DEFPUSHBUTTON 0x10
#define DLGC_UNDEFPUSHBUTTON 0x20
#define DLGC_RADIOBUTTON 0x40
#define DLGC_WANTCHARS 0x80
#define DLGC_STATIC 0x100
#define DLGC_BUTTON 0x2000
#define LB_CTLCODE 0
#define LB_OKAY 0
#define LB_ERR (-1)
#define LB_ERRSPACE (-2)
#define LBN_ERRSPACE (-2)
#define LBN_SELCHANGE 1
#define LBN_DBLCLK 2
#define LBN_SELCANCEL 3
#define LBN_SETFOCUS 4
#define LBN_KILLFOCUS 5
#define LB_ADDSTRING 0x180
#define LB_INSERTSTRING 0x181
#define LB_DELETESTRING 0x182
#define LB_SELITEMRANGEEX 0x183
#define LB_RESETCONTENT 0x184
#define LB_SETSEL 0x185
#define LB_SETCURSEL 0x186
#define LB_GETSEL 0x187
#define LB_GETCURSEL 0x188
#define LB_GETTEXT 0x189
#define LB_GETTEXTLEN 0x18A
#define LB_GETCOUNT 0x18B
#define LB_SELECTSTRING 0x18C
#define LB_DIR 0x18D
#define LB_GETTOPINDEX 0x18E
#define LB_FINDSTRING 0x18F
#define LB_GETSELCOUNT 0x190
#define LB_GETSELITEMS 0x191
#define LB_SETTABSTOPS 0x192
#define LB_GETHORIZONTALEXTENT 0x193
#define LB_SETHORIZONTALEXTENT 0x194
#define LB_SETCOLUMNWIDTH 0x195
#define LB_ADDFILE 0x196
#define LB_SETTOPINDEX 0x197
#define LB_GETITEMRECT 0x198
#define LB_GETITEMDATA 0x199
#define LB_SETITEMDATA 0x19A
#define LB_SELITEMRANGE 0x19B
#define LB_SETANCHORINDEX 0x19C
#define LB_GETANCHORINDEX 0x19D
#define LB_SETCARETINDEX 0x19E
#define LB_GETCARETINDEX 0x19F
#define LB_SETITEMHEIGHT 0x1A0
#define LB_GETITEMHEIGHT 0x1A1
#define LB_FINDSTRINGEXACT 0x1A2
#define LB_SETLOCALE 0x1A5
#define LB_GETLOCALE 0x1A6
#define LB_SETCOUNT 0x1A7
#define LB_MSGMAX 0x1A8
#define LBS_NOTIFY 0x1
#define LBS_SORT 0x2
#define LBS_NOREDRAW 0x4
#define LBS_MULTIPLESEL 0x8
#define LBS_OWNERDRAWFIXED 0x10
#define LBS_OWNERDRAWVARIABLE 0x20
#define LBS_HASSTRINGS 0x40
#define LBS_USETABSTOPS 0x80
#define LBS_NOINTEGRALHEIGHT 0x100
#define LBS_MULTICOLUMN 0x200
#define LBS_WANTKEYBOARDINPUT 0x400
#define LBS_EXTENDEDSEL 0x800
#define LBS_DISABLENOSCROLL 0x1000
#define LBS_NODATA 0x2000
#define LBS_STANDARD (LBS_NOTIFY|LBS_SORT|WS_VSCROLL|WS_BORDER)
#define CB_OKAY 0
#define CB_ERR (-1)
#define CB_ERRSPACE (-2)
#define CBN_ERRSPACE (-1)
#define CBN_SELCHANGE 1
#define CBN_DBLCLK 2
#define CBN_SETFOCUS 3
#define CBN_KILLFOCUS 4
#define CBN_EDITCHANGE 5
#define CBN_EDITUPDATE 6
#define CBN_DROPDOWN 7
#define CBN_CLOSEUP 8
#define CBN_SELENDOK 9
#define CBN_SELENDCANCEL 10
#define CBS_SIMPLE 0x1
#define CBS_DROPDOWN 0x2
#define CBS_DROPDOWNLIST 0x3
#define CBS_OWNERDRAWFIXED 0x10
#define CBS_OWNERDRAWVARIABLE 0x20
#define CBS_AUTOHSCROLL 0x40
#define CBS_OEMCONVERT 0x80
#define CBS_SORT 0x100
#define CBS_HASSTRINGS 0x200
#define CBS_NOINTEGRALHEIGHT 0x400
#define CBS_DISABLENOSCROLL 0x800
#define CB_GETEDITSEL 0x140
#define CB_LIMITTEXT 0x141
#define CB_SETEDITSEL 0x142
#define CB_ADDSTRING 0x143
#define CB_DELETESTRING 0x144
#define CB_DIR 0x145
#define CB_GETCOUNT 0x146
#define CB_GETCURSEL 0x147
#define CB_GETLBTEXT 0x148
#define CB_GETLBTEXTLEN 0x149
#define CB_INSERTSTRING 0x14A
#define CB_RESETCONTENT 0x14B
#define CB_FINDSTRING 0x14C
#define CB_SELECTSTRING 0x14D
#define CB_SETCURSEL 0x14E
#define CB_SHOWDROPDOWN 0x14F
#define CB_GETITEMDATA 0x150
#define CB_SETITEMDATA 0x151
#define CB_GETDROPPEDCONTROLRECT 0x152
#define CB_SETITEMHEIGHT 0x153
#define CB_GETITEMHEIGHT 0x154
#define CB_SETEXTENDEDUI 0x155
#define CB_GETEXTENDEDUI 0x156
#define CB_GETDROPPEDSTATE 0x157
#define CB_FINDSTRINGEXACT 0x158
#define CB_SETLOCALE 0x159
#define CB_GETLOCALE 0x15A
#define CB_MSGMAX 0x15B
#define SBS_HORZ 0x0
#define SBS_VERT 0x1
#define SBS_TOPALIGN 0x2
#define SBS_LEFTALIGN 0x2
#define SBS_BOTTOMALIGN 0x4
#define SBS_RIGHTALIGN 0x4
#define SBS_SIZEBOXTOPLEFTALIGN 0x2
#define SBS_SIZEBOXBOTTOMRIGHTALIGN 0x4
#define SBS_SIZEBOX 0x8
#define SBM_SETPOS 0xE0
#define SBM_GETPOS 0xE1
#define SBM_SETRANGE 0xE2
#define SBM_SETRANGEREDRAW 0xE6
#define SBM_GETRANGE 0xE3
#define SBM_ENABLE_ARROWS 0xE4
#define MDIS_ALLCHILDSTYLES 0x1
#define MDITILE_VERTICAL 0x0
#define MDITILE_HORIZONTAL 0x1
#define MDITILE_SKIPDISABLED 0x2
#define HELP_CONTEXT 0x1
#define HELP_QUIT 0x2
#define HELP_INDEX 0x3
#define HELP_CONTENTS 0x3
#define HELP_HELPONHELP 0x4
#define HELP_SETINDEX 0x5
#define HELP_SETCONTENTS 0x5
#define HELP_CONTEXTPOPUP 0x8
#define HELP_FORCEFILE 0x9
#define HELP_KEY 0x101
#define HELP_COMMAND 0x102
#define HELP_PARTIALKEY 0x105
#define HELP_MULTIKEY 0x201
#define HELP_SETWINPOS 0x203
#define SPI_GETBEEP 1
#define SPI_SETBEEP 2
#define SPI_GETMOUSE 3
#define SPI_SETMOUSE 4
#define SPI_GETBORDER 5
#define SPI_SETBORDER 6
#define SPI_GETKEYBOARDSPEED 10
#define SPI_SETKEYBOARDSPEED 11
#define SPI_LANGDRIVER 12
#define SPI_ICONHORIZONTALSPACING 13
#define SPI_GETSCREENSAVETIMEOUT 14
#define SPI_SETSCREENSAVETIMEOUT 15
#define SPI_GETSCREENSAVEACTIVE 16
#define SPI_SETSCREENSAVEACTIVE 17
#define SPI_GETGRIDGRANULARITY 18
#define SPI_SETGRIDGRANULARITY 19
#define SPI_SETDESKWALLPAPER 20
#define SPI_SETDESKPATTERN 21
#define SPI_GETKEYBOARDDELAY 22
#define SPI_SETKEYBOARDDELAY 23
#define SPI_ICONVERTICALSPACING 24
#define SPI_GETICONTITLEWRAP 25
#define SPI_SETICONTITLEWRAP 26
#define SPI_GETMENUDROPALIGNMENT 27
#define SPI_SETMENUDROPALIGNMENT 28
#define SPI_SETDOUBLECLKWIDTH 29
#define SPI_SETDOUBLECLKHEIGHT 30
#define SPI_GETICONTITLELOGFONT 31
#define SPI_SETDOUBLECLICKTIME 32
#define SPI_SETMOUSEBUTTONSWAP 33
#define SPI_SETICONTITLELOGFONT 34
#define SPI_GETFASTTASKSWITCH 35
#define SPI_SETFASTTASKSWITCH 36
#define SPI_SETDRAGFULLWINDOWS 37
#define SPI_GETDRAGFULLWINDOWS 38
#define SPI_GETNONCLIENTMETRICS 41
#define SPI_SETNONCLIENTMETRICS 42
#define SPI_GETMINIMIZEDMETRICS 43
#define SPI_SETMINIMIZEDMETRICS 44
#define SPI_GETICONMETRICS 45
#define SPI_SETICONMETRICS 46
#define SPI_SETWORKAREA 47
#define SPI_GETWORKAREA 48
#define SPI_SETPENWINDOWS 49
#define SPI_GETFILTERKEYS 50
#define SPI_SETFILTERKEYS 51
#define SPI_GETTOGGLEKEYS 52
#define SPI_SETTOGGLEKEYS 53
#define SPI_GETMOUSEKEYS 54
#define SPI_SETMOUSEKEYS 55
#define SPI_GETSHOWSOUNDS 56
#define SPI_SETSHOWSOUNDS 57
#define SPI_GETSTICKYKEYS 58
#define SPI_SETSTICKYKEYS 59
#define SPI_GETACCESSTIMEOUT 60
#define SPI_SETACCESSTIMEOUT 61
#define SPI_GETSERIALKEYS 62
#define SPI_SETSERIALKEYS 63
#define SPI_GETSOUNDSENTRY 64
#define SPI_SETSOUNDSENTRY 65
#define SPI_GETHIGHCONTRAST 66
#define SPI_SETHIGHCONTRAST 67
#define SPI_GETKEYBOARDPREF 68
#define SPI_SETKEYBOARDPREF 69
#define SPI_GETSCREENREADER 70
#define SPI_SETSCREENREADER 71
#define SPI_GETANIMATION 72
#define SPI_SETANIMATION 73
#define SPI_GETFONTSMOOTHING 74
#define SPI_SETFONTSMOOTHING 75
#define SPI_SETDRAGWIDTH 76
#define SPI_SETDRAGHEIGHT 77
#define SPI_SETHANDHELD 78
#define SPI_GETLOWPOWERTIMEOUT 79
#define SPI_GETPOWEROFFTIMEOUT 80
#define SPI_SETLOWPOWERTIMEOUT 81
#define SPI_SETPOWEROFFTIMEOUT 82
#define SPI_GETLOWPOWERACTIVE 83
#define SPI_GETPOWEROFFACTIVE 84
#define SPI_SETLOWPOWERACTIVE 85
#define SPI_SETPOWEROFFACTIVE 86
#define SPI_SETCURSORS 87
#define SPI_SETICONS 88
#define SPI_GETDEFAULTINPUTLANG 89
#define SPI_SETDEFAULTINPUTLANG 90
#define SPI_SETLANGTOGGLE 91
#define SPI_GETWINDOWSEXTENSION 92
#define SPI_SETMOUSETRAILS 93
#define SPI_GETMOUSETRAILS 94
#define SPI_SCREENSAVERRUNNING 97
#define SPIF_UPDATEINIFILE 0x1
#define SPIF_SENDWININICHANGE 0x2
#define WM_DDE_FIRST 0x3E0
#define WM_DDE_INITIATE (WM_DDE_FIRST)
#define WM_DDE_TERMINATE (WM_DDE_FIRST + 1)
#define WM_DDE_ADVISE (WM_DDE_FIRST + 2)
#define WM_DDE_UNADVISE (WM_DDE_FIRST + 3)
#define WM_DDE_ACK (WM_DDE_FIRST + 4)
#define WM_DDE_DATA (WM_DDE_FIRST + 5)
#define WM_DDE_REQUEST (WM_DDE_FIRST + 6)
#define WM_DDE_POKE (WM_DDE_FIRST + 7)
#define WM_DDE_EXECUTE (WM_DDE_FIRST + 8)
#define WM_DDE_LAST (WM_DDE_FIRST + 8)
#define XST_NULL 0
#define XST_INCOMPLETE 1
#define XST_CONNECTED 2
#define XST_INIT1 3
#define XST_INIT2 4
#define XST_REQSENT 5
#define XST_DATARCVD 6
#define XST_POKESENT 7
#define XST_POKEACKRCVD 8
#define XST_EXECSENT 9
#define XST_EXECACKRCVD 10
#define XST_ADVSENT 11
#define XST_UNADVSENT 12
#define XST_ADVACKRCVD 13
#define XST_UNADVACKRCVD 14
#define XST_ADVDATASENT 15
#define XST_ADVDATAACKRCVD 16
#define CADV_LATEACK 0xFFFF
#define ST_CONNECTED 0x1
#define ST_ADVISE 0x2
#define ST_ISLOCAL 0x4
#define ST_BLOCKED 0x8
#define ST_CLIENT 0x10
#define ST_TERMINATED 0x20
#define ST_INLIST 0x40
#define ST_BLOCKNEXT 0x80
#define ST_ISSELF 0x100
#define DDE_FACK 0x8000
#define DDE_FBUSY 0x4000
#define DDE_FDEFERUPD 0x4000
#define DDE_FACKREQ 0x8000
#define DDE_FRELEASE 0x2000
#define DDE_FREQUESTED 0x1000
#define DDE_FAPPSTATUS 0xFF
#define DDE_FNOTPROCESSED 0x0
#define DDE_FACKRESERVED (~(DDE_FACK|DDE_FBUSY|DDE_FAPPSTATUS))
#define DDE_FADVRESERVED (~(DDE_FACKREQ|DDE_FDEFERUPD))
#define DDE_FDATRESERVED (~(DDE_FACKREQ|DDE_FRELEASE|DDE_FREQUESTED))
#define DDE_FPOKRESERVED (~(DDE_FRELEASE))
#define MSGF_DDEMGR 0x8001
#define CP_WINANSI 1004
#define CP_WINUNICODE 1200
#define XTYPF_NOBLOCK 0x2
#define XTYPF_NODATA 0x4
#define XTYPF_ACKREQ 0x8
#define XCLASS_MASK 0xFC00
#define XCLASS_BOOL 0x1000
#define XCLASS_DATA 0x2000
#define XCLASS_FLAGS 0x4000
#define XCLASS_NOTIFICATION 0x8000
#define XTYP_ERROR (0x0|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define XTYP_ADVDATA (0x10|XCLASS_FLAGS)
#define XTYP_ADVREQ (0x20|XCLASS_DATA|XTYPF_NOBLOCK)
#define XTYP_ADVSTART (0x30|XCLASS_BOOL)
#define XTYP_ADVSTOP (0x40|XCLASS_NOTIFICATION)
#define XTYP_EXECUTE (0x50|XCLASS_FLAGS)
#define XTYP_CONNECT (0x60|XCLASS_BOOL|XTYPF_NOBLOCK)
#define XTYP_CONNECT_CONFIRM (0x70|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define XTYP_XACT_COMPLETE (0x80|XCLASS_NOTIFICATION)
#define XTYP_POKE (0x90|XCLASS_FLAGS)
#define XTYP_REGISTER (0xA0|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define XTYP_REQUEST (0xB0|XCLASS_DATA)
#define XTYP_DISCONNECT (0xC0|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define XTYP_UNREGISTER (0xD0|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define XTYP_WILDCONNECT (0xE0|XCLASS_DATA|XTYPF_NOBLOCK)
#define XTYP_MASK 0xF0
#define XTYP_SHIFT 4
#define TIMEOUT_ASYNC 0xFFFF
#define QID_SYNC 0xFFFF
#define SZDDESYS_TOPIC "System"
#define SZDDESYS_ITEM_TOPICS "Topics"
#define SZDDESYS_ITEM_SYSITEMS "SysItems"
#define SZDDESYS_ITEM_RTNMSG "ReturnMessage"
#define SZDDESYS_ITEM_STATUS "Status"
#define SZDDESYS_ITEM_FORMATS "Formats"
#define SZDDESYS_ITEM_HELP "Help"
#define SZDDE_ITEM_ITEMLIST "TopicItemList"
#define CBR_BLOCK 0xFFFF
#define CBF_FAIL_SELFCONNECTIONS 0x1000
#define CBF_FAIL_CONNECTIONS 0x2000
#define CBF_FAIL_ADVISES 0x4000
#define CBF_FAIL_EXECUTES 0x8000
#define CBF_FAIL_POKES 0x10000
#define CBF_FAIL_REQUESTS 0x20000
#define CBF_FAIL_ALLSVRXACTIONS 0x3F000
#define CBF_SKIP_CONNECT_CONFIRMS 0x40000
#define CBF_SKIP_REGISTRATIONS 0x80000
#define CBF_SKIP_UNREGISTRATIONS 0x100000
#define CBF_SKIP_DISCONNECTS 0x200000
#define CBF_SKIP_ALLNOTIFICATIONS 0x3C0000
#define APPCMD_CLIENTONLY 0x10
#define APPCMD_FILTERINITS 0x20
#define APPCMD_MASK 0xFF0
#define APPCLASS_STANDARD 0x0
#define APPCLASS_MASK 0xF
#define EC_ENABLEALL 0
#define EC_ENABLEONE ST_BLOCKNEXT
#define EC_DISABLE ST_BLOCKED
#define EC_QUERYWAITING 2
#define DNS_REGISTER 0x1
#define DNS_UNREGISTER 0x2
#define DNS_FILTERON 0x4
#define DNS_FILTEROFF 0x8
#define HDATA_APPOWNED 0x1
#define DMLERR_NO_ERROR 0
#define DMLERR_FIRST 0x4000
#define DMLERR_ADVACKTIMEOUT 0x4000
#define DMLERR_BUSY 0x4001
#define DMLERR_DATAACKTIMEOUT 0x4002
#define DMLERR_DLL_NOT_INITIALIZED 0x4003
#define DMLERR_DLL_USAGE 0x4004
#define DMLERR_EXECACKTIMEOUT 0x4005
#define DMLERR_INVALIDPARAMETER 0x4006
#define DMLERR_LOW_MEMORY 0x4007
#define DMLERR_MEMORY_ERROR 0x4008
#define DMLERR_NOTPROCESSED 0x4009
#define DMLERR_NO_CONV_ESTABLISHED 0x400A
#define DMLERR_POKEACKTIMEOUT 0x400B
#define DMLERR_POSTMSG_FAILED 0x400C
#define DMLERR_REENTRANCY 0x400D
#define DMLERR_SERVER_DIED 0x400E
#define DMLERR_SYS_ERROR 0x400F
#define DMLERR_UNADVACKTIMEOUT 0x4010
#define DMLERR_UNFOUND_QUEUE_ID 0x4011
#define DMLERR_LAST 0x4011
#define MH_CREATE 1
#define MH_KEEP 2
#define MH_DELETE 3
#define MH_CLEANUP 4
#define MAX_MONITORS 4
#define APPCLASS_MONITOR 0x1
#define XTYP_MONITOR (0xF0|XCLASS_NOTIFICATION|XTYPF_NOBLOCK)
#define MF_HSZ_INFO 0x1000000
#define MF_SENDMSGS 0x2000000
#define MF_POSTMSGS 0x4000000
#define MF_CALLBACKS 0x8000000
#define MF_ERRORS 0x10000000
#define MF_LINKS 0x20000000
#define MF_CONV 0x40000000
#define MF_MASK 0xFF000000
#define NO_ERROR 0
#define ERROR_SUCCESS 0
#define ERROR_INVALID_FUNCTION 1
#define ERROR_FILE_NOT_FOUND 2
#define ERROR_PATH_NOT_FOUND 3
#define ERROR_TOO_MANY_OPEN_FILES 4
#define ERROR_ACCESS_DENIED 5
#define ERROR_INVALID_HANDLE 6
#define ERROR_ARENA_TRASHED 7
#define ERROR_NOT_ENOUGH_MEMORY 8
#define ERROR_INVALID_BLOCK 9
#define ERROR_BAD_ENVIRONMENT 10
#define ERROR_BAD_FORMAT 11
#define ERROR_INVALID_ACCESS 12
#define ERROR_INVALID_DATA 13
#define ERROR_OUTOFMEMORY 14
#define ERROR_INVALID_DRIVE 15
#define ERROR_CURRENT_DIRECTORY 16
#define ERROR_NOT_SAME_DEVICE 17
#define ERROR_NO_MORE_FILES 18
#define ERROR_WRITE_PROTECT 19
#define ERROR_BAD_UNIT 20
#define ERROR_NOT_READY 21
#define ERROR_BAD_COMMAND 22
#define ERROR_CRC 23
#define ERROR_BAD_LENGTH 24
#define ERROR_SEEK 25
#define ERROR_NOT_DOS_DISK 26
#define ERROR_SECTOR_NOT_FOUND 27
#define ERROR_OUT_OF_PAPER 28
#define ERROR_WRITE_FAULT 29
#define ERROR_READ_FAULT 30
#define ERROR_GEN_FAILURE 31
#define ERROR_SHARING_VIOLATION 32
#define ERROR_LOCK_VIOLATION 33
#define ERROR_WRONG_DISK 34
#define ERROR_SHARING_BUFFER_EXCEEDED 36
#define ERROR_HANDLE_EOF 38
#define ERROR_HANDLE_DISK_FULL 39
#define ERROR_NOT_SUPPORTED 50
#define ERROR_REM_NOT_LIST 51
#define ERROR_DUP_NAME 52
#define ERROR_BAD_NETPATH 53
#define ERROR_NETWORK_BUSY 54
#define ERROR_DEV_NOT_EXIST 55
#define ERROR_TOO_MANY_CMDS 56
#define ERROR_ADAP_HDW_ERR 57
#define ERROR_BAD_NET_RESP 58
#define ERROR_UNEXP_NET_ERR 59
#define ERROR_BAD_REM_ADAP 60
#define ERROR_PRINTQ_FULL 61
#define ERROR_NO_SPOOL_SPACE 62
#define ERROR_PRINT_CANCELLED 63
#define ERROR_NETNAME_DELETED 64
#define ERROR_NETWORK_ACCESS_DENIED 65
#define ERROR_BAD_DEV_TYPE 66
#define ERROR_BAD_NET_NAME 67
#define ERROR_TOO_MANY_NAMES 68
#define ERROR_TOO_MANY_SESS 69
#define ERROR_SHARING_PAUSED 70
#define ERROR_REQ_NOT_ACCEP 71
#define ERROR_REDIR_PAUSED 72
#define ERROR_FILE_EXISTS 80
#define ERROR_CANNOT_MAKE 82
#define ERROR_FAIL_I24 83
#define ERROR_OUT_OF_STRUCTURES 84
#define ERROR_ALREADY_ASSIGNED 85
#define ERROR_INVALID_PASSWORD 86
#define ERROR_INVALID_PARAMETER 87
#define ERROR_NET_WRITE_FAULT 88
#define ERROR_NO_PROC_SLOTS 89
#define ERROR_TOO_MANY_SEMAPHORES 100
#define ERROR_EXCL_SEM_ALREADY_OWNED 101
#define ERROR_SEM_IS_SET 102
#define ERROR_TOO_MANY_SEM_REQUESTS 103
#define ERROR_INVALID_AT_INTERRUPT_TIME 104
#define ERROR_SEM_OWNER_DIED 105
#define ERROR_SEM_USER_LIMIT 106
#define ERROR_DISK_CHANGE 107
#define ERROR_DRIVE_LOCKED 108
#define ERROR_BROKEN_PIPE 109
#define ERROR_OPEN_FAILED 110
#define ERROR_BUFFER_OVERFLOW 111
#define ERROR_DISK_FULL 112
#define ERROR_NO_MORE_SEARCH_HANDLES 113
#define ERROR_INVALID_TARGET_HANDLE 114
#define ERROR_INVALID_CATEGORY 117
#define ERROR_INVALID_VERIFY_SWITCH 118
#define ERROR_BAD_DRIVER_LEVEL 119
#define ERROR_CALL_NOT_IMPLEMENTED 120
#define ERROR_SEM_TIMEOUT 121
#define ERROR_INSUFFICIENT_BUFFER 122
#define ERROR_INVALID_NAME 123
#define ERROR_INVALID_LEVEL 124
#define ERROR_NO_VOLUME_LABEL 125
#define ERROR_MOD_NOT_FOUND 126
#define ERROR_PROC_NOT_FOUND 127
#define ERROR_WAIT_NO_CHILDREN 128
#define ERROR_CHILD_NOT_COMPLETE 129
#define ERROR_DIRECT_ACCESS_HANDLE 130
#define ERROR_NEGATIVE_SEEK 131
#define ERROR_SEEK_ON_DEVICE 132
#define ERROR_IS_JOIN_TARGET 133
#define ERROR_IS_JOINED 134
#define ERROR_IS_SUBSTED 135
#define ERROR_NOT_JOINED 136
#define ERROR_NOT_SUBSTED 137
#define ERROR_JOIN_TO_JOIN 138
#define ERROR_SUBST_TO_SUBST 139
#define ERROR_JOIN_TO_SUBST 140
#define ERROR_SUBST_TO_JOIN 141
#define ERROR_BUSY_DRIVE 142
#define ERROR_SAME_DRIVE 143
#define ERROR_DIR_NOT_ROOT 144
#define ERROR_DIR_NOT_EMPTY 145
#define ERROR_IS_SUBST_PATH 146
#define ERROR_IS_JOIN_PATH 147
#define ERROR_PATH_BUSY 148
#define ERROR_IS_SUBST_TARGET 149
#define ERROR_SYSTEM_TRACE 150
#define ERROR_INVALID_EVENT_COUNT 151
#define ERROR_TOO_MANY_MUXWAITERS 152
#define ERROR_INVALID_LIST_FORMAT 153
#define ERROR_LABEL_TOO_LONG 154
#define ERROR_TOO_MANY_TCBS 155
#define ERROR_SIGNAL_REFUSED 156
#define ERROR_DISCARDED 157
#define ERROR_NOT_LOCKED 158
#define ERROR_BAD_THREADID_ADDR 159
#define ERROR_BAD_ARGUMENTS 160
#define ERROR_BAD_PATHNAME 161
#define ERROR_SIGNAL_PENDING 162
#define ERROR_MAX_THRDS_REACHED 164
#define ERROR_LOCK_FAILED 167
#define ERROR_BUSY 170
#define ERROR_CANCEL_VIOLATION 173
#define ERROR_ATOMIC_LOCKS_NOT_SUPPORTED 174
#define ERROR_INVALID_SEGMENT_NUMBER 180
#define ERROR_INVALID_ORDINAL 182
#define ERROR_ALREADY_EXISTS 183
#define ERROR_INVALID_FLAG_NUMBER 186
#define ERROR_SEM_NOT_FOUND 187
#define ERROR_INVALID_STARTING_CODESEG 188
#define ERROR_INVALID_STACKSEG 189
#define ERROR_INVALID_MODULETYPE 190
#define ERROR_INVALID_EXE_SIGNATURE 191
#define ERROR_EXE_MARKED_INVALID 192
#define ERROR_BAD_EXE_FORMAT 193
#define ERROR_ITERATED_DATA_EXCEEDS_64k 194
#define ERROR_INVALID_MINALLOCSIZE 195
#define ERROR_DYNLINK_FROM_INVALID_RING 196
#define ERROR_IOPL_NOT_ENABLED 197
#define ERROR_INVALID_SEGDPL 198
#define ERROR_AUTODATASEG_EXCEEDS_64k 199
#define ERROR_RING2SEG_MUST_BE_MOVABLE 200
#define ERROR_RELOC_CHAIN_XEEDS_SEGLIM 201
#define ERROR_INFLOOP_IN_RELOC_CHAIN 202
#define ERROR_ENVVAR_NOT_FOUND 203
#define ERROR_NO_SIGNAL_SENT 205
#define ERROR_FILENAME_EXCED_RANGE 206
#define ERROR_RING2_STACK_IN_USE 207
#define ERROR_META_EXPANSION_TOO_LONG 208
#define ERROR_INVALID_SIGNAL_NUMBER 209
#define ERROR_THREAD_1_INACTIVE 210
#define ERROR_LOCKED 212
#define ERROR_TOO_MANY_MODULES 214
#define ERROR_NESTING_NOT_ALLOWED 215
#define ERROR_BAD_PIPE 230
#define ERROR_PIPE_BUSY 231
#define ERROR_NO_DATA 232
#define ERROR_PIPE_NOT_CONNECTED 233
#define ERROR_MORE_DATA 234
#define ERROR_VC_DISCONNECTED 240
#define ERROR_INVALID_EA_NAME 254
#define ERROR_EA_LIST_INCONSISTENT 255
#define ERROR_NO_MORE_ITEMS 259
#define ERROR_CANNOT_COPY 266
#define ERROR_DIRECTORY 267
#define ERROR_EAS_DIDNT_FIT 275
#define ERROR_EA_FILE_CORRUPT 276
#define ERROR_EA_TABLE_FULL 277
#define ERROR_INVALID_EA_HANDLE 278
#define ERROR_EAS_NOT_SUPPORTED 282
#define ERROR_NOT_OWNER 288
#define ERROR_TOO_MANY_POSTS 298
#define ERROR_MR_MID_NOT_FOUND 317
#define ERROR_INVALID_ADDRESS 487
#define ERROR_ARITHMETIC_OVERFLOW 534
#define ERROR_PIPE_CONNECTED 535
#define ERROR_PIPE_LISTENING 536
#define ERROR_EA_ACCESS_DENIED 994
#define ERROR_OPERATION_ABORTED 995
#define ERROR_IO_INCOMPLETE 996
#define ERROR_IO_PENDING 997
#define ERROR_NOACCESS 998
#define ERROR_SWAPERROR 999
#define ERROR_STACK_OVERFLOW 1001
#define ERROR_INVALID_MESSAGE 1002
#define ERROR_CAN_NOT_COMPLETE 1003
#define ERROR_INVALID_FLAGS 1004
#define ERROR_UNRECOGNIZED_VOLUME 1005
#define ERROR_FILE_INVALID 1006
#define ERROR_FULLSCREEN_MODE 1007
#define ERROR_NO_TOKEN 1008
#define ERROR_BADDB 1009
#define ERROR_BADKEY 1010
#define ERROR_CANTOPEN 1011
#define ERROR_CANTREAD 1012
#define ERROR_CANTWRITE 1013
#define ERROR_REGISTRY_RECOVERED 1014
#define ERROR_REGISTRY_CORRUPT 1015
#define ERROR_REGISTRY_IO_FAILED 1016
#define ERROR_NOT_REGISTRY_FILE 1017
#define ERROR_KEY_DELETED 1018
#define ERROR_NO_LOG_SPACE 1019
#define ERROR_KEY_HAS_CHILDREN 1020
#define ERROR_CHILD_MUST_BE_VOLATILE 1021
#define ERROR_NOTIFY_ENUM_DIR 1022
#define ERROR_DEPENDENT_SERVICES_RUNNING 1051
#define ERROR_INVALID_SERVICE_CONTROL 1052
#define ERROR_SERVICE_REQUEST_TIMEOUT 1053
#define ERROR_SERVICE_NO_THREAD 1054
#define ERROR_SERVICE_DATABASE_LOCKED 1055
#define ERROR_SERVICE_ALREADY_RUNNING 1056
#define ERROR_INVALID_SERVICE_ACCOUNT 1057
#define ERROR_SERVICE_DISABLED 1058
#define ERROR_CIRCULAR_DEPENDENCY 1059
#define ERROR_SERVICE_DOES_NOT_EXIST 1060
#define ERROR_SERVICE_CANNOT_ACCEPT_CTRL 1061
#define ERROR_SERVICE_NOT_ACTIVE 1062
#define ERROR_FAILED_SERVICE_CONTROLLER_CONNECT 1063
#define ERROR_EXCEPTION_IN_SERVICE 1064
#define ERROR_DATABASE_DOES_NOT_EXIST 1065
#define ERROR_SERVICE_SPECIFIC_ERROR 1066
#define ERROR_PROCESS_ABORTED 1067
#define ERROR_SERVICE_DEPENDENCY_FAIL 1068
#define ERROR_SERVICE_LOGON_FAILED 1069
#define ERROR_SERVICE_START_HANG 1070
#define ERROR_INVALID_SERVICE_LOCK 1071
#define ERROR_SERVICE_MARKED_FOR_DELETE 1072
#define ERROR_SERVICE_EXISTS 1073
#define ERROR_ALREADY_RUNNING_LKG 1074
#define ERROR_SERVICE_DEPENDENCY_DELETED 1075
#define ERROR_BOOT_ALREADY_ACCEPTED 1076
#define ERROR_SERVICE_NEVER_STARTED 1077
#define ERROR_DUPLICATE_SERVICE_NAME 1078
#define ERROR_END_OF_MEDIA 1100
#define ERROR_FILEMARK_DETECTED 1101
#define ERROR_BEGINNING_OF_MEDIA 1102
#define ERROR_SETMARK_DETECTED 1103
#define ERROR_NO_DATA_DETECTED 1104
#define ERROR_PARTITION_FAILURE 1105
#define ERROR_INVALID_BLOCK_LENGTH 1106
#define ERROR_DEVICE_NOT_PARTITIONED 1107
#define ERROR_UNABLE_TO_LOCK_MEDIA 1108
#define ERROR_UNABLE_TO_UNLOAD_MEDIA 1109
#define ERROR_MEDIA_CHANGED 1110
#define ERROR_BUS_RESET 1111
#define ERROR_NO_MEDIA_IN_DRIVE 1112
#define ERROR_NO_UNICODE_TRANSLATION 1113
#define ERROR_DLL_INIT_FAILED 1114
#define ERROR_SHUTDOWN_IN_PROGRESS 1115
#define ERROR_NO_SHUTDOWN_IN_PROGRESS 1116
#define ERROR_IO_DEVICE 1117
#define ERROR_SERIAL_NO_DEVICE 1118
#define ERROR_IRQ_BUSY 1119
#define ERROR_MORE_WRITES 1120
#define ERROR_COUNTER_TIMEOUT 1121
#define ERROR_FLOPPY_ID_MARK_NOT_FOUND 1122
#define ERROR_FLOPPY_WRONG_CYLINDER 1123
#define ERROR_FLOPPY_UNKNOWN_ERROR 1124
#define ERROR_FLOPPY_BAD_REGISTERS 1125
#define ERROR_DISK_RECALIBRATE_FAILED 1126
#define ERROR_DISK_OPERATION_FAILED 1127
#define ERROR_DISK_RESET_FAILED 1128
#define ERROR_EOM_OVERFLOW 1129
#define ERROR_NOT_ENOUGH_SERVER_MEMORY 1130
#define ERROR_POSSIBLE_DEADLOCK 1131
#define ERROR_MAPPED_ALIGNMENT 1132
#define ERROR_INVALID_PIXEL_FORMAT 2000
#define ERROR_BAD_DRIVER 2001
#define ERROR_INVALID_WINDOW_STYLE 2002
#define ERROR_METAFILE_NOT_SUPPORTED 2003
#define ERROR_TRANSFORM_NOT_SUPPORTED 2004
#define ERROR_CLIPPING_NOT_SUPPORTED 2005
#define ERROR_UNKNOWN_PRINT_MONITOR 3000
#define ERROR_PRINTER_DRIVER_IN_USE 3001
#define ERROR_SPOOL_FILE_NOT_FOUND 3002
#define ERROR_SPL_NO_STARTDOC 3003
#define ERROR_SPL_NO_ADDJOB 3004
#define ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED 3005
#define ERROR_PRINT_MONITOR_ALREADY_INSTALLED 3006
#define ERROR_WINS_INTERNAL 4000
#define ERROR_CAN_NOT_DEL_LOCAL_WINS 4001
#define ERROR_STATIC_INIT 4002
#define ERROR_INC_BACKUP 4003
#define ERROR_FULL_BACKUP 4004
#define ERROR_REC_NON_EXISTENT 4005
#define ERROR_RPL_NOT_ALLOWED 4006
#define SEVERITY_SUCCESS 0
#define SEVERITY_ERROR 1
#define FACILITY_NT_BIT 0x10000000
#define NOERROR 0
#define E_UNEXPECTED 0x8000FFFF
#define E_NOTIMPL 0x80004001
#define E_OUTOFMEMORY 0x8007000E
#define E_INVALIDARG 0x80070057
#define E_NOINTERFACE 0x80004002
#define E_POINTER 0x80004003
#define E_HANDLE 0x80070006
#define E_ABORT 0x80004004
#define E_FAIL 0x80004005
#define E_ACCESSDENIED 0x80070005
#define CO_E_INIT_TLS 0x80004006
#define CO_E_INIT_SHARED_ALLOCATOR 0x80004007
#define CO_E_INIT_MEMORY_ALLOCATOR 0x80004008
#define CO_E_INIT_CLASS_CACHE 0x80004009
#define CO_E_INIT_RPC_CHANNEL 0x8000400A
#define CO_E_INIT_TLS_SET_CHANNEL_CONTROL 0x8000400B
#define CO_E_INIT_TLS_CHANNEL_CONTROL 0x8000400C
#define CO_E_INIT_UNACCEPTED_USER_ALLOCATOR 0x8000400D
#define CO_E_INIT_SCM_MUTEX_EXISTS 0x8000400E
#define CO_E_INIT_SCM_FILE_MAPPING_EXISTS 0x8000400F
#define CO_E_INIT_SCM_MAP_VIEW_OF_FILE 0x80004010
#define CO_E_INIT_SCM_EXEC_FAILURE 0x80004011
#define CO_E_INIT_ONLY_SINGLE_THREADED 0x80004012
#define S_OK 0x0
#define S_FALSE 0x1
#define OLE_E_FIRST 0x80040000
#define OLE_E_LAST 0x800400FF
#define OLE_S_FIRST 0x40000
#define OLE_S_LAST 0x400FF
#define OLE_E_OLEVERB 0x80040000
#define OLE_E_ADVF 0x80040001
#define OLE_E_ENUM_NOMORE 0x80040002
#define OLE_E_ADVISENOTSUPPORTED 0x80040003
#define OLE_E_NOCONNECTION 0x80040004
#define OLE_E_NOTRUNNING 0x80040005
#define OLE_E_NOCACHE 0x80040006
#define OLE_E_BLANK 0x80040007
#define OLE_E_CLASSDIFF 0x80040008
#define OLE_E_CANT_GETMONIKER 0x80040009
#define OLE_E_CANT_BINDTOSOURCE 0x8004000A
#define OLE_E_STATIC 0x8004000B
#define OLE_E_PROMPTSAVECANCELLED 0x8004000C
#define OLE_E_INVALIDRECT 0x8004000D
#define OLE_E_WRONGCOMPOBJ 0x8004000E
#define OLE_E_INVALIDHWND 0x8004000F
#define OLE_E_NOT_INPLACEACTIVE 0x80040010
#define OLE_E_CANTCONVERT 0x80040011
#define OLE_E_NOSTORAGE 0x80040012
#define DV_E_FORMATETC 0x80040064
#define DV_E_DVTARGETDEVICE 0x80040065
#define DV_E_STGMEDIUM 0x80040066
#define DV_E_STATDATA 0x80040067
#define DV_E_LINDEX 0x80040068
#define DV_E_TYMED 0x80040069
#define DV_E_CLIPFORMAT 0x8004006A
#define DV_E_DVASPECT 0x8004006B
#define DV_E_DVTARGETDEVICE_SIZE 0x8004006C
#define DV_E_NOIVIEWOBJECT 0x8004006D
#define DRAGDROP_E_FIRST 0x80040100
#define DRAGDROP_E_LAST 0x8004010F
#define DRAGDROP_S_FIRST 0x40100
#define DRAGDROP_S_LAST 0x4010F
#define DRAGDROP_E_NOTREGISTERED 0x80040100
#define DRAGDROP_E_ALREADYREGISTERED 0x80040101
#define DRAGDROP_E_INVALIDHWND 0x80040102
#define CLASSFACTORY_E_FIRST 0x80040110
#define CLASSFACTORY_E_LAST 0x8004011F
#define CLASSFACTORY_S_FIRST 0x40110
#define CLASSFACTORY_S_LAST 0x4011F
#define CLASS_E_NOAGGREGATION 0x80040110
#define CLASS_E_CLASSNOTAVAILABLE 0x80040111
#define MARSHAL_E_FIRST 0x80040120
#define MARSHAL_E_LAST 0x8004012F
#define MARSHAL_S_FIRST 0x40120
#define MARSHAL_S_LAST 0x4012F
#define DATA_E_FIRST 0x80040130
#define DATA_E_LAST 0x8004013F
#define DATA_S_FIRST 0x40130
#define DATA_S_LAST 0x4013F
#define VIEW_E_FIRST 0x80040140
#define VIEW_E_LAST 0x8004014F
#define VIEW_S_FIRST 0x40140
#define VIEW_S_LAST 0x4014F
#define VIEW_E_DRAW 0x80040140
#define REGDB_E_FIRST 0x80040150
#define REGDB_E_LAST 0x8004015F
#define REGDB_S_FIRST 0x40150
#define REGDB_S_LAST 0x4015F
#define REGDB_E_READREGDB 0x80040150
#define REGDB_E_WRITEREGDB 0x80040151
#define REGDB_E_KEYMISSING 0x80040152
#define REGDB_E_INVALIDVALUE 0x80040153
#define REGDB_E_CLASSNOTREG 0x80040154
#define REGDB_E_IIDNOTREG 0x80040155
#define CACHE_E_FIRST 0x80040170
#define CACHE_E_LAST 0x8004017F
#define CACHE_S_FIRST 0x40170
#define CACHE_S_LAST 0x4017F
#define CACHE_E_NOCACHE_UPDATED 0x80040170
#define OLEOBJ_E_FIRST 0x80040180
#define OLEOBJ_E_LAST 0x8004018F
#define OLEOBJ_S_FIRST 0x40180
#define OLEOBJ_S_LAST 0x4018F
#define OLEOBJ_E_NOVERBS 0x80040180
#define OLEOBJ_E_INVALIDVERB 0x80040181
#define CLIENTSITE_E_FIRST 0x80040190
#define CLIENTSITE_E_LAST 0x8004019F
#define CLIENTSITE_S_FIRST 0x40190
#define CLIENTSITE_S_LAST 0x4019F
#define INPLACE_E_NOTUNDOABLE 0x800401A0
#define INPLACE_E_NOTOOLSPACE 0x800401A1
#define INPLACE_E_FIRST 0x800401A0
#define INPLACE_E_LAST 0x800401AF
#define INPLACE_S_FIRST 0x401A0
#define INPLACE_S_LAST 0x401AF
#define ENUM_E_FIRST 0x800401B0
#define ENUM_E_LAST 0x800401BF
#define ENUM_S_FIRST 0x401B0
#define ENUM_S_LAST 0x401BF
#define CONVERT10_E_FIRST 0x800401C0
#define CONVERT10_E_LAST 0x800401CF
#define CONVERT10_S_FIRST 0x401C0
#define CONVERT10_S_LAST 0x401CF
#define CONVERT10_E_OLESTREAM_GET 0x800401C0
#define CONVERT10_E_OLESTREAM_PUT 0x800401C1
#define CONVERT10_E_OLESTREAM_FMT 0x800401C2
#define CONVERT10_E_OLESTREAM_BITMAP_TO_DIB 0x800401C3
#define CONVERT10_E_STG_FMT 0x800401C4
#define CONVERT10_E_STG_NO_STD_STREAM 0x800401C5
#define CONVERT10_E_STG_DIB_TO_BITMAP 0x800401C6
#define CLIPBRD_E_FIRST 0x800401D0
#define CLIPBRD_E_LAST 0x800401DF
#define CLIPBRD_S_FIRST 0x401D0
#define CLIPBRD_S_LAST 0x401DF
#define CLIPBRD_E_CANT_OPEN 0x800401D0
#define CLIPBRD_E_CANT_EMPTY 0x800401D1
#define CLIPBRD_E_CANT_SET 0x800401D2
#define CLIPBRD_E_BAD_DATA 0x800401D3
#define CLIPBRD_E_CANT_CLOSE 0x800401D4
#define MK_E_FIRST 0x800401E0
#define MK_E_LAST 0x800401EF
#define MK_S_FIRST 0x401E0
#define MK_S_LAST 0x401EF
#define MK_E_CONNECTMANUALLY 0x800401E0
#define MK_E_EXCEEDEDDEADLINE 0x800401E1
#define MK_E_NEEDGENERIC 0x800401E2
#define MK_E_UNAVAILABLE 0x800401E3
#define MK_E_SYNTAX 0x800401E4
#define MK_E_NOOBJECT 0x800401E5
#define MK_E_INVALIDEXTENSION 0x800401E6
#define MK_E_INTERMEDIATEINTERFACENOTSUPPORTED 0x800401E7
#define MK_E_NOTBINDABLE 0x800401E8
#define MK_E_NOTBOUND 0x800401E9
#define MK_E_CANTOPENFILE 0x800401EA
#define MK_E_MUSTBOTHERUSER 0x800401EB
#define MK_E_NOINVERSE 0x800401EC
#define MK_E_NOSTORAGE 0x800401ED
#define MK_E_NOPREFIX 0x800401EE
#define MK_E_ENUMERATION_FAILED 0x800401EF
#define CO_E_FIRST 0x800401F0
#define CO_E_LAST 0x800401FF
#define CO_S_FIRST 0x401F0
#define CO_S_LAST 0x401FF
#define CO_E_NOTINITIALIZED 0x800401F0
#define CO_E_ALREADYINITIALIZED 0x800401F1
#define CO_E_CANTDETERMINECLASS 0x800401F2
#define CO_E_CLASSSTRING 0x800401F3
#define CO_E_IIDSTRING 0x800401F4
#define CO_E_APPNOTFOUND 0x800401F5
#define CO_E_APPSINGLEUSE 0x800401F6
#define CO_E_ERRORINAPP 0x800401F7
#define CO_E_DLLNOTFOUND 0x800401F8
#define CO_E_ERRORINDLL 0x800401F9
#define CO_E_WRONGOSFORAPP 0x800401FA
#define CO_E_OBJNOTREG 0x800401FB
#define CO_E_OBJISREG 0x800401FC
#define CO_E_OBJNOTCONNECTED 0x800401FD
#define CO_E_APPDIDNTREG 0x800401FE
#define CO_E_RELEASED 0x800401FF
#define OLE_S_USEREG 0x40000
#define OLE_S_STATIC 0x40001
#define OLE_S_MAC_CLIPFORMAT 0x40002
#define DRAGDROP_S_DROP 0x40100
#define DRAGDROP_S_CANCEL 0x40101
#define DRAGDROP_S_USEDEFAULTCURSORS 0x40102
#define DATA_S_SAMEFORMATETC 0x40130
#define VIEW_S_ALREADY_FROZEN 0x40140
#define CACHE_S_FORMATETC_NOTSUPPORTED 0x40170
#define CACHE_S_SAMECACHE 0x40171
#define CACHE_S_SOMECACHES_NOTUPDATED 0x40172
#define OLEOBJ_S_INVALIDVERB 0x40180
#define OLEOBJ_S_CANNOT_DOVERB_NOW 0x40181
#define OLEOBJ_S_INVALIDHWND 0x40182
#define INPLACE_S_TRUNCATED 0x401A0
#define CONVERT10_S_NO_PRESENTATION 0x401C0
#define MK_S_REDUCED_TO_SELF 0x401E2
#define MK_S_ME 0x401E4
#define MK_S_HIM 0x401E5
#define MK_S_US 0x401E6
#define MK_S_MONIKERALREADYREGISTERED 0x401E7
#define CO_E_CLASS_CREATE_FAILED 0x80080001
#define CO_E_SCM_ERROR 0x80080002
#define CO_E_SCM_RPC_FAILURE 0x80080003
#define CO_E_BAD_PATH 0x80080004
#define CO_E_SERVER_EXEC_FAILURE 0x80080005
#define CO_E_OBJSRV_RPC_FAILURE 0x80080006
#define MK_E_NO_NORMALIZED 0x80080007
#define CO_E_SERVER_STOPPING 0x80080008
#define MEM_E_INVALID_ROOT 0x80080009
#define MEM_E_INVALID_LINK 0x80080010
#define MEM_E_INVALID_SIZE 0x80080011
#define DISP_E_UNKNOWNINTERFACE 0x80020001
#define DISP_E_MEMBERNOTFOUND 0x80020003
#define DISP_E_PARAMNOTFOUND 0x80020004
#define DISP_E_TYPEMISMATCH 0x80020005
#define DISP_E_UNKNOWNNAME 0x80020006
#define DISP_E_NONAMEDARGS 0x80020007
#define DISP_E_BADVARTYPE 0x80020008
#define DISP_E_EXCEPTION 0x80020009
#define DISP_E_OVERFLOW 0x8002000A
#define DISP_E_BADINDEX 0x8002000B
#define DISP_E_UNKNOWNLCID 0x8002000C
#define DISP_E_ARRAYISLOCKED 0x8002000D
#define DISP_E_BADPARAMCOUNT 0x8002000E
#define DISP_E_PARAMNOTOPTIONAL 0x8002000F
#define DISP_E_BADCALLEE 0x80020010
#define DISP_E_NOTACOLLECTION 0x80020011
#define TYPE_E_BUFFERTOOSMALL 0x80028016
#define TYPE_E_INVDATAREAD 0x80028018
#define TYPE_E_UNSUPFORMAT 0x80028019
#define TYPE_E_REGISTRYACCESS 0x8002801C
#define TYPE_E_LIBNOTREGISTERED 0x8002801D
#define TYPE_E_UNDEFINEDTYPE 0x80028027
#define TYPE_E_QUALIFIEDNAMEDISALLOWED 0x80028028
#define TYPE_E_INVALIDSTATE 0x80028029
#define TYPE_E_WRONGTYPEKIND 0x8002802A
#define TYPE_E_ELEMENTNOTFOUND 0x8002802B
#define TYPE_E_AMBIGUOUSNAME 0x8002802C
#define TYPE_E_NAMECONFLICT 0x8002802D
#define TYPE_E_UNKNOWNLCID 0x8002802E
#define TYPE_E_DLLFUNCTIONNOTFOUND 0x8002802F
#define TYPE_E_BADMODULEKIND 0x800288BD
#define TYPE_E_SIZETOOBIG 0x800288C5
#define TYPE_E_DUPLICATEID 0x800288C6
#define TYPE_E_INVALIDID 0x800288CF
#define TYPE_E_TYPEMISMATCH 0x80028CA0
#define TYPE_E_OUTOFBOUNDS 0x80028CA1
#define TYPE_E_IOERROR 0x80028CA2
#define TYPE_E_CANTCREATETMPFILE 0x80028CA3
#define TYPE_E_CANTLOADLIBRARY 0x80029C4A
#define TYPE_E_INCONSISTENTPROPFUNCS 0x80029C83
#define TYPE_E_CIRCULARTYPE 0x80029C84
#define STG_E_INVALIDFUNCTION 0x80030001
#define STG_E_FILENOTFOUND 0x80030002
#define STG_E_PATHNOTFOUND 0x80030003
#define STG_E_TOOMANYOPENFILES 0x80030004
#define STG_E_ACCESSDENIED 0x80030005
#define STG_E_INVALIDHANDLE 0x80030006
#define STG_E_INSUFFICIENTMEMORY 0x80030008
#define STG_E_INVALIDPOINTER 0x80030009
#define STG_E_NOMOREFILES 0x80030012
#define STG_E_DISKISWRITEPROTECTED 0x80030013
#define STG_E_SEEKERROR 0x80030019
#define STG_E_WRITEFAULT 0x8003001D
#define STG_E_READFAULT 0x8003001E
#define STG_E_SHAREVIOLATION 0x80030020
#define STG_E_LOCKVIOLATION 0x80030021
#define STG_E_FILEALREADYEXISTS 0x80030050
#define STG_E_INVALIDPARAMETER 0x80030057
#define STG_E_MEDIUMFULL 0x80030070
#define STG_E_ABNORMALAPIEXIT 0x800300FA
#define STG_E_INVALIDHEADER 0x800300FB
#define STG_E_INVALIDNAME 0x800300FC
#define STG_E_UNKNOWN 0x800300FD
#define STG_E_UNIMPLEMENTEDFUNCTION 0x800300FE
#define STG_E_INVALIDFLAG 0x800300FF
#define STG_E_INUSE 0x80030100
#define STG_E_NOTCURRENT 0x80030101
#define STG_E_REVERTED 0x80030102
#define STG_E_CANTSAVE 0x80030103
#define STG_E_OLDFORMAT 0x80030104
#define STG_E_OLDDLL 0x80030105
#define STG_E_SHAREREQUIRED 0x80030106
#define STG_E_NOTFILEBASEDSTORAGE 0x80030107
#define STG_E_EXTANTMARSHALLINGS 0x80030108
#define STG_S_CONVERTED 0x30200
#define RPC_E_CALL_REJECTED 0x80010001
#define RPC_E_CALL_CANCELED 0x80010002
#define RPC_E_CANTPOST_INSENDCALL 0x80010003
#define RPC_E_CANTCALLOUT_INASYNCCALL 0x80010004
#define RPC_E_CANTCALLOUT_INEXTERNALCALL 0x80010005
#define RPC_E_CONNECTION_TERMINATED 0x80010006
#define RPC_E_SERVER_DIED 0x80010007
#define RPC_E_CLIENT_DIED 0x80010008
#define RPC_E_INVALID_DATAPACKET 0x80010009
#define RPC_E_CANTTRANSMIT_CALL 0x8001000A
#define RPC_E_CLIENT_CANTMARSHAL_DATA 0x8001000B
#define RPC_E_CLIENT_CANTUNMARSHAL_DATA 0x8001000C
#define RPC_E_SERVER_CANTMARSHAL_DATA 0x8001000D
#define RPC_E_SERVER_CANTUNMARSHAL_DATA 0x8001000E
#define RPC_E_INVALID_DATA 0x8001000F
#define RPC_E_INVALID_PARAMETER 0x80010010
#define RPC_E_CANTCALLOUT_AGAIN 0x80010011
#define RPC_E_SERVER_DIED_DNE 0x80010012
#define RPC_E_SYS_CALL_FAILED 0x80010100
#define RPC_E_OUT_OF_RESOURCES 0x80010101
#define RPC_E_ATTEMPTED_MULTITHREAD 0x80010102
#define RPC_E_NOT_REGISTERED 0x80010103
#define RPC_E_FAULT 0x80010104
#define RPC_E_SERVERFAULT 0x80010105
#define RPC_E_CHANGED_MODE 0x80010106
#define RPC_E_INVALIDMETHOD 0x80010107
#define RPC_E_DISCONNECTED 0x80010108
#define RPC_E_RETRY 0x80010109
#define RPC_E_SERVERCALL_RETRYLATER 0x8001010A
#define RPC_E_SERVERCALL_REJECTED 0x8001010B
#define RPC_E_INVALID_CALLDATA 0x8001010C
#define RPC_E_CANTCALLOUT_ININPUTSYNCCALL 0x8001010D
#define RPC_E_WRONG_THREAD 0x8001010E
#define RPC_E_THREAD_NOT_INIT 0x8001010F
#define RPC_E_UNEXPECTED 0x8001FFFF
#define ERROR_BAD_USERNAME 2202
#define ERROR_NOT_CONNECTED 2250
#define ERROR_OPEN_FILES 2401
#define ERROR_DEVICE_IN_USE 2404
#define ERROR_BAD_DEVICE 1200
#define ERROR_CONNECTION_UNAVAIL 1201
#define ERROR_DEVICE_ALREADY_REMEMBERED 1202
#define ERROR_NO_NET_OR_BAD_PATH 1203
#define ERROR_BAD_PROVIDER 1204
#define ERROR_CANNOT_OPEN_PROFILE 1205
#define ERROR_BAD_PROFILE 1206
#define ERROR_NOT_CONTAINER 1207
#define ERROR_EXTENDED_ERROR 1208
#define ERROR_INVALID_GROUPNAME 1209
#define ERROR_INVALID_COMPUTERNAME 1210
#define ERROR_INVALID_EVENTNAME 1211
#define ERROR_INVALID_DOMAINNAME 1212
#define ERROR_INVALID_SERVICENAME 1213
#define ERROR_INVALID_NETNAME 1214
#define ERROR_INVALID_SHARENAME 1215
#define ERROR_INVALID_PASSWORDNAME 1216
#define ERROR_INVALID_MESSAGENAME 1217
#define ERROR_INVALID_MESSAGEDEST 1218
#define ERROR_SESSION_CREDENTIAL_CONFLICT 1219
#define ERROR_REMOTE_SESSION_LIMIT_EXCEEDED 1220
#define ERROR_DUP_DOMAINNAME 1221
#define ERROR_NO_NETWORK 1222
#define ERROR_NOT_ALL_ASSIGNED 1300
#define ERROR_SOME_NOT_MAPPED 1301
#define ERROR_NO_QUOTAS_FOR_ACCOUNT 1302
#define ERROR_LOCAL_USER_SESSION_KEY 1303
#define ERROR_NULL_LM_PASSWORD 1304
#define ERROR_UNKNOWN_REVISION 1305
#define ERROR_REVISION_MISMATCH 1306
#define ERROR_INVALID_OWNER 1307
#define ERROR_INVALID_PRIMARY_GROUP 1308
#define ERROR_NO_IMPERSONATION_TOKEN 1309
#define ERROR_CANT_DISABLE_MANDATORY 1310
#define ERROR_NO_LOGON_SERVERS 1311
#define ERROR_NO_SUCH_LOGON_SESSION 1312
#define ERROR_NO_SUCH_PRIVILEGE 1313
#define ERROR_PRIVILEGE_NOT_HELD 1314
#define ERROR_INVALID_ACCOUNT_NAME 1315
#define ERROR_USER_EXISTS 1316
#define ERROR_NO_SUCH_USER 1317
#define ERROR_GROUP_EXISTS 1318
#define ERROR_NO_SUCH_GROUP 1319
#define ERROR_MEMBER_IN_GROUP 1320
#define ERROR_MEMBER_NOT_IN_GROUP 1321
#define ERROR_LAST_ADMIN 1322
#define ERROR_WRONG_PASSWORD 1323
#define ERROR_ILL_FORMED_PASSWORD 1324
#define ERROR_PASSWORD_RESTRICTION 1325
#define ERROR_LOGON_FAILURE 1326
#define ERROR_ACCOUNT_RESTRICTION 1327
#define ERROR_INVALID_LOGON_HOURS 1328
#define ERROR_INVALID_WORKSTATION 1329
#define ERROR_PASSWORD_EXPIRED 1330
#define ERROR_ACCOUNT_DISABLED 1331
#define ERROR_NONE_MAPPED 1332
#define ERROR_TOO_MANY_LUIDS_REQUESTED 1333
#define ERROR_LUIDS_EXHAUSTED 1334
#define ERROR_INVALID_SUB_AUTHORITY 1335
#define ERROR_INVALID_ACL 1336
#define ERROR_INVALID_SID 1337
#define ERROR_INVALID_SECURITY_DESCR 1338
#define ERROR_BAD_INHERITANCE_ACL 1340
#define ERROR_SERVER_DISABLED 1341
#define ERROR_SERVER_NOT_DISABLED 1342
#define ERROR_INVALID_ID_AUTHORITY 1343
#define ERROR_ALLOTTED_SPACE_EXCEEDED 1344
#define ERROR_INVALID_GROUP_ATTRIBUTES 1345
#define ERROR_BAD_IMPERSONATION_LEVEL 1346
#define ERROR_CANT_OPEN_ANONYMOUS 1347
#define ERROR_BAD_VALIDATION_CLASS 1348
#define ERROR_BAD_TOKEN_TYPE 1349
#define ERROR_NO_SECURITY_ON_OBJECT 1350
#define ERROR_CANT_ACCESS_DOMAIN_INFO 1351
#define ERROR_INVALID_SERVER_STATE 1352
#define ERROR_INVALID_DOMAIN_STATE 1353
#define ERROR_INVALID_DOMAIN_ROLE 1354
#define ERROR_NO_SUCH_DOMAIN 1355
#define ERROR_DOMAIN_EXISTS 1356
#define ERROR_DOMAIN_LIMIT_EXCEEDED 1357
#define ERROR_INTERNAL_DB_CORRUPTION 1358
#define ERROR_INTERNAL_ERROR 1359
#define ERROR_GENERIC_NOT_MAPPED 1360
#define ERROR_BAD_DESCRIPTOR_FORMAT 1361
#define ERROR_NOT_LOGON_PROCESS 1362
#define ERROR_LOGON_SESSION_EXISTS 1363
#define ERROR_NO_SUCH_PACKAGE 1364
#define ERROR_BAD_LOGON_SESSION_STATE 1365
#define ERROR_LOGON_SESSION_COLLISION 1366
#define ERROR_INVALID_LOGON_TYPE 1367
#define ERROR_CANNOT_IMPERSONATE 1368
#define ERROR_RXACT_INVALID_STATE 1369
#define ERROR_RXACT_COMMIT_FAILURE 1370
#define ERROR_SPECIAL_ACCOUNT 1371
#define ERROR_SPECIAL_GROUP 1372
#define ERROR_SPECIAL_USER 1373
#define ERROR_MEMBERS_PRIMARY_GROUP 1374
#define ERROR_TOKEN_ALREADY_IN_USE 1375
#define ERROR_NO_SUCH_ALIAS 1376
#define ERROR_MEMBER_NOT_IN_ALIAS 1377
#define ERROR_MEMBER_IN_ALIAS 1378
#define ERROR_ALIAS_EXISTS 1379
#define ERROR_LOGON_NOT_GRANTED 1380
#define ERROR_TOO_MANY_SECRETS 1381
#define ERROR_SECRET_TOO_LONG 1382
#define ERROR_INTERNAL_DB_ERROR 1383
#define ERROR_TOO_MANY_CONTEXT_IDS 1384
#define ERROR_LOGON_TYPE_NOT_GRANTED 1385
#define ERROR_NT_CROSS_ENCRYPTION_REQUIRED 1386
#define ERROR_NO_SUCH_MEMBER 1387
#define ERROR_INVALID_MEMBER 1388
#define ERROR_TOO_MANY_SIDS 1389
#define ERROR_LM_CROSS_ENCRYPTION_REQUIRED 1390
#define ERROR_NO_INHERITANCE 1391
#define ERROR_FILE_CORRUPT 1392
#define ERROR_DISK_CORRUPT 1393
#define ERROR_NO_USER_SESSION_KEY 1394
#define ERROR_INVALID_WINDOW_HANDLE 1400
#define ERROR_INVALID_MENU_HANDLE 1401
#define ERROR_INVALID_CURSOR_HANDLE 1402
#define ERROR_INVALID_ACCEL_HANDLE 1403
#define ERROR_INVALID_HOOK_HANDLE 1404
#define ERROR_INVALID_DWP_HANDLE 1405
#define ERROR_TLW_WITH_WSCHILD 1406
#define ERROR_CANNOT_FIND_WND_CLASS 1407
#define ERROR_WINDOW_OF_OTHER_THREAD 1408
#define ERROR_HOTKEY_ALREADY_REGISTERED 1409
#define ERROR_CLASS_ALREADY_EXISTS 1410
#define ERROR_CLASS_DOES_NOT_EXIST 1411
#define ERROR_CLASS_HAS_WINDOWS 1412
#define ERROR_INVALID_INDEX 1413
#define ERROR_INVALID_ICON_HANDLE 1414
#define ERROR_PRIVATE_DIALOG_INDEX 1415
#define ERROR_LISTBOX_ID_NOT_FOUND 1416
#define ERROR_NO_WILDCARD_CHARACTERS 1417
#define ERROR_CLIPBOARD_NOT_OPEN 1418
#define ERROR_HOTKEY_NOT_REGISTERED 1419
#define ERROR_WINDOW_NOT_DIALOG 1420
#define ERROR_CONTROL_ID_NOT_FOUND 1421
#define ERROR_INVALID_COMBOBOX_MESSAGE 1422
#define ERROR_WINDOW_NOT_COMBOBOX 1423
#define ERROR_INVALID_EDIT_HEIGHT 1424
#define ERROR_DC_NOT_FOUND 1425
#define ERROR_INVALID_HOOK_FILTER 1426
#define ERROR_INVALID_FILTER_PROC 1427
#define ERROR_HOOK_NEEDS_HMOD 1428
#define ERROR_PUBLIC_ONLY_HOOK 1429
#define ERROR_JOURNAL_HOOK_SET 1430
#define ERROR_HOOK_NOT_INSTALLED 1431
#define ERROR_INVALID_LB_MESSAGE 1432
#define ERROR_SETCOUNT_ON_BAD_LB 1433
#define ERROR_LB_WITHOUT_TABSTOPS 1434
#define ERROR_DESTROY_OBJECT_OF_OTHER_THREAD 1435
#define ERROR_CHILD_WINDOW_MENU 1436
#define ERROR_NO_SYSTEM_MENU 1437
#define ERROR_INVALID_MSGBOX_STYLE 1438
#define ERROR_INVALID_SPI_VALUE 1439
#define ERROR_SCREEN_ALREADY_LOCKED 1440
#define ERROR_HWNDS_HAVE_DIFF_PARENT 1441
#define ERROR_NOT_CHILD_WINDOW 1442
#define ERROR_INVALID_GW_COMMAND 1443
#define ERROR_INVALID_THREAD_ID 1444
#define ERROR_NON_MDICHILD_WINDOW 1445
#define ERROR_POPUP_ALREADY_ACTIVE 1446
#define ERROR_NO_SCROLLBARS 1447
#define ERROR_INVALID_SCROLLBAR_RANGE 1448
#define ERROR_INVALID_SHOWWIN_COMMAND 1449
#define ERROR_EVENTLOG_FILE_CORRUPT 1500
#define ERROR_EVENTLOG_CANT_START 1501
#define ERROR_LOG_FILE_FULL 1502
#define ERROR_EVENTLOG_FILE_CHANGED 1503
#define RPC_S_INVALID_STRING_BINDING 1700
#define RPC_S_WRONG_KIND_OF_BINDING 1701
#define RPC_S_INVALID_BINDING 1702
#define RPC_S_PROTSEQ_NOT_SUPPORTED 1703
#define RPC_S_INVALID_RPC_PROTSEQ 1704
#define RPC_S_INVALID_STRING_UUID 1705
#define RPC_S_INVALID_ENDPOINT_FORMAT 1706
#define RPC_S_INVALID_NET_ADDR 1707
#define RPC_S_NO_ENDPOINT_FOUND 1708
#define RPC_S_INVALID_TIMEOUT 1709
#define RPC_S_OBJECT_NOT_FOUND 1710
#define RPC_S_ALREADY_REGISTERED 1711
#define RPC_S_TYPE_ALREADY_REGISTERED 1712
#define RPC_S_ALREADY_LISTENING 1713
#define RPC_S_NO_PROTSEQS_REGISTERED 1714
#define RPC_S_NOT_LISTENING 1715
#define RPC_S_UNKNOWN_MGR_TYPE 1716
#define RPC_S_UNKNOWN_IF 1717
#define RPC_S_NO_BINDINGS 1718
#define RPC_S_NO_PROTSEQS 1719
#define RPC_S_CANT_CREATE_ENDPOINT 1720
#define RPC_S_OUT_OF_RESOURCES 1721
#define RPC_S_SERVER_UNAVAILABLE 1722
#define RPC_S_SERVER_TOO_BUSY 1723
#define RPC_S_INVALID_NETWORK_OPTIONS 1724
#define RPC_S_NO_CALL_ACTIVE 1725
#define RPC_S_CALL_FAILED 1726
#define RPC_S_CALL_FAILED_DNE 1727
#define RPC_S_PROTOCOL_ERROR 1728
#define RPC_S_UNSUPPORTED_TRANS_SYN 1730
#define RPC_S_UNSUPPORTED_TYPE 1732
#define RPC_S_INVALID_TAG 1733
#define RPC_S_INVALID_BOUND 1734
#define RPC_S_NO_ENTRY_NAME 1735
#define RPC_S_INVALID_NAME_SYNTAX 1736
#define RPC_S_UNSUPPORTED_NAME_SYNTAX 1737
#define RPC_S_UUID_NO_ADDRESS 1739
#define RPC_S_DUPLICATE_ENDPOINT 1740
#define RPC_S_UNKNOWN_AUTHN_TYPE 1741
#define RPC_S_MAX_CALLS_TOO_SMALL 1742
#define RPC_S_STRING_TOO_LONG 1743
#define RPC_S_PROTSEQ_NOT_FOUND 1744
#define RPC_S_PROCNUM_OUT_OF_RANGE 1745
#define RPC_S_BINDING_HAS_NO_AUTH 1746
#define RPC_S_UNKNOWN_AUTHN_SERVICE 1747
#define RPC_S_UNKNOWN_AUTHN_LEVEL 1748
#define RPC_S_INVALID_AUTH_IDENTITY 1749
#define RPC_S_UNKNOWN_AUTHZ_SERVICE 1750
#define EPT_S_INVALID_ENTRY 1751
#define EPT_S_CANT_PERFORM_OP 1752
#define EPT_S_NOT_REGISTERED 1753
#define RPC_S_NOTHING_TO_EXPORT 1754
#define RPC_S_INCOMPLETE_NAME 1755
#define RPC_S_INVALID_VERS_OPTION 1756
#define RPC_S_NO_MORE_MEMBERS 1757
#define RPC_S_NOT_ALL_OBJS_UNEXPORTED 1758
#define RPC_S_INTERFACE_NOT_FOUND 1759
#define RPC_S_ENTRY_ALREADY_EXISTS 1760
#define RPC_S_ENTRY_NOT_FOUND 1761
#define RPC_S_NAME_SERVICE_UNAVAILABLE 1762
#define RPC_S_INVALID_NAF_ID 1763
#define RPC_S_CANNOT_SUPPORT 1764
#define RPC_S_NO_CONTEXT_AVAILABLE 1765
#define RPC_S_INTERNAL_ERROR 1766
#define RPC_S_ZERO_DIVIDE 1767
#define RPC_S_ADDRESS_ERROR 1768
#define RPC_S_FP_DIV_ZERO 1769
#define RPC_S_FP_UNDERFLOW 1770
#define RPC_S_FP_OVERFLOW 1771
#define RPC_X_NO_MORE_ENTRIES 1772
#define RPC_X_SS_CHAR_TRANS_OPEN_FAIL 1773
#define RPC_X_SS_CHAR_TRANS_SHORT_FILE 1774
#define RPC_X_SS_IN_NULL_CONTEXT 1775
#define RPC_X_SS_CONTEXT_DAMAGED 1777
#define RPC_X_SS_HANDLES_MISMATCH 1778
#define RPC_X_SS_CANNOT_GET_CALL_HANDLE 1779
#define RPC_X_NULL_REF_POINTER 1780
#define RPC_X_ENUM_VALUE_OUT_OF_RANGE 1781
#define RPC_X_BYTE_COUNT_TOO_SMALL 1782
#define RPC_X_BAD_STUB_DATA 1783
#define ERROR_INVALID_USER_BUFFER 1784
#define ERROR_UNRECOGNIZED_MEDIA 1785
#define ERROR_NO_TRUST_LSA_SECRET 1786
#define ERROR_NO_TRUST_SAM_ACCOUNT 1787
#define ERROR_TRUSTED_DOMAIN_FAILURE 1788
#define ERROR_TRUSTED_RELATIONSHIP_FAILURE 1789
#define ERROR_TRUST_FAILURE 1790
#define RPC_S_CALL_IN_PROGRESS 1791
#define ERROR_NETLOGON_NOT_STARTED 1792
#define ERROR_ACCOUNT_EXPIRED 1793
#define ERROR_REDIRECTOR_HAS_OPEN_HANDLES 1794
#define ERROR_PRINTER_DRIVER_ALREADY_INSTALLED 1795
#define ERROR_UNKNOWN_PORT 1796
#define ERROR_UNKNOWN_PRINTER_DRIVER 1797
#define ERROR_UNKNOWN_PRINTPROCESSOR 1798
#define ERROR_INVALID_SEPARATOR_FILE 1799
#define ERROR_INVALID_PRIORITY 1800
#define ERROR_INVALID_PRINTER_NAME 1801
#define ERROR_PRINTER_ALREADY_EXISTS 1802
#define ERROR_INVALID_PRINTER_COMMAND 1803
#define ERROR_INVALID_DATATYPE 1804
#define ERROR_INVALID_ENVIRONMENT 1805
#define RPC_S_NO_MORE_BINDINGS 1806
#define ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT 1807
#define ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT 1808
#define ERROR_NOLOGON_SERVER_TRUST_ACCOUNT 1809
#define ERROR_DOMAIN_TRUST_INCONSISTENT 1810
#define ERROR_SERVER_HAS_OPEN_HANDLES 1811
#define ERROR_RESOURCE_DATA_NOT_FOUND 1812
#define ERROR_RESOURCE_TYPE_NOT_FOUND 1813
#define ERROR_RESOURCE_NAME_NOT_FOUND 1814
#define ERROR_RESOURCE_LANG_NOT_FOUND 1815
#define ERROR_NOT_ENOUGH_QUOTA 1816
#define RPC_S_GROUP_MEMBER_NOT_FOUND 1898
#define EPT_S_CANT_CREATE 1899
#define RPC_S_INVALID_OBJECT 1900
#define ERROR_INVALID_TIME 1901
#define ERROR_INVALID_FORM_NAME 1902
#define ERROR_INVALID_FORM_SIZE 1903
#define ERROR_ALREADY_WAITING 1904
#define ERROR_PRINTER_DELETED 1905
#define ERROR_INVALID_PRINTER_STATE 1906
#define ERROR_NO_BROWSER_SERVERS_FOUND 6118
#define MAXPNAMELEN 32
#define MAXERRORLENGTH 128
#define TIME_MS 0x1
#define TIME_SAMPLES 0x2
#define TIME_BYTES 0x4
#define TIME_SMPTE 0x8
#define TIME_MIDI 0x10
#define MM_JOY1MOVE 0x3A0
#define MM_JOY2MOVE 0x3A1
#define MM_JOY1ZMOVE 0x3A2
#define MM_JOY2ZMOVE 0x3A3
#define MM_JOY1BUTTONDOWN 0x3B5
#define MM_JOY2BUTTONDOWN 0x3B6
#define MM_JOY1BUTTONUP 0x3B7
#define MM_JOY2BUTTONUP 0x3B8
#define MM_MCINOTIFY 0x3B9
#define MM_MCISYSTEM_STRING 0x3CA
#define MM_WOM_OPEN 0x3BB
#define MM_WOM_CLOSE 0x3BC
#define MM_WOM_DONE 0x3BD
#define MM_WIM_OPEN 0x3BE
#define MM_WIM_CLOSE 0x3BF
#define MM_WIM_DATA 0x3C0
#define MM_MIM_OPEN 0x3C1
#define MM_MIM_CLOSE 0x3C2
#define MM_MIM_DATA 0x3C3
#define MM_MIM_LONGDATA 0x3C4
#define MM_MIM_ERROR 0x3C5
#define MM_MIM_LONGERROR 0x3C6
#define MM_MOM_OPEN 0x3C7
#define MM_MOM_CLOSE 0x3C8
#define MM_MOM_DONE 0x3C9
#define MMSYSERR_BASE 0
#define WAVERR_BASE 32
#define MIDIERR_BASE 64
#define TIMERR_BASE 96
#define JOYERR_BASE 160
#define MCIERR_BASE 256
#define MCI_STRING_OFFSET 512
#define MCI_VD_OFFSET 1024
#define MCI_CD_OFFSET 1088
#define MCI_WAVE_OFFSET 1152
#define MCI_SEQ_OFFSET 1216
#define MMSYSERR_NOERROR 0
#define MMSYSERR_ERROR (MMSYSERR_BASE + 1)
#define MMSYSERR_BADDEVICEID (MMSYSERR_BASE + 2)
#define MMSYSERR_NOTENABLED (MMSYSERR_BASE + 3)
#define MMSYSERR_ALLOCATED (MMSYSERR_BASE + 4)
#define MMSYSERR_INVALHANDLE (MMSYSERR_BASE + 5)
#define MMSYSERR_NODRIVER (MMSYSERR_BASE + 6)
#define MMSYSERR_NOMEM (MMSYSERR_BASE + 7)
#define MMSYSERR_NOTSUPPORTED (MMSYSERR_BASE + 8)
#define MMSYSERR_BADERRNUM (MMSYSERR_BASE + 9)
#define MMSYSERR_INVALFLAG (MMSYSERR_BASE + 10)
#define MMSYSERR_INVALPARAM (MMSYSERR_BASE + 11)
#define MMSYSERR_HANDLEBUSY (MMSYSERR_BASE + 12)
#define MMSYSERR_INVALIDALIAS (MMSYSERR_BASE + 13)
#define MMSYSERR_LASTERROR (MMSYSERR_BASE + 13)
#define MM_MOM_POSITIONCB 0x3CA
#define MM_MCISIGNAL 0x3CB
#define MM_MIM_MOREDATA 0x3CC
#define MIDICAPS_STREAM 0x8
#define MEVT_F_SHORT 0x0
#define MEVT_F_LONG 0x80000000
#define MEVT_F_CALLBACK 0x40000000
#define MIDISTRM_ERROR -2
#define MIDIPROP_SET 0x80000000
#define MIDIPROP_GET 0x40000000
#define MIDIPROP_TIMEDIV 0x1
#define MIDIPROP_TEMPO 0x2
#define MIXER_SHORT_NAME_CHARS 16
#define MIXER_LONG_NAME_CHARS 64
#define MIXERR_BASE 1024
#define MIXERR_INVALLINE (MIXERR_BASE + 0)
#define MIXERR_INVALCONTROL (MIXERR_BASE + 1)
#define MIXERR_INVALVALUE (MIXERR_BASE + 2)
#define MIXERR_LASTERROR (MIXERR_BASE + 2)
#define MIXER_OBJECTF_HANDLE 0x80000000
#define MIXER_OBJECTF_MIXER 0x0
#define MIXER_OBJECTF_HMIXER (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIXER)
#define MIXER_OBJECTF_WAVEOUT 0x10000000
#define MIXER_OBJECTF_HWAVEOUT (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_WAVEOUT)
#define MIXER_OBJECTF_WAVEIN 0x20000000
#define MIXER_OBJECTF_HWAVEIN (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_WAVEIN)
#define MIXER_OBJECTF_MIDIOUT 0x30000000
#define MIXER_OBJECTF_HMIDIOUT (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIDIOUT)
#define MIXER_OBJECTF_MIDIIN 0x40000000
#define MIXER_OBJECTF_HMIDIIN (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIDIIN)
#define MIXER_OBJECTF_AUX 0x50000000
#define MIXERLINE_LINEF_ACTIVE 0x1
#define MIXERLINE_LINEF_DISCONNECTED 0x8000
#define MIXERLINE_LINEF_SOURCE 0x80000000
#define MIXERLINE_COMPONENTTYPE_DST_FIRST 0x0
#define MIXERLINE_COMPONENTTYPE_DST_UNDEFINED (MIXERLINE_COMPONENTTYPE_DST_FIRST + 0)
#define MIXERLINE_COMPONENTTYPE_DST_DIGITAL (MIXERLINE_COMPONENTTYPE_DST_FIRST + 1)
#define MIXERLINE_COMPONENTTYPE_DST_LINE (MIXERLINE_COMPONENTTYPE_DST_FIRST + 2)
#define MIXERLINE_COMPONENTTYPE_DST_MONITOR (MIXERLINE_COMPONENTTYPE_DST_FIRST + 3)
#define MIXERLINE_COMPONENTTYPE_DST_SPEAKERS (MIXERLINE_COMPONENTTYPE_DST_FIRST + 4)
#define MIXERLINE_COMPONENTTYPE_DST_HEADPHONES (MIXERLINE_COMPONENTTYPE_DST_FIRST + 5)
#define MIXERLINE_COMPONENTTYPE_DST_TELEPHONE (MIXERLINE_COMPONENTTYPE_DST_FIRST + 6)
#define MIXERLINE_COMPONENTTYPE_DST_WAVEIN (MIXERLINE_COMPONENTTYPE_DST_FIRST + 7)
#define MIXERLINE_COMPONENTTYPE_DST_VOICEIN (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
#define MIXERLINE_COMPONENTTYPE_DST_LAST (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
#define MIXERLINE_COMPONENTTYPE_SRC_FIRST 0x1000
#define MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0)
#define MIXERLINE_COMPONENTTYPE_SRC_DIGITAL (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1)
#define MIXERLINE_COMPONENTTYPE_SRC_LINE (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2)
#define MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3)
#define MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4)
#define MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5)
#define MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6)
#define MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7)
#define MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8)
#define MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9)
#define MIXERLINE_COMPONENTTYPE_SRC_ANALOG (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)
#define MIXERLINE_COMPONENTTYPE_SRC_LAST (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)
#define MIXERLINE_TARGETTYPE_UNDEFINED 0
#define MIXERLINE_TARGETTYPE_WAVEOUT 1
#define MIXERLINE_TARGETTYPE_WAVEIN 2
#define MIXERLINE_TARGETTYPE_MIDIOUT 3
#define MIXERLINE_TARGETTYPE_MIDIIN 4
#define MIXERLINE_TARGETTYPE_AUX 5
#define MIXER_GETLINEINFOF_DESTINATION 0x0
#define MIXER_GETLINEINFOF_SOURCE 0x1
#define MIXER_GETLINEINFOF_LINEID 0x2
#define MIXER_GETLINEINFOF_COMPONENTTYPE 0x3
#define MIXER_GETLINEINFOF_TARGETTYPE 0x4
#define MIXER_GETLINEINFOF_QUERYMASK 0xF
#define MIXERCONTROL_CONTROLF_UNIFORM 0x1
#define MIXERCONTROL_CONTROLF_MULTIPLE 0x2
#define MIXERCONTROL_CONTROLF_DISABLED 0x80000000
#define MIXERCONTROL_CT_CLASS_MASK 0xF0000000
#define MIXERCONTROL_CT_CLASS_CUSTOM 0x0
#define MIXERCONTROL_CT_CLASS_METER 0x10000000
#define MIXERCONTROL_CT_CLASS_SWITCH 0x20000000
#define MIXERCONTROL_CT_CLASS_NUMBER 0x30000000
#define MIXERCONTROL_CT_CLASS_SLIDER 0x40000000
#define MIXERCONTROL_CT_CLASS_FADER 0x50000000
#define MIXERCONTROL_CT_CLASS_TIME 0x60000000
#define MIXERCONTROL_CT_CLASS_LIST 0x70000000
#define MIXERCONTROL_CT_SUBCLASS_MASK 0xF000000
#define MIXERCONTROL_CT_SC_SWITCH_BOOLEAN 0x0
#define MIXERCONTROL_CT_SC_SWITCH_BUTTON 0x1000000
#define MIXERCONTROL_CT_SC_METER_POLLED 0x0
#define MIXERCONTROL_CT_SC_TIME_MICROSECS 0x0
#define MIXERCONTROL_CT_SC_TIME_MILLISECS 0x1000000
#define MIXERCONTROL_CT_SC_LIST_SINGLE 0x0
#define MIXERCONTROL_CT_SC_LIST_MULTIPLE 0x1000000
#define MIXERCONTROL_CT_UNITS_MASK 0xFF0000
#define MIXERCONTROL_CT_UNITS_CUSTOM 0x0
#define MIXERCONTROL_CT_UNITS_BOOLEAN 0x10000
#define MIXERCONTROL_CT_UNITS_SIGNED 0x20000
#define MIXERCONTROL_CT_UNITS_UNSIGNED 0x30000
#define MIXERCONTROL_CT_UNITS_DECIBELS 0x40000
#define MIXERCONTROL_CT_UNITS_PERCENT 0x50000
#define MIXERCONTROL_CONTROLTYPE_CUSTOM (MIXERCONTROL_CT_CLASS_CUSTOM|MIXERCONTROL_CT_UNITS_CUSTOM)
#define MIXERCONTROL_CONTROLTYPE_BOOLEANMETER (MIXERCONTROL_CT_CLASS_METER|MIXERCONTROL_CT_SC_METER_POLLED|MIXERCONTROL_CT_UNITS_BOOLEAN)
#define MIXERCONTROL_CONTROLTYPE_SIGNEDMETER (MIXERCONTROL_CT_CLASS_METER|MIXERCONTROL_CT_SC_METER_POLLED|MIXERCONTROL_CT_UNITS_SIGNED)
#define MIXERCONTROL_CONTROLTYPE_PEAKMETER (MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1)
#define MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER (MIXERCONTROL_CT_CLASS_METER|MIXERCONTROL_CT_SC_METER_POLLED|MIXERCONTROL_CT_UNITS_UNSIGNED)
#define MIXERCONTROL_CONTROLTYPE_BOOLEAN (MIXERCONTROL_CT_CLASS_SWITCH|MIXERCONTROL_CT_SC_SWITCH_BOOLEAN|MIXERCONTROL_CT_UNITS_BOOLEAN)
#define MIXERCONTROL_CONTROLTYPE_ONOFF (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 1)
#define MIXERCONTROL_CONTROLTYPE_MUTE (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2)
#define MIXERCONTROL_CONTROLTYPE_MONO (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3)
#define MIXERCONTROL_CONTROLTYPE_LOUDNESS (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4)
#define MIXERCONTROL_CONTROLTYPE_STEREOENH (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5)
#define MIXERCONTROL_CONTROLTYPE_BUTTON (MIXERCONTROL_CT_CLASS_SWITCH|MIXERCONTROL_CT_SC_SWITCH_BUTTON|MIXERCONTROL_CT_UNITS_BOOLEAN)
#define MIXERCONTROL_CONTROLTYPE_DECIBELS (MIXERCONTROL_CT_CLASS_NUMBER|MIXERCONTROL_CT_UNITS_DECIBELS)
#define MIXERCONTROL_CONTROLTYPE_SIGNED (MIXERCONTROL_CT_CLASS_NUMBER|MIXERCONTROL_CT_UNITS_SIGNED)
#define MIXERCONTROL_CONTROLTYPE_UNSIGNED (MIXERCONTROL_CT_CLASS_NUMBER|MIXERCONTROL_CT_UNITS_UNSIGNED)
#define MIXERCONTROL_CONTROLTYPE_PERCENT (MIXERCONTROL_CT_CLASS_NUMBER|MIXERCONTROL_CT_UNITS_PERCENT)
#define MIXERCONTROL_CONTROLTYPE_SLIDER (MIXERCONTROL_CT_CLASS_SLIDER|MIXERCONTROL_CT_UNITS_SIGNED)
#define MIXERCONTROL_CONTROLTYPE_PAN (MIXERCONTROL_CONTROLTYPE_SLIDER + 1)
#define MIXERCONTROL_CONTROLTYPE_QSOUNDPAN (MIXERCONTROL_CONTROLTYPE_SLIDER + 2)
#define MIXERCONTROL_CONTROLTYPE_FADER (MIXERCONTROL_CT_CLASS_FADER|MIXERCONTROL_CT_UNITS_UNSIGNED)
#define MIXERCONTROL_CONTROLTYPE_VOLUME (MIXERCONTROL_CONTROLTYPE_FADER + 1)
#define MIXERCONTROL_CONTROLTYPE_BASS (MIXERCONTROL_CONTROLTYPE_FADER + 2)
#define MIXERCONTROL_CONTROLTYPE_TREBLE (MIXERCONTROL_CONTROLTYPE_FADER + 3)
#define MIXERCONTROL_CONTROLTYPE_EQUALIZER (MIXERCONTROL_CONTROLTYPE_FADER + 4)
#define MIXERCONTROL_CONTROLTYPE_SINGLESELECT (MIXERCONTROL_CT_CLASS_LIST|MIXERCONTROL_CT_SC_LIST_SINGLE|MIXERCONTROL_CT_UNITS_BOOLEAN)
#define MIXERCONTROL_CONTROLTYPE_MUX (MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1)
#define MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT (MIXERCONTROL_CT_CLASS_LIST|MIXERCONTROL_CT_SC_LIST_MULTIPLE|MIXERCONTROL_CT_UNITS_BOOLEAN)
#define MIXERCONTROL_CONTROLTYPE_MIXER (MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1)
#define MIXERCONTROL_CONTROLTYPE_MICROTIME (MIXERCONTROL_CT_CLASS_TIME|MIXERCONTROL_CT_SC_TIME_MICROSECS|MIXERCONTROL_CT_UNITS_UNSIGNED)
#define MIXERCONTROL_CONTROLTYPE_MILLITIME (MIXERCONTROL_CT_CLASS_TIME|MIXERCONTROL_CT_SC_TIME_MILLISECS|MIXERCONTROL_CT_UNITS_UNSIGNED)
#define MIXER_GETLINECONTROLSF_ALL 0x0
#define MIXER_GETLINECONTROLSF_ONEBYID 0x1
#define MIXER_GETLINECONTROLSF_ONEBYTYPE 0x2
#define MIXER_GETLINECONTROLSF_QUERYMASK 0xF
#define MIXER_GETCONTROLDETAILSF_VALUE 0x0
#define MIXER_GETCONTROLDETAILSF_LISTTEXT 0x1
#define MIXER_GETCONTROLDETAILSF_QUERYMASK 0xF
#define MIXER_SETCONTROLDETAILSF_VALUE 0x0
#define MIXER_SETCONTROLDETAILSF_CUSTOM 0x1
#define MIXER_SETCONTROLDETAILSF_QUERYMASK 0xF
#define JOY_BUTTON5 0x10
#define JOY_BUTTON6 0x20
#define JOY_BUTTON7 0x40
#define JOY_BUTTON8 0x80
#define JOY_BUTTON9 0x100
#define JOY_BUTTON10 0x200
#define JOY_BUTTON11 0x400
#define JOY_BUTTON12 0x800
#define JOY_BUTTON13 0x1000
#define JOY_BUTTON14 0x2000
#define JOY_BUTTON15 0x4000
#define JOY_BUTTON16 0x8000
#define JOY_BUTTON17 0x10000
#define JOY_BUTTON18 0x20000
#define JOY_BUTTON19 0x40000
#define JOY_BUTTON20 0x80000
#define JOY_BUTTON21 0x100000
#define JOY_BUTTON22 0x200000
#define JOY_BUTTON23 0x400000
#define JOY_BUTTON24 0x800000
#define JOY_BUTTON25 0x1000000
#define JOY_BUTTON26 0x2000000
#define JOY_BUTTON27 0x4000000
#define JOY_BUTTON28 0x8000000
#define JOY_BUTTON29 0x10000000
#define JOY_BUTTON30 0x20000000
#define JOY_BUTTON31 0x40000000
#define JOY_BUTTON32 0x80000000
#define JOY_POVCENTERED -1
#define JOY_POVFORWARD 0
#define JOY_POVRIGHT 9000
#define JOY_POVBACKWARD 18000
#define JOY_POVLEFT 27000
#define JOY_RETURNX 0x1
#define JOY_RETURNY 0x2
#define JOY_RETURNZ 0x4
#define JOY_RETURNR 0x8
#define JOY_RETURNU 0x10
#define JOY_RETURNV 0x20
#define JOY_RETURNPOV 0x40
#define JOY_RETURNBUTTONS 0x80
#define JOY_RETURNRAWDATA 0x100
#define JOY_RETURNPOVCTS 0x200
#define JOY_RETURNCENTERED 0x400
#define JOY_USEDEADZONE 0x800
#define JOY_RETURNALL (JOY_RETURNX|JOY_RETURNY|JOY_RETURNZ|JOY_RETURNR|JOY_RETURNU|JOY_RETURNV|JOY_RETURNPOV|JOY_RETURNBUTTONS)
#define JOY_CAL_READALWAYS 0x10000
#define JOY_CAL_READXYONLY 0x20000
#define JOY_CAL_READ3 0x40000
#define JOY_CAL_READ4 0x80000
#define JOY_CAL_READXONLY 0x100000
#define JOY_CAL_READYONLY 0x200000
#define JOY_CAL_READ5 0x400000
#define JOY_CAL_READ6 0x800000
#define JOY_CAL_READZONLY 0x1000000
#define JOY_CAL_READRONLY 0x2000000
#define JOY_CAL_READUONLY 0x4000000
#define JOY_CAL_READVONLY 0x8000000
#define WAVE_FORMAT_QUERY 0x1
#define SND_PURGE 0x40
#define SND_APPLICATION 0x80
#define WAVE_MAPPED 0x4
#define WAVE_FORMAT_DIRECT 0x8
#define WAVE_FORMAT_DIRECT_QUERY (WAVE_FORMAT_QUERY|WAVE_FORMAT_DIRECT)
#define MIM_MOREDATA MM_MIM_MOREDATA
#define MOM_POSITIONCB MM_MOM_POSITIONCB
#define MIDI_IO_STATUS 0x20
#define DRV_LOAD 0x1
#define DRV_ENABLE 0x2
#define DRV_OPEN 0x3
#define DRV_CLOSE 0x4
#define DRV_DISABLE 0x5
#define DRV_FREE 0x6
#define DRV_CONFIGURE 0x7
#define DRV_QUERYCONFIGURE 0x8
#define DRV_INSTALL 0x9
#define DRV_REMOVE 0xA
#define DRV_EXITSESSION 0xB
#define DRV_POWER 0xF
#define DRV_RESERVED 0x800
#define DRV_USER 0x4000
#define DRVCNF_CANCEL 0x0
#define DRVCNF_OK 0x1
#define DRVCNF_RESTART 0x2
#define DRV_CANCEL DRVCNF_CANCEL
#define DRV_OK DRVCNF_OK
#define DRV_RESTART DRVCNF_RESTART
#define DRV_MCI_FIRST DRV_RESERVED
#define DRV_MCI_LAST DRV_RESERVED + 0xFFF
#define CALLBACK_TYPEMASK 0x70000
#define CALLBACK_NULL 0x0
#define CALLBACK_WINDOW 0x10000
#define CALLBACK_TASK 0x20000
#define CALLBACK_FUNCTION 0x30000
#define MM_MICROSOFT 1
#define MM_MIDI_MAPPER 1
#define MM_WAVE_MAPPER 2
#define MM_SNDBLST_MIDIOUT 3
#define MM_SNDBLST_MIDIIN 4
#define MM_SNDBLST_SYNTH 5
#define MM_SNDBLST_WAVEOUT 6
#define MM_SNDBLST_WAVEIN 7
#define MM_ADLIB 9
#define MM_MPU401_MIDIOUT 10
#define MM_MPU401_MIDIIN 11
#define MM_PC_JOYSTICK 12
#define SND_SYNC 0x0
#define SND_ASYNC 0x1
#define SND_NODEFAULT 0x2
#define SND_MEMORY 0x4
#define SND_ALIAS 0x10000
#define SND_FILENAME 0x20000
#define SND_RESOURCE 0x40004
#define SND_ALIAS_ID 0x110000
#define SND_ALIAS_START 0
#define SND_LOOP 0x8
#define SND_NOSTOP 0x10
#define SND_VALID 0x1F
#define SND_NOWAIT 0x2000
#define SND_VALIDFLAGS 0x17201F
#define SND_RESERVED 0xFF000000
#define SND_TYPE_MASK 0x170007
#define WAVERR_BADFORMAT (WAVERR_BASE + 0)
#define WAVERR_STILLPLAYING (WAVERR_BASE + 1)
#define WAVERR_UNPREPARED (WAVERR_BASE + 2)
#define WAVERR_SYNC (WAVERR_BASE + 3)
#define WAVERR_LASTERROR (WAVERR_BASE + 3)
#define WOM_OPEN MM_WOM_OPEN
#define WOM_CLOSE MM_WOM_CLOSE
#define WOM_DONE MM_WOM_DONE
#define WIM_OPEN MM_WIM_OPEN
#define WIM_CLOSE MM_WIM_CLOSE
#define WIM_DATA MM_WIM_DATA
#define WAVE_MAPPER -1
#define WAVE_ALLOWSYNC 0x2
#define WAVE_VALID 0x3
#define WHDR_DONE 0x1
#define WHDR_PREPARED 0x2
#define WHDR_BEGINLOOP 0x4
#define WHDR_ENDLOOP 0x8
#define WHDR_INQUEUE 0x10
#define WHDR_VALID 0x1F
#define WAVECAPS_PITCH 0x1
#define WAVECAPS_PLAYBACKRATE 0x2
#define WAVECAPS_VOLUME 0x4
#define WAVECAPS_LRVOLUME 0x8
#define WAVECAPS_SYNC 0x10
#define WAVE_INVALIDFORMAT 0x0
#define WAVE_FORMAT_1M08 0x1
#define WAVE_FORMAT_1S08 0x2
#define WAVE_FORMAT_1M16 0x4
#define WAVE_FORMAT_1S16 0x8
#define WAVE_FORMAT_2M08 0x10
#define WAVE_FORMAT_2S08 0x20
#define WAVE_FORMAT_2M16 0x40
#define WAVE_FORMAT_2S16 0x80
#define WAVE_FORMAT_4M08 0x100
#define WAVE_FORMAT_4S08 0x200
#define WAVE_FORMAT_4M16 0x400
#define WAVE_FORMAT_4S16 0x800
#define WAVE_FORMAT_PCM 1
#define MIDIERR_UNPREPARED (MIDIERR_BASE + 0)
#define MIDIERR_STILLPLAYING (MIDIERR_BASE + 1)
#define MIDIERR_NOMAP (MIDIERR_BASE + 2)
#define MIDIERR_NOTREADY (MIDIERR_BASE + 3)
#define MIDIERR_NODEVICE (MIDIERR_BASE + 4)
#define MIDIERR_INVALIDSETUP (MIDIERR_BASE + 5)
#define MIDIERR_LASTERROR (MIDIERR_BASE + 5)
#define MIM_OPEN MM_MIM_OPEN
#define MIM_CLOSE MM_MIM_CLOSE
#define MIM_DATA MM_MIM_DATA
#define MIM_LONGDATA MM_MIM_LONGDATA
#define MIM_ERROR MM_MIM_ERROR
#define MIM_LONGERROR MM_MIM_LONGERROR
#define MOM_OPEN MM_MOM_OPEN
#define MOM_CLOSE MM_MOM_CLOSE
#define MOM_DONE MM_MOM_DONE
#define MIDIMAPPER (-1)
#define MIDI_MAPPER -1
#define MIDI_CACHE_ALL 1
#define MIDI_CACHE_BESTFIT 2
#define MIDI_CACHE_QUERY 3
#define MIDI_UNCACHE 4
#define MIDI_CACHE_VALID (MIDI_CACHE_ALL|MIDI_CACHE_BESTFIT|MIDI_CACHE_QUERY|MIDI_UNCACHE)
#define MOD_MIDIPORT 1
#define MOD_SYNTH 2
#define MOD_SQSYNTH 3
#define MOD_FMSYNTH 4
#define MOD_MAPPER 5
#define MIDICAPS_VOLUME 0x1
#define MIDICAPS_LRVOLUME 0x2
#define MIDICAPS_CACHE 0x4
#define MHDR_DONE 0x1
#define MHDR_PREPARED 0x2
#define MHDR_INQUEUE 0x4
#define MHDR_VALID 0x7
#define AUX_MAPPER -1
#define AUXCAPS_CDAUDIO 1
#define AUXCAPS_AUXIN 2
#define AUXCAPS_VOLUME 0x1
#define AUXCAPS_LRVOLUME 0x2
#define TIMERR_NOERROR (0)
#define TIMERR_NOCANDO (TIMERR_BASE + 1)
#define TIMERR_STRUCT (TIMERR_BASE + 33)
#define TIME_ONESHOT 0
#define TIME_PERIODIC 1
#define JOYERR_NOERROR (0)
#define JOYERR_PARMS (JOYERR_BASE + 5)
#define JOYERR_NOCANDO (JOYERR_BASE + 6)
#define JOYERR_UNPLUGGED (JOYERR_BASE + 7)
#define JOY_BUTTON1 0x1
#define JOY_BUTTON2 0x2
#define JOY_BUTTON3 0x4
#define JOY_BUTTON4 0x8
#define JOY_BUTTON1CHG 0x100
#define JOY_BUTTON2CHG 0x200
#define JOY_BUTTON3CHG 0x400
#define JOY_BUTTON4CHG 0x800
#define JOYSTICKID1 0
#define JOYSTICKID2 1
#define MMIOERR_BASE 256
#define MMIOERR_FILENOTFOUND (MMIOERR_BASE + 1)
#define MMIOERR_OUTOFMEMORY (MMIOERR_BASE + 2)
#define MMIOERR_CANNOTOPEN (MMIOERR_BASE + 3)
#define MMIOERR_CANNOTCLOSE (MMIOERR_BASE + 4)
#define MMIOERR_CANNOTREAD (MMIOERR_BASE + 5)
#define MMIOERR_CANNOTWRITE (MMIOERR_BASE + 6)
#define MMIOERR_CANNOTSEEK (MMIOERR_BASE + 7)
#define MMIOERR_CANNOTEXPAND (MMIOERR_BASE + 8)
#define MMIOERR_CHUNKNOTFOUND (MMIOERR_BASE + 9)
#define MMIOERR_UNBUFFERED (MMIOERR_BASE + 10)
#define CFSEPCHAR "+"
#define MMIO_RWMODE 0x3
#define MMIO_SHAREMODE 0x70
#define MMIO_CREATE 0x1000
#define MMIO_PARSE 0x100
#define MMIO_DELETE 0x200
#define MMIO_EXIST 0x4000
#define MMIO_ALLOCBUF 0x10000
#define MMIO_GETTEMP 0x20000
#define MMIO_DIRTY 0x10000000
#define MMIO_OPEN_VALID 0x3FFFF
#define MMIO_READ 0x0
#define MMIO_WRITE 0x1
#define MMIO_READWRITE 0x2
#define MMIO_COMPAT 0x0
#define MMIO_EXCLUSIVE 0x10
#define MMIO_DENYWRITE 0x20
#define MMIO_DENYREAD 0x30
#define MMIO_DENYNONE 0x40
#define MMIO_FHOPEN 0x10
#define MMIO_EMPTYBUF 0x10
#define MMIO_TOUPPER 0x10
#define MMIO_INSTALLPROC 0x10000
#define MMIO_PUBLICPROC 0x10000000
#define MMIO_UNICODEPROC 0x1000000
#define MMIO_REMOVEPROC 0x20000
#define MMIO_FINDPROC 0x40000
#define MMIO_FINDCHUNK 0x10
#define MMIO_FINDRIFF 0x20
#define MMIO_FINDLIST 0x40
#define MMIO_CREATERIFF 0x20
#define MMIO_CREATELIST 0x40
#define MMIO_VALIDPROC 0x11070000
#define MMIOM_READ MMIO_READ
#define MMIOM_WRITE MMIO_WRITE
#define MMIOM_SEEK 2
#define MMIOM_OPEN 3
#define MMIOM_CLOSE 4
#define MMIOM_WRITEFLUSH 5
#define MMIOM_RENAME 6
#define MMIOM_USER 0x8000
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#define MMIO_DEFAULTBUFFER 8192
#define MCIERR_INVALID_DEVICE_ID (MCIERR_BASE + 1)
#define MCIERR_UNRECOGNIZED_KEYWORD (MCIERR_BASE + 3)
#define MCIERR_UNRECOGNIZED_COMMAND (MCIERR_BASE + 5)
#define MCIERR_HARDWARE (MCIERR_BASE + 6)
#define MCIERR_INVALID_DEVICE_NAME (MCIERR_BASE + 7)
#define MCIERR_OUT_OF_MEMORY (MCIERR_BASE + 8)
#define MCIERR_DEVICE_OPEN (MCIERR_BASE + 9)
#define MCIERR_CANNOT_LOAD_DRIVER (MCIERR_BASE + 10)
#define MCIERR_MISSING_COMMAND_STRING (MCIERR_BASE + 11)
#define MCIERR_PARAM_OVERFLOW (MCIERR_BASE + 12)
#define MCIERR_MISSING_STRING_ARGUMENT (MCIERR_BASE + 13)
#define MCIERR_BAD_INTEGER (MCIERR_BASE + 14)
#define MCIERR_PARSER_INTERNAL (MCIERR_BASE + 15)
#define MCIERR_DRIVER_INTERNAL (MCIERR_BASE + 16)
#define MCIERR_MISSING_PARAMETER (MCIERR_BASE + 17)
#define MCIERR_UNSUPPORTED_FUNCTION (MCIERR_BASE + 18)
#define MCIERR_FILE_NOT_FOUND (MCIERR_BASE + 19)
#define MCIERR_DEVICE_NOT_READY (MCIERR_BASE + 20)
#define MCIERR_INTERNAL (MCIERR_BASE + 21)
#define MCIERR_DRIVER (MCIERR_BASE + 22)
#define MCIERR_CANNOT_USE_ALL (MCIERR_BASE + 23)
#define MCIERR_MULTIPLE (MCIERR_BASE + 24)
#define MCIERR_EXTENSION_NOT_FOUND (MCIERR_BASE + 25)
#define MCIERR_OUTOFRANGE (MCIERR_BASE + 26)
#define MCIERR_FLAGS_NOT_COMPATIBLE (MCIERR_BASE + 28)
#define MCIERR_FILE_NOT_SAVED (MCIERR_BASE + 30)
#define MCIERR_DEVICE_TYPE_REQUIRED (MCIERR_BASE + 31)
#define MCIERR_DEVICE_LOCKED (MCIERR_BASE + 32)
#define MCIERR_DUPLICATE_ALIAS (MCIERR_BASE + 33)
#define MCIERR_BAD_CONSTANT (MCIERR_BASE + 34)
#define MCIERR_MUST_USE_SHAREABLE (MCIERR_BASE + 35)
#define MCIERR_MISSING_DEVICE_NAME (MCIERR_BASE + 36)
#define MCIERR_BAD_TIME_FORMAT (MCIERR_BASE + 37)
#define MCIERR_NO_CLOSING_QUOTE (MCIERR_BASE + 38)
#define MCIERR_DUPLICATE_FLAGS (MCIERR_BASE + 39)
#define MCIERR_INVALID_FILE (MCIERR_BASE + 40)
#define MCIERR_NULL_PARAMETER_BLOCK (MCIERR_BASE + 41)
#define MCIERR_UNNAMED_RESOURCE (MCIERR_BASE + 42)
#define MCIERR_NEW_REQUIRES_ALIAS (MCIERR_BASE + 43)
#define MCIERR_NOTIFY_ON_AUTO_OPEN (MCIERR_BASE + 44)
#define MCIERR_NO_ELEMENT_ALLOWED (MCIERR_BASE + 45)
#define MCIERR_NONAPPLICABLE_FUNCTION (MCIERR_BASE + 46)
#define MCIERR_ILLEGAL_FOR_AUTO_OPEN (MCIERR_BASE + 47)
#define MCIERR_FILENAME_REQUIRED (MCIERR_BASE + 48)
#define MCIERR_EXTRA_CHARACTERS (MCIERR_BASE + 49)
#define MCIERR_DEVICE_NOT_INSTALLED (MCIERR_BASE + 50)
#define MCIERR_GET_CD (MCIERR_BASE + 51)
#define MCIERR_SET_CD (MCIERR_BASE + 52)
#define MCIERR_SET_DRIVE (MCIERR_BASE + 53)
#define MCIERR_DEVICE_LENGTH (MCIERR_BASE + 54)
#define MCIERR_DEVICE_ORD_LENGTH (MCIERR_BASE + 55)
#define MCIERR_NO_INTEGER (MCIERR_BASE + 56)
#define MCIERR_WAVE_OUTPUTSINUSE (MCIERR_BASE + 64)
#define MCIERR_WAVE_SETOUTPUTINUSE (MCIERR_BASE + 65)
#define MCIERR_WAVE_INPUTSINUSE (MCIERR_BASE + 66)
#define MCIERR_WAVE_SETINPUTINUSE (MCIERR_BASE + 67)
#define MCIERR_WAVE_OUTPUTUNSPECIFIED (MCIERR_BASE + 68)
#define MCIERR_WAVE_INPUTUNSPECIFIED (MCIERR_BASE + 69)
#define MCIERR_WAVE_OUTPUTSUNSUITABLE (MCIERR_BASE + 70)
#define MCIERR_WAVE_SETOUTPUTUNSUITABLE (MCIERR_BASE + 71)
#define MCIERR_WAVE_INPUTSUNSUITABLE (MCIERR_BASE + 72)
#define MCIERR_WAVE_SETINPUTUNSUITABLE (MCIERR_BASE + 73)
#define MCIERR_SEQ_DIV_INCOMPATIBLE (MCIERR_BASE + 80)
#define MCIERR_SEQ_PORT_INUSE (MCIERR_BASE + 81)
#define MCIERR_SEQ_PORT_NONEXISTENT (MCIERR_BASE + 82)
#define MCIERR_SEQ_PORT_MAPNODEVICE (MCIERR_BASE + 83)
#define MCIERR_SEQ_PORT_MISCERROR (MCIERR_BASE + 84)
#define MCIERR_SEQ_TIMER (MCIERR_BASE + 85)
#define MCIERR_SEQ_PORTUNSPECIFIED (MCIERR_BASE + 86)
#define MCIERR_SEQ_NOMIDIPRESENT (MCIERR_BASE + 87)
#define MCIERR_NO_WINDOW (MCIERR_BASE + 90)
#define MCIERR_CREATEWINDOW (MCIERR_BASE + 91)
#define MCIERR_FILE_READ (MCIERR_BASE + 92)
#define MCIERR_FILE_WRITE (MCIERR_BASE + 93)
#define MCIERR_CUSTOM_DRIVER_BASE (MCIERR_BASE + 256)
#define MCI_FIRST 0x800
#define MCI_OPEN 0x803
#define MCI_CLOSE 0x804
#define MCI_ESCAPE 0x805
#define MCI_PLAY 0x806
#define MCI_SEEK 0x807
#define MCI_STOP 0x808
#define MCI_PAUSE 0x809
#define MCI_INFO 0x80A
#define MCI_GETDEVCAPS 0x80B
#define MCI_SPIN 0x80C
#define MCI_SET 0x80D
#define MCI_STEP 0x80E
#define MCI_RECORD 0x80F
#define MCI_SYSINFO 0x810
#define MCI_BREAK 0x811
#define MCI_SOUND 0x812
#define MCI_SAVE 0x813
#define MCI_STATUS 0x814
#define MCI_CUE 0x830
#define MCI_REALIZE 0x840
#define MCI_WINDOW 0x841
#define MCI_PUT 0x842
#define MCI_WHERE 0x843
#define MCI_FREEZE 0x844
#define MCI_UNFREEZE 0x845
#define MCI_LOAD 0x850
#define MCI_CUT 0x851
#define MCI_COPY 0x852
#define MCI_PASTE 0x853
#define MCI_UPDATE 0x854
#define MCI_RESUME 0x855
#define MCI_DELETE 0x856
#define MCI_LAST 0xFFF
#define MCI_USER_MESSAGES (0x400 + MCI_FIRST)
#define MCI_ALL_DEVICE_ID - 1
#define MCI_DEVTYPE_VCR 513
#define MCI_DEVTYPE_VIDEODISC 514
#define MCI_DEVTYPE_OVERLAY 515
#define MCI_DEVTYPE_CD_AUDIO 516
#define MCI_DEVTYPE_DAT 517
#define MCI_DEVTYPE_SCANNER 518
#define MCI_DEVTYPE_ANIMATION 519
#define MCI_DEVTYPE_DIGITAL_VIDEO 520
#define MCI_DEVTYPE_OTHER 521
#define MCI_DEVTYPE_WAVEFORM_AUDIO 522
#define MCI_DEVTYPE_SEQUENCER 523
#define MCI_DEVTYPE_FIRST MCI_DEVTYPE_VCR
#define MCI_DEVTYPE_LAST MCI_DEVTYPE_SEQUENCER
#define MCI_DEVTYPE_FIRST_USER 0x1000
#define MCI_MODE_NOT_READY (MCI_STRING_OFFSET + 12)
#define MCI_MODE_STOP (MCI_STRING_OFFSET + 13)
#define MCI_MODE_PLAY (MCI_STRING_OFFSET + 14)
#define MCI_MODE_RECORD (MCI_STRING_OFFSET + 15)
#define MCI_MODE_SEEK (MCI_STRING_OFFSET + 16)
#define MCI_MODE_PAUSE (MCI_STRING_OFFSET + 17)
#define MCI_MODE_OPEN (MCI_STRING_OFFSET + 18)
#define MCI_FORMAT_MILLISECONDS 0
#define MCI_FORMAT_HMS 1
#define MCI_FORMAT_MSF 2
#define MCI_FORMAT_FRAMES 3
#define MCI_FORMAT_SMPTE_24 4
#define MCI_FORMAT_SMPTE_25 5
#define MCI_FORMAT_SMPTE_30 6
#define MCI_FORMAT_SMPTE_30DROP 7
#define MCI_FORMAT_BYTES 8
#define MCI_FORMAT_SAMPLES 9
#define MCI_FORMAT_TMSF 10
#define MCI_NOTIFY_SUCCESSFUL 0x1
#define MCI_NOTIFY_SUPERSEDED 0x2
#define MCI_NOTIFY_ABORTED 0x4
#define MCI_NOTIFY_FAILURE 0x8
#define MCI_NOTIFY 0x1
#define MCI_WAIT 0x2
#define MCI_FROM 0x4
#define MCI_TO 0x8
#define MCI_TRACK 0x10
#define MCI_OPEN_SHAREABLE 0x100
#define MCI_OPEN_ELEMENT 0x200
#define MCI_OPEN_ALIAS 0x400
#define MCI_OPEN_ELEMENT_ID 0x800
#define MCI_OPEN_TYPE_ID 0x1000
#define MCI_OPEN_TYPE 0x2000
#define MCI_SEEK_TO_START 0x100
#define MCI_SEEK_TO_END 0x200
#define MCI_STATUS_ITEM 0x100
#define MCI_STATUS_START 0x200
#define MCI_STATUS_LENGTH 0x1
#define MCI_STATUS_POSITION 0x2
#define MCI_STATUS_NUMBER_OF_TRACKS 0x3
#define MCI_STATUS_MODE 0x4
#define MCI_STATUS_MEDIA_PRESENT 0x5
#define MCI_STATUS_TIME_FORMAT 0x6
#define MCI_STATUS_READY 0x7
#define MCI_STATUS_CURRENT_TRACK 0x8
#define MCI_INFO_PRODUCT 0x100
#define MCI_INFO_FILE 0x200
#define MCI_GETDEVCAPS_ITEM 0x100
#define MCI_GETDEVCAPS_CAN_RECORD 0x1
#define MCI_GETDEVCAPS_HAS_AUDIO 0x2
#define MCI_GETDEVCAPS_HAS_VIDEO 0x3
#define MCI_GETDEVCAPS_DEVICE_TYPE 0x4
#define MCI_GETDEVCAPS_USES_FILES 0x5
#define MCI_GETDEVCAPS_COMPOUND_DEVICE 0x6
#define MCI_GETDEVCAPS_CAN_EJECT 0x7
#define MCI_GETDEVCAPS_CAN_PLAY 0x8
#define MCI_GETDEVCAPS_CAN_SAVE 0x9
#define MCI_SYSINFO_QUANTITY 0x100
#define MCI_SYSINFO_OPEN 0x200
#define MCI_SYSINFO_NAME 0x400
#define MCI_SYSINFO_INSTALLNAME 0x800
#define MCI_SET_DOOR_OPEN 0x100
#define MCI_SET_DOOR_CLOSED 0x200
#define MCI_SET_TIME_FORMAT 0x400
#define MCI_SET_AUDIO 0x800
#define MCI_SET_VIDEO 0x1000
#define MCI_SET_ON 0x2000
#define MCI_SET_OFF 0x4000
#define MCI_SET_AUDIO_ALL 0x4001
#define MCI_SET_AUDIO_LEFT 0x4002
#define MCI_SET_AUDIO_RIGHT 0x4003
#define MCI_BREAK_KEY 0x100
#define MCI_BREAK_HWND 0x200
#define MCI_BREAK_OFF 0x400
#define MCI_RECORD_INSERT 0x100
#define MCI_RECORD_OVERWRITE 0x200
#define MCI_SOUND_NAME 0x100
#define MCI_SAVE_FILE 0x100
#define MCI_LOAD_FILE 0x100
#define MCI_VD_MODE_PARK (MCI_VD_OFFSET + 1)
#define MCI_VD_MEDIA_CLV (MCI_VD_OFFSET + 2)
#define MCI_VD_MEDIA_CAV (MCI_VD_OFFSET + 3)
#define MCI_VD_MEDIA_OTHER (MCI_VD_OFFSET + 4)
#define MCI_VD_FORMAT_TRACK 0x4001
#define MCI_VD_PLAY_REVERSE 0x10000
#define MCI_VD_PLAY_FAST 0x20000
#define MCI_VD_PLAY_SPEED 0x40000
#define MCI_VD_PLAY_SCAN 0x80000
#define MCI_VD_PLAY_SLOW 0x100000
#define MCI_VD_SEEK_REVERSE 0x10000
#define MCI_VD_STATUS_SPEED 0x4002
#define MCI_VD_STATUS_FORWARD 0x4003
#define MCI_VD_STATUS_MEDIA_TYPE 0x4004
#define MCI_VD_STATUS_SIDE 0x4005
#define MCI_VD_STATUS_DISC_SIZE 0x4006
#define MCI_VD_GETDEVCAPS_CLV 0x10000
#define MCI_VD_GETDEVCAPS_CAV 0x20000
#define MCI_VD_SPIN_UP 0x10000
#define MCI_VD_SPIN_DOWN 0x20000
#define MCI_VD_GETDEVCAPS_CAN_REVERSE 0x4002
#define MCI_VD_GETDEVCAPS_FAST_RATE 0x4003
#define MCI_VD_GETDEVCAPS_SLOW_RATE 0x4004
#define MCI_VD_GETDEVCAPS_NORMAL_RATE 0x4005
#define MCI_VD_STEP_FRAMES 0x10000
#define MCI_VD_STEP_REVERSE 0x20000
#define MCI_VD_ESCAPE_STRING 0x100
#define MCI_WAVE_PCM (MCI_WAVE_OFFSET + 0)
#define MCI_WAVE_MAPPER (MCI_WAVE_OFFSET + 1)
#define MCI_WAVE_OPEN_BUFFER 0x10000
#define MCI_WAVE_SET_FORMATTAG 0x10000
#define MCI_WAVE_SET_CHANNELS 0x20000
#define MCI_WAVE_SET_SAMPLESPERSEC 0x40000
#define MCI_WAVE_SET_AVGBYTESPERSEC 0x80000
#define MCI_WAVE_SET_BLOCKALIGN 0x100000
#define MCI_WAVE_SET_BITSPERSAMPLE 0x200000
#define MCI_WAVE_INPUT 0x400000
#define MCI_WAVE_OUTPUT 0x800000
#define MCI_WAVE_STATUS_FORMATTAG 0x4001
#define MCI_WAVE_STATUS_CHANNELS 0x4002
#define MCI_WAVE_STATUS_SAMPLESPERSEC 0x4003
#define MCI_WAVE_STATUS_AVGBYTESPERSEC 0x4004
#define MCI_WAVE_STATUS_BLOCKALIGN 0x4005
#define MCI_WAVE_STATUS_BITSPERSAMPLE 0x4006
#define MCI_WAVE_STATUS_LEVEL 0x4007
#define MCI_WAVE_SET_ANYINPUT 0x4000000
#define MCI_WAVE_SET_ANYOUTPUT 0x8000000
#define MCI_WAVE_GETDEVCAPS_INPUTS 0x4001
#define MCI_WAVE_GETDEVCAPS_OUTPUTS 0x4002
#define MCI_SEQ_DIV_PPQN (0 + MCI_SEQ_OFFSET)
#define MCI_SEQ_DIV_SMPTE_24 (1 + MCI_SEQ_OFFSET)
#define MCI_SEQ_DIV_SMPTE_25 (2 + MCI_SEQ_OFFSET)
#define MCI_SEQ_DIV_SMPTE_30DROP (3 + MCI_SEQ_OFFSET)
#define MCI_SEQ_DIV_SMPTE_30 (4 + MCI_SEQ_OFFSET)
#define MCI_SEQ_FORMAT_SONGPTR 0x4001
#define MCI_SEQ_FILE 0x4002
#define MCI_SEQ_MIDI 0x4003
#define MCI_SEQ_SMPTE 0x4004
#define MCI_SEQ_NONE 65533
#define MCI_SEQ_MAPPER 65535
#define MCI_SEQ_STATUS_TEMPO 0x4002
#define MCI_SEQ_STATUS_PORT 0x4003
#define MCI_SEQ_STATUS_SLAVE 0x4007
#define MCI_SEQ_STATUS_MASTER 0x4008
#define MCI_SEQ_STATUS_OFFSET 0x4009
#define MCI_SEQ_STATUS_DIVTYPE 0x400A
#define MCI_SEQ_SET_TEMPO 0x10000
#define MCI_SEQ_SET_PORT 0x20000
#define MCI_SEQ_SET_SLAVE 0x40000
#define MCI_SEQ_SET_MASTER 0x80000
#define MCI_SEQ_SET_OFFSET 0x1000000
#define MCI_ANIM_OPEN_WS 0x10000
#define MCI_ANIM_OPEN_PARENT 0x20000
#define MCI_ANIM_OPEN_NOSTATIC 0x40000
#define MCI_ANIM_PLAY_SPEED 0x10000
#define MCI_ANIM_PLAY_REVERSE 0x20000
#define MCI_ANIM_PLAY_FAST 0x40000
#define MCI_ANIM_PLAY_SLOW 0x80000
#define MCI_ANIM_PLAY_SCAN 0x100000
#define MCI_ANIM_STEP_REVERSE 0x10000
#define MCI_ANIM_STEP_FRAMES 0x20000
#define MCI_ANIM_STATUS_SPEED 0x4001
#define MCI_ANIM_STATUS_FORWARD 0x4002
#define MCI_ANIM_STATUS_HWND 0x4003
#define MCI_ANIM_STATUS_HPAL 0x4004
#define MCI_ANIM_STATUS_STRETCH 0x4005
#define MCI_ANIM_INFO_TEXT 0x10000
#define MCI_ANIM_GETDEVCAPS_CAN_REVERSE 0x4001
#define MCI_ANIM_GETDEVCAPS_FAST_RATE 0x4002
#define MCI_ANIM_GETDEVCAPS_SLOW_RATE 0x4003
#define MCI_ANIM_GETDEVCAPS_NORMAL_RATE 0x4004
#define MCI_ANIM_GETDEVCAPS_PALETTES 0x4006
#define MCI_ANIM_GETDEVCAPS_CAN_STRETCH 0x4007
#define MCI_ANIM_GETDEVCAPS_MAX_WINDOWS 0x4008
#define MCI_ANIM_REALIZE_NORM 0x10000
#define MCI_ANIM_REALIZE_BKGD 0x20000
#define MCI_ANIM_WINDOW_HWND 0x10000
#define MCI_ANIM_WINDOW_STATE 0x40000
#define MCI_ANIM_WINDOW_TEXT 0x80000
#define MCI_ANIM_WINDOW_ENABLE_STRETCH 0x100000
#define MCI_ANIM_WINDOW_DISABLE_STRETCH 0x200000
#define MCI_ANIM_WINDOW_DEFAULT 0x0
#define MCI_ANIM_RECT 0x10000
#define MCI_ANIM_PUT_SOURCE 0x20000
#define MCI_ANIM_PUT_DESTINATION 0x40000
#define MCI_ANIM_WHERE_SOURCE 0x20000
#define MCI_ANIM_WHERE_DESTINATION 0x40000
#define MCI_ANIM_UPDATE_HDC 0x20000
#define MCI_OVLY_OPEN_WS 0x10000
#define MCI_OVLY_OPEN_PARENT 0x20000
#define MCI_OVLY_STATUS_HWND 0x4001
#define MCI_OVLY_STATUS_STRETCH 0x4002
#define MCI_OVLY_INFO_TEXT 0x10000
#define MCI_OVLY_GETDEVCAPS_CAN_STRETCH 0x4001
#define MCI_OVLY_GETDEVCAPS_CAN_FREEZE 0x4002
#define MCI_OVLY_GETDEVCAPS_MAX_WINDOWS 0x4003
#define MCI_OVLY_WINDOW_HWND 0x10000
#define MCI_OVLY_WINDOW_STATE 0x40000
#define MCI_OVLY_WINDOW_TEXT 0x80000
#define MCI_OVLY_WINDOW_ENABLE_STRETCH 0x100000
#define MCI_OVLY_WINDOW_DISABLE_STRETCH 0x200000
#define MCI_OVLY_WINDOW_DEFAULT 0x0
#define MCI_OVLY_RECT 0x10000
#define MCI_OVLY_PUT_SOURCE 0x20000
#define MCI_OVLY_PUT_DESTINATION 0x40000
#define MCI_OVLY_PUT_FRAME 0x80000
#define MCI_OVLY_PUT_VIDEO 0x100000
#define MCI_OVLY_WHERE_SOURCE 0x20000
#define MCI_OVLY_WHERE_DESTINATION 0x40000
#define MCI_OVLY_WHERE_FRAME 0x80000
#define MCI_OVLY_WHERE_VIDEO 0x100000
#define CAPS1 94
#define C1_TRANSPARENT 0x1
#define NEWTRANSPARENT 3
#define QUERYROPSUPPORT 40
#define SELECTDIB 41
#define SE_ERR_SHARE 26
#define SE_ERR_ASSOCINCOMPLETE 27
#define SE_ERR_DDETIMEOUT 28
#define SE_ERR_DDEFAIL 29
#define SE_ERR_DDEBUSY 30
#define SE_ERR_NOASSOC 31
#define PRINTER_CONTROL_PAUSE 1
#define PRINTER_CONTROL_RESUME 2
#define PRINTER_CONTROL_PURGE 3
#define PRINTER_STATUS_PAUSED 0x1
#define PRINTER_STATUS_ERROR 0x2
#define PRINTER_STATUS_PENDING_DELETION 0x4
#define PRINTER_STATUS_PAPER_JAM 0x8
#define PRINTER_STATUS_PAPER_OUT 0x10
#define PRINTER_STATUS_MANUAL_FEED 0x20
#define PRINTER_STATUS_PAPER_PROBLEM 0x40
#define PRINTER_STATUS_OFFLINE 0x80
#define PRINTER_STATUS_IO_ACTIVE 0x100
#define PRINTER_STATUS_BUSY 0x200
#define PRINTER_STATUS_PRINTING 0x400
#define PRINTER_STATUS_OUTPUT_BIN_FULL 0x800
#define PRINTER_STATUS_NOT_AVAILABLE 0x1000
#define PRINTER_STATUS_WAITING 0x2000
#define PRINTER_STATUS_PROCESSING 0x4000
#define PRINTER_STATUS_INITIALIZING 0x8000
#define PRINTER_STATUS_WARMING_UP 0x10000
#define PRINTER_STATUS_TONER_LOW 0x20000
#define PRINTER_STATUS_NO_TONER 0x40000
#define PRINTER_STATUS_PAGE_PUNT 0x80000
#define PRINTER_STATUS_USER_INTERVENTION 0x100000
#define PRINTER_STATUS_OUT_OF_MEMORY 0x200000
#define PRINTER_STATUS_DOOR_OPEN 0x400000
#define PRINTER_ATTRIBUTE_QUEUED 0x1
#define PRINTER_ATTRIBUTE_DIRECT 0x2
#define PRINTER_ATTRIBUTE_DEFAULT 0x4
#define PRINTER_ATTRIBUTE_SHARED 0x8
#define PRINTER_ATTRIBUTE_NETWORK 0x10
#define PRINTER_ATTRIBUTE_HIDDEN 0x20
#define PRINTER_ATTRIBUTE_LOCAL 0x40
#define NO_PRIORITY 0
#define MAX_PRIORITY 99
#define MIN_PRIORITY 1
#define DEF_PRIORITY 1
#define JOB_CONTROL_PAUSE 1
#define JOB_CONTROL_RESUME 2
#define JOB_CONTROL_CANCEL 3
#define JOB_CONTROL_RESTART 4
#define JOB_STATUS_PAUSED 0x1
#define JOB_STATUS_ERROR 0x2
#define JOB_STATUS_DELETING 0x4
#define JOB_STATUS_SPOOLING 0x8
#define JOB_STATUS_PRINTING 0x10
#define JOB_STATUS_OFFLINE 0x20
#define JOB_STATUS_PAPEROUT 0x40
#define JOB_STATUS_PRINTED 0x80
#define JOB_POSITION_UNSPECIFIED 0
#define FORM_BUILTIN 0x1
#define PRINTER_CONTROL_SET_STATUS 4
#define PRINTER_ATTRIBUTE_WORK_OFFLINE 0x400
#define PRINTER_ATTRIBUTE_ENABLE_BIDI 0x800
#define JOB_CONTROL_DELETE 5
#define JOB_STATUS_USER_INTERVENTION 0x10000
#define DI_CHANNEL 1
#define DI_READ_SPOOL_JOB 3
#define PORT_TYPE_WRITE 0x1
#define PORT_TYPE_READ 0x2
#define PORT_TYPE_REDIRECTED 0x4
#define PORT_TYPE_NET_ATTACHED 0x8
#define PRINTER_ENUM_DEFAULT 0x1
#define PRINTER_ENUM_LOCAL 0x2
#define PRINTER_ENUM_CONNECTIONS 0x4
#define PRINTER_ENUM_FAVORITE 0x4
#define PRINTER_ENUM_NAME 0x8
#define PRINTER_ENUM_REMOTE 0x10
#define PRINTER_ENUM_SHARED 0x20
#define PRINTER_ENUM_NETWORK 0x40
#define PRINTER_ENUM_EXPAND 0x4000
#define PRINTER_ENUM_CONTAINER 0x8000
#define PRINTER_ENUM_ICONMASK 0xFF0000
#define PRINTER_ENUM_ICON1 0x10000
#define PRINTER_ENUM_ICON2 0x20000
#define PRINTER_ENUM_ICON3 0x40000
#define PRINTER_ENUM_ICON4 0x80000
#define PRINTER_ENUM_ICON5 0x100000
#define PRINTER_ENUM_ICON6 0x200000
#define PRINTER_ENUM_ICON7 0x400000
#define PRINTER_ENUM_ICON8 0x800000
#define PRINTER_CHANGE_ADD_PRINTER 0x1
#define PRINTER_CHANGE_SET_PRINTER 0x2
#define PRINTER_CHANGE_DELETE_PRINTER 0x4
#define PRINTER_CHANGE_PRINTER 0xFF
#define PRINTER_CHANGE_ADD_JOB 0x100
#define PRINTER_CHANGE_SET_JOB 0x200
#define PRINTER_CHANGE_DELETE_JOB 0x400
#define PRINTER_CHANGE_WRITE_JOB 0x800
#define PRINTER_CHANGE_JOB 0xFF00
#define PRINTER_CHANGE_ADD_FORM 0x10000
#define PRINTER_CHANGE_SET_FORM 0x20000
#define PRINTER_CHANGE_DELETE_FORM 0x40000
#define PRINTER_CHANGE_FORM 0x70000
#define PRINTER_CHANGE_ADD_PORT 0x100000
#define PRINTER_CHANGE_CONFIGURE_PORT 0x200000
#define PRINTER_CHANGE_DELETE_PORT 0x400000
#define PRINTER_CHANGE_PORT 0x700000
#define PRINTER_CHANGE_ADD_PRINT_PROCESSOR 0x1000000
#define PRINTER_CHANGE_DELETE_PRINT_PROCESSOR 0x4000000
#define PRINTER_CHANGE_PRINT_PROCESSOR 0x7000000
#define PRINTER_CHANGE_ADD_PRINTER_DRIVER 0x10000000
#define PRINTER_CHANGE_DELETE_PRINTER_DRIVER 0x40000000
#define PRINTER_CHANGE_PRINTER_DRIVER 0x70000000
#define PRINTER_CHANGE_TIMEOUT 0x80000000
#define PRINTER_CHANGE_ALL 0x7777FFFF
#define PRINTER_ERROR_INFORMATION 0x80000000
#define PRINTER_ERROR_WARNING 0x40000000
#define PRINTER_ERROR_SEVERE 0x20000000
#define PRINTER_ERROR_OUTOFPAPER 0x1
#define PRINTER_ERROR_JAM 0x2
#define PRINTER_ERROR_OUTOFTONER 0x4
#define SERVER_ACCESS_ADMINISTER 0x1
#define SERVER_ACCESS_ENUMERATE 0x2
#define PRINTER_ACCESS_ADMINISTER 0x4
#define PRINTER_ACCESS_USE 0x8
#define JOB_ACCESS_ADMINISTER 0x10
#define SERVER_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SERVER_ACCESS_ADMINISTER|SERVER_ACCESS_ENUMERATE)
#define SERVER_READ (STANDARD_RIGHTS_READ|SERVER_ACCESS_ENUMERATE)
#define SERVER_WRITE (STANDARD_RIGHTS_WRITE|SERVER_ACCESS_ADMINISTER|SERVER_ACCESS_ENUMERATE)
#define SERVER_EXECUTE (STANDARD_RIGHTS_EXECUTE|SERVER_ACCESS_ENUMERATE)
#define PRINTER_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|PRINTER_ACCESS_ADMINISTER|PRINTER_ACCESS_USE)
#define PRINTER_READ (STANDARD_RIGHTS_READ|PRINTER_ACCESS_USE)
#define PRINTER_WRITE (STANDARD_RIGHTS_WRITE|PRINTER_ACCESS_USE)
#define PRINTER_EXECUTE (STANDARD_RIGHTS_EXECUTE|PRINTER_ACCESS_USE)
#define JOB_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|JOB_ACCESS_ADMINISTER)
#define JOB_READ (STANDARD_RIGHTS_READ|JOB_ACCESS_ADMINISTER)
#define JOB_WRITE (STANDARD_RIGHTS_WRITE|JOB_ACCESS_ADMINISTER)
#define JOB_EXECUTE (STANDARD_RIGHTS_EXECUTE|JOB_ACCESS_ADMINISTER)
#define RESOURCE_CONNECTED 0x1
#define RESOURCE_PUBLICNET 0x2
#define RESOURCE_REMEMBERED 0x3
#define RESOURCETYPE_ANY 0x0
#define RESOURCETYPE_DISK 0x1
#define RESOURCETYPE_PRINT 0x2
#define RESOURCETYPE_UNKNOWN 0xFFFF
#define RESOURCEUSAGE_CONNECTABLE 0x1
#define RESOURCEUSAGE_CONTAINER 0x2
#define RESOURCEUSAGE_RESERVED 0x80000000
#define RESOURCEDISPLAYTYPE_GENERIC 0x0
#define RESOURCEDISPLAYTYPE_DOMAIN 0x1
#define RESOURCEDISPLAYTYPE_SERVER 0x2
#define RESOURCEDISPLAYTYPE_SHARE 0x3
#define RESOURCEDISPLAYTYPE_FILE 0x4
#define RESOURCEDISPLAYTYPE_GROUP 0x5
#define CONNECT_UPDATE_PROFILE 0x1
#define WN_SUCCESS NO_ERROR
#define WN_NOT_SUPPORTED ERROR_NOT_SUPPORTED
#define WN_NET_ERROR ERROR_UNEXP_NET_ERR
#define WN_MORE_DATA ERROR_MORE_DATA
#define WN_BAD_POINTER ERROR_INVALID_ADDRESS
#define WN_BAD_VALUE ERROR_INVALID_PARAMETER
#define WN_BAD_PASSWORD ERROR_INVALID_PASSWORD
#define WN_ACCESS_DENIED ERROR_ACCESS_DENIED
#define WN_FUNCTION_BUSY ERROR_BUSY
#define WN_WINDOWS_ERROR ERROR_UNEXP_NET_ERR
#define WN_BAD_USER ERROR_BAD_USERNAME
#define WN_OUT_OF_MEMORY ERROR_NOT_ENOUGH_MEMORY
#define WN_NO_NETWORK ERROR_NO_NETWORK
#define WN_EXTENDED_ERROR ERROR_EXTENDED_ERROR
#define WN_NOT_CONNECTED ERROR_NOT_CONNECTED
#define WN_OPEN_FILES ERROR_OPEN_FILES
#define WN_DEVICE_IN_USE ERROR_DEVICE_IN_USE
#define WN_BAD_NETNAME ERROR_BAD_NET_NAME
#define WN_BAD_LOCALNAME ERROR_BAD_DEVICE
#define WN_ALREADY_CONNECTED ERROR_ALREADY_ASSIGNED
#define WN_DEVICE_ERROR ERROR_GEN_FAILURE
#define WN_CONNECTION_CLOSED ERROR_CONNECTION_UNAVAIL
#define WN_NO_NET_OR_BAD_PATH ERROR_NO_NET_OR_BAD_PATH
#define WN_BAD_PROVIDER ERROR_BAD_PROVIDER
#define WN_CANNOT_OPEN_PROFILE ERROR_CANNOT_OPEN_PROFILE
#define WN_BAD_PROFILE ERROR_BAD_PROFILE
#define WN_BAD_HANDLE ERROR_INVALID_HANDLE
#define WN_NO_MORE_ENTRIES ERROR_NO_MORE_ITEMS
#define WN_NOT_CONTAINER ERROR_NOT_CONTAINER
#define WN_NO_ERROR NO_ERROR
#define NCBNAMSZ 16
#define MAX_LANA 254
#define NAME_FLAGS_MASK 0x87
#define GROUP_NAME 0x80
#define UNIQUE_NAME 0x0
#define REGISTERING 0x0
#define REGISTERED 0x4
#define DEREGISTERED 0x5
#define DUPLICATE 0x6
#define DUPLICATE_DEREG 0x7
#define LISTEN_OUTSTANDING 0x1
#define CALL_PENDING 0x2
#define SESSION_ESTABLISHED 0x3
#define HANGUP_PENDING 0x4
#define HANGUP_COMPLETE 0x5
#define SESSION_ABORTED 0x6
#define ALL_TRANSPORTS "M\0\0\0"
#define MS_NBF "MNBF"
#define NCBCALL 0x10
#define NCBLISTEN 0x11
#define NCBHANGUP 0x12
#define NCBSEND 0x14
#define NCBRECV 0x15
#define NCBRECVANY 0x16
#define NCBCHAINSEND 0x17
#define NCBDGSEND 0x20
#define NCBDGRECV 0x21
#define NCBDGSENDBC 0x22
#define NCBDGRECVBC 0x23
#define NCBADDNAME 0x30
#define NCBDELNAME 0x31
#define NCBRESET 0x32
#define NCBASTAT 0x33
#define NCBSSTAT 0x34
#define NCBCANCEL 0x35
#define NCBADDGRNAME 0x36
#define NCBENUM 0x37
#define NCBUNLINK 0x70
#define NCBSENDNA 0x71
#define NCBCHAINSENDNA 0x72
#define NCBLANSTALERT 0x73
#define NCBACTION 0x77
#define NCBFINDNAME 0x78
#define NCBTRACE 0x79
#define ASYNCH 0x80
#define NRC_GOODRET 0x0
#define NRC_BUFLEN 0x1
#define NRC_ILLCMD 0x3
#define NRC_CMDTMO 0x5
#define NRC_INCOMP 0x6
#define NRC_BADDR 0x7
#define NRC_SNUMOUT 0x8
#define NRC_NORES 0x9
#define NRC_SCLOSED 0xA
#define NRC_CMDCAN 0xB
#define NRC_DUPNAME 0xD
#define NRC_NAMTFUL 0xE
#define NRC_ACTSES 0xF
#define NRC_LOCTFUL 0x11
#define NRC_REMTFUL 0x12
#define NRC_ILLNN 0x13
#define NRC_NOCALL 0x14
#define NRC_NOWILD 0x15
#define NRC_INUSE 0x16
#define NRC_NAMERR 0x17
#define NRC_SABORT 0x18
#define NRC_NAMCONF 0x19
#define NRC_IFBUSY 0x21
#define NRC_TOOMANY 0x22
#define NRC_BRIDGE 0x23
#define NRC_CANOCCR 0x24
#define NRC_CANCEL 0x26
#define NRC_DUPENV 0x30
#define NRC_ENVNOTDEF 0x34
#define NRC_OSRESNOTAV 0x35
#define NRC_MAXAPPS 0x36
#define NRC_NOSAPS 0x37
#define NRC_NORESOURCES 0x38
#define NRC_INVADDRESS 0x39
#define NRC_INVDDID 0x3B
#define NRC_LOCKFAIL 0x3C
#define NRC_OPENERR 0x3F
#define NRC_SYSTEM 0x40
#define NRC_PENDING 0xFF
#define FILTER_TEMP_DUPLICATE_ACCOUNT 0x1
#define FILTER_NORMAL_ACCOUNT 0x2
#define FILTER_PROXY_ACCOUNT 0x4
#define FILTER_INTERDOMAIN_TRUST_ACCOUNT 0x8
#define FILTER_WORKSTATION_TRUST_ACCOUNT 0x10
#define FILTER_SERVER_TRUST_ACCOUNT 0x20
#define TIMEQ_FOREVER -1
#define USER_MAXSTORAGE_UNLIMITED -1
#define USER_NO_LOGOFF -1
#define UNITS_PER_DAY 24
#define UNITS_PER_WEEK UNITS_PER_DAY * 7
#define USER_PRIV_MASK 3
#define USER_PRIV_GUEST 0
#define USER_PRIV_USER 1
#define USER_PRIV_ADMIN 2
#define UNLEN 256
#define GNLEN UNLEN
#define CNLEN 15
#define PWLEN 256
#define LM20_PWLEN 14
#define MAXCOMMENTSZ 256
#define LG_INCLUDE_INDIRECT 0x1
#define UF_SCRIPT 0x1
#define UF_ACCOUNTDISABLE 0x2
#define UF_HOMEDIR_REQUIRED 0x8
#define UF_LOCKOUT 0x10
#define UF_PASSWD_NOTREQD 0x20
#define UF_PASSWD_CANT_CHANGE 0x40
#define LG_INCLUDE_INDIRECT 0x1
#define NERR_Success 0
#define NERR_BASE 2100
#define NERR_InvalidComputer (NERR_BASE + 251)
#define NERR_NotPrimary (NERR_BASE + 126)
#define NERR_GroupExists (NERR_BASE + 123)
#define NERR_UserExists (NERR_BASE + 124)
#define NERR_PasswordTooShort (NERR_BASE + 145)
#define RESOURCE_CONNECTED 0x1
#define RESOURCE_GLOBALNET 0x2
#define RESOURCE_REMEMBERED 0x3
#define RESOURCE_ENUM_ALL 0xFFFF
#define RESOURCEDISPLAYTYPE_DOMAIN 0x1
#define RESOURCEDISPLAYTYPE_FILE 0x4
#define RESOURCEDISPLAYTYPE_GENERIC 0x0
#define RESOURCEDISPLAYTYPE_GROUP 0x5
#define RESOURCEDISPLAYTYPE_SERVER 0x2
#define RESOURCEDISPLAYTYPE_SHARE 0x3
#define RESOURCETYPE_ANY 0x0
#define RESOURCETYPE_DISK 0x1
#define RESOURCETYPE_PRINT 0x2
#define RESOURCETYPE_UNKNOWN 0xFFFF
#define RESOURCEUSAGE_ALL 0x0
#define RESOURCEUSAGE_CONNECTABLE 0x1
#define RESOURCEUSAGE_CONTAINER 0x2
#define RESOURCEUSAGE_RESERVED 0x80000000
#define EXCEPTION_EXECUTE_HANDLER 1
#define EXCEPTION_CONTINUE_SEARCH 0
#define EXCEPTION_CONTINUE_EXECUTION -1
#define ctlFirst 0x400
#define ctlLast 0x4FF
#define psh1 0x400
#define psh2 0x401
#define psh3 0x402
#define psh4 0x403
#define psh5 0x404
#define psh6 0x405
#define psh7 0x406
#define psh8 0x407
#define psh9 0x408
#define psh10 0x409
#define psh11 0x40A
#define psh12 0x40B
#define psh13 0x40C
#define psh14 0x40D
#define psh15 0x40E
#define pshHelp psh15
#define psh16 0x40F
#define chx1 0x410
#define chx2 0x411
#define chx3 0x412
#define chx4 0x413
#define chx5 0x414
#define chx6 0x415
#define chx7 0x416
#define chx8 0x417
#define chx9 0x418
#define chx10 0x419
#define chx11 0x41A
#define chx12 0x41B
#define chx13 0x41C
#define chx14 0x41D
#define chx15 0x41E
#define chx16 0x41D
#define rad1 0x420
#define rad2 0x421
#define rad3 0x422
#define rad4 0x423
#define rad5 0x424
#define rad6 0x425
#define rad7 0x426
#define rad8 0x427
#define rad9 0x428
#define rad10 0x429
#define rad11 0x42A
#define rad12 0x42B
#define rad13 0x42C
#define rad14 0x42D
#define rad15 0x42E
#define rad16 0x42F
#define grp1 0x430
#define grp2 0x431
#define grp3 0x432
#define grp4 0x433
#define frm1 0x434
#define frm2 0x435
#define frm3 0x436
#define frm4 0x437
#define rct1 0x438
#define rct2 0x439
#define rct3 0x43A
#define rct4 0x43B
#define ico1 0x43C
#define ico2 0x43D
#define ico3 0x43E
#define ico4 0x43F
#define stc1 0x440
#define stc2 0x441
#define stc3 0x442
#define stc4 0x443
#define stc5 0x444
#define stc6 0x445
#define stc7 0x446
#define stc8 0x447
#define stc9 0x448
#define stc10 0x449
#define stc11 0x44A
#define stc12 0x44B
#define stc13 0x44C
#define stc14 0x44D
#define stc15 0x44E
#define stc16 0x44F
#define stc17 0x450
#define stc18 0x451
#define stc19 0x452
#define stc20 0x453
#define stc21 0x454
#define stc22 0x455
#define stc23 0x456
#define stc24 0x457
#define stc25 0x458
#define stc26 0x459
#define stc27 0x45A
#define stc28 0x45B
#define stc29 0x45C
#define stc30 0x45D
#define stc31 0x45E
#define stc32 0x45F
#define lst1 0x460
#define lst2 0x461
#define lst3 0x462
#define lst4 0x463
#define lst5 0x464
#define lst6 0x465
#define lst7 0x466
#define lst8 0x467
#define lst9 0x468
#define lst10 0x469
#define lst11 0x46A
#define lst12 0x46B
#define lst13 0x46C
#define lst14 0x46D
#define lst15 0x46E
#define lst16 0x46F
#define cmb1 0x470
#define cmb2 0x471
#define cmb3 0x472
#define cmb4 0x473
#define cmb5 0x474
#define cmb6 0x475
#define cmb7 0x476
#define cmb8 0x477
#define cmb9 0x478
#define cmb10 0x479
#define cmb11 0x47A
#define cmb12 0x47B
#define cmb13 0x47C
#define cmb14 0x47D
#define cmb15 0x47E
#define cmb16 0x47F
#define edt1 0x480
#define edt2 0x481
#define edt3 0x482
#define edt4 0x483
#define edt5 0x484
#define edt6 0x485
#define edt7 0x486
#define edt8 0x487
#define edt9 0x488
#define edt10 0x489
#define edt11 0x48A
#define edt12 0x48B
#define edt13 0x48C
#define edt14 0x48D
#define edt15 0x48E
#define edt16 0x48F
#define scr1 0x490
#define scr2 0x491
#define scr3 0x492
#define scr4 0x493
#define scr5 0x494
#define scr6 0x495
#define scr7 0x496
#define scr8 0x497
#define FILEOPENORD 1536
#define MULTIFILEOPENORD 1537
#define PRINTDLGORD 1538
#define PRNSETUPDLGORD 1539
#define FINDDLGORD 1540
#define REPLACEDLGORD 1541
#define FONTDLGORD 1542
#define FORMATDLGORD31 1543
#define FORMATDLGORD30 1544
#define HKEY_CLASSES_ROOT 0x80000000
#define HKEY_CURRENT_USER 0x80000001
#define HKEY_LOCAL_MACHINE 0x80000002
#define HKEY_USERS 0x80000003
#define HKEY_PERFORMANCE_DATA 0x80000004
#define HKEY_CURRENT_CONFIG 0x80000005
#define HKEY_DYN_DATA 0x80000006
#define SERVICES_ACTIVE_DATABASE "ServicesActive"
#define SERVICES_FAILED_DATABASE "ServicesFailed"
#define SERVICE_NO_CHANGE 0xFFFF
#define SERVICE_ACTIVE 0x1
#define SERVICE_INACTIVE 0x2
#define SERVICE_STATE_ALL (SERVICE_ACTIVE|SERVICE_INACTIVE)
#define SERVICE_CONTROL_STOP 0x1
#define SERVICE_CONTROL_PAUSE 0x2
#define SERVICE_CONTROL_CONTINUE 0x3
#define SERVICE_CONTROL_INTERROGATE 0x4
#define SERVICE_CONTROL_SHUTDOWN 0x5
#define SERVICE_STOPPED 0x1
#define SERVICE_START_PENDING 0x2
#define SERVICE_STOP_PENDING 0x3
#define SERVICE_RUNNING 0x4
#define SERVICE_CONTINUE_PENDING 0x5
#define SERVICE_PAUSE_PENDING 0x6
#define SERVICE_PAUSED 0x7
#define SERVICE_ACCEPT_STOP 0x1
#define SERVICE_ACCEPT_PAUSE_CONTINUE 0x2
#define SERVICE_ACCEPT_SHUTDOWN 0x4
#define SC_MANAGER_CONNECT 0x1
#define SC_MANAGER_CREATE_SERVICE 0x2
#define SC_MANAGER_ENUMERATE_SERVICE 0x4
#define SC_MANAGER_LOCK 0x8
#define SC_MANAGER_QUERY_LOCK_STATUS 0x10
#define SC_MANAGER_MODIFY_BOOT_CONFIG 0x20
#define SC_MANAGER_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SC_MANAGER_CONNECT|SC_MANAGER_CREATE_SERVICE|SC_MANAGER_ENUMERATE_SERVICE|SC_MANAGER_LOCK|SC_MANAGER_QUERY_LOCK_STATUS|SC_MANAGER_MODIFY_BOOT_CONFIG)
#define SERVICE_QUERY_CONFIG 0x1
#define SERVICE_CHANGE_CONFIG 0x2
#define SERVICE_QUERY_STATUS 0x4
#define SERVICE_ENUMERATE_DEPENDENTS 0x8
#define SERVICE_START 0x10
#define SERVICE_STOP 0x20
#define SERVICE_PAUSE_CONTINUE 0x40
#define SERVICE_INTERROGATE 0x80
#define SERVICE_USER_DEFINED_CONTROL 0x100
#define SERVICE_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SERVICE_QUERY_CONFIG|SERVICE_CHANGE_CONFIG|SERVICE_QUERY_STATUS|SERVICE_ENUMERATE_DEPENDENTS|SERVICE_START|SERVICE_STOP|SERVICE_PAUSE_CONTINUE|SERVICE_INTERROGATE|SERVICE_USER_DEFINED_CONTROL)
#define SC_GROUP_IDENTIFIER "+"
#define PERF_DATA_VERSION 1
#define PERF_DATA_REVISION 1
#define PERF_NO_INSTANCES -1
#define PERF_SIZE_DWORD 0x0
#define PERF_SIZE_LARGE 0x100
#define PERF_SIZE_ZERO 0x200
#define PERF_SIZE_VARIABLE_LEN 0x300
#define PERF_TYPE_NUMBER 0x0
#define PERF_TYPE_COUNTER 0x400
#define PERF_TYPE_TEXT 0x800
#define PERF_TYPE_ZERO 0xC00
#define PERF_NUMBER_HEX 0x0
#define PERF_NUMBER_DECIMAL 0x10000
#define PERF_NUMBER_DEC_1000 0x20000
#define PERF_COUNTER_VALUE 0x0
#define PERF_COUNTER_RATE 0x10000
#define PERF_COUNTER_FRACTION 0x20000
#define PERF_COUNTER_BASE 0x30000
#define PERF_COUNTER_ELAPSED 0x40000
#define PERF_COUNTER_QUEUELEN 0x50000
#define PERF_COUNTER_HISTOGRAM 0x60000
#define PERF_TEXT_UNICODE 0x0
#define PERF_TEXT_ASCII 0x10000
#define PERF_TIMER_TICK 0x0
#define PERF_TIMER_100NS 0x100000
#define PERF_OBJECT_TIMER 0x200000
#define PERF_DELTA_COUNTER 0x400000
#define PERF_DELTA_BASE 0x800000
#define PERF_INVERSE_COUNTER 0x1000000
#define PERF_MULTI_COUNTER 0x2000000
#define PERF_DISPLAY_NO_SUFFIX 0x0
#define PERF_DISPLAY_PER_SEC 0x10000000
#define PERF_DISPLAY_PERCENT 0x20000000
#define PERF_DISPLAY_SECONDS 0x30000000
#define PERF_DISPLAY_NOSHOW 0x40000000
#define PERF_COUNTER_COUNTER (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_DISPLAY_PER_SEC)
#define PERF_COUNTER_TIMER (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_COUNTER_QUEUELEN_TYPE (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_QUEUELEN|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_DISPLAY_NO_SUFFIX)
#define PERF_COUNTER_BULK_COUNT (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_DISPLAY_PER_SEC)
#define PERF_COUNTER_TEXT (PERF_SIZE_VARIABLE_LEN|PERF_TYPE_TEXT|PERF_TEXT_UNICODE|PERF_DISPLAY_NO_SUFFIX)
#define PERF_COUNTER_RAWCOUNT (PERF_SIZE_DWORD|PERF_TYPE_NUMBER|PERF_NUMBER_DECIMAL|PERF_DISPLAY_NO_SUFFIX)
#define PERF_SAMPLE_FRACTION (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_FRACTION|PERF_DELTA_COUNTER|PERF_DELTA_BASE|PERF_DISPLAY_PERCENT)
#define PERF_SAMPLE_COUNTER (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_DISPLAY_NO_SUFFIX)
#define PERF_COUNTER_NODATA (PERF_SIZE_ZERO|PERF_DISPLAY_NOSHOW)
#define PERF_COUNTER_TIMER_INV (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_TICK|PERF_DELTA_COUNTER|PERF_INVERSE_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_SAMPLE_BASE (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_BASE|PERF_DISPLAY_NOSHOW|0x1)
#define PERF_AVERAGE_TIMER (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_FRACTION|PERF_DISPLAY_SECONDS)
#define PERF_AVERAGE_BASE (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_BASE|PERF_DISPLAY_NOSHOW|0x2)
#define PERF_AVERAGE_BULK (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_FRACTION|PERF_DISPLAY_NOSHOW)
#define PERF_100NSEC_TIMER (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_100NS|PERF_DELTA_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_100NSEC_TIMER_INV (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_100NS|PERF_DELTA_COUNTER|PERF_INVERSE_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_COUNTER_MULTI_TIMER (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_DELTA_COUNTER|PERF_TIMER_TICK|PERF_MULTI_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_COUNTER_MULTI_TIMER_INV (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_RATE|PERF_DELTA_COUNTER|PERF_MULTI_COUNTER|PERF_TIMER_TICK|PERF_INVERSE_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_COUNTER_MULTI_BASE (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_BASE|PERF_MULTI_COUNTER|PERF_DISPLAY_NOSHOW)
#define PERF_100NSEC_MULTI_TIMER (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_DELTA_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_100NS|PERF_MULTI_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_100NSEC_MULTI_TIMER_INV (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_DELTA_COUNTER|PERF_COUNTER_RATE|PERF_TIMER_100NS|PERF_MULTI_COUNTER|PERF_INVERSE_COUNTER|PERF_DISPLAY_PERCENT)
#define PERF_RAW_FRACTION (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_FRACTION|PERF_DISPLAY_PERCENT)
#define PERF_RAW_BASE (PERF_SIZE_DWORD|PERF_TYPE_COUNTER|PERF_COUNTER_BASE|PERF_DISPLAY_NOSHOW|0x3)
#define PERF_ELAPSED_TIME (PERF_SIZE_LARGE|PERF_TYPE_COUNTER|PERF_COUNTER_ELAPSED|PERF_OBJECT_TIMER|PERF_DISPLAY_SECONDS)
#define PERF_COUNTER_HISTOGRAM_TYPE 0x80000000
#define PERF_DETAIL_NOVICE 100
#define PERF_DETAIL_ADVANCED 200
#define PERF_DETAIL_EXPERT 300
#define PERF_DETAIL_WIZARD 400
#define PERF_NO_UNIQUE_ID -1
#define CDERR_DIALOGFAILURE 0xFFFF
#define CDERR_GENERALCODES 0x0
#define CDERR_STRUCTSIZE 0x1
#define CDERR_INITIALIZATION 0x2
#define CDERR_NOTEMPLATE 0x3
#define CDERR_NOHINSTANCE 0x4
#define CDERR_LOADSTRFAILURE 0x5
#define CDERR_FINDRESFAILURE 0x6
#define CDERR_LOADRESFAILURE 0x7
#define CDERR_LOCKRESFAILURE 0x8
#define CDERR_MEMALLOCFAILURE 0x9
#define CDERR_MEMLOCKFAILURE 0xA
#define CDERR_NOHOOK 0xB
#define CDERR_REGISTERMSGFAIL 0xC
#define PDERR_PRINTERCODES 0x1000
#define PDERR_SETUPFAILURE 0x1001
#define PDERR_PARSEFAILURE 0x1002
#define PDERR_RETDEFFAILURE 0x1003
#define PDERR_LOADDRVFAILURE 0x1004
#define PDERR_GETDEVMODEFAIL 0x1005
#define PDERR_INITFAILURE 0x1006
#define PDERR_NODEVICES 0x1007
#define PDERR_NODEFAULTPRN 0x1008
#define PDERR_DNDMMISMATCH 0x1009
#define PDERR_CREATEICFAILURE 0x100A
#define PDERR_PRINTERNOTFOUND 0x100B
#define PDERR_DEFAULTDIFFERENT 0x100C
#define CFERR_CHOOSEFONTCODES 0x2000
#define CFERR_NOFONTS 0x2001
#define CFERR_MAXLESSTHANMIN 0x2002
#define FNERR_FILENAMECODES 0x3000
#define FNERR_SUBCLASSFAILURE 0x3001
#define FNERR_INVALIDFILENAME 0x3002
#define FNERR_BUFFERTOOSMALL 0x3003
#define FRERR_FINDREPLACECODES 0x4000
#define FRERR_BUFFERLENGTHZERO 0x4001
#define CCERR_CHOOSECOLORCODES 0x5000
#define LZERROR_BADINHANDLE (-1)
#define LZERROR_BADOUTHANDLE (-2)
#define LZERROR_READ (-3)
#define LZERROR_WRITE (-4)
#define LZERROR_PUBLICLOC (-5)
#define LZERROR_GLOBLOCK (-6)
#define LZERROR_BADVALUE (-7)
#define LZERROR_UNKNOWNALG (-8)
#define VK_PROCESSKEY 0xE5
#define STYLE_DESCRIPTION_SIZE 32
#define WM_CONVERTREQUESTEX 0x108
#define WM_IME_STARTCOMPOSITION 0x10D
#define WM_IME_ENDCOMPOSITION 0x10E
#define WM_IME_COMPOSITION 0x10F
#define WM_IME_KEYLAST 0x10F
#define WM_IME_SETCONTEXT 0x281
#define WM_IME_NOTIFY 0x282
#define WM_IME_CONTROL 0x283
#define WM_IME_COMPOSITIONFULL 0x284
#define WM_IME_SELECT 0x285
#define WM_IME_CHAR 0x286
#define WM_IME_KEYDOWN 0x290
#define WM_IME_KEYUP 0x291
#define IMC_GETCANDIDATEPOS 0x7
#define IMC_SETCANDIDATEPOS 0x8
#define IMC_GETCOMPOSITIONFONT 0x9
#define IMC_SETCOMPOSITIONFONT 0xA
#define IMC_GETCOMPOSITIONWINDOW 0xB
#define IMC_SETCOMPOSITIONWINDOW 0xC
#define IMC_GETSTATUSWINDOWPOS 0xF
#define IMC_SETSTATUSWINDOWPOS 0x10
#define IMC_CLOSESTATUSWINDOW 0x21
#define IMC_OPENSTATUSWINDOW 0x22
#define NI_OPENCANDIDATE 0x10
#define NI_CLOSECANDIDATE 0x11
#define NI_SELECTCANDIDATESTR 0x12
#define NI_CHANGECANDIDATELIST 0x13
#define NI_FINALIZECONVERSIONRESULT 0x14
#define NI_COMPOSITIONSTR 0x15
#define NI_SETCANDIDATE_PAGESTART 0x16
#define NI_SETCANDIDATE_PAGESIZE 0x17
#define ISC_SHOWUICANDIDATEWINDOW 0x1
#define ISC_SHOWUICOMPOSITIONWINDOW 0x80000000
#define ISC_SHOWUIGUIDELINE 0x40000000
#define ISC_SHOWUIALLCANDIDATEWINDOW 0xF
#define ISC_SHOWUIALL 0xC000000F
#define CPS_COMPLETE 0x1
#define CPS_CONVERT 0x2
#define CPS_REVERT 0x3
#define CPS_CANCEL 0x4
#define IME_CHOTKEY_IME_NONIME_TOGGLE 0x10
#define IME_CHOTKEY_SHAPE_TOGGLE 0x11
#define IME_CHOTKEY_SYMBOL_TOGGLE 0x12
#define IME_JHOTKEY_CLOSE_OPEN 0x30
#define IME_KHOTKEY_SHAPE_TOGGLE 0x50
#define IME_KHOTKEY_HANJACONVERT 0x51
#define IME_KHOTKEY_ENGLISH 0x52
#define IME_THOTKEY_IME_NONIME_TOGGLE 0x70
#define IME_THOTKEY_SHAPE_TOGGLE 0x71
#define IME_THOTKEY_SYMBOL_TOGGLE 0x72
#define IME_HOTKEY_DSWITCH_FIRST 0x100
#define IME_HOTKEY_DSWITCH_LAST 0x11F
#define IME_ITHOTKEY_RESEND_RESULTSTR 0x200
#define IME_ITHOTKEY_PREVIOUS_COMPOSITION 0x201
#define IME_ITHOTKEY_UISTYLE_TOGGLE 0x202
#define GCS_COMPREADSTR 0x1
#define GCS_COMPREADATTR 0x2
#define GCS_COMPREADCLAUSE 0x4
#define GCS_COMPSTR 0x8
#define GCS_COMPATTR 0x10
#define GCS_COMPCLAUSE 0x20
#define GCS_CURSORPOS 0x80
#define GCS_DELTASTART 0x100
#define GCS_RESULTREADSTR 0x200
#define GCS_RESULTREADCLAUSE 0x400
#define GCS_RESULTSTR 0x800
#define GCS_RESULTCLAUSE 0x1000
#define CS_INSERTCHAR 0x2000
#define CS_NOMOVECARET 0x4000
#define IME_PROP_AT_CARET 0x10000
#define IME_PROP_SPECIAL_UI 0x20000
#define IME_PROP_CANDLIST_START_FROM_1 0x40000
#define IME_PROP_UNICODE 0x80000
#define UI_CAP_2700 0x1
#define UI_CAP_ROT90 0x2
#define UI_CAP_ROTANY 0x4
#define SCS_CAP_COMPSTR 0x1
#define SCS_CAP_MAKEREAD 0x2
#define SELECT_CAP_CONVERSION 0x1
#define SELECT_CAP_SENTENCE 0x2
#define GGL_LEVEL 0x1
#define GGL_INDEX 0x2
#define GGL_STRING 0x3
#define GGL_PRIVATE 0x4
#define GL_LEVEL_NOGUIDELINE 0x0
#define GL_LEVEL_FATAL 0x1
#define GL_LEVEL_ERROR 0x2
#define GL_LEVEL_WARNING 0x3
#define GL_LEVEL_INFORMATION 0x4
#define GL_ID_UNKNOWN 0x0
#define GL_ID_NOMODULE 0x1
#define GL_ID_NODICTIONARY 0x10
#define GL_ID_CANNOTSAVE 0x11
#define GL_ID_NOCONVERT 0x20
#define GL_ID_TYPINGERROR 0x21
#define GL_ID_TOOMANYSTROKE 0x22
#define GL_ID_READINGCONFLICT 0x23
#define GL_ID_INPUTREADING 0x24
#define GL_ID_INPUTRADICAL 0x25
#define GL_ID_INPUTCODE 0x26
#define GL_ID_INPUTSYMBOL 0x27
#define GL_ID_CHOOSECANDIDATE 0x28
#define GL_ID_REVERSECONVERSION 0x29
#define GL_ID_PRIVATE_FIRST 0x8000
#define GL_ID_PRIVATE_LAST 0xFFFF
#define IGP_PROPERTY 0x4
#define IGP_CONVERSION 0x8
#define IGP_SENTENCE 0xC
#define IGP_UI 0x10
#define IGP_SETCOMPSTR 0x14
#define IGP_SELECT 0x18
#define SCS_SETSTR (GCS_COMPREADSTR|GCS_COMPSTR)
#define SCS_CHANGEATTR (GCS_COMPREADATTR|GCS_COMPATTR)
#define SCS_CHANGECLAUSE (GCS_COMPREADCLAUSE|GCS_COMPCLAUSE)
#define ATTR_INPUT 0x0
#define ATTR_TARGET_CONVERTED 0x1
#define ATTR_CONVERTED 0x2
#define ATTR_TARGET_NOTCONVERTED 0x3
#define ATTR_INPUT_ERROR 0x4
#define CFS_DEFAULT 0x0
#define CFS_RECT 0x1
#define CFS_POINT 0x2
#define CFS_SCREEN 0x4
#define CFS_FORCE_POSITION 0x20
#define CFS_CANDIDATEPOS 0x40
#define CFS_EXCLUDE 0x80
#define GCL_CONVERSION 0x1
#define GCL_REVERSECONVERSION 0x2
#define GCL_REVERSE_LENGTH 0x3
#define IME_CMODE_ALPHANUMERIC 0x0
#define IME_CMODE_NATIVE 0x1
#define IME_CMODE_CHINESE IME_CMODE_NATIVE
#define IME_CMODE_HANGEUL IME_CMODE_NATIVE
#define IME_CMODE_JAPANESE IME_CMODE_NATIVE
#define IME_CMODE_KATAKANA 0x2
#define IME_CMODE_LANGUAGE 0x3
#define IME_CMODE_FULLSHAPE 0x8
#define IME_CMODE_ROMAN 0x10
#define IME_CMODE_CHARCODE 0x20
#define IME_CMODE_HANJACONVERT 0x40
#define IME_CMODE_SOFTKBD 0x80
#define IME_CMODE_NOCONVERSION 0x100
#define IME_CMODE_EUDC 0x200
#define IME_CMODE_SYMBOL 0x400
#define IME_SMODE_NONE 0x0
#define IME_SMODE_PLAURALCLAUSE 0x1
#define IME_SMODE_SINGLECONVERT 0x2
#define IME_SMODE_AUTOMATIC 0x4
#define IME_SMODE_PHRASEPREDICT 0x8
#define IME_CAND_UNKNOWN 0x0
#define IME_CAND_READ 0x1
#define IME_CAND_CODE 0x2
#define IME_CAND_MEANING 0x3
#define IME_CAND_RADICAL 0x4
#define IME_CAND_STROKE 0x5
#define IMN_CLOSESTATUSWINDOW 0x1
#define IMN_OPENSTATUSWINDOW 0x2
#define IMN_CHANGECANDIDATE 0x3
#define IMN_CLOSECANDIDATE 0x4
#define IMN_OPENCANDIDATE 0x5
#define IMN_SETCONVERSIONMODE 0x6
#define IMN_SETSENTENCEMODE 0x7
#define IMN_SETOPENSTATUS 0x8
#define IMN_SETCANDIDATEPOS 0x9
#define IMN_SETCOMPOSITIONFONT 0xA
#define IMN_SETCOMPOSITIONWINDOW 0xB
#define IMN_SETSTATUSWINDOWPOS 0xC
#define IMN_GUIDELINE 0xD
#define IMN_PRIVATE 0xE
#define IMM_ERROR_NODATA (-1)
#define IMM_ERROR_GENERAL (-2)
#define IME_CONFIG_GENERAL 1
#define IME_CONFIG_REGISTERWORD 2
#define IME_CONFIG_SELECTDICTIONARY 3
#define IME_ESC_QUERY_SUPPORT 0x3
#define IME_ESC_RESERVED_FIRST 0x4
#define IME_ESC_RESERVED_LAST 0x7FF
#define IME_ESC_PRIVATE_FIRST 0x800
#define IME_ESC_PRIVATE_LAST 0xFFF
#define IME_ESC_SEQUENCE_TO_INTERNAL 0x1001
#define IME_ESC_GET_EUDC_DICTIONARY 0x1003
#define IME_ESC_SET_EUDC_DICTIONARY 0x1004
#define IME_ESC_MAX_KEY 0x1005
#define IME_ESC_IME_NAME 0x1006
#define IME_ESC_SYNC_HOTKEY 0x1007
#define IME_ESC_HANJA_MODE 0x1008
#define IME_REGWORD_STYLE_EUDC 0x1
#define IME_REGWORD_STYLE_USER_FIRST 0x80000000
#define IME_REGWORD_STYLE_USER_LAST 0xFFFF
#define SOFTKEYBOARD_TYPE_T1 0x1
#define SOFTKEYBOARD_TYPE_C1 0x2
#define DIALOPTION_BILLING 0x40
#define DIALOPTION_QUIET 0x80
#define DIALOPTION_DIALTONE 0x100
#define MDMVOLFLAG_LOW 0x1
#define MDMVOLFLAG_MEDIUM 0x2
#define MDMVOLFLAG_HIGH 0x4
#define MDMVOL_LOW 0x0
#define MDMVOL_MEDIUM 0x1
#define MDMVOL_HIGH 0x2
#define MDMSPKRFLAG_OFF 0x1
#define MDMSPKRFLAG_DIAL 0x2
#define MDMSPKRFLAG_ON 0x4
#define MDMSPKRFLAG_CALLSETUP 0x8
#define MDMSPKR_OFF 0x0
#define MDMSPKR_DIAL 0x1
#define MDMSPKR_ON 0x2
#define MDMSPKR_CALLSETUP 0x3
#define MDM_COMPRESSION 0x1
#define MDM_ERROR_CONTROL 0x2
#define MDM_FORCED_EC 0x4
#define MDM_CELLULAR 0x8
#define MDM_FLOWCONTROL_HARD 0x10
#define MDM_FLOWCONTROL_SOFT 0x20
#define MDM_CCITT_OVERRIDE 0x40
#define MDM_SPEED_ADJUST 0x80
#define MDM_TONE_DIAL 0x100
#define MDM_BLIND_DIAL 0x200
#define MDM_V23_OVERRIDE 0x400
#define ABM_NEW 0x0
#define ABM_REMOVE 0x1
#define ABM_QUERYPOS 0x2
#define ABM_SETPOS 0x3
#define ABM_GETSTATE 0x4
#define ABM_GETTASKBARPOS 0x5
#define ABM_ACTIVATE 0x6
#define ABM_GETAUTOHIDEBAR 0x7
#define ABM_SETAUTOHIDEBAR 0x8
#define ABM_WINDOWPOSCHANGED 0x9
#define ABN_STATECHANGE 0x0
#define ABN_POSCHANGED 0x1
#define ABN_FULLSCREENAPP 0x2
#define ABN_WINDOWARRANGE 0x3
#define ABS_AUTOHIDE 0x1
#define ABS_ALWAYSONTOP 0x2
#define ABE_LEFT 0
#define ABE_TOP 1
#define ABE_RIGHT 2
#define ABE_BOTTOM 3
#define EIRESID -1
#define FO_MOVE 0x1
#define FO_COPY 0x2
#define FO_DELETE 0x3
#define FO_RENAME 0x4
#define FOF_MULTIDESTFILES 0x1
#define FOF_CONFIRMMOUSE 0x2
#define FOF_SILENT 0x4
#define FOF_RENAMEONCOLLISION 0x8
#define FOF_NOCONFIRMATION 0x10
#define FOF_WANTMAPPINGHANDLE 0x20
#define FOF_ALLOWUNDO 0x40
#define FOF_FILESONLY 0x80
#define FOF_SIMPLEPROGRESS 0x100
#define FOF_NOCONFIRMMKDIR 0x200
#define PO_DELETE 0x13
#define PO_RENAME 0x14
#define PO_PORTCHANGE 0x20
#define PO_REN_PORT 0x34
#define SE_ERR_FNF 2
#define SE_ERR_PNF 3
#define SE_ERR_ACCESSDENIED 5
#define SE_ERR_OOM 8
#define SE_ERR_DLLNOTFOUND 32
#define SEE_MASK_CLASSNAME 0x1
#define SEE_MASK_CLASSKEY 0x3
#define SEE_MASK_IDLIST 0x4
#define SEE_MASK_INVOKEIDLIST 0xC
#define SEE_MASK_ICON 0x10
#define SEE_MASK_HOTKEY 0x20
#define SEE_MASK_NOCLOSEPROCESS 0x40
#define SEE_MASK_CONNECTNETDRV 0x80
#define SEE_MASK_FLAG_DDEWAIT 0x100
#define SEE_MASK_DOENVSUBST 0x200
#define SEE_MASK_FLAG_NO_UI 0x400
#define NIM_ADD 0x0
#define NIM_MODIFY 0x1
#define NIM_DELETE 0x2
#define NIF_MESSAGE 0x1
#define NIF_ICON 0x2
#define NIF_TIP 0x4
#define SHGFI_ICON 0x100
#define SHGFI_DISPLAYNAME 0x200
#define SHGFI_TYPENAME 0x400
#define SHGFI_ATTRIBUTES 0x800
#define SHGFI_ICONLOCATION 0x1000
#define SHGFI_EXETYPE 0x2000
#define SHGFI_SYSICONINDEX 0x4000
#define SHGFI_LINKOVERLAY 0x8000
#define SHGFI_SELECTED 0x10000
#define SHGFI_LARGEICON 0x0
#define SHGFI_SMALLICON 0x1
#define SHGFI_OPENICON 0x2
#define SHGFI_SHELLICONSIZE 0x4
#define SHGFI_PIDL 0x8
#define SHGFI_USEFILEATTRIBUTES 0x10
#define SHGNLI_PIDL 0x1
#define SHGNLI_PREFIXNAME 0x2
#define VS_VERSION_INFO 1
#define VS_USER_DEFINED 100
#define VS_FFI_SIGNATURE 0xFEEF04BD
#define VS_FFI_STRUCVERSION 0x10000
#define VS_FFI_FILEFLAGSMASK 0x3F
#define VS_FF_DEBUG 0x1
#define VS_FF_PRERELEASE 0x2
#define VS_FF_PATCHED 0x4
#define VS_FF_PRIVATEBUILD 0x8
#define VS_FF_INFOINFERRED 0x10
#define VS_FF_SPECIALBUILD 0x20
#define VOS_UNKNOWN 0x0
#define VOS_DOS 0x10000
#define VOS_OS216 0x20000
#define VOS_OS232 0x30000
#define VOS_NT 0x40000
#define VOS__BASE 0x0
#define VOS__WINDOWS16 0x1
#define VOS__PM16 0x2
#define VOS__PM32 0x3
#define VOS__WINDOWS32 0x4
#define VOS_DOS_WINDOWS16 0x10001
#define VOS_DOS_WINDOWS32 0x10004
#define VOS_OS216_PM16 0x20002
#define VOS_OS232_PM32 0x30003
#define VOS_NT_WINDOWS32 0x40004
#define VFT_UNKNOWN 0x0
#define VFT_APP 0x1
#define VFT_DLL 0x2
#define VFT_DRV 0x3
#define VFT_FONT 0x4
#define VFT_VXD 0x5
#define VFT_STATIC_LIB 0x7
#define VFT2_UNKNOWN 0x0
#define VFT2_DRV_PRINTER 0x1
#define VFT2_DRV_KEYBOARD 0x2
#define VFT2_DRV_LANGUAGE 0x3
#define VFT2_DRV_DISPLAY 0x4
#define VFT2_DRV_MOUSE 0x5
#define VFT2_DRV_NETWORK 0x6
#define VFT2_DRV_SYSTEM 0x7
#define VFT2_DRV_INSTALLABLE 0x8
#define VFT2_DRV_SOUND 0x9
#define VFT2_DRV_COMM 0xA
#define VFT2_DRV_INPUTMETHOD 0xB
#define VFT2_FONT_RASTER 0x1
#define VFT2_FONT_VECTOR 0x2
#define VFT2_FONT_TRUETYPE 0x3
#define VFFF_ISSHAREDFILE 0x1
#define VFF_CURNEDEST 0x1
#define VFF_FILEINUSE 0x2
#define VFF_BUFFTOOSMALL 0x4
#define VIFF_FORCEINSTALL 0x1
#define VIFF_DONTDELETEOLD 0x2
#define VIF_TEMPFILE 0x1
#define VIF_MISMATCH 0x2
#define VIF_SRCOLD 0x4
#define VIF_DIFFLANG 0x8
#define VIF_DIFFCODEPG 0x10
#define VIF_DIFFTYPE 0x20
#define VIF_WRITEPROT 0x40
#define VIF_FILEINUSE 0x80
#define VIF_OUTOFSPACE 0x100
#define VIF_ACCESSVIOLATION 0x200
#define VIF_SHARINGVIOLATION 0x400
#define VIF_CANNOTCREATE 0x800
#define VIF_CANNOTDELETE 0x1000
#define VIF_CANNOTRENAME 0x2000
#define VIF_CANNOTDELETECUR 0x4000
#define VIF_OUTOFMEMORY 0x8000
#define VIF_CANNOTREADSRC 0x10000
#define VIF_CANNOTREADDST 0x20000
#define VIF_BUFFTOOSMALL 0x40000
#define PROCESS_HEAP_REGION 0x1
#define PROCESS_HEAP_UNCOMMITTED_RANGE 0x2
#define PROCESS_HEAP_ENTRY_BUSY 0x4
#define PROCESS_HEAP_ENTRY_MOVEABLE 0x10
#define PROCESS_HEAP_ENTRY_DDESHARE 0x20
#define SCS_32BIT_BINARY 0
#define SCS_DOS_BINARY 1
#define SCS_WOW_BINARY 2
#define SCS_PIF_BINARY 3
#define SCS_POSIX_BINARY 4
#define SCS_OS216_BINARY 5
#define LOGON32_LOGON_INTERACTIVE 2
#define LOGON32_LOGON_BATCH 4
#define LOGON32_LOGON_SERVICE 5
#define LOGON32_PROVIDER_DEFAULT 0
#define LOGON32_PROVIDER_WINNT35 1
#define VER_PLATFORM_WIN32s 0
#define VER_PLATFORM_WIN32_WINDOWS 1
#define VER_PLATFORM_WIN32_NT 2
#define AC_LINE_OFFLINE 0x0
#define AC_LINE_ONLINE 0x1
#define AC_LINE_BACKUP_POWER 0x2
#define AC_LINE_UNKNOWN 0xFF
#define BATTERY_FLAG_HIGH 0x1
#define BATTERY_FLAG_LOW 0x2
#define BATTERY_FLAG_CRITICAL 0x4
#define BATTERY_FLAG_CHARGING 0x8
#define BATTERY_FLAG_NO_BATTERY 0x80
#define BATTERY_FLAG_UNKNOWN 0xFF
#define BATTERY_PERCENTAGE_UNKNOWN 0xFF
#define BATTERY_LIFE_UNKNOWN 0xFFFF
#define OFN_READONLY 0x1
#define OFN_OVERWRITEPROMPT 0x2
#define OFN_HIDEREADONLY 0x4
#define OFN_NOCHANGEDIR 0x8
#define OFN_SHOWHELP 0x10
#define OFN_ENABLEHOOK 0x20
#define OFN_ENABLETEMPLATE 0x40
#define OFN_ENABLETEMPLATEHANDLE 0x80
#define OFN_NOVALIDATE 0x100
#define OFN_ALLOWMULTISELECT 0x200
#define OFN_EXTENSIONDIFFERENT 0x400
#define OFN_PATHMUSTEXIST 0x800
#define OFN_FILEMUSTEXIST 0x1000
#define OFN_CREATEPROMPT 0x2000
#define OFN_SHAREAWARE 0x4000
#define OFN_NOREADONLYRETURN 0x8000
#define OFN_NOTESTFILECREATE 0x10000
#define OFN_NONETWORKBUTTON 0x20000
#define OFN_NOLONGNAMES 0x40000
#define OFN_EXPLORER 0x80000
#define OFN_NODEREFERENCELINKS 0x100000
#define OFN_LONGNAMES 0x200000
#define OFN_SHAREFALLTHROUGH 2
#define OFN_SHARENOWARN 1
#define OFN_SHAREWARN 0
#define CDM_FIRST (WM_USER + 100)
#define CDM_LAST (WM_USER + 200)
#define CDM_GETSPEC (CDM_FIRST + 0x0)
#define CDM_GETFILEPATH (CDM_FIRST + 0x1)
#define CDM_GETFOLDERPATH (CDM_FIRST + 0x2)
#define CDM_GETFOLDERIDLIST (CDM_FIRST + 0x3)
#define CDM_SETCONTROLTEXT (CDM_FIRST + 0x4)
#define CDM_HIDECONTROL (CDM_FIRST + 0x5)
#define CDM_SETDEFEXT (CDM_FIRST + 0x6)
#define CC_RGBINIT 0x1
#define CC_FULLOPEN 0x2
#define CC_PREVENTFULLOPEN 0x4
#define CC_SHOWHELP 0x8
#define CC_ENABLEHOOK 0x10
#define CC_ENABLETEMPLATE 0x20
#define CC_ENABLETEMPLATEHANDLE 0x40
#define CC_SOLIDCOLOR 0x80
#define CC_ANYCOLOR 0x100
#define FR_DOWN 0x1
#define FR_WHOLEWORD 0x2
#define FR_MATCHCASE 0x4
#define FR_FINDNEXT 0x8
#define FR_REPLACE 0x10
#define FR_REPLACEALL 0x20
#define FR_DIALOGTERM 0x40
#define FR_SHOWHELP 0x80
#define FR_ENABLEHOOK 0x100
#define FR_ENABLETEMPLATE 0x200
#define FR_NOUPDOWN 0x400
#define FR_NOMATCHCASE 0x800
#define FR_NOWHOLEWORD 0x1000
#define FR_ENABLETEMPLATEHANDLE 0x2000
#define FR_HIDEUPDOWN 0x4000
#define FR_HIDEMATCHCASE 0x8000
#define FR_HIDEWHOLEWORD 0x10000
#define CF_SCREENFONTS 0x1
#define CF_PRINTERFONTS 0x2
#define CF_BOTH (CF_SCREENFONTS|CF_PRINTERFONTS)
#define CF_SHOWHELP 0x4
#define CF_ENABLEHOOK 0x8
#define CF_ENABLETEMPLATE 0x10
#define CF_ENABLETEMPLATEHANDLE 0x20
#define CF_INITTOLOGFONTSTRUCT 0x40
#define CF_USESTYLE 0x80
#define CF_EFFECTS 0x100
#define CF_APPLY 0x200
#define CF_ANSIONLY 0x400
#define CF_SCRIPTSONLY CF_ANSIONLY
#define CF_NOVECTORFONTS 0x800
#define CF_NOOEMFONTS CF_NOVECTORFONTS
#define CF_NOSIMULATIONS 0x1000
#define CF_LIMITSIZE 0x2000
#define CF_FIXEDPITCHONLY 0x4000
#define CF_WYSIWYG 0x8000
#define CF_FORCEFONTEXIST 0x10000
#define CF_SCALABLEONLY 0x20000
#define CF_TTONLY 0x40000
#define CF_NOFACESEL 0x80000
#define CF_NOSTYLESEL 0x100000
#define CF_NOSIZESEL 0x200000
#define CF_SELECTSCRIPT 0x400000
#define CF_NOSCRIPTSEL 0x800000
#define CF_NOVERTFONTS 0x1000000
#define SIMULATED_FONTTYPE 0x8000
#define PRINTER_FONTTYPE 0x4000
#define SCREEN_FONTTYPE 0x2000
#define BOLD_FONTTYPE 0x100
#define ITALIC_FONTTYPE 0x200
#define REGULAR_FONTTYPE 0x400
#define WM_CHOOSEFONT_GETLOGFONT (WM_USER + 1)
#define WM_CHOOSEFONT_SETLOGFONT (WM_USER + 101)
#define WM_CHOOSEFONT_SETFLAGS (WM_USER + 102)
#define LBSELCHSTRING "commdlg_LBSelChangedNotify"
#define SHAREVISTRING "commdlg_ShareViolation"
#define FILEOKSTRING "commdlg_FileNameOK"
#define COLOROKSTRING "commdlg_ColorOK"
#define SETRGBSTRING "commdlg_SetRGBColor"
#define HELPMSGSTRING "commdlg_help"
#define FINDMSGSTRING "commdlg_FindReplace"
#define CD_LBSELNOITEMS -1
#define CD_LBSELCHANGE 0
#define CD_LBSELSUB 1
#define CD_LBSELADD 2
#define PD_ALLPAGES 0x0
#define PD_SELECTION 0x1
#define PD_PAGENUMS 0x2
#define PD_NOSELECTION 0x4
#define PD_NOPAGENUMS 0x8
#define PD_COLLATE 0x10
#define PD_PRINTTOFILE 0x20
#define PD_PRINTSETUP 0x40
#define PD_NOWARNING 0x80
#define PD_RETURNDC 0x100
#define PD_RETURNIC 0x200
#define PD_RETURNDEFAULT 0x400
#define PD_SHOWHELP 0x800
#define PD_ENABLEPRINTHOOK 0x1000
#define PD_ENABLESETUPHOOK 0x2000
#define PD_ENABLEPRINTTEMPLATE 0x4000
#define PD_ENABLESETUPTEMPLATE 0x8000
#define PD_ENABLEPRINTTEMPLATEHANDLE 0x10000
#define PD_ENABLESETUPTEMPLATEHANDLE 0x20000
#define PD_USEDEVMODECOPIES 0x40000
#define PD_USEDEVMODECOPIESANDCOLLATE 0x40000
#define PD_DISABLEPRINTTOFILE 0x80000
#define PD_HIDEPRINTTOFILE 0x100000
#define PD_NONETWORKBUTTON 0x200000
#define DN_DEFAULTPRN 0x1
#define WM_PSD_PAGESETUPDLG (WM_USER)
#define WM_PSD_FULLPAGERECT (WM_USER + 1)
#define WM_PSD_MINMARGINRECT (WM_USER + 2)
#define WM_PSD_MARGINRECT (WM_USER + 3)
#define WM_PSD_GREEKTEXTRECT (WM_USER + 4)
#define WM_PSD_ENVSTAMPRECT (WM_USER + 5)
#define WM_PSD_YAFULLPAGERECT (WM_USER + 6)
#define PSD_DEFAULTMINMARGINS 0x0
#define PSD_INWININIINTLMEASURE 0x0
#define PSD_MINMARGINS 0x1
#define PSD_MARGINS 0x2
#define PSD_INTHOUSANDTHSOFINCHES 0x4
#define PSD_INHUNDREDTHSOFMILLIMETERS 0x8
#define PSD_DISABLEMARGINS 0x10
#define PSD_DISABLEPRINTER 0x20
#define PSD_NOWARNING 0x80
#define PSD_DISABLEORIENTATION 0x100
#define PSD_RETURNDEFAULT 0x400
#define PSD_DISABLEPAPER 0x200
#define PSD_SHOWHELP 0x800
#define PSD_ENABLEPAGESETUPHOOK 0x2000
#define PSD_ENABLEPAGESETUPTEMPLATE 0x8000
#define PSD_ENABLEPAGESETUPTEMPLATEHANDLE 0x20000
#define PSD_ENABLEPAGEPAINTHOOK 0x40000
#define PSD_DISABLEPAGEPAINTING 0x80000
#define INVALID_HANDLE_VALUE -1
#define BDR_RAISEDOUTER 0x1
#define BDR_SUNKENOUTER 0x2
#define BDR_RAISEDINNER 0x4
#define BDR_SUNKENINNER 0x8
#define BDR_OUTER 0x3
#define BDR_INNER 0xC
#define BDR_RAISED 0x5
#define BDR_SUNKEN 0xA
#define EDGE_RAISED (BDR_RAISEDOUTER|BDR_RAISEDINNER)
#define EDGE_SUNKEN (BDR_SUNKENOUTER|BDR_SUNKENINNER)
#define EDGE_ETCHED (BDR_SUNKENOUTER|BDR_RAISEDINNER)
#define EDGE_BUMP (BDR_RAISEDOUTER|BDR_SUNKENINNER)
#define BF_LEFT 0x1
#define BF_TOP 0x2
#define BF_RIGHT 0x4
#define BF_BOTTOM 0x8
#define BF_TOPLEFT (BF_TOP|BF_LEFT)
#define BF_TOPRIGHT (BF_TOP|BF_RIGHT)
#define BF_BOTTOMLEFT (BF_BOTTOM|BF_LEFT)
#define BF_BOTTOMRIGHT (BF_BOTTOM|BF_RIGHT)
#define BF_RECT (BF_LEFT|BF_TOP|BF_RIGHT|BF_BOTTOM)
#define BF_DIAGONAL 0x10
#define BF_DIAGONAL_ENDTOPRIGHT (BF_DIAGONAL|BF_TOP|BF_RIGHT)
#define BF_DIAGONAL_ENDTOPLEFT (BF_DIAGONAL|BF_TOP|BF_LEFT)
#define BF_DIAGONAL_ENDBOTTOMLEFT (BF_DIAGONAL|BF_BOTTOM|BF_LEFT)
#define BF_DIAGONAL_ENDBOTTOMRIGHT (BF_DIAGONAL|BF_BOTTOM|BF_RIGHT)
#define BF_MIDDLE 0x800
#define BF_SOFT 0x1000
#define BF_ADJUST 0x2000
#define BF_FLAT 0x4000
#define BF_MONO 0x8000

//////////////////////////////////////////////////////////////////

typedef struct _RECTL{
	long         Left;
	long         Top;
	long         Right;
	long         Bottom;
}RECTL;

typedef struct _POINTAPI{
	long         x;
	long         y;
}POINTAPI;
typedef struct _POINT{
	long         x;
	long         y;
}POINT;
typedef struct _POINTL{
	long         x;
	long         y;
}POINTL;

typedef struct _SIZE{
	long         cx;
	long         cy;
}SIZE;

typedef struct _POINTS{
	int         x ;
	int         y ;
}POINTS;

typedef struct _MSG{
	long     hwnd;
	long     message;
	long     wParam;
	long     lParam;
	long     time;
	POINTAPI    pt;
}MSG;

typedef struct _WNDCLASSEX{
	long     cbSize;
	long     style;
	long     lpfnWndProc;
	long     cbClsExtra;
	long     cbWndExtra;
	long     hInstance;
	long     hIcon;
	long     hCursor;
	long     hbrBackground;
	char*     lpszMenuName;
	char*     lpszClassName;
	long     hIconSm;
}WNDCLASSEX;

typedef struct _PAINTSTRUCT{
	long         hdc;
	long         fErase;
	RECT        rcPaint;
	long         fRestore;
	long         fIncUpdate;
	char         rgbReserved[32];
}PAINTSTRUCT;

typedef struct _OPENFILENAME{
	long         lStructSize;
	long         hwndOwner;
	long         hInstance;
	char*         lpstrFilter;
	char*         lpstrCustomFilter;
	long         nMaxCustFilter;
	long         nFilterIndex;
	char*         lpstrFile;
	long         nMaxFile;
	char*         lpstrFileTitle;
	long         nMaxFileTitle;
	char*         lpstrInitialDir;
	char*         lpstrTitle;
	long         Flags;
	short         nFileOffset;
	short       nFileExtension;
	char*         lpstrDefExt;
	long         lCustData;
	long         lpfnHook;
	char*         lpTemplateName;
}OPENFILENAME;

typedef struct _ULARGE_INTEGER
{
	DWORD LowPart;
	DWORD HighPart;
}ULARGE_INTEGER;

typedef struct _GUID
{
    long        Data1;
    short       Data2;
    short       Data3;
    char        Data4[8];
} GUID;

typedef struct _IID
{
    long        Data1;
    short       Data2;
    short       Data3;
    char        Data4[8];
} IID;

typedef struct _WNDCLASS
{
    long	style;
    long	lpfnWndProc;
    int		cbClsExtra;
    int		cbWndExtra;
    long	hInstance;
    long	hIcon;
    long	hCursor;
    long	hbrBackground;
    char*	lpszMenuName;
    char*	lpszClassName;
} WNDCLASS;

typedef struct _FILETIME {  
    DWORD dwLowDateTime;  
    DWORD dwHighDateTime;
} FILETIME;


typedef struct _WIN32_FIND_DATA {  
    DWORD dwFileAttributes;  
    FILETIME ftCreationTime;  
    FILETIME ftLastAccessTime;  
    FILETIME ftLastWriteTime;  
    DWORD nFileSizeHigh;  
    DWORD nFileSizeLow;  
    DWORD dwReserved0;  
    DWORD dwReserved1;  
    char* cFileName[MAX_PATH];
    char* cAlternateFileName[14];
} WIN32_FIND_DATA;

//////////////////////////////////////////////////////////////////
// function prototypes and API definitions (APIA = ASCII version).
// API definitions not contained herein are contained in api.def
//^{:i};{:i}!\1A

VOID WINAPI CopyMemory(long Destination,long Source,DWORD Length);
VOID WINAPI FillMemory(long Destination,DWORD Length,char Fill);
VOID WINAPI ZeroMemory(long Destination,DWORD Length);

#define PRAGMA_API CopyMemory;kernel32!RtlMoveMemory
#define PRAGMA_API FillMemory;kernel32!RtlFillMemory
#define PRAGMA_API ZeroMemory;kernel32!RtlZeroMemory

DWORD WINAPI GetOpenFileName(DWORD);
DWORD WINAPI GetSaveFileName(DWORD);

API(GetOpenFileName,comdlg32)
API(GetSaveFileName,comdlg32)

long WINAPI LoadKeyboardLayout(long pwszKLID,long Flags);
long WINAPI ActivateKeyboardLayout(long hkl,long Flags);
long WINAPI ActivateKeyboardLayout(long hkl,long Flags);

long WINAPI UnloadKeyboardLayout(long hkl);
long WINAPI GetKeyboardLayoutName(long pwszKLID);
long WINAPI GetKeyboardLayoutList(long nBuff,long lpList);
long WINAPI GetKeyboardLayout(long dwLayout);

APIA(LoadKeyboardLayout,user32)
API(ActivateKeyboardLayout,user32)
API(UnloadKeyboardLayout,user32)
APIA(GetKeyboardLayoutName,user32)

long WINAPI ToUnicodeEx(long wVirtKey,long wScanCode,long lpKeyState,long pwszBuff,long cchBuff,long wFlags,long dwhkl);
//long WINAPI GetMouseMovePoints(long cbSize,long lppt,long lpptBuf,long nBufPoints,long resolution);
API(ToUnicodeEx,user32)

long WINAPI CreateDesktop(long lpszDesktop,long lpszDevice,long pDevmode,long dwFlags,long dwDesiredAccess,long lpsa);
long WINAPI OpenDesktop(long lpszDesktop,long dwFlags,long fInherit,long dwDesiredAccess);
long WINAPI OpenInputDesktop(long dwFlags,long fInherit,long dwDesiredAccess);
long WINAPI CloseDesktop(long hDesktop);
long WINAPI EnumDesktops(long hwinsta,long lpEnumFunc,long lParam);
long WINAPI EnumDesktopWindows(long hDesktop,long lpfn,long lParam);
long WINAPI SwitchDesktop(long hDesktop);
long WINAPI SetThreadDesktop(long hDesktop);
long WINAPI GetThreadDesktop(long dwThreadId);

APIA(CreateDesktop,user32)
APIA(OpenDesktop,user32)
API(OpenInputDesktop,user32)
API(CloseDesktop,user32)
APIA(EnumDesktops,user32)
API(EnumDesktopWindows,user32)
API(SwitchDesktop,user32)
API(SetThreadDesktop,user32)
API(GetThreadDesktop,user32)

long WINAPI CreateWindowStation(long lpwinsta,long dwReserved,long dwDesiredAccess,long lpsa);
long WINAPI OpenWindowStation(long lpszWinSta,long fInherit,long dwDesiredAccess);
long WINAPI EnumWindowStations(long lpEnumFunc,long lParam);
long WINAPI CloseWindowStation(long hWinSta);
long WINAPI SetProcessWindowStation(long hWinSta);
long WINAPI GetProcessWindowStation(long);

APIA(CreateWindowStation,user32)
APIA(OpenWindowStation,user32)
API(CloseWindowStation,user32)
API(GetProcessWindowStation,user32)
API(SetProcessWindowStation,user32)

long WINAPI SetUserObjectSecurity(long hObj,long pSIRequested,long pSID);
long WINAPI GetUserObjectSecurity(long hObj,long pSIRequested,long pSID,long nLength,long lpnLengthNeeded);
long WINAPI GetUserObjectInformation(long hObj,long nIndex,long pvInfo,long nLength,long lpnLengthNeeded);
long WINAPI SetUserObjectInformation(long hObj,long nIndex,long pvInfo,long nLength);

API(SetUserObjectSecurity,user32)
API(GetUserObjectSecurity,user32)
APIA(GetUserObjectInformation,user32)
APIA(SetUserObjectInformation,user32)

long WINAPI TrackMouseEvent(long lpEventTrack);
API(TrackMouseEvent,user32)

long WINAPI DrawEdge(long hdc,long qrc,long edge,long grfFlags);
long WINAPI DrawFrameControl(long,long,long,long);
long WINAPI DrawCaption(long,long,long ,long);
long WINAPI DrawAnimatedRects(long hwnd,long idAni,long lprcFrom,long lprcTo);

API(DrawEdge,user32)
API(DrawFrameControl,user32)
API(DrawCaption,user32)
API(DrawAnimatedRects,user32)

long WINAPI GetMessage(long lpMsg,long hWnd,long wMsgFilterMin,long wMsgFilterMax);
long WINAPI RegisterWindowMessage(long lpString);
long WINAPI TranslateMessage(long lpMsg);
long WINAPI DispatchMessage(long lpMsg);
long WINAPI SetMessageQueue(long cMessagesMax);
long WINAPI PeekMessage(long lpMsg,long hWnd,long wMsgFilterMin,long wMsgFilterMax,long wRemoveMsg);
long WINAPI GetMessagePos(long);
long WINAPI GetMessageTime(long);
long WINAPI GetMessageExtraInfo(long);
long WINAPI SetMessageExtraInfo(long lParam);
long WINAPI SendMessage(long hWnd,long Msg,long wParam,long lParam);
long WINAPI SendMessageTimeout(long hWnd,long Msg,long wParam,long lParam,long fuFlags,long uTimeout,long lpdwResult);
long WINAPI SendNotifyMessage(long hWnd,long Msg,long wParam,long lParam);
long WINAPI SendMessageCallback(long hWnd,long Msg,long wParam,long lParam,long lpResultCallBack,long dwData);
long WINAPI BroadcastSystemMessage(long,long,long,long,long);
long WINAPI PostMessage(long hWnd,long Msg,long wParam,long lParam);
long WINAPI PostThreadMessage(long idThread,long Msg,long wParam,long lParam);
long WINAPI ReplyMessage(long lResult);
long WINAPI WaitMessage(void);
VOID WINAPI PostQuitMessage(long nExitCode);
long WINAPI InSendMessage(long);
long WINAPI InSendMessageEx(long lpReserved);

APIA(GetMessage,user32)
APIA(RegisterWindowMessage,user32)
API(TranslateMessage,user32)
APIA(DispatchMessage,user32)
APIA(PeekMessage,user32)
API(GetMessagePos,user32)
API(GetMessageTime,user32)
API(GetMessageExtraInfo,user32)
APIA(SendMessage,user32)
APIA(SendMessageTimeout,user32)
APIA(SendNotifyMessage,user32)
APIA(SendMessageCallback,user32)
APIA(PostMessage,user32)
APIA(PostThreadMessage,user32)
API(ReplyMessage,user32)
API(WaitMessage,user32)
API(PostQuitMessage,user32)
API(InSendMessage,user32)
API(InSendMessageEx,user32)

long WINAPI RegisterHotKey(long hWnd,long id,long fsModifiers,long vk);
long WINAPI UnregisterHotKey(long hWnd,long id);

long WINAPI ExitWindowsEx(long uFlags,long dwReserved);
long WINAPI SwapMouseButton(long fSwap);
//long WINAPI RegisterDeviceNotification(long hRecipient,long NotificationFilter,long Flags);
//long WINAPI UnregisterDeviceNotification(long Handle);
long WINAPI AttachThreadInput(long idAttach,long idAttachTo,long fAttach);
long WINAPI WaitForInputIdle(long hProcess,long dwMilliseconds);
long WINAPI DefWindowProc(long hWnd,long Msg,long wParam,long lParam);
long WINAPI CallWindowProc(long lpPrevWndFunc,long hWnd,long Msg,long wParam,long lParam);
long WINAPI CallWindowProc(long lpPrevWndFunc,long hWnd,long Msg,long wParam,long lParam);
long WINAPI GetDoubleClickTime(long);
long WINAPI SetDoubleClickTime(long);
long WINAPI RegisterClass(long lpWndClass);
long WINAPI UnregisterClass(long lpClassName,long hInstance);
long WINAPI GetClassInfo(long hInstance,long lpClassName,long lpWndClass);
long WINAPI RegisterClassEx(long);
long WINAPI GetClassInfoEx(long,long,long);
long WINAPI CreateWindowEx(long dwExStyle,long lpClassName,long lpWindowName,long dwStyle,long X,long Y,long nWidth,long nHeight,long hWndParent,long hMenu,long hInstance,long lpParam);
long WINAPI IsWindow(long hWnd);
long WINAPI IsMenu(long hMenu);
long WINAPI IsChild(long hWndParent,long hWnd);
long WINAPI DestroyWindow(long hWnd);
long WINAPI ShowWindow(long hWnd,long nCmdShow);
long WINAPI AnimateWindow(long hWnd,long dwTime,long dwFlags);
long WINAPI ShowWindowAsync(long hWnd,long nCmdShow);
long WINAPI FlashWindow(long hWnd,long bInvert);
long WINAPI ShowOwnedPopups(long hWnd,long fShow);
long WINAPI OpenIcon(long hWnd);
long WINAPI CloseWindow(long hWnd);
long WINAPI MoveWindow(long hWnd,long X,long Y,long nWidth,long nHeight,long bRepaint);
long WINAPI SetWindowPos(long hWnd,long hWndInsertAfter,long X,long Y,long cx,long cy,long uFlags);
long WINAPI GetWindowPlacement(long hWnd,long lpwndpl);
long WINAPI SetWindowPlacement(long hWnd,long lpwndpl);
long WINAPI BeginDeferWindowPos(long nNumWindows);
long WINAPI DeferWindowPos(long hWinPosInfo,long hWnd,long hWndInsertAfter,long x,long y,long cx,long cy,long uFlags);
long WINAPI EndDeferWindowPos(long hWinPosInfo);
long WINAPI IsWindowVisible(long hWnd);
long WINAPI IsIconic(long hWnd);
long WINAPI AnyPopup(long);
long WINAPI BringWindowToTop(long hWnd);
long WINAPI IsZoomed(long hWnd);
long WINAPI CreateDialogParam(long hInstance,long lpTemplateName,long hWndParent,long lpDialogFunc,long dwInitParam);
long WINAPI CreateDialogIndirectParam(long hInstance,long lpTemplate,long hWndParent,long lpDialogFunc,long dwInitParam);
long WINAPI DialogBoxParam(long hInstance,long lpTemplateName,long hWndParent,long lpDialogFunc,long dwInitParam);
long WINAPI DialogBoxIndirectParam(long hInstance,long hDialogTemplate,long hWndParent,long lpDialogFunc,long dwInitParam);
long WINAPI EndDialog(long hDlg,long nResult);
long WINAPI GetDlgItem(long hDlg,long nIDDlgItem);
long WINAPI SetDlgItemInt(long hDlg,long nIDDlgItem,long uValue,long bSigned);
long WINAPI GetDlgItemInt(long hDlg,long nIDDlgItem,long lpTranslated,long bSigned);
long WINAPI SetDlgItemText(long hDlg,long nIDDlgItem,long lpString);
long WINAPI GetDlgItemText(long hDlg,long nIDDlgItem,long lpString,long nMaxCount);
long WINAPI CheckDlgButton(long hDlg,long nIDButton,long uCheck);
long WINAPI CheckRadioButton(long hDlg,long nIDFirstButton,long nIDLastButton,long nIDCheckButton);
long WINAPI IsDlgButtonChecked(long hDlg,long nIDButton);
long WINAPI SendDlgItemMessage(long hDlg,long nIDDlgItem,long Msg,long wParam,long lParam);
long WINAPI GetNextDlgGroupItem(long hDlg,long hCtl,long bPrevious);
long WINAPI GetNextDlgTabItem(long hDlg,long hCtl,long bPrevious);
long WINAPI GetDlgCtrlID(long hWnd);
long WINAPI GetDialogBaseUnits(long);
long WINAPI DefDlgProc(long hDlg,long Msg,long wParam,long lParam);
long WINAPI CallMsgFilter(long lpMsg,long nCode);

API(AnimateWindow,user32)
API(CheckDlgButton,user32)
API(CheckRadioButton,user32)
APIA(DialogBoxParam,user32)
API(RegisterHotKey,user32)
API(UnregisterHotKey,user32)
API(ExitWindows,user32)
API(ExitWindowsEx,user32)
API(SwapMouseButton,user32)
API(AttachThreadInput,user32)
API(WaitForInputIdle,user32)
APIA(DefWindowProc,user32)
API(GetDoubleClickTime,user32)
API(SetDoubleClickTime,user32)
APIA(RegisterClass,user32)
APIA(UnregisterClass,user32)
APIA(GetClassInfo,user32)
APIA(GetClassInfoEx,user32)
APIA(CreateWindowEx,user32)
API(IsWindow,user32)
API(IsMenu,user32)
API(IsChild,user32)
API(DestroyWindow,user32)
API(ShowWindow,user32)
API(FlashWindow,user32)
API(ShowOwnedPopups,user32)
API(OpenIcon,user32)
API(CloseWindow,user32)
API(MoveWindow,user32)
API(SetWindowPos,user32)
API(GetWindowPlacement,user32)
API(SetWindowPlacement,user32)
API(BeginDeferWindowPos,user32)
API(DeferWindowPos,user32)
API(EndDeferWindowPos,user32)
API(IsWindowVisible,user32)
API(IsIconic,user32)
API(AnyPopup,user32)
API(BringWindowToTop,user32)
API(IsZoomed,user32)
API(EndDialog,user32)
API(GetDlgItem,user32)
API(SetDlgItemInt,user32)
API(GetDlgItemInt,user32)
APIA(SetDlgItemText,user32)
APIA(GetDlgItemText,user32)
API(IsDlgButtonChecked,user32)
APIA(SendDlgItemMessage,user32)
API(GetNextDlgGroupItem,user32)
API(GetNextDlgTabItem,user32)
API(GetDlgCtrlID,user32)
API(GetDialogBaseUnits,user32)
APIA(DefDlgProc,user32)
APIA(CallMsgFilter,user32)

long WINAPI OpenClipboard(long hWndNewOwner);
long WINAPI CloseClipboard(long);
long WINAPI GetClipboardSequenceNumber(long);
long WINAPI GetClipboardOwner(long);
long WINAPI SetClipboardViewer(long hWndNewViewer);
long WINAPI GetClipboardViewer(long);
long WINAPI ChangeClipboardChain(long hWndRemove,long hWndNewNext);
long WINAPI SetClipboardData(long uFormat,long hMem);
long WINAPI GetClipboardData(long uFormat);
long WINAPI RegisterClipboardFormat(long lpszFormat);
long WINAPI CountClipboardFormats(long);
long WINAPI EnumClipboardFormats(long format);
long WINAPI GetClipboardFormatName(long format,long lpszFormatName,long cchMaxCount);
long WINAPI EmptyClipboard(long);
long WINAPI IsClipboardFormatAvailable(long format);
long WINAPI GetPriorityClipboardFormat(long paFormatPriorityList,long cFormats);
long WINAPI GetOpenClipboardWindow(long);

API(OpenClipboard,user32)
API(CloseClipboard,user32)
API(GetClipboardOwner,user32)
API(SetClipboardViewer,user32)
API(GetClipboardViewer,user32)
API(ChangeClipboardChain,user32)
API(SetClipboardData,user32)
API(GetClipboardData,user32)
APIA(RegisterClipboardFormat,user32)
API(CountClipboardFormats,user32)
API(EnumClipboardFormats,user32)
APIA(GetClipboardFormatName,user32)
API(EmptyClipboard,user32)
API(IsClipboardFormatAvailable,user32)
API(GetPriorityClipboardFormat,user32)
API(GetOpenClipboardWindow,user32)
API(GetClipboardSequenceNumber,user32)

long WINAPI CharToOem(long lpszSrc,long lpszDst);
long WINAPI OemToChar(long lpszSrc,long lpszDst);
long WINAPI CharToOemBuff(long lpszSrc,long lpszDst,long cchDstLength);
long WINAPI OemToCharBuff(long lpszSrc,long lpszDst,long cchDstLength);
long WINAPI CharUpper(long lpsz);
long WINAPI CharUpperBuff(long lpsz,long cchLength);
long WINAPI CharLower(long lpsz);
long WINAPI CharLowerBuff(long lpsz,long cchLength);
long WINAPI CharNext(long lpsz);
long WINAPI CharPrev(long lpszStart,long lpszCurrent);
//long WINAPI CharNextEx(long CodePage,long lpCurrentChar,long dwFlags);
//long WINAPI CharPrevEx(long CodePage,long lpStart,long lpCurrentChar,long dwFlags);
long WINAPI IsCharAlpha(long ch);
long WINAPI IsCharAlphaNumeric(long ch);
long WINAPI IsCharUpper(long ch);
long WINAPI IsCharLower(long ch);

APIA(CharToOem,user32)
APIA(OemToChar,user32)
APIA(CharToOemBuff,user32)
APIA(OemToCharBuff,user32)
APIA(CharUpper,user32)
APIA(CharUpperBuff,user32)
APIA(CharLower,user32)
APIA(CharLowerBuff,user32)
APIA(CharNext,user32)
APIA(CharPrev,user32)
APIA(IsCharAlpha,user32)
APIA(IsCharAlphaNumeric,user32)
APIA(IsCharUpper,user32)
APIA(IsCharLower,user32)

long WINAPI SetFocus(long hWnd);
long WINAPI GetActiveWindow(void);
long WINAPI GetFocus(void);

long WINAPI GetKBCodePage(long);
long WINAPI GetKeyState(long nVirtKey);
long WINAPI GetAsyncKeyState(long vKey);
long WINAPI GetKeyboardState(long lpKeyState);
long WINAPI SetKeyboardState(long lpKeyState);
long WINAPI GetKeyNameText(long lParam,long lpString,long nSize);
long WINAPI GetKeyboardType(long nTypeFlag);
long WINAPI ToAscii(long uVirtKey,long uScanCode,long lpKeyState,long lpChar,long uFlags);
long WINAPI ToAsciiEx(long uVirtKey,long uScanCode,long lpKeyState,long lpChar,long uFlags,long dwhkl);
long WINAPI ToUnicode(long wVirtKey,long wScanCode,long lpKeyState,long pwszBuff,long cchBuff,long wFlags);
long WINAPI OemKeyScan(long wOemChar);
long WINAPI VkKeyScan(long ch);
long WINAPI VkKeyScanEx(long ch,long dwhkl);
VOID WINAPI keybd_event(long bVk,long bScan,long dwFlags,long dwExtraInfo);
VOID WINAPI mouse_event(long dwFlags,long dx,long dy,long dwData,long dwExtraInfo);
//long WINAPI SendInput(long cInputs,long pInputs,long cbSize);
long WINAPI GetLastInputInfo(long plii);
long WINAPI MapVirtualKey(long uCode,long uMapType);
long WINAPI MapVirtualKeyEx(long uCode,long uMapType,long dwhkl);
long WINAPI GetInputState(long);
long WINAPI GetQueueStatus(long flags);
long WINAPI GetCapture(long);
long WINAPI SetCapture(long hWnd);
long WINAPI ReleaseCapture(void);
long WINAPI MsgWaitForMultipleObjects(long nCount,long pHandles,long fWaitAll,long dwMilliseconds,long dwWakeMask);
long WINAPI MsgWaitForMultipleObjectsEx(long nCount,long pHandles,long dwMilliseconds,long dwWakeMask,long dwFlags);
long WINAPI SetTimer(long hWnd,long nIDEvent,long uElapse,long lpTimerFunc);
long WINAPI KillTimer(long hWnd,long uIDEvent);
long WINAPI IsWindowUnicode(long hWnd);
long WINAPI EnableWindow(long hWnd,long bEnable);
long WINAPI IsWindowEnabled(long hWnd);
long WINAPI LoadAccelerators(long hInstance,long lpTableName);
long WINAPI CreateAcceleratorTable(long,long);
long WINAPI DestroyAcceleratorTable(long hAccel);
long WINAPI CopyAcceleratorTable(long hAccelSrc,long lpAccelDst,long cAccelEntries);
long WINAPI TranslateAccelerator(long hWnd,long hAccTable,long lpMsg);
long WINAPI GetSystemMetrics(long nIndex);
long WINAPI LoadMenu(long hInstance,long lpMenuName);
long WINAPI LoadMenuIndirect(long lpMenuTemplate);
long WINAPI GetMenu(long hWnd);
long WINAPI SetMenu(long hWnd,long hMenu);
long WINAPI ChangeMenu(long hMenu,long cmd,long lpszNewItem,long cmdInsert,long flags);
long WINAPI HiliteMenuItem(long hWnd,long hMenu,long uIDHiliteItem,long uHilite);
long WINAPI GetMenuString(long hMenu,long uIDItem,long lpString,long nMaxCount,long uFlag);
long WINAPI GetMenuState(long hMenu,long uId,long uFlags);
long WINAPI DrawMenuBar(long hWnd);
long WINAPI GetSystemMenu(long hWnd,long bRevert);
long WINAPI CreateMenu(void);
long WINAPI CreatePopupMenu(void);
long WINAPI DestroyMenu(long hMenu);
long WINAPI CheckMenuItem(long hMenu,long uIDCheckItem,long uCheck);
long WINAPI EnableMenuItem(long hMenu,long uIDEnableItem,long uEnable);
long WINAPI GetSubMenu(long hMenu,long nPos);
long WINAPI GetMenuItemID(long hMenu,long nPos);
long WINAPI GetMenuItemCount(long hMenu);
long WINAPI InsertMenu(long hMenu,long uPosition,long uFlags,long uIDNewItem,long lpNewItem);
long WINAPI AppendMenu(long hMenu,long uFlags,long uIDNewItem,long lpNewItem);
long WINAPI ModifyMenu(long hMnu,long uPosition,long uFlags,long uIDNewItem,long lpNewItem);
long WINAPI RemoveMenu(long hMenu,long uPosition,long uFlags);
long WINAPI DeleteMenu(long hMenu,long uPosition,long uFlags);
long WINAPI SetMenuItemBitmaps(long hMenu,long uPosition,long uFlags,long hBitmapUnchecked,long hBitmapChecked);
long WINAPI GetMenuCheckMarkDimensions(long);
long WINAPI TrackPopupMenu(long hMenu,long uFlags,long x,long y,long nReserved,long hWnd,long prcRect);
long WINAPI TrackPopupMenuEx(long,long,long,long,long,long);
long WINAPI GetMenuInfo(long,long);
long WINAPI SetMenuInfo(long,long);
long WINAPI EndMenu(void);
long WINAPI InsertMenuItem(long,long,long,long);
long WINAPI GetMenuItemInfo(long,long,long,long);
long WINAPI SetMenuItemInfo(long,long,long,long);
long WINAPI GetMenuDefaultItem(long hMenu,long fByPos,long gmdiFlags);
long WINAPI SetMenuDefaultItem(long hMenu,long uItem,long fByPos);
long WINAPI GetMenuItemRect(long hWnd,long hMenu,long uItem,long lprcItem);
long WINAPI MenuItemFromPoint(long hWnd,long hMenu,long ptScreen);
long WINAPI DragObject(long,long,long,long,long);
long WINAPI DragDetect(long,long);
long WINAPI DrawIcon(long hDC,long X,long Y,long hIcon);
long WINAPI DrawText(long hDC,long lpString,long nCount,long lpRect,long uFormat);
long WINAPI DrawTextEx(long,long,long,long,long,long);
long WINAPI GrayString(long hDC,long hBrush,long lpOutputFunc,long lpData,long nCount,long X,long Y,long nWidth,long nHeight);
long WINAPI DrawState(long,long,long,long,long,long,long,long,long,long);
long WINAPI TabbedTextOut(long hDC,long X,long Y,long lpString,long nCount,long nTabPositions,long lpnTabStopPositions,long nTabOrigin);
long WINAPI GetTabbedTextExtent(long hDC,long lpString,long nCount,long nTabPositions,long lpnTabStopPositions);
long WINAPI UpdateWindow(long hWnd);
long WINAPI SetActiveWindow(long hWnd);
long WINAPI GetForegroundWindow(long);
long WINAPI PaintDesktop(long hdc);
long WINAPI SetForegroundWindow(long hWnd);
long WINAPI WindowFromDC(long hDC);
long WINAPI GetDC(long hWnd);
long WINAPI GetDCEx(long hWnd,long hrgnClip,long flags);
//long WINAPI AlignRects(long arc,long cCount,long iPrimary,long dwFlags);
long WINAPI GetWindowDC(long hWnd);
long WINAPI ReleaseDC(long hWnd,long hDC);
long WINAPI BeginPaint(long hWnd,long lpPaint);
long WINAPI EndPaint(long hWnd,long lpPaint);
long WINAPI GetUpdateRect(long hWnd,long lpRect,long bErase);
long WINAPI GetUpdateRgn(long hWnd,long hRgn,long bErase);
long WINAPI SetWindowRgn(long hWnd,long hRgn,long bRedraw);
long WINAPI GetWindowRgn(long hWnd,long hRgn);
long WINAPI ExcludeUpdateRgn(long hDC,long hWnd);
long WINAPI InvalidateRect(long hWnd,long lpRect,long bErase);
long WINAPI ValidateRect(long hWnd,long lpRect);
long WINAPI InvalidateRgn(long hWnd,long hRgn,long bErase);
long WINAPI ValidateRgn(long hWnd,long hRgn);
long WINAPI RedrawWindow(long hWnd,long lprcUpdate,long hrgnUpdate,long flags);
long WINAPI LockWindowUpdate(long hWndLock);
long WINAPI ScrollWindow(long hWnd,long XAmount,long YAmount,long lpRect,long lpClipRect);
long WINAPI ScrollDC(long hDC,long dx,long dy,long lprcScroll,long lprcClip,long hrgnUpdate,long lprcUpdate);
long WINAPI ScrollWindowEx(long hWnd,long dx,long dy,long prcScroll,long prcClip,long hrgnUpdate,long prcUpdate,long flags);
long WINAPI SetScrollPos(long hWnd,long nBar,long nPos,long bRedraw);
long WINAPI GetScrollPos(long hWnd,long nBar);
long WINAPI SetScrollRange(long hWnd,long nBar,long nMinPos,long nMaxPos,long bRedraw);
long WINAPI GetScrollRange(long hWnd,long nBar,long lpMinPos,long lpMaxPos);
long WINAPI ShowScrollBar(long hWnd,long wBar,long bShow);
long WINAPI EnableScrollBar(long hWnd,long wSBflags,long wArrows);
long WINAPI SetProp(long hWnd,long lpString,long hData);
long WINAPI GetProp(long hWnd,long lpString);
long WINAPI RemoveProp(long hWnd,long lpString);
long WINAPI EnumPropsEx(long hWnd,long lpEnumFunc,long lParam);
long WINAPI EnumProps(long hWnd,long lpEnumFunc);
long WINAPI SetWindowText(long hWnd,long lpString);
long WINAPI GetWindowText(long hWnd,long lpString,long nMaxCount);
long WINAPI GetWindowTextLength(long hWnd);
long WINAPI GetClientRect(long hWnd,long lpRect);
long WINAPI GetWindowRect(long hWnd,long lpRect);
long WINAPI AdjustWindowRect(long lpRect,long dwStyle,long bMenu);
long WINAPI AdjustWindowRectEx(long lpRect,long dwStyle,long bMenu,long dwExStyle);
long WINAPI SetWindowContextHelpId(long,long);
long WINAPI GetWindowContextHelpId(long);
long WINAPI SetMenuContextHelpId(long,long);
long WINAPI GetMenuContextHelpId(long);
long WINAPI MessageBox(long hWnd,long lpText,long lpCaption,long uType);
long WINAPI MessageBoxEx(long hWnd,long lpText,long lpCaption,long uType,long wLanguageId);
long WINAPI MessageBoxIndirect(long);
long WINAPI MessageBeep(long uType);
long WINAPI ShowCursor(long bShow);
long WINAPI SetCursorPos(long X,long Y);
long WINAPI SetCursor(long hCursor);
long WINAPI GetCursorPos(long lpPoint);
long WINAPI ClipCursor(long lpRect);
long WINAPI GetClipCursor(long lpRect);
long WINAPI GetCursor(long);
long WINAPI CreateCaret(long hWnd,long hBitmap,long nWidth,long nHeight);
long WINAPI GetCaretBlinkTime(long);
long WINAPI SetCaretBlinkTime(long uMSeconds);
long WINAPI DestroyCaret(long);
long WINAPI HideCaret(long hWnd);
long WINAPI ShowCaret(long hWnd);
long WINAPI SetCaretPos(long X,long Y);
long WINAPI GetCaretPos(long lpPoint);
long WINAPI ClientToScreen(long hWnd,long lpPoint);
long WINAPI ScreenToClient(long hWnd,long lpPoint);
long WINAPI MapWindowPoints(long hWndFrom,long hWndTo,long lpPoints,long cPoints);
long WINAPI WindowFromPoint(long Point);
long WINAPI ChildWindowFromPoint(long hWndParent,long Point);
long WINAPI ChildWindowFromPointEx(long,long,long);
long WINAPI GetSysColor(long nIndex);
long WINAPI GetSysColorBrush(long nIndex);
long WINAPI SetSysColors(long cElements,long lpaElements,long lpaRgbValues);
long WINAPI DrawFocusRect(long hDC,long lprc);
long WINAPI FillRect(long hDC,long lprc,long hbr);
long WINAPI FrameRect(long hDC,long lprc,long hbr);
long WINAPI InvertRect(long hDC,long lprc);
long WINAPI SetRect(long lprc,long xLeft,long yTop,long xRight,long yBottom);
long WINAPI SetRectEmpty(long lprc);
long WINAPI CopyRect(long lprcDst,long lprcSrc);
long WINAPI InflateRect(long lprc,long dx,long dy);
long WINAPI IntersectRect(long lprcDst,long lprcSrc1,long lprcSrc2);
long WINAPI UnionRect(long lprcDst,long lprcSrc1,long lprcSrc2);
long WINAPI SubtractRect(long lprcDst,long lprcSrc1,long lprcSrc2);
long WINAPI OffsetRect(long lprc,long dx,long dy);
long WINAPI IsRectEmpty(long lprc);
long WINAPI EqualRect(long lprc1,long lprc2);
long WINAPI PtInRect(long lprc,long pt);
long WINAPI GetWindowWord(long hWnd,long nIndex);
long WINAPI SetWindowWord(long hWnd,long nIndex,long wNewWord);
long WINAPI GetWindowLong(long hWnd,long nIndex);
long WINAPI SetWindowLong(long hWnd,long nIndex,long dwNewLong);
long WINAPI GetClassWord(long hWnd,long nIndex);
long WINAPI SetClassWord(long hWnd,long nIndex,long wNewWord);
long WINAPI GetClassLong(long hWnd,long nIndex);
long WINAPI SetClassLong(long hWnd,long nIndex,long dwNewLong);
long WINAPI GetDesktopWindow(long);
long WINAPI GetParent(long hWnd);
long WINAPI SetParent(long hWndChild,long hWndNewParent);
long WINAPI EnumChildWindows(long hWndParent,long lpEnumFunc,long lParam);
long WINAPI FindWindow(long lpClassName,long lpWindowName);
long WINAPI FindWindowEx(long,long,long,long);
long WINAPI EnumWindows(long lpEnumFunc,long lParam);
long WINAPI EnumThreadWindows(long dwThreadId,long lpfn,long lParam);
long WINAPI GetClassName(long hWnd,long lpClassName,long nMaxCount);
long WINAPI GetTopWindow(long hWnd);
long WINAPI GetWindowThreadProcessId(long hWnd,long lpdwProcessId);
long WINAPI GetLastActivePopup(long hWnd);
long WINAPI GetWindow(long hWnd,long uCmd);
long WINAPI SetWindowsHook(long nFilterType,long pfnFilterProc);
long WINAPI SetWindowsHook(long nFilterType,long pfnFilterProc);
long WINAPI UnhookWindowsHook(long nCode,long pfnFilterProc);
long WINAPI SetWindowsHookEx(long idHook,long lpfn,long hmod,long dwThreadId);
long WINAPI UnhookWindowsHookEx(long hhk);
long WINAPI CallNextHookEx(long hhk,long nCode,long wParam,long lParam);
long WINAPI CheckMenuRadioItem(long,long,long,long,long);

API(EnumWindows,user32)
API(EndMenu,user32)
API(GetLastInputInfo,user32)
API(GetMenuInfo,user32)
API(SetMenuInfo,user32)

long WINAPI LoadBitmap(long hInstance,long lpBitmapName);
long WINAPI LoadCursor(long hInstance,long lpCursorName);
long WINAPI LoadCursorFromFile(long lpFileName);
long WINAPI CreateCursor(long hInst,long xHotSpot,long yHotSpot,long nWidth,long nHeight,long pvANDPlane,long pvXORPlane);
long WINAPI DestroyCursor(long hCursor);
//long WINAPI CopyCursor(HANDLE hCursor);
long WINAPI SetSystemCursor(long hcur,long id);
long WINAPI LoadIcon(long hInstance,long lpIconName);
long WINAPI CreateIcon(long hInstance,long nWidth,long nHeight,long cPlanes,long cBitsPixel,long lpbANDbits,long lpbXORbits);
long WINAPI DestroyIcon(long hIcon);
long WINAPI LookupIconIdFromDirectory(long presbits,long fIcon);
long WINAPI LookupIconIdFromDirectoryEx(long presbits,long fIcon,long cxDesired,long cyDesired,long Flags);
long WINAPI CreateIconFromResource(long presbits,long dwResSize,long fIcon,long dwVer);
long WINAPI CreateIconFromResourceEx(long presbits,long dwResSize,long fIcon,long dwVer,long cxDesired,long cyDesired,long Flags);
long WINAPI LoadImage(long,long,long,long,long,long);
long WINAPI CopyImage(long,long,long,long,long);

//API(CopyCursor,user32)
API(DrawIconEx,user32)
APIA(DrawState,user32)
APIA(DrawTextEx,user32)
APIA(LoadBitmap,user32)
APIA(LoadCursor,user32)
API(CreateCursor,user32)
API(DestroyCursor,user32)
APIA(LoadIcon,user32)
API(CreateIcon,user32)
API(DestroyIcon,user32)
API(LookupIconIdFromDirectory,user32)
API(CreateIconIndirect,user32)
API(CopyIcon,user32)
API(GetIconInfo,user32)
API(CreateIconFromResourceEx,user32)

long WINAPI DrawIconEx(long hdc,long xLeft,long yTop,long hIcon,long cxWidth,long cyWidth,long istepIfAniCur,long hbrFlickerFreeDraw,long diFlags);
long WINAPI CreateIconIndirect(long piconinfo);
long WINAPI CopyIcon(long hIcon);
long WINAPI GetIconInfo(long hIcon,long piconinfo);

long WINAPI LoadString(long hInstance,long uID,long lpBuffer,long nBufferMax);
long WINAPI IsDialogMessage(long hDlg,long lpMsg);
long WINAPI MapDialogRect(long hDlg,long lpRect);
long WINAPI DlgDirList(long hDlg,long lpPathSpec,long nIDListBox,long nIDStaticPath,long uFileType);
long WINAPI DlgDirSelectEx(long hDlg,long lpString,long nCount,long nIDListBox);
long WINAPI DlgDirListComboBox(long hDlg,long lpPathSpec,long nIDComboBox,long nIDStaticPath,long uFiletype);
long WINAPI DlgDirSelectComboBoxEx(long hDlg,long lpString,long nCount,long nIDComboBox);
long WINAPI SetScrollInfo(long,long,long,long);
long WINAPI GetScrollInfo(long,long,long);
long WINAPI DefFrameProc(long hWnd,long hWndMDIClient,long uMsg,long wParam,long lParam);
long WINAPI DefMDIChildProc(long hWnd,long uMsg,long wParam,long lParam);
long WINAPI TranslateMDISysAccel(long hWndClient,long lpMsg);
long WINAPI ArrangeIconicWindows(long hWnd);
long WINAPI CreateMDIWindow(long lpClassName,long lpWindowName,long dwStyle,long X,long Y,long nWidth,long nHeight,long hWndParent,long hInstance,long lParam);
long WINAPI TileWindows(long hwndParent,long wHow,long lpRect,long cKids,long lpKids);
long WINAPI CascadeWindows(long hwndParent,long wHow,long lpRect,long cKids,long lpKids);
long WINAPI WinHelp(long hWndMain,long lpszHelp,long uCommand,long dwData);

//long WINAPI ChangeDisplaySettings(long lpDevMode,long dwFlags);
//long WINAPI ChangeDisplaySettingsEx(long lpszDeviceName,long lpDevMode,long hwnd,long dwflags,long lParam);
long WINAPI EnumDisplaySettings(long lpszDeviceName,long iModeNum,long lpDevMode);
long WINAPI EnumDisplayDevices(long Unused,long iDevNum,long lpDisplayDevice,long dwFlags);
long WINAPI EnumDisplayMonitors(long hdc,long lprcClip,long lpfnEnum,long dwData);
APIA(EnumDisplaySettings,user32)
API(EnumDisplayMonitors,user32)
APIA(EnumDisplayDevices,user32)

long WINAPI SystemParametersInfo(long uiAction,long uiParam,long pvParam,long fWinIni);
VOID WINAPI SetDebugErrorLevel(long dwLevel);
VOID WINAPI SetLastErrorEx(long dwErrCode,long dwType);
//long WINAPI MonitorFromPoint(long pt,long dwFlags);
//long WINAPI MonitorFromRect(long lprc,long dwFlags);
//long WINAPI MonitorFromWindow(long hwnd,long dwFlags);
long WINAPI GetMonitorInfo(long hMonitor,long lpmi);
//VOID WINAPI NotifyWinEvent(long event,long hwnd,long idObject,long idChild);
//long WINAPI SetWinEventHook(long eventMin,long eventMax,long hmodWinEventProc,long pfnWinEventProc,long idProcess,long idThread,long dwFlags);
//long WINAPI UnhookWinEvent(long hWinEventHook);
//long WINAPI GetGUIThreadInfo(long idThread,long pgui);
long WINAPI GetWindowModuleFileName(long hwnd,long pszFileName,long cchFileNameMax);
//long WINAPI LockWorkStation(long);

//API(GetGUIThreadInfo,user32)
APIA(GetMonitorInfo,user32)
APIA(GetWindowModuleFileName,user32)

long WINAPI AddFontResource(long);
long WINAPI AnimatePalette(long,long,long,long);
long WINAPI Arc(long,long,long,long,long,long,long,long,long);
long WINAPI BitBlt(long,long,long,long,long,long,long,long,long);
long WINAPI CancelDC(long);
long WINAPI Chord(long,long,long,long,long,long,long,long,long);
long WINAPI ChoosePixelFormat(long,long);
long WINAPI CloseMetaFile(long);
long WINAPI CombineRgn(long,long,long,long);
long WINAPI CopyMetaFile(long,long);
long WINAPI CreateBitmap(long,long,long,long,long);
long WINAPI CreateBitmapIndirect(long);
long WINAPI CreateBrushIndirect(long);
long WINAPI CreateCompatibleBitmap(long,long,long);
long WINAPI CreateDiscardableBitmap(long,long,long);
long WINAPI CreateCompatibleDC(long);
long WINAPI CreateDC(long,long,long,long);
long WINAPI CreateDIBitmap(long,long ,long,long ,long ,long);
long WINAPI CreateDIBPatternBrush(long,long);
long WINAPI CreateDIBPatternBrushPt(long ,long);
long WINAPI CreateEllipticRgn(long,long,long,long);
long WINAPI CreateEllipticRgnIndirect(long);
long WINAPI CreateFontIndirect(long);
long WINAPI CreateFont(long,long,long,long,long,long,long,long,long,long,long,long,long,long);
long WINAPI CreateHatchBrush(long,long);
long WINAPI CreateIC(long,long,long,long);
long WINAPI CreateMetaFile(long);
long WINAPI CreatePalette(long);
long WINAPI CreatePen(long,long,long);
long WINAPI CreatePenIndirect(long);
long WINAPI CreatePolyPolygonRgn(long ,long ,long,long);
long WINAPI CreatePatternBrush(long);
long WINAPI CreateRectRgn(long,long,long,long);
long WINAPI CreateRectRgnIndirect(long);
long WINAPI CreateRoundRectRgn(long,long,long,long,long,long);
long WINAPI CreateScalableFontResource(long,long,long,long);
long WINAPI CreateSolidBrush(long);
long WINAPI DeleteDC(long);
long WINAPI DeleteMetaFile(long);
long WINAPI DeleteObject(long);
long WINAPI DescribePixelFormat(long,long,long,long);
long WINAPI DrawEscape(long,long,long,long);
long WINAPI Ellipse(long,long,long,long,long);
long WINAPI EnumFontFamiliesEx(long,long,long,long,long);
long WINAPI EnumFontFamilies(long,long,long,long);
long WINAPI EnumFonts(long,long,long,long);
long WINAPI EnumObjects(long,long,long,long);
long WINAPI EnumObjects(long,long,long,long);
long WINAPI EqualRgn(long,long);
long WINAPI Escape(long,long,long,long,long);
long WINAPI ExtEscape(long,long,long,long,long,long);
long WINAPI ExcludeClipRect(long,long,long,long,long);
long WINAPI ExtCreateRegion(long ,long,long);
long WINAPI ExtFloodFill(long,long,long,long,long);
long WINAPI FillRgn(long,long,long);
long WINAPI FloodFill(long,long,long,long);
long WINAPI FrameRgn(long,long,long,long,long);
long WINAPI GetROP2(long);
long WINAPI GetAspectRatioFilterEx(long,long);
long WINAPI GetBkColor(long);
//long WINAPI GetDCBrushColor(long);
//long WINAPI GetDCPenColor(long);
long WINAPI GetBkMode(long);
long WINAPI GetBitmapBits(long,long,long);
long WINAPI GetBitmapDimensionEx(long,long);
long WINAPI GetBoundsRect(long,long,long);
long WINAPI GetBrushOrgEx(long,long);
long WINAPI GetCharWidth(long,long,long,long);
long WINAPI GetCharWidth32(long,long,long,long);
long WINAPI GetCharWidthFloat(long,long,long,long);
long WINAPI GetCharABCWidths(long,long,long,long);
long WINAPI GetCharABCWidthsFloat(long,long,long,long);
long WINAPI GetClipBox(long,long);
long WINAPI GetClipRgn(long,long);
long WINAPI GetMetaRgn(long,long);
long WINAPI GetCurrentObject(long,long);
long WINAPI GetCurrentPositionEx(long,long);
long WINAPI GetDeviceCaps(long,long);
long WINAPI GetDIBits(long,long,long,long,long,long,long);
//long WINAPI GetFontData(long,long,long,long,long);
long WINAPI GetGlyphIndices(long,long,long,long,long);
long WINAPI GetGlyphOutline(long,long,long,long,long,long,long);
long WINAPI GetGraphicsMode(long);
long WINAPI GetMapMode(long);
long WINAPI GetMetaFileBitsEx(long,long,long);
long WINAPI GetMetaFile(long);
long WINAPI GetNearestColor(long,long);
long WINAPI GetNearestPaletteIndex(long,long);
long WINAPI GetObjectType(long h);
long WINAPI GetOutlineTextMetrics(long,long,long);
long WINAPI GetPaletteEntries(long,long,long,long);
long WINAPI GetPixel(long,long,long);
long WINAPI GetPixelFormat(long);
long WINAPI GetPolyFillMode(long);
long WINAPI GetRasterizerCaps(long,long);
//long WINAPI GetRegionData(long,long,long);
long WINAPI GetRgnBox(long,long);
long WINAPI GetStockObject(long);
long WINAPI GetStretchBltMode(long);
long WINAPI GetSystemPaletteEntries(long,long,long,long);
long WINAPI GetSystemPaletteUse(long);
long WINAPI GetTextCharacterExtra(long);
long WINAPI GetTextAlign(long);
long WINAPI GetTextColor(long);
long WINAPI GetTextExtentPoint(long,long,long,long);
long WINAPI GetTextExtentPoint32(long,long,long,long);
long WINAPI GetTextExtentExPoint(long,long,long,long,long,long,long);
long WINAPI GetTextCharset(long hdc);
long WINAPI GetTextCharsetInfo(long hdc,long lpSig,long dwFlags);
long WINAPI TranslateCharsetInfo(long lpSrc,long lpCs,long dwFlags);
long WINAPI GetFontLanguageInfo(long);
long WINAPI GetCharacterPlacement(long,long,long,long,long,long);
//long WINAPI GetFontUnicodeRanges(long,long);
long WINAPI GetTextExtentPointI(long,long,long,long);
long WINAPI GetTextExtentExPointI(long,long,long,long,long,long,long);
long WINAPI GetCharWidthI(long,long,long,long,long);
long WINAPI GetCharABCWidthsI(long,long,long,long,long);
long WINAPI AddFontResourceEx(long,long,long);
//long WINAPI RemoveFontResourceEx(long,long,long);
long WINAPI AddFontMemResourceEx(long,long,long ,long);
long WINAPI RemoveFontMemResourceEx(long);
//long WINAPI CreateFontIndirectEx(void*);
BOOL WINAPI SwapBuffers(HDC hdc);

APIA(AddFontResource,gdi32)
APIA(AddFontResourceEx,gdi32)
API(AddFontMemResourceEx,gdi32)
API(RemoveFontMemResourceEx,gdi32)
//API(RemoveFontResourceEx,gdi32)
APIA(GetGlyphIndices,gdi32)
API(GetTextCharacterExtra,gdi32)
API(GetTextAlign,gdi32)
API(GetTextColor,gdi32)
API(GetTextExtentPoint,gdi32)
API(GetTextExtentPoint32,gdi32)
API(GetTextExtentExPoint,gdi32)
API(GetTextCharset,gdi32)
API(GetTextCharsetInfo,gdi32)
API(GetTextExtentPointI,gdi32)
API(GetTextExtentExPointI,gdi32)
//API(GetRegionData,gdi32)
//API(GetFontData,gdi32)
//API(CreateFontIndirectEx,gdi32)
//API(GetDCBrushColor,msimg32)
API(GradientFill,msimg32)
API(TransparentBlt,msimg32)
//API(TransparentDIBits,msimg32)

long WINAPI GetViewportExtEx(long,long);
long WINAPI GetViewportOrgEx(long,long);
long WINAPI GetWindowExtEx(long,long);
long WINAPI GetWindowOrgEx(long,long);
long WINAPI IntersectClipRect(long,long,long,long,long);
long WINAPI InvertRgn(long,long);
//long WINAPI LineDD(long,long,long,long,long,long);
long WINAPI LineTo(long,long,long);
long WINAPI MaskBlt(long,long,long,long,long,long,long,long,long,long,long,long);
long WINAPI PlgBlt(long,long ,long,long,long,long,long,long,long,long);
long WINAPI OffsetClipRgn(long,long,long);
long WINAPI OffsetRgn(long,long,long);
long WINAPI PatBlt(long,long,long,long,long,long);
long WINAPI Pie(long,long,long,long,long,long,long,long,long);
long WINAPI PlayMetaFile(long,long);
long WINAPI PaintRgn(long,long);
long WINAPI PolyPolygon(long,long ,long ,long);
long WINAPI PtInRegion(long,long,long);
long WINAPI PtVisible(long,long,long);
long WINAPI RectInRegion(long,long);
long WINAPI RectVisible(long,long);
long WINAPI Rectangle(long,long,long,long,long);
long WINAPI RestoreDC(long,long);
long WINAPI ResetDC(long,long);
long WINAPI RealizePalette(long);
long WINAPI RemoveFontResource(long);
long WINAPI RoundRect(long,long,long,long,long,long,long);
long WINAPI ResizePalette(long,long);
long WINAPI SaveDC(long);
long WINAPI SelectClipRgn(long,long);
long WINAPI ExtSelectClipRgn(long,long,long);
long WINAPI SetMetaRgn(long);
long WINAPI SelectObject(long,long);
long WINAPI SelectPalette(long,long,long);
long WINAPI SetBkColor(long,long);
long WINAPI SetDCBrushColor(long,long);
long WINAPI SetDCPenColor(long,long);
long WINAPI SetBkMode(long,long);
long WINAPI SetBitmapBits(long,long,long);
long WINAPI SetBoundsRect(long,long ,long);
long WINAPI SetDIBits(long,long,long,long,long ,long ,long);
long WINAPI SetDIBitsToDevice(long,long,long,long,long,long,long,long,long,long ,long ,long);
long WINAPI SetMapperFlags(long,long);
long WINAPI SetGraphicsMode(long hdc,long iMode);
long WINAPI SetMapMode(long,long);
long WINAPI SetMetaFileBitsEx(long,long);
long WINAPI SetPaletteEntries(long,long,long,long);
long WINAPI SetPixel(long,long,long,long);
long WINAPI SetPixelV(long,long,long,long);
long WINAPI SetPixelFormat(long,long,long);
long WINAPI SetPolyFillMode(long,long);
long WINAPI StretchBlt(long,long,long,long,long,long,long,long,long,long,long);
long WINAPI SetRectRgn(long,long,long,long,long);
long WINAPI StretchDIBits(long,long,long,long,long,long,long,long,long,long ,long ,long,long);
long WINAPI SetROP2(long,long);
long WINAPI SetStretchBltMode(long,long);
long WINAPI SetSystemPaletteUse(long,long);
long WINAPI SetTextCharacterExtra(long,long);
long WINAPI SetTextColor(long,long);
long WINAPI SetTextAlign(long,long);
long WINAPI SetTextJustification(long,long,long);
long WINAPI UpdateColors(long);

long WINAPI AlphaBlend(long,long,long,long,long,long,long,long,long,long,long);
//long WINAPI AlphaDIBBlend(long,long,long,long,long,long ,long ,long,long,long,long,long,long);
API(AlphaBlend,msimg32)

long WINAPI TransparentBlt(long,long,long,long,long,long,long,long,long,long,long);
//long WINAPI TransparentDIBits(long,long,long,long,long,long ,long ,long,long,long,long,long,long);
long WINAPI GradientFill(long,long,long,long,long,long);
long WINAPI PlayMetaFileRecord(long,long,long,long);
long WINAPI EnumMetaFile(long,long,long,long);
long WINAPI CloseEnhMetaFile(long);
long WINAPI CopyEnhMetaFile(long,long);
long WINAPI CreateEnhMetaFile(long,long,long ,long);
long WINAPI DeleteEnhMetaFile(long);
long WINAPI EnumEnhMetaFile(long,long,long,long,long);
long WINAPI GetEnhMetaFile(long);
long WINAPI GetEnhMetaFileBits(long,long,long);
long WINAPI GetEnhMetaFileDescription(long,long,long);
long WINAPI GetEnhMetaFileHeader(long,long,long);
long WINAPI GetEnhMetaFilePaletteEntries(long,long,long);
long WINAPI GetEnhMetaFilePixelFormat(long,long,long);
long WINAPI GetWinMetaFileBits(long,long,long,long,long);
long WINAPI PlayEnhMetaFile(long,long,long);
long WINAPI PlayEnhMetaFileRecord(long,long,long ,long);
long WINAPI SetEnhMetaFileBits(long,long);
long WINAPI SetWinMetaFileBits(long,long ,long,long);
long WINAPI GdiComment(long,long,long);
long WINAPI GetTextMetrics(long,long);
long WINAPI AngleArc(long,long,long,long,long,long);
long WINAPI PolyPolyline(long,long ,long ,long);
long WINAPI GetWorldTransform(long,long);
long WINAPI SetWorldTransform(long,long);
long WINAPI ModifyWorldTransform(long,long ,long);
long WINAPI CombineTransform(long,long ,long);
long WINAPI CreateDIBSection(long,long ,long,long ,long,long);
long WINAPI GetDIBColorTable(long,long,long,long);
long WINAPI SetDIBColorTable(long,long,long,long);
long WINAPI SetColorAdjustment(long,long);
long WINAPI GetColorAdjustment(long,long);
long WINAPI CreateHalftonePalette(long);
long WINAPI StartDoc(long,long);
long WINAPI EndDoc(long);
long WINAPI StartPage(long);
long WINAPI EndPage(long);
long WINAPI AbortDoc(long);
long WINAPI SetAbortProc(long,long);
long WINAPI AbortPath(long);
long WINAPI ArcTo(long,long,long,long,long,long,long,long,long);
long WINAPI BeginPath(long);
long WINAPI CloseFigure(long);
long WINAPI EndPath(long);
long WINAPI FillPath(long);
long WINAPI FlattenPath(long);
long WINAPI GetPath(long,long,long,long);
long WINAPI PathToRegion(long);
long WINAPI PolyDraw(long,long ,long ,long);
long WINAPI SelectClipPath(long,long);
long WINAPI SetArcDirection(long,long);
long WINAPI SetMiterLimit(long,long,long);
long WINAPI StrokeAndFillPath(long);
long WINAPI StrokePath(long);
long WINAPI WidenPath(long);
long WINAPI ExtCreatePen(long,long,long ,long,long);
long WINAPI GetMiterLimit(long,long);
long WINAPI GetArcDirection(long);
long WINAPI GetObject(long,long,long);
long WINAPI MoveToEx(long,long,long,long);
long WINAPI TextOut(long,long,long,long,long);
long WINAPI ExtTextOut(long,long,long,long,long ,long,long,long);
long WINAPI PolyTextOut(long,long ,long);
long WINAPI CreatePolygonRgn(long ,long,long);
long WINAPI DPtoLP(long,long,long);
long WINAPI LPtoDP(long,long,long);
long WINAPI Polygon(long,long ,long);
long WINAPI Polyline(long,long ,long);
long WINAPI PolyBezier(long,long ,long);
long WINAPI PolyBezierTo(long,long ,long);
long WINAPI PolylineTo(long,long ,long);
long WINAPI SetViewportExtEx(long,long,long,long);
long WINAPI SetViewportOrgEx(long,long,long,long);
long WINAPI SetWindowExtEx(long,long,long,long);
long WINAPI SetWindowOrgEx(long,long,long,long);
long WINAPI OffsetViewportOrgEx(long,long,long,long);
long WINAPI OffsetWindowOrgEx(long,long,long,long);
long WINAPI ScaleViewportExtEx(long,long,long,long,long,long);
long WINAPI ScaleWindowExtEx(long,long,long,long,long,long);
long WINAPI SetBitmapDimensionEx(long,long,long,long);
long WINAPI SetBrushOrgEx(long,long,long,long);
long WINAPI GetTextFace(long,long,long);
long WINAPI GetKerningPairs(long,long,long);
long WINAPI GetDCOrgEx(long,long);
long WINAPI FixBrushOrgEx(long,long,long,long);
long WINAPI UnrealizeObject(long);
long WINAPI GdiFlush();
long WINAPI GdiSetBatchLimit(long);
long WINAPI GdiGetBatchLimit();
long WINAPI SetICMMode(long,long);
long WINAPI CheckColorsInGamut(long,long,long,long);
long WINAPI GetColorSpace(long);
long WINAPI GetLogColorSpace(long,long,long);
long WINAPI CreateColorSpace(long);
long WINAPI SetColorSpace(long,long);
long WINAPI DeleteColorSpace(long);
long WINAPI GetICMProfile(long,long,long);
long WINAPI SetICMProfile(long,long);
long WINAPI GetDeviceGammaRamp(long,long);
long WINAPI SetDeviceGammaRamp(long,long);
long WINAPI ColorMatchToTarget(long,long,long);
long WINAPI EnumICMProfiles(long,long,long);
long WINAPI UpdateICMRegKey(long,long,long,long);
long WINAPI ColorCorrectPalette(long,long,long,long);

API(AnimatePalette,gdi32)
API(ColorCorrectPalette,gdi32)
API(Arc,gdi32)
API(BitBlt,gdi32)
API(CancelDC,gdi32)
API(Chord,gdi32)
API(CloseMetaFile,gdi32)
API(CombineRgn,gdi32)
APIA(CopyMetaFile,gdi32)
API(CreateBitmap,gdi32)
API(CreateBitmapIndirect,gdi32)
API(CreateBrushIndirect,gdi32)
API(CreateCompatibleBitmap,gdi32)
API(CreateDiscardableBitmap,gdi32)
API(CreateCompatibleDC,gdi32)
APIA(CreateDC,gdi32)
API(CreateDIBitmap,gdi32)
API(CreateDIBPatternBrush,gdi32)
API(CreateDIBPatternBrushPt,gdi32)
API(CreateEllipticRgnIndirect,gdi32)
API(CreateEllipticRgn,gdi32)
APIA(CreateFontIndirect,gdi32)
APIA(CreateFont,gdi32)
API(CreateHatchBrush,gdi32)
APIA(CreateIC,gdi32)
APIA(CreateMetaFile,gdi32)
API(CreatePalette,gdi32)
API(CreatePen,gdi32)
API(CreatePenIndirect,gdi32)
API(CreateRectRgn,gdi32)
API(CreateRectRgnIndirect,gdi32)
API(CreatePolyPolygonRgn,gdi32)
API(CreatePatternBrush,gdi32)
API(CreateRoundRectRgn,gdi32)
APIA(CreateScalableFontResource,gdi32)
API(CreateSolidBrush,gdi32)
API(DeleteDC,gdi32)
API(DeleteObject,gdi32)
API(DeleteMetaFile,gdi32)
API(Ellipse,gdi32)
API(EqualRgn,gdi32)
API(Escape,gdi32)
API(ExtEscape,gdi32)
API(DrawEscape,gdi32)
API(ExcludeClipRect,gdi32)
API(ExtCreateRegion,gdi32)
API(ExtFloodFill,gdi32)
API(FillRgn,gdi32)
API(FrameRgn,gdi32)
API(FloodFill,gdi32)
API(GetROP2,gdi32)
API(GetAspectRatioFilterEx,gdi32)
API(GetBkColor,gdi32)
API(GetBkMode,gdi32)
API(GetBitmapBits,gdi32)
API(GetBitmapDimensionEx,gdi32)
API(GetBoundsRect,gdi32)
APIA(GetCharWidth,gdi32)
APIA(GetCharWidth32,gdi32)
APIA(GetCharWidthFloat,gdi32)
API(GetCharWidthI,gdi32)
APIA(GetCharABCWidths,gdi32)
APIA(GetCharABCWidthsFloat,gdi32)
API(GetCharABCWidthsI,gdi32)
API(GetClipBox,gdi32)
API(GetClipRgn,gdi32)
API(GetMetaRgn,gdi32)
API(GetCurrentObject,gdi32)
API(GetCurrentPositionEx,gdi32)
API(GetDeviceCaps,gdi32)
API(GetDIBits,gdi32)
APIA(GetFontData,gdi32)
APIA(GetGlyphOutline,gdi32)
API(GetGraphicsMode,gdi32)
API(GetMapMode,gdi32)
API(GetMetaFileBitsEx,gdi32)
APIA(GetMetaFile,gdi32)
API(GetNearestColor,gdi32)
API(GetNearestPaletteIndex,gdi32)
API(GetObjectType,gdi32)
APIA(GetOutlineTextMetrics,gdi32)
API(GetPaletteEntries,gdi32)
API(GetPixel,gdi32)
API(GetPolyFillMode,gdi32)
API(GetRasterizerCaps,gdi32)
APIA(GetRegionData,gdi32)
API(GetRgnBox,gdi32)
API(GetStockObject,gdi32)
API(GetStretchBltMode,gdi32)
API(GetSystemPaletteEntries,gdi32)
API(GetSystemPaletteUse,gdi32)
API(GetTextCharacterExtra,gdi32)
API(GetTextAlign,gdi32)
API(GetTextColor,gdi32)
APIA(GetTextExtentPoint,gdi32)
APIA(GetTextExtentPoint32,gdi32)
APIA(GetTextExtentExPoint,gdi32)
API(GetViewportExtEx,gdi32)
API(GetViewportOrgEx,gdi32)
API(GetWindowExtEx,gdi32)
API(GetWindowOrgEx,gdi32)
API(IntersectClipRect,gdi32)
API(InvertRgn,gdi32)
API(LineTo,gdi32)
API(MaskBlt,gdi32)
API(PlgBlt,gdi32)
API(OffsetClipRgn,gdi32)
API(OffsetRgn,gdi32)
API(PatBlt,gdi32)
API(Pie,gdi32)
API(PlayMetaFile,gdi32)
API(PaintRgn,gdi32)
API(PolyPolygon,gdi32)
API(PtInRegion,gdi32)
API(PtVisible,gdi32)
API(RectVisible,gdi32)
API(RectInRegion,gdi32)
API(Rectangle,gdi32)
API(RestoreDC,gdi32)
APIA(ResetDC,gdi32)
API(RealizePalette,gdi32)
APIA(RemoveFontResource,gdi32)
API(RoundRect,gdi32)
API(ResizePalette,gdi32)
API(SaveDC,gdi32)
API(SelectClipRgn,gdi32)
API(ExtSelectClipRgn,gdi32)
API(SetMetaRgn,gdi32)
API(SelectObject,gdi32)
API(SelectPalette,gdi32)
API(SetBkColor,gdi32)
API(SetBkMode,gdi32)
API(SetDCBrushColor,gdi32)
API(SetDCPenColor,gdi32)
API(SetBitmapBits,gdi32)
API(SetBoundsRect,gdi32)
API(SetDIBits,gdi32)
API(SetDIBitsToDevice,gdi32)
API(SetMapperFlags,gdi32)
API(SetGraphicsMode,gdi32)
API(SetMapMode,gdi32)
API(SetMetaFileBitsEx,gdi32)
API(SetPaletteEntries,gdi32)
API(SetPixel,gdi32)
API(SetPixelV,gdi32)
API(SetPolyFillMode,gdi32)
API(StretchBlt,gdi32)
API(SetRectRgn,gdi32)
API(StretchDIBits,gdi32)
API(SetROP2,gdi32)
API(SetStretchBltMode,gdi32)
API(SetSystemPaletteUse,gdi32)
API(SetTextCharacterExtra,gdi32)
API(SetTextColor,gdi32)
API(SetTextAlign,gdi32)
API(SetTextJustification,gdi32)
API(UpdateColors,gdi32)
API(GetProcAddress,kernel32)
API(PlayMetaFileRecord,gdi32)
API(CloseEnhMetaFile,gdi32)
APIA(CopyEnhMetaFile,gdi32)
APIA(CreateEnhMetaFile,gdi32)
API(DeleteEnhMetaFile,gdi32)
API(EnumEnhMetaFile,gdi32)
APIA(GetEnhMetaFile,gdi32)
API(GetEnhMetaFileBits,gdi32)
APIA(GetEnhMetaFileDescription,gdi32)
API(GetEnhMetaFileHeader,gdi32)
API(GetEnhMetaFilePaletteEntries,gdi32)
API(GetEnhMetaFilePixelFormat,gdi32)
API(GetWinMetaFileBits,gdi32)
API(PlayEnhMetaFile,gdi32)
API(PlayEnhMetaFileRecord,gdi32)
API(SetEnhMetaFileBits,gdi32)
API(SetWinMetaFileBits,gdi32)
API(GdiComment,gdi32)
APIA(GetTextMetrics,gdi32)
API(AngleArc,gdi32)
API(PolyPolyline,gdi32)
API(GetWorldTransform,gdi32)
API(SetWorldTransform,gdi32)
API(ModifyWorldTransform,gdi32)
API(CombineTransform,gdi32)
API(SetColorAdjustment,gdi32)
API(GetColorAdjustment,gdi32)
API(CreateHalftonePalette,gdi32)
APIA(StartDoc,gdi32)
API(StartPage,gdi32)
API(EndPage,gdi32)
API(EndDoc,gdi32)
API(AbortDoc,gdi32)
API(AbortPath,gdi32)
API(ArcTo,gdi32)
API(BeginPath,gdi32)
API(CloseFigure,gdi32)
API(EndPath,gdi32)
API(FillPath,gdi32)
API(FlattenPath,gdi32)
API(GetPath,gdi32)
API(PathToRegion,gdi32)
API(PolyDraw,gdi32)
API(SelectClipPath,gdi32)
API(SetArcDirection,gdi32)
API(SetMiterLimit,gdi32)
API(StrokeAndFillPath,gdi32)
API(StrokePath,gdi32)
API(WidenPath,gdi32)
API(ExtCreatePen,gdi32)
API(GetMiterLimit,gdi32)
API(GetArcDirection,gdi32)
APIA(GetObject,gdi32)
API(MoveToEx,gdi32)
APIA(TextOut,gdi32)
APIA(ExtTextOut,gdi32)
APIA(PolyTextOut,gdi32)
API(CreatePolygonRgn,gdi32)
API(DPtoLP,gdi32)
API(LPtoDP,gdi32)
API(Polyline,gdi32)
API(Polygon,gdi32)
API(PolyBezier,gdi32)
API(PolyBezierTo,gdi32)
API(PolylineTo,gdi32)
API(SetViewportExtEx,gdi32)
API(SetViewportOrgEx,gdi32)
API(SetWindowOrgEx,gdi32)
API(SetWindowExtEx,gdi32)
API(OffsetViewportOrgEx,gdi32)
API(OffsetWindowOrgEx,gdi32)
API(ScaleWindowExtEx,gdi32)
API(ScaleViewportExtEx,gdi32)
API(SetBitmapDimensionEx,gdi32)
API(SetBrushOrgEx,gdi32)
APIA(GetTextFace,gdi32)
APIA(GetKerningPairs,gdi32)
API(GetDCOrgEx,gdi32)
API(UnrealizeObject,gdi32)
API(GdiFlush,gdi32)
API(GdiSetBatchLimit,gdi32)
API(GdiGetBatchLimit,gdi32)
APIA(EnumFontFamilies,gdi32)
APIA(EnumFontFamiliesEx,gdi32)
API(GetTextCharset,gdi32)
API(GetTextCharsetInfo,gdi32)
API(TranslateCharsetInfo,gdi32)
API(GetFontLanguageInfo,gdi32)
APIA(GetCharacterPlacement,gdi32)
API(SetICMMode,gdi32)
API(CheckColorsInGamut,gdi32)
APIA(GetLogColorSpace,gdi32)
API(GetColorSpace,gdi32)
APIA(CreateColorSpace,gdi32)
API(SetColorSpace,gdi32)
API(DeleteColorSpace,gdi32)
APIA(GetICMProfile,gdi32)
APIA(SetICMProfile,gdi32)
API(GetDeviceGammaRamp,gdi32)
API(SetDeviceGammaRamp,gdi32)
API(ColorMatchToTarget,gdi32)
APIA(EnumICMProfiles,gdi32)
APIA(UpdateICMRegKey,gdi32)

long WINAPI EncryptFile(long lpFileName);
long WINAPI DecryptFile(long lpFileName,long dwReserved);
APIA(EncryptFile,advapi32)
APIA(DecryptFile,advapi32)

//long WINAPI OpenRaw(long lpFileName,long ulFlags,long pvContext);
//long WINAPI ReadRaw(long pfExportCallback,long pvCallbackContext,long pvContext);
//long WINAPI WriteRaw(long pfImportCallback,long pvCallbackContext,long pvContext);
//VOID WINAPI CloseRaw(long pvContext);
//long WINAPI QueryRecoveryAgents(long lpFileName,long AgentCount,long RecoveryAgentInformation);
long WINAPI IsTextUnicode(long lpBuffer,long cb,long lpi);
long WINAPI ClearEventLog(long hEventLog,long lpBackupFileName);
long WINAPI BackupEventLog(long hEventLog,long lpBackupFileName);
long WINAPI CloseEventLog(long hEventLog);
long WINAPI DeregisterEventSource(long hEventLog);
long WINAPI NotifyChangeEventLog(long hEventLog,long hEvent);
long WINAPI GetNumberOfEventLogRecords(long hEventLog,long NumberOfRecords);
long WINAPI GetOldestEventLogRecord(long hEventLog,long OldestRecord);
long WINAPI OpenEventLog(long lpUNCServerName,long lpSourceName);
long WINAPI RegisterEventSource(long lpUNCServerName,long lpSourceName);
long WINAPI OpenBackupEventLog(long lpUNCServerName,long lpFileName);
long WINAPI ReadEventLog(long hEventLog,long dwReadFlags,long dwRecordOffset,long lpBuffer,long nNumberOfBytesToRead,long pnBytesRead,long pnMinNumberOfBytesNeeded);
long WINAPI ReportEvent(long hEventLog,long wType,long wCategory,long dwEventID,long lpUserSid,long wNumStrings,long dwDataSize,long lpStrings,long lpRawData);
long WINAPI DuplicateToken(long ExistingTokenHandle,long ImpersonationLevel,long DuplicateTokenHandle);
long WINAPI GetKernelObjectSecurity(long Handle,long RequestedInformation,long pSecurityDescriptor,long nLength,long lpnLengthNeeded);
long WINAPI ImpersonateNamedPipeClient(long hNamedPipe);
long WINAPI ImpersonateSelf(long ImpersonationLevel);
long WINAPI RevertToSelf(long);
long WINAPI SetThreadToken(long Thread,long Token);

API(DuplicateToken,advapi32)
API(DuplicateTokenEx,advapi32)

long WINAPI AccessCheck(long pSecurityDescriptor,long ClientToken,long DesiredAccess,long GenericMapping,long PrivilegeSet,long PrivilegeSetLength,long GrantedAccess,long AccessStatus);
long WINAPI AccessCheckByType(long pSecurityDescriptor,long PrincipalSelfSid,long ClientToken,long DesiredAccess,long ObjectTypeList,long ObjectTypeListLength,long GenericMapping,long PrivilegeSet,long PrivilegeSetLength,long GrantedAccess,long AccessStatus);
long WINAPI AccessCheckByTypeResultList(long pSecurityDescriptor,long PrincipalSelfSid,long ClientToken,long DesiredAccess,long ObjectTypeList,long ObjectTypeListLength,long GenericMapping,long PrivilegeSet,long PrivilegeSetLength,long GrantedAccessList,long AccessStatusList);
long WINAPI AccessCheckAndAuditAlarm(long SubsystemName,long HandleId,long ObjectTypeName,long ObjectName,long SecurityDescriptor,long DesiredAccess,long GenericMapping,long ObjectCreation,long GrantedAccess,long AccessStatus,long pfGenerateOnClose);
long WINAPI AccessCheckByTypeAndAuditAlarm(long SubsystemName,long HandleId,long ObjectTypeName,long ObjectName,long SecurityDescriptor,long PrincipalSelfSid,long DesiredAccess,long AuditType,long Flags,long ObjectTypeList,long ObjectTypeListLength,long GenericMapping,long ObjectCreation,long GrantedAccess,long AccessStatus,long pfGenerateOnClose);
long WINAPI AccessCheckByTypeResultListAndAuditAlarm(long SubsystemName,long HandleId,long ObjectTypeName,long ObjectName,long SecurityDescriptor,long PrincipalSelfSid,long DesiredAccess,long AuditType,long Flags,long ObjectTypeList,long ObjectTypeListLength,long GenericMapping,long ObjectCreation,long GrantedAccess,long AccessStatusList,long pfGenerateOnClose);

API(AccessCheck,advapi32)
API(AccessCheckByType,advapi32)
API(AccessCheckByTypeResultList,advapi32)
#define PRAGMA_API AccessCheckAndAuditAlarm;advapi32!AccessCheckAndAuditAlarmA
#define PRAGMA_API AccessCheckByTypeAndAuditAlarm;advapi32!AccessCheckByTypeAndAuditAlarmA
#define PRAGMA_API AccessCheckByTypeResultListAndAuditAlarm;advapi32!AccessCheckByTypeResultListAndAuditAlarmA

long WINAPI OpenProcessToken(long ProcessHandle,long DesiredAccess,long TokenHandle);
long WINAPI OpenThreadToken(long ThreadHandle,long DesiredAccess,long OpenAsSelf,long TokenHandle);
long WINAPI GetTokenInformation(long TokenHandle,long TokenInformationClass,long TokenInformation,long TokenInformationLength,long ReturnLength);
long WINAPI SetTokenInformation(long TokenHandle,long TokenInformationClass,long TokenInformation,long TokenInformationLength);
long WINAPI AdjustTokenPrivileges(long TokenHandle,long DisableAllPrivileges,long NewState,long BufferLength,long PreviousState,long ReturnLength);
long WINAPI AdjustTokenGroups(long TokenHandle,long ResetToDefault,long NewState,long BufferLength,long PreviousState,long ReturnLength);
long WINAPI PrivilegeCheck(long ClientToken,long RequiredPrivileges,long pfResult);
long WINAPI ObjectOpenAuditAlarm(long SubsystemName,long HandleId,long ObjectTypeName,long ObjectName,long pSecurityDescriptor,long ClientToken,long DesiredAccess,long GrantedAccess,long Privileges,long ObjectCreation,long AccessGranted,long GenerateOnClose);
long WINAPI ObjectPrivilegeAuditAlarm(long SubsystemName,long HandleId,long ClientToken,long DesiredAccess,long Privileges,long AccessGranted);
long WINAPI ObjectCloseAuditAlarm(long SubsystemName,long HandleId,long GenerateOnClose);
long WINAPI ObjectDeleteAuditAlarm(long SubsystemName,long HandleId,long GenerateOnClose);
long WINAPI PrivilegedServiceAuditAlarm(long SubsystemName,long ServiceName,long ClientToken,long Privileges,long AccessGranted);
long WINAPI IsValidSid(long pSid);
long WINAPI EqualSid(long pSid1,long pSid2);
long WINAPI EqualPrefixSid(long pSid1,long pSid2);
long WINAPI GetSidLengthRequired(long nSubAuthorityCount);
long WINAPI AllocateAndInitializeSid(long pIdentifierAuthority,long nSubAuthorityCount,long nSubAuthority0,long nSubAuthority1,long nSubAuthority2,long nSubAuthority3,long nSubAuthority4,long nSubAuthority5,long nSubAuthority6,long nSubAuthority7,long pSid);
long WINAPI FreeSid(long pSid);
long WINAPI InitializeSid(long Sid,long pIdentifierAuthority,long nSubAuthorityCount);
long WINAPI GetSidIdentifierAuthority(long pSid);
long WINAPI GetSidSubAuthority(long pSid,long nSubAuthority);
long WINAPI GetSidSubAuthorityCount(long pSid);
long WINAPI GetLengthSid(long pSid);
long WINAPI CopySid(long nDestinationSidLength,long pDestinationSid,long pSourceSid);
long WINAPI AreAllAccessesGranted(long GrantedAccess,long DesiredAccess);
VOID WINAPI MapGenericMask(long AccessMask,long GenericMapping);

API(OpenProcessToken,advapi32)
API(GetTokenInformation,advapi32)
APIA(LookupAccountSid,advapi32)
API(NetLocalGroupDelMembers,advapi32)
API(NetLocalGroupGetMembers,advapi32)

long WINAPI IsValidAcl(long pAcl);
long WINAPI InitializeAcl(long pAcl,long nAclLength,long dwAclRevision);
long WINAPI GetAclInformation(long pAcl,long pAclInformation,long nAclInformationLength,long dwAclInformationClass);
long WINAPI SetAclInformation(long pAcl,long pAclInformation,long nAclInformationLength,long dwAclInformationClass);
long WINAPI AddAce(long pAcl,long dwAceRevision,long dwStartingAceIndex,long pAceList,long nAceListLength);
long WINAPI DeleteAce(long pAcl,long dwAceIndex);
long WINAPI GetAce(long pAcl,long dwAceIndex,long pAce);
long WINAPI AddAccessAllowedAce(long pAcl,long dwAceRevision,long AccessMask,long pSid);
long WINAPI AddAccessAllowedAceEx(long pAcl,long dwAceRevision,long AceFlags,long AccessMask,long pSid);
long WINAPI AddAccessDeniedAce(long pAcl,long dwAceRevision,long AccessMask,long pSid);
long WINAPI AddAccessDeniedAceEx(long pAcl,long dwAceRevision,long AceFlags,long AccessMask,long pSid);
long WINAPI AddAuditAccessAce(long pAcl,long dwAceRevision,long dwAccessMask,long pSid,long bAuditSuccess,long bAuditFailure);
long WINAPI AddAuditAccessAceEx(long pAcl,long dwAceRevision,long AceFlags,long dwAccessMask,long pSid,long bAuditSuccess,long bAuditFailure);
long WINAPI AddAccessAllowedObjectAce(long pAcl,long dwAceRevision,long AceFlags,long AccessMask,long ObjectTypeGuid,long InheritedObjectTypeGuid,long pSid);
long WINAPI AddAccessDeniedObjectAce(long pAcl,long dwAceRevision,long AceFlags,long AccessMask,long ObjectTypeGuid,long InheritedObjectTypeGuid,long pSid);
long WINAPI AddAuditAccessObjectAce(long pAcl,long dwAceRevision,long AceFlags,long AccessMask,long ObjectTypeGuid,long InheritedObjectTypeGuid,long pSid,long bAuditSuccess,long bAuditFailure);
long WINAPI FindFirstFreeAce(long pAcl,long pAce);

API(AddAccessAllowedAceEx,advapi32)
API(AddAccessAllowedObjectAce,advapi32)
API(AddAccessDeniedAceEx,advapi32)
API(AddAccessDeniedObjectAce,advapi32)
API(AddAuditAccessAceEx,advapi32)
API(AddAuditAccessObjectAce,advapi32)

long WINAPI InitializeSecurityDescriptor(long pSecurityDescriptor,long dwRevision);
long WINAPI IsValidSecurityDescriptor(long pSecurityDescriptor);
long WINAPI GetSecurityDescriptorLength(long pSecurityDescriptor);
long WINAPI GetSecurityDescriptorControl(long pSecurityDescriptor,long pControl,long lpdwRevision);
long WINAPI SetSecurityDescriptorControl(long pSecurityDescriptor,long ControlBitsOfInterest,long ControlBitsToSet);
long WINAPI SetSecurityDescriptorDacl(long pSecurityDescriptor,long bDaclPresent,long pDacl,long bDaclDefaulted);
long WINAPI GetSecurityDescriptorDacl(long pSecurityDescriptor,long lpbDaclPresent,long pDacl,long lpbDaclDefaulted);
long WINAPI SetSecurityDescriptorSacl(long pSecurityDescriptor,long bSaclPresent,long pSacl,long bSaclDefaulted);
long WINAPI GetSecurityDescriptorSacl(long pSecurityDescriptor,long lpbSaclPresent,long pSacl,long lpbSaclDefaulted);
long WINAPI SetSecurityDescriptorOwner(long pSecurityDescriptor,long pOwner,long bOwnerDefaulted);
long WINAPI GetSecurityDescriptorOwner(long pSecurityDescriptor,long pOwner,long lpbOwnerDefaulted);
long WINAPI SetSecurityDescriptorGroup(long pSecurityDescriptor,long pGroup,long bGroupDefaulted);
long WINAPI GetSecurityDescriptorGroup(long pSecurityDescriptor,long pGroup,long lpbGroupDefaulted);
long WINAPI CreatePrivateObjectSecurity(long ParentDescriptor,long CreatorDescriptor,long NewDescriptor,long IsDirectoryObject,long Token,long GenericMapping);
long WINAPI ConvertToAutoInheritPrivateObjectSecurity(long ParentDescriptor,long CurrentSecurityDescriptor,long NewSecurityDescriptor,long ObjectType,long IsDirectoryObject,long GenericMapping);
long WINAPI CreatePrivateObjectSecurityEx(long ParentDescriptor,long CreatorDescriptor,long NewDescriptor,long ObjectType,long IsContainerObject,long AutoInheritFlags,long Token,long GenericMapping);
long WINAPI SetPrivateObjectSecurity(long SecurityInformation,long ModificationDescriptor,long ObjectsSecurityDescriptor,long GenericMapping,long Token);
long WINAPI SetPrivateObjectSecurityEx(long SecurityInformation,long ModificationDescriptor,long ObjectsSecurityDescriptor,long AutoInheritFlags,long GenericMapping,long Token);
long WINAPI GetPrivateObjectSecurity(long ObjectDescriptor,long SecurityInformation,long ResultantDescriptor,long DescriptorLength,long ReturnLength);
long WINAPI DestroyPrivateObjectSecurity(long ObjectDescriptor);
long WINAPI MakeSelfRelativeSD(long pAbsoluteSecurityDescriptor,long pSelfRelativeSecurityDescriptor,long lpdwBufferLength);
long WINAPI MakeAbsoluteSD(long pSelfRelativeSecurityDescriptor,long pAbsoluteSecurityDescriptor,long lpdwAbsoluteSecurityDescriptorSize,long pDacl,long lpdwDaclSize,long pSacl,long lpdwSaclSize,long pOwner,long lpdwOwnerSize,long pPrimaryGroup,long lpdwPrimaryGroupSize);
long WINAPI SetFileSecurity(long lpFileName,long SecurityInformation,long pSecurityDescriptor);
long WINAPI GetFileSecurity(long lpFileName,long RequestedInformation,long pSecurityDescriptor,long nLength,long lpnLengthNeeded);
long WINAPI SetKernelObjectSecurity(long Handle,long SecurityInformation,long SecurityDescriptor);
long WINAPI LookupAccountSid(long lpSystemName,long Sid,long Name,long cbName,long ReferencedDomainName,long cbReferencedDomainName,long peUse);
long WINAPI LookupAccountName(long lpSystemName,long lpAccountName,long Sid,long cbSid,long ReferencedDomainName,long cbReferencedDomainName,long peUse);
long WINAPI LookupPrivilegeValue(long lpSystemName,long lpName,long lpLuid);
long WINAPI LookupPrivilegeName(long lpSystemName,long lpLuid,long lpName,long cbName);
long WINAPI LookupPrivilegeDisplayName(long lpSystemName,long lpName,long lpDisplayName,long cbDisplayName,long lpLanguageId);
long WINAPI AllocateLocallyUniqueId(long Luid);
long WINAPI GetUserName(long lpBuffer,long nSize);
//long WINAPI LogonUser(long lpszUsername,long lpszDomain,long lpszPassword,long dwLogonType,long dwLogonProvider,long phToken);
//long WINAPI ImpersonateLoggedOnUser(long hToken);
long WINAPI CreateProcessAsUser(long hToken,long lpApplicationName,long lpCommandLine,long lpProcessAttributes,long lpThreadAttributes,long bInheritHandles,long dwCreationFlags,long lpEnvironment,long lpCurrentDirectory,long lpStartupInfo,long lpProcessInformation);
//long WINAPI IsTokenRestricted(long TokenHandle);
long WINAPI GetCurrentHwProfile(long lpHwProfileInfo);

API(ConvertToAutoInheritPrivateObjectSecurity,advapi32)
API(CreatePrivateObjectSecurityEx,advapi32)
APIA(GetCurrentHwProfile,advapi32)
//API(ImpersonateLoggedOnUser,advapi32)

//long WINAPI GetFreeSpace(long);
long WINAPI InterlockedIncrement(long lpAddend);
long WINAPI InterlockedDecrement(long lpAddend);
long WINAPI InterlockedExchange(long ,long );
long WINAPI InterlockedExchangeAdd(long Addend,long Value);
long WINAPI InterlockedCompareExchange(long Destination,long Exchange,long Comperand);
long WINAPI FreeResource(long hResData);
long WINAPI LockResource(long hResData);
long WINAPI FreeLibrary(long hLibModule);
VOID WINAPI FreeLibraryAndExitThread(long hLibModule,long dwExitCode);
long WINAPI DisableThreadLibraryCalls(long hLibModule);
long WINAPI GetProcAddress(long hModule,long lpProcName);
long WINAPI GetVersion(long);

long WINAPI GlobalAlloc(long uFlags,long dwBytes);
long WINAPI GlobalReAlloc(long hMem,long dwBytes,long uFlags);
long WINAPI GlobalSize(long hMem);
long WINAPI GlobalFlags(long hMem);
long WINAPI GlobalLock(long hMem);
long WINAPI GlobalHandle(long pMem);
long WINAPI GlobalUnlock(long hMem);
long WINAPI GlobalFree(long hMem);
long WINAPI GlobalCompact(long dwMinFree);
VOID WINAPI GlobalFix(long hMem);
VOID WINAPI GlobalUnfix(long hMem);
long WINAPI GlobalWire(long hMem);
long WINAPI GlobalUnWire(long hMem);
VOID WINAPI GlobalMemoryStatus(long lpBuffer);
long WINAPI LocalAlloc(long uFlags,long uBytes);
long WINAPI LocalReAlloc(long hMem,long uBytes,long uFlags);
long WINAPI LocalLock(long hMem);
long WINAPI LocalHandle(long pMem);
long WINAPI LocalUnlock(long hMem);
long WINAPI LocalSize(long hMem);
long WINAPI LocalFlags(long hMem);
long WINAPI LocalFree(long hMem);
long WINAPI LocalShrink(long hMem,long cbNewSize);
long WINAPI LocalCompact(long uMinFree);
long WINAPI FlushInstructionCache(long hProcess,long lpBaseAddress,long dwSize);
long WINAPI VirtualAlloc(long lpAddress,long dwSize,long flAllocationType,long flProtect);
long WINAPI VirtualFree(long lpAddress,long dwSize,long dwFreeType);
long WINAPI VirtualProtect(long lpAddress,long dwSize,long flNewProtect,long lpflOldProtect);
long WINAPI VirtualQuery(long lpAddress,long lpBuffer,long dwLength);
long WINAPI VirtualAllocEx(long hProcess,long lpAddress,long dwSize,long flAllocationType,long flProtect);
long WINAPI VirtualFreeEx(long hProcess,long lpAddress,long dwSize,long dwFreeType);
long WINAPI VirtualProtectEx(long hProcess,long lpAddress,long dwSize,long flNewProtect,long lpflOldProtect);
long WINAPI VirtualQueryEx(long hProcess,long lpAddress,long lpBuffer,long dwLength);

long WINAPI HeapCreate(long flOptions,long dwInitialSize,long dwMaximumSize);
long WINAPI HeapDestroy(long hHeap);
long WINAPI HeapAlloc(long hHeap,long dwFlags,long dwBytes);
long WINAPI HeapReAlloc(long hHeap,long dwFlags,long lpMem,long dwBytes);
long WINAPI HeapFree(long hHeap,long dwFlags,long lpMem);
long WINAPI HeapSize(long hHeap,long dwFlags,long lpMem);
long WINAPI HeapValidate(long hHeap,long dwFlags,long lpMem);
long WINAPI HeapCompact(long hHeap,long dwFlags);
long WINAPI GetProcessHeap(long);
long WINAPI GetProcessHeaps(long NumberOfHeaps,long ProcessHeaps);
long WINAPI HeapLock(long hHeap);
long WINAPI HeapUnlock(long hHeap);
long WINAPI HeapWalk(long hHeap,long lpEntry);

API(HeapCreate,kernel32)
API(HeapDestroy,kernel32)
API(HeapAlloc,kernel32)
API(HeapReAlloc,kernel32)
API(HeapFree,kernel32)
API(HeapSize,kernel32)
API(HeapUnlock,kernel32)
API(HeapLock,kernel32)
API(HeapCompact,kernel32)
API(HeapValidate,kernel32)
API(HeapWalk,kernel32)
API(GetProcessHeap,kernel32)
API(GetProcessHeaps,kernel32)

long WINAPI GetBinaryType(long lpApplicationName,long lpBinaryType);
long WINAPI GetShortPathName(long lpszLongPath,long lpszShortPath,long cchBuffer);
long WINAPI GetLongPathName(long lpszShortPath,long lpszLongPath,long cchBuffer);
long WINAPI GetProcessAffinityMask(long hProcess,long lpProcessAffinityMask,long lpSystemAffinityMask);
long WINAPI SetProcessAffinityMask(long hProcess,long dwProcessAffinityMask);
long WINAPI GetProcessTimes(long hProcess,long lpCreationTime,long lpExitTime,long lpKernelTime,long lpUserTime);
long WINAPI GetProcessWorkingSetSize(long hProcess,long lpMinimumWorkingSetSize,long lpMaximumWorkingSetSize);
long WINAPI SetProcessWorkingSetSize(long hProcess,long dwMinimumWorkingSetSize,long dwMaximumWorkingSetSize);
long WINAPI OpenProcess(long dwDesiredAccess,long bInheritHandle,long dwProcessId);
long WINAPI GetCurrentProcess(long);
long WINAPI GetCurrentProcessId(long);
VOID WINAPI ExitProcess(long uExitCode);
long WINAPI TerminateProcess(long hProcess,long uExitCode);
long WINAPI GetExitCodeProcess(long hProcess,long lpExitCode);
VOID WINAPI FatalExit(long ExitCode);
long WINAPI GetEnvironmentStrings(long);
long WINAPI FreeEnvironmentStrings(long);
VOID WINAPI RaiseException(long dwExceptionCode,long dwExceptionFlags,long nNumberOfArguments,long lpArguments);
long WINAPI UnhandledExceptionFilter(long ExceptionInfo);
long WINAPI SetUnhandledExceptionFilter(long lpTopLevelExceptionFilter);

API(GetCurrentProcess,kernel32)
APIA(GetLongPathName,kernel32)
API(GetProcessAffinityMask,kernel32)
API(SetProcessAffinityMask,kernel32)
API(GlobalAlloc,kernel32)
API(GlobalFree,kernel32)
API(GlobalHandle,kernel32)
API(GlobalLock,kernel32)
API(GlobalReAlloc,kernel32)
API(GlobalSize,kernel32)
API(GlobalUnlock,kernel32)
API(GlobalFlags,kernel32)
API(GlobalMemoryStatus,kernel32)
API(LocalAlloc,kernel32)
API(LocalFree,kernel32)
API(LocalHandle,kernel32)
API(LocalLock,kernel32)
API(LocalReAlloc,kernel32)
API(LocalSize,kernel32)
API(LocalUnlock,kernel32)
API(LocalFlags,kernel32)
API(FlushInstructionCache,kernel32)
API(VirtualAlloc,kernel32)
API(VirtualFree,kernel32)
API(VirtualAllocEx,kernel32)
API(VirtualFreeEx,kernel32)
API(VirtualProtect,kernel32)
API(VirtualQuery,kernel32)
API(VirtualProtectEx,kernel32)
API(VirtualQueryEx,kernel32)
API(HeapCreate,kernel32)
API(HeapDestroy,kernel32)
API(HeapAlloc,kernel32)
API(HeapReAlloc,kernel32)
API(HeapFree,kernel32)
API(HeapSize,kernel32)
API(GetProcessTimes,kernel32)
API(OpenProcess,kernel32)
API(GetCurrentProcess,kernel32)
API(GetCurrentProcessId,kernel32)
API(ExitProcess,kernel32)
API(TerminateProcess,kernel32)
API(GetExitCodeProcess,kernel32)


long WINAPI CreateFiber(long dwStackSize,long lpStartAddress,long lpParameter);
VOID WINAPI DeleteFiber(long lpFiber);
long WINAPI ConvertThreadToFiber(long lpParameter);
VOID WINAPI SwitchToFiber(long lpFiber);
long WINAPI SwitchToThread(long);
long WINAPI CreateThread(long lpThreadAttributes,long dwStackSize,long lpStartAddress,long lpParameter,long dwCreationFlags,long lpThreadId);
long WINAPI CreateRemoteThread(long hProcess,long lpThreadAttributes,long dwStackSize,long lpStartAddress,long lpParameter,long dwCreationFlags,long lpThreadId);
long WINAPI GetCurrentThread(void);
long WINAPI GetCurrentThreadId(void);
long WINAPI SetThreadAffinityMask(long hThread,long dwThreadAffinityMask);
//long WINAPI SetThreadIdealProcessor(long hThread,long dwIdealProcessor);
long WINAPI SetProcessPriorityBoost(long hProcess,long bDisablePriorityBoost);
long WINAPI GetProcessPriorityBoost(long hProcess,long pDisablePriorityBoost);
long WINAPI RequestWakeupLatency(long latency);
long WINAPI SetThreadPriority(long hThread,long nPriority);
long WINAPI SetThreadPriorityBoost(long hThread,long bDisablePriorityBoost);
long WINAPI GetThreadPriorityBoost(long hThread,long pDisablePriorityBoost);
long WINAPI GetThreadPriority(long hThread);
long WINAPI GetThreadTimes(long hThread,long lpCreationTime,long lpExitTime,long lpKernelTime,long lpUserTime);
VOID WINAPI ExitThread(long dwExitCode);
long WINAPI TerminateThread(long hThread,long dwExitCode);
long WINAPI GetExitCodeThread(long hThread,long lpExitCode);
long WINAPI GetThreadSelectorEntry(long hThread,long dwSelector,long lpSelectorEntry);
long WINAPI SetThreadExecutionState(long esFlags);
long WINAPI SetProcessShutdownParameters(long dwLevel,long dwFlags);
long WINAPI GetProcessShutdownParameters(long lpdwLevel,long lpdwFlags);
long WINAPI GetProcessVersion(long ProcessId);

API(ConvertThreadToFiber,kernel32)
API(CreateFiber,kernel32)
API(DeleteFiber,kernel32)
API(SwitchToFiber,kernel32)
API(SwitchToThread,kernel32)
API(CreateThread,kernel32)
API(CreateRemoteThread,kernel32)
API(GetCurrentThread,kernel32)
API(GetCurrentThreadId,kernel32)
API(SetProcessPriorityBoost,kernel32)
API(GetProcessPriorityBoost,kernel32)
API(RequestWakeupLatency,kernel32)
API(GetThreadPriorityBoost,kernel32)
API(SetThreadPriorityBoost,kernel32)
API(SetThreadPriority,kernel32)
API(GetThreadPriority,kernel32)
API(GetThreadTimes,kernel32)
API(ExitThread,kernel32)
API(TerminateThread,kernel32)
API(GetExitCodeThread,kernel32)
API(GetThreadSelectorEntry,kernel32)
API(SetThreadExecutionState,kernel32)
API(SetProcessShutdownParameters,kernel32)
API(GetProcessShutdownParameters,kernel32)
API(GetProcessVersion,kernel32)

long WINAPI GetLastError(long);
VOID WINAPI SetLastError(long dwErrCode);
long WINAPI GetOverlappedResult(long hFile,long lpOverlapped,long lpNumberOfBytesTransferred,long bWait);
long WINAPI CreateIoCompletionPort(long FileHandle,long ExistingCompletionPort,long CompletionKey,long NumberOfConcurrentThreads);
long WINAPI GetQueuedCompletionStatus(long CompletionPort,long lpNumberOfBytesTransferred,long lpCompletionKey,long lpOverlapped,long dwMilliseconds);
long WINAPI PostQueuedCompletionStatus(long CompletionPort,long dwNumberOfBytesTransferred,long dwCompletionKey,long lpOverlapped);
long WINAPI SetErrorMode(long uMode);
long WINAPI ReadProcessMemory(long hProcess,long lpBaseAddress,long lpBuffer,long nSize,long lpNumberOfBytesRead);
long WINAPI WriteProcessMemory(long hProcess,long lpBaseAddress,long lpBuffer,long nSize,long lpNumberOfBytesWritten);
long WINAPI GetThreadContext(long hThread,long lpContext);
long WINAPI SetThreadContext(long hThread,long lpContext);
long WINAPI SuspendThread(long hThread);
long WINAPI ResumeThread(long hThread);
//long WINAPI QueueUserAPC(long pfnAPC,long hThread,long dwData);
//long WINAPI IsDebuggerPresent(long);
VOID WINAPI DebugBreak(long);
long WINAPI WaitForDebugEvent(long lpDebugEvent,long dwMilliseconds);
long WINAPI ContinueDebugEvent(long dwProcessId,long dwThreadId,long dwContinueStatus);
long WINAPI DebugActiveProcess(long dwProcessId);
VOID WINAPI InitializeCriticalSection(long lpCriticalSection);
VOID WINAPI EnterCriticalSection(long lpCriticalSection);
VOID WINAPI LeaveCriticalSection(long lpCriticalSection);
long WINAPI InitializeCriticalSectionAndSpinCount(long lpCriticalSection,long dwSpinCount);
long WINAPI SetCriticalSectionSpinCount(long lpCriticalSection,long dwSpinCount);
long WINAPI TryEnterCriticalSection(long lpCriticalSection);
VOID WINAPI DeleteCriticalSection(long lpCriticalSection);
long WINAPI SetEvent(long hEvent);
long WINAPI ResetEvent(long hEvent);
long WINAPI PulseEvent(long hEvent);
long WINAPI ReleaseSemaphore(long hSemaphore,long lReleaseCount,long lpPreviousCount);
long WINAPI ReleaseMutex(long hMutex);
long WINAPI WaitForSingleObject(long hHandle,long dwMilliseconds);
long WINAPI WaitForMultipleObjects(long nCount,long lpHandles,long bWaitAll,long dwMilliseconds);
VOID WINAPI Sleep(long dwMilliseconds);
long WINAPI LoadResource(long hModule,long hResInfo);
long WINAPI SizeofResource(long hModule,long hResInfo);

long WINAPI InitAtomTable(long nSize);
long WINAPI AddAtom(long lpString);
long WINAPI FindAtom(long lpString);
long WINAPI GetAtomName(long nAtom,long lpBuffer,long nSize);
long WINAPI DeleteAtom(long nAtom);
long WINAPI GlobalDeleteAtom(long nAtom);
long WINAPI GlobalAddAtom(long lpString);
long WINAPI GlobalFindAtom(long lpString);
long WINAPI GlobalGetAtomName(long nAtom,long lpBuffer,long nSize);

API(InitAtomTable,kernel32)
APIA(AddAtom,kernel32)
APIA(FindAtom,kernel32)
API(DeleteAtom,kernel32)
APIA(GetAtomName,kernel32)
APIA(GlobalAddAtom,kernel32)
API(GlobalDeleteAtom,kernel32)
APIA(GlobalFindAtom,kernel32)
APIA(GlobalGetAtomName,kernel32)

long WINAPI SetHandleCount(long uNumber);
long WINAPI GetLogicalDrives(long);
long WINAPI LockFile(long hFile,long dwFileOffsetLow,long dwFileOffsetHigh,long nNumberOfBytesToLockLow,long nNumberOfBytesToLockHigh);
long WINAPI UnlockFile(long hFile,long dwFileOffsetLow,long dwFileOffsetHigh,long nNumberOfBytesToUnlockLow,long nNumberOfBytesToUnlockHigh);
long WINAPI LockFileEx(long hFile,long dwFlags,long dwReserved,long nNumberOfBytesToLockLow,long nNumberOfBytesToLockHigh,long lpOverlapped);
long WINAPI UnlockFileEx(long hFile,long dwReserved,long nNumberOfBytesToUnlockLow,long nNumberOfBytesToUnlockHigh,long lpOverlapped);
long WINAPI GetFileInformationByHandle(long hFile,long lpFileInformation);
long WINAPI GetFileType(long hFile);
long WINAPI GetFileSize(long hFile,long lpFileSizeHigh);
long WINAPI GetStdHandle(long nStdHandle);
long WINAPI SetStdHandle(long nStdHandle,long hHandle);
long WINAPI WriteFile(long hFile,long lpBuffer,long nNumberOfBytesToWrite,long lpNumberOfBytesWritten,long lpOverlapped);
long WINAPI ReadFile(long hFile,long lpBuffer,long nNumberOfBytesToRead,long lpNumberOfBytesRead,long lpOverlapped);
long WINAPI FlushFileBuffers(long hFile);
long WINAPI DeviceIoControl(long hDevice,long dwIoControlCode,long lpInBuffer,long nInBufferSize,long lpOutBuffer,long nOutBufferSize,long lpBytesReturned,long lpOverlapped);
long WINAPI SetEndOfFile(long hFile);
long WINAPI SetFilePointer(long hFile,long lDistanceToMove,long lpDistanceToMoveHigh,long dwMoveMethod);
long WINAPI FindClose(long hFindFile);
long WINAPI GetFileTime(long hFile,long lpCreationTime,long lpLastAccessTime,long lpLastWriteTime);
long WINAPI SetFileTime(long hFile,long lpCreationTime,long lpLastAccessTime,long lpLastWriteTime);
long WINAPI CloseHandle(long hObject);
long WINAPI DuplicateHandle(long hSourceProcessHandle,long hSourceHandle,long hTargetProcessHandle,long lpTargetHandle,long dwDesiredAccess,long bInheritHandle,long dwOptions);
long WINAPI GetHandleInformation(long hObject,long lpdwFlags);
long WINAPI SetHandleInformation(long hObject,long dwMask,long dwFlags);
long WINAPI LoadModule(long lpModuleName,long lpParameterBlock);

long WINAPI GetDevicePowerState(long hFile);
long WINAPI WinExec(long lpCmdLine,long uCmdShow);
long WINAPI ClearCommBreak(long hFile);
long WINAPI ClearCommError(long hFile,long lpErrors,long lpStat);
long WINAPI SetupComm(long hFile,long dwInQueue,long dwOutQueue);
long WINAPI EscapeCommFunction(long hFile,long dwFunc);
long WINAPI GetCommConfig(long hCommDev,long lpCC,long lpdwSize);
long WINAPI GetCommMask(long hFile,long lpEvtMask);
long WINAPI GetCommProperties(long hFile,long lpCommProp);
long WINAPI GetCommModemStatus(long hFile,long lpModemStat);
long WINAPI GetCommState(long hFile,long lpDCB);
long WINAPI GetCommTimeouts(long hFile,long lpCommTimeouts);
long WINAPI PurgeComm(long hFile,long dwFlags);
long WINAPI SetCommBreak(long hFile);
long WINAPI SetCommConfig(long hCommDev,long lpCC,long dwSize);
long WINAPI SetCommMask(long hFile,long dwEvtMask);
long WINAPI SetCommState(long hFile,long lpDCB);
long WINAPI SetCommTimeouts(long hFile,long lpCommTimeouts);
long WINAPI TransmitCommChar(long hFile,long cChar);
long WINAPI WaitCommEvent(long hFile,long lpEvtMask,long lpOverlapped);
long WINAPI SetTapePosition(long hDevice,long dwPositionMethod,long dwPartition,long dwOffsetLow,long dwOffsetHigh,long bImmediate);
long WINAPI GetTapePosition(long hDevice,long dwPositionType,long lpdwPartition,long lpdwOffsetLow,long lpdwOffsetHigh);
long WINAPI PrepareTape(long hDevice,long dwOperation,long bImmediate);
long WINAPI EraseTape(long hDevice,long dwEraseType,long bImmediate);
long WINAPI CreateTapePartition(long hDevice,long dwPartitionMethod,long dwCount,long dwSize);
long WINAPI WriteTapemark(long hDevice,long dwTapemarkType,long dwTapemarkCount,long bImmediate);
long WINAPI GetTapeStatus(long hDevice);
long WINAPI GetTapeParameters(long hDevice,long dwOperation,long lpdwSize,long lpTapeInformation);
long WINAPI SetTapeParameters(long hDevice,long dwOperation,long lpTapeInformation);
long WINAPI Beep(long dwFreq,long dwDuration);
long WINAPI MulDiv(long nNumber,long nNumerator,long nDenominator);

API(GetDevicePowerState,kernel32)

VOID WINAPI GetSystemTime(long lpSystemTime);
VOID WINAPI GetSystemTimeAsFileTime(long lpSystemTimeAsFileTime);
long WINAPI SetSystemTime(long lpSystemTime);
VOID WINAPI GetLocalTime(long lpSystemTime);
long WINAPI SetLocalTime(long lpSystemTime);
VOID WINAPI GetSystemInfo(long lpSystemInfo);
//long WINAPI IsProcessorFeaturePresent(long ProcessorFeature);
long WINAPI SystemTimeToTzSpecificLocalTime(long lpTimeZoneInformation,long lpUniversalTime,long lpLocalTime);
long WINAPI GetTimeZoneInformation(long lpTimeZoneInformation);
long WINAPI SetTimeZoneInformation(long lpTimeZoneInformation);
long WINAPI SystemTimeToFileTime(long lpSystemTime,long lpFileTime);
long WINAPI FileTimeToLocalFileTime(long lpFileTime,long lpLocalFileTime);
long WINAPI LocalFileTimeToFileTime(long lpLocalFileTime,long lpFileTime);
long WINAPI FileTimeToSystemTime(long lpFileTime,long lpSystemTime);
long WINAPI CompareFileTime(long lpFileTime1,long lpFileTime2);
long WINAPI FileTimeToDosDateTime(long lpFileTime,long lpFatDate,long lpFatTime);
long WINAPI DosDateTimeToFileTime(long wFatDate,long wFatTime,long lpFileTime);
long WINAPI GetTickCount(void);
long WINAPI SetSystemTimeAdjustment(long dwTimeAdjustment,long bTimeAdjustmentDisabled);
long WINAPI GetSystemTimeAdjustment(long lpTimeAdjustment,long lpTimeIncrement,long lpTimeAdjustmentDisabled);

API(GetSystemTimeAsFileTime,kernel32)
API(GetSystemTime,kernel32)
API(SetSystemTime,kernel32)
API(GetLocalTime,kernel32)
API(SetLocalTime,kernel32)
API(GetSystemInfo,kernel32)
API(GetTimeZoneInformation,kernel32)
API(SetTimeZoneInformation,kernel32)
API(SystemTimeToFileTime,kernel32)
API(FileTimeToLocalFileTime,kernel32)
API(LocalFileTimeToFileTime,kernel32)
API(FileTimeToSystemTime,kernel32)
API(CompareFileTime,kernel32)
API(FileTimeToDosDateTime,kernel32)
API(DosDateTimeToFileTime,kernel32)
API(GetTickCount,kernel32)
API(SetSystemTimeAdjustment,kernel32)
API(GetSystemTimeAdjustment,kernel32)


long WINAPI FormatMessage(long dwFlags,long lpSource,long dwMessageId,long dwLanguageId,long lpBuffer,long nSize,long Arguments);
long WINAPI CreatePipe(long hReadPipe,long hWritePipe,long lpPipeAttributes,long nSize);
long WINAPI ConnectNamedPipe(long hNamedPipe,long lpOverlapped);
long WINAPI DisconnectNamedPipe(long hNamedPipe);
long WINAPI SetNamedPipeHandleState(long hNamedPipe,long lpMode,long lpMaxCollectionCount,long lpCollectDataTimeout);
long WINAPI GetNamedPipeInfo(long hNamedPipe,long lpFlags,long lpOutBufferSize,long lpInBufferSize,long lpMaxInstances);
long WINAPI PeekNamedPipe(long hNamedPipe,long lpBuffer,long nBufferSize,long lpBytesRead,long lpTotalBytesAvail,long lpBytesLeftThisMessage);
long WINAPI TransactNamedPipe(long hNamedPipe,long lpInBuffer,long nInBufferSize,long lpOutBuffer,long nOutBufferSize,long lpBytesRead,long lpOverlapped);
long WINAPI CreateMailslot(long lpName,long nMaxMessageSize,long lReadTimeout,long lpSecurityAttributes);
long WINAPI GetMailslotInfo(long hMailslot,long lpMaxMessageSize,long lpNextSize,long lpMessageCount,long lpReadTimeout);
long WINAPI SetMailslotInfo(long hMailslot,long lReadTimeout);
long WINAPI MapViewOfFile(long hFileMappingObject,long dwDesiredAccess,long dwFileOffsetHigh,long dwFileOffsetLow,long dwNumberOfBytesToMap);
//long WINAPI MapViewOfFileVlm(long hFileMappingObject,long dwDesiredAccess,long ulOffset,long ulNumberOfBytesToMap,long lpBaseAddress);
long WINAPI FlushViewOfFile(long lpBaseAddress,long dwNumberOfBytesToFlush);
long WINAPI UnmapViewOfFile(long lpBaseAddress);
//long WINAPI UnmapViewOfFileVlm(long lpBaseAddress);

long WINAPI lstrcmp(long lpString1,long lpString2);
long WINAPI lstrcmpi(long lpString1,long lpString2);
long WINAPI lstrcpyn(long lpString1,long lpString2,long iMaxLength);
long WINAPI lstrcpy(long lpString1,long lpString2);
long WINAPI lstrcat(long lpString1,long lpString2);
long WINAPI lstrlen(long lpString);
long WINAPI OpenFile(long lpFileName,long lpReOpenBuff,long uStyle);
//long WINAPI _lopen(long lpPathName,long iReadWrite);
//long WINAPI _lcreat(long lpPathName,long iAttribute);
//long WINAPI _lread(long hFile,long lpBuffer,long uBytes);
//long WINAPI _lwrite(long hFile,long lpBuffer,long uBytes);
//long WINAPI _hread(long hFile,long lpBuffer,long lBytes);
//long WINAPI _hwrite(long hFile,long lpBuffer,long lBytes);
//long WINAPI _lclose(long hFile);
//long WINAPI _llseek(long hFile,long lOffset,long iOrigin);
long WINAPI TlsAlloc(long);
long WINAPI TlsGetValue(long dwTlsIndex);
long WINAPI TlsSetValue(long dwTlsIndex,long lpTlsValue);
long WINAPI TlsFree(long dwTlsIndex);
long WINAPI SleepEx(long dwMilliseconds,long bAlertable);
long WINAPI WaitForSingleObjectEx(long hHandle,long dwMilliseconds,long bAlertable);
long WINAPI WaitForMultipleObjectsEx(long nCount,long lpHandles,long bWaitAll,long dwMilliseconds,long bAlertable);
//long WINAPI SignalObjectAndWait(long hObjectToSignal,long hObjectToWaitOn,long dwMilliseconds,long bAlertable);
long WINAPI ReadFileEx(long hFile,long lpBuffer,long nNumberOfBytesToRead,long lpOverlapped,long lpCompletionRoutine);
long WINAPI WriteFileEx(long hFile,long lpBuffer,long nNumberOfBytesToWrite,long lpOverlapped,long lpCompletionRoutine);
long WINAPI BackupRead(long hFile,long lpBuffer,long nNumberOfBytesToRead,long lpNumberOfBytesRead,long bAbort,long bProcessSecurity,long lpContext);
long WINAPI BackupSeek(long hFile,long dwLowBytesToSeek,long dwHighBytesToSeek,long lpdwLowByteSeeked,long lpdwHighByteSeeked,long lpContext);
long WINAPI BackupWrite(long hFile,long lpBuffer,long nNumberOfBytesToWrite,long lpNumberOfBytesWritten,long bAbort,long bProcessSecurity,long lpContext);
//long WINAPI ReadFileScatter(long hFile,long aSegmentArray,long nNumberOfBytesToRead,long lpReserved,long lpOverlapped);
//long WINAPI WriteFileGather(long hFile,long aSegmentArray,long nNumberOfBytesToWrite,long lpReserved,long lpOverlapped);
long WINAPI CreateMutex(long lpMutexAttributes,long bInitialOwner,long lpName);
long WINAPI OpenMutex(long dwDesiredAccess,long bInheritHandle,long lpName);
long WINAPI CreateEvent(long lpEventAttributes,long bManualReset,long bInitialState,long lpName);
long WINAPI OpenEvent(long dwDesiredAccess,long bInheritHandle,long lpName);
long WINAPI CreateSemaphore(long lpSemaphoreAttributes,long lInitialCount,long lMaximumCount,long lpName);
long WINAPI OpenSemaphore(long dwDesiredAccess,long bInheritHandle,long lpName);

long WINAPI CreateWaitableTimer(long lpTimerAttributes,long bManualReset,long lpTimerName);
long WINAPI OpenWaitableTimer(long dwDesiredAccess,long bInheritHandle,long lpTimerName);
long WINAPI SetWaitableTimer(long hTimer,long lpDueTime,long lPeriod,long pfnCompletionRoutine,long lpArgToCompletionRoutine,long fResume);
long WINAPI CancelWaitableTimer(long hTimer);

APIA(CreateWaitableTimer,kernel32)
APIA(OpenWaitableTimer,kernel32)
API(SetWaitableTimer,kernel32)
API(CancelWaitableTimer,kernel32)

long WINAPI CreateFileMapping(long hFile,long lpFileMappingAttributes,long flProtect,long dwMaximumSizeHigh,long dwMaximumSizeLow,long lpName);
long WINAPI OpenFileMapping(long dwDesiredAccess,long bInheritHandle,long lpName);
long WINAPI GetLogicalDriveStrings(long nBufferLength,long lpBuffer);
long WINAPI LoadLibrary(long lpLibFileName);
long WINAPI LoadLibraryEx(long lpLibFileName,long hFile,long dwFlags);
long WINAPI GetModuleFileName(long hModule,long lpFilename,long nSize);
long WINAPI GetModuleHandle(long lpModuleName);
long WINAPI CreateProcess(long lpApplicationName,long lpCommandLine,long lpProcessAttributes,long lpThreadAttributes,long bInheritHandles,long dwCreationFlags,long lpEnvironment,long lpCurrentDirectory,long lpStartupInfo,long lpProcessInformation);
VOID WINAPI FatalAppExit(long uAction,long lpMessageText);
VOID WINAPI GetStartupInfo(long lpStartupInfo);
long WINAPI GetCommandLine(long);
long WINAPI GetEnvironmentVariable(long lpName,long lpBuffer,long nSize);
long WINAPI SetEnvironmentVariable(long lpName,long lpValue);
long WINAPI ExpandEnvironmentStrings(long lpSrc,long lpDst,long nSize);
VOID WINAPI OutputDebugString(long lpOutputString);
long WINAPI FindResource(long hModule,long lpName,long lpType);
long WINAPI FindResourceEx(long hModule,long lpType,long lpName,long wLanguage);
long WINAPI EnumResourceTypes(long hModule,long lpEnumFunc,long lParam);
long WINAPI EnumResourceNames(long hModule,long lpType,long lpEnumFunc,long lParam);
long WINAPI EnumResourceLanguages(long hModule,long lpType,long lpName,long lpEnumFunc,long lParam);
long WINAPI BeginUpdateResource(long pFileName,long bDeleteExistingResources);
long WINAPI UpdateResource(long hUpdate,long lpType,long lpName,long wLanguage,long lpData,long cbData);
long WINAPI EndUpdateResource(long hUpdate,long fDiscard);

long WINAPI GetProfileInt(long lpAppName,long lpKeyName,long nDefault);
long WINAPI GetProfileString(long lpAppName,long lpKeyName,long lpDefault,long lpReturnedString,long nSize);
long WINAPI WriteProfileString(long lpAppName,long lpKeyName,long lpString);
long WINAPI GetProfileSection(long lpAppName,long lpReturnedString,long nSize);
long WINAPI WriteProfileSection(long lpAppName,long lpString);
long WINAPI GetPrivateProfileInt(long lpAppName,long lpKeyName,long nDefault,long lpFileName);
long WINAPI GetPrivateProfileString(long lpAppName,long lpKeyName,long lpDefault,long lpReturnedString,long nSize,long lpFileName);
long WINAPI WritePrivateProfileString(long lpAppName,long lpKeyName,long lpString,long lpFileName);
long WINAPI GetPrivateProfileSection(long lpAppName,long lpReturnedString,long nSize,long lpFileName);
long WINAPI WritePrivateProfileSection(long lpAppName,long lpString,long lpFileName);
long WINAPI GetPrivateProfileSectionNames(long lpszReturnBuffer,long nSize,long lpFileName);
long WINAPI GetPrivateProfileStruct(long lpszSection,long lpszKey,long lpStruct,long uSizeStruct,long szFile);
long WINAPI WritePrivateProfileStruct(long lpszSection,long lpszKey,long lpStruct,long uSizeStruct,long szFile);

APIA(GetProfileInt,kernel32)
APIA(GetProfileString,kernel32)
APIA(WriteProfileString,kernel32)
APIA(GetProfileSection,kernel32)
APIA(WriteProfileSection,kernel32)
APIA(GetPrivateProfileInt,kernel32)
APIA(GetPrivateProfileString,kernel32)
APIA(WritePrivateProfileString,kernel32)
APIA(GetPrivateProfileSection,kernel32)
APIA(WritePrivateProfileSection,kernel32)
APIA(GetPrivateProfileSectionNames,kernel32)
APIA(GetPrivateProfileStruct,kernel32)
APIA(WritePrivateProfileStruct,kernel32)

long WINAPI GetDriveType(char* lpRootPathName);
long WINAPI GetTempPath(long nBufferLength,long lpBuffer);
long WINAPI GetTempFileName(char* lpPathName,long lpPrefixString,long uUnique,long lpTempFileName);
long WINAPI GetSystemDirectory(long lpBuffer,long uSize);
long WINAPI GetWindowsDirectory(long lpBuffer,long uSize);
long WINAPI SetCurrentDirectory(char* lpPathName);
long WINAPI GetCurrentDirectory(long nBufferLength,long lpBuffer);
long WINAPI GetDiskFreeSpace(char* lpRootPathName,long lpSectorsPerCluster,long lpBytesPerSector,long lpNumberOfFreeClusters,long lpTotalNumberOfClusters);
long WINAPI GetDiskFreeSpaceEx(char* lpDirectoryName,long lpFreeBytesAvailableToCaller,long lpTotalNumberOfBytes,long lpTotalNumberOfFreeBytes);
long WINAPI CreateDirectory(char* lpPathName,long lpSecurityAttributes);
long WINAPI CreateDirectoryEx(long lpTemplateDirectory,long lpNewDirectory,long lpSecurityAttributes);
long WINAPI RemoveDirectory(char* lpPathName);
long WINAPI GetFullPathName(char* lpFileName,long nBufferLength,long lpBuffer,long lpFilePart);
long WINAPI DefineDosDevice(long dwFlags,char* lpDeviceName,char* lpTargetPath);
long WINAPI QueryDosDevice(char* lpDeviceName,char* lpTargetPath,long ucchMax);
long WINAPI CreateFile(char* lpFileName,long dwDesiredAccess,long dwShareMode,long lpSecurityAttributes,long dwCreationDisposition,long dwFlagsAndAttributes,long hTemplateFile);
long WINAPI SetFileAttributes(char* lpFileName,long dwFileAttributes);
long WINAPI GetFileAttributes(char* lpFileName);
long WINAPI GetFileAttributesEx(char* lpFileName,long fInfoLevelId,long lpFileInformation);
long WINAPI GetCompressedFileSize(char* lpFileName,long lpFileSizeHigh);
long WINAPI DeleteFile(char* lpFileName);
long WINAPI FindFirstFileEx(char* lpFileName,long fInfoLevelId,WIN32_FIND_DATA *lpFindFileData,long fSearchOp,long lpSearchFilter,long dwAdditionalFlags);
long WINAPI FindFirstFile(char* lpFileName,WIN32_FIND_DATA *lpFindFileData);
long WINAPI FindNextFile(long hFindFile,WIN32_FIND_DATA *lpFindFileData);
long WINAPI SearchPath(char* lpPath,char* lpFileName,char* lpExtension,long nBufferLength,long lpBuffer,long lpFilePart);
long WINAPI CopyFile(char* lpExistingFileName,char* lpNewFileName,long bFailIfExists);
long WINAPI CopyFileEx(char* lpExistingFileName,char* lpNewFileName,long lpProgressRoutine,long lpData,long pbCancel,long dwCopyFlags);
long WINAPI MoveFile(char* lpExistingFileName,char* lpNewFileName);
long WINAPI MoveFileEx(char* lpExistingFileName,char* lpNewFileName,long dwFlags);
long WINAPI MoveFileWithProgress(char* lpExistingFileName,char* lpNewFileName,long lpProgressRoutine,long lpData,long dwFlags);

APIA(FindFirstFileEx,kernel32)
APIA(GetWindowsDirectory,kernel32)
APIA(GetSystemDirectory,kernel32)
APIA(GetTempPath,kernel32)
APIA(SetCurrentDirectory,kernel32)
APIA(GetCurrentDirectory,kernel32)
APIA(GetDiskFreeSpace,kernel32)
APIA(GetDiskFreeSpaceEx,kernel32)
APIA(CreateDirectory,kernel32)
APIA(CreateDirectoryEx,kernel32)
APIA(RemoveDirectory,kernel32)
APIA(GetFullPathName,kernel32)
APIA(DefineDosDevice,kernel32)
APIA(QueryDosDevice,kernel32)
APIA(CreateFile,kernel32)
APIA(SetFileAttributes,kernel32)
APIA(GetFileAttributes,kernel32)
APIA(GetFileAttributesEx,kernel32)
APIA(DeleteFile,kernel32)
APIA(FindFirstFile,kernel32)
APIA(FindNextFile,kernel32)
APIA(SearchPath,kernel32)
APIA(CopyFile,kernel32)
APIA(MoveFile,kernel32)
APIA(MoveFileEx,kernel32)
APIA(MoveFileWithProgress,kernel32)
APIA(CreateNamedPipe,kernel32)
APIA(GetNamedPipeHandleState,kernel32)
APIA(CallNamedPipe,kernel32)
APIA(WaitNamedPipe,kernel32)
APIA(SetVolumeLabel,kernel32)
API(SetFileApisToOEM,kernel32)
APIA(GetVolumeInformation,kernel32)

long WINAPI CreateHardLink(long lpFileName,long lpExistingFileName,long lpSecurityAttributes);
long WINAPI CreateNamedPipe(long lpName,long dwOpenMode,long dwPipeMode,long nMaxInstances,long nOutBufferSize,long nInBufferSize,long nDefaultTimeOut,long lpSecurityAttributes);
long WINAPI GetNamedPipeHandleState(long hNamedPipe,long lpState,long lpCurInstances,long lpMaxCollectionCount,long lpCollectDataTimeout,long lpUserName,long nMaxUserNameSize);
long WINAPI CallNamedPipe(long lpNamedPipeName,long lpInBuffer,long nInBufferSize,long lpOutBuffer,long nOutBufferSize,long lpBytesRead,long nTimeOut);
long WINAPI WaitNamedPipe(long lpNamedPipeName,long nTimeOut);
long WINAPI SetVolumeLabel(long lpRootPathName,long lpVolumeName);

APIA(CopyFileEx,kernel32)
APIA(CreateHardLink,kernel32)

VOID WINAPI SetFileApisToOEM(long);
VOID WINAPI SetFileApisToANSI(long);
long WINAPI AreFileApisANSI(long);
API(AreFileApisANSI,kernel32)

long WINAPI GetVolumeInformation(long lpRootPathName,long lpVolumeNameBuffer,long nVolumeNameSize,long lpVolumeSerialNumber,long lpMaximumComponentLength,long lpFileSystemFlags,long lpFileSystemNameBuffer,long nFileSystemNameSize);
long WINAPI CancelIo(long hFile);
API(CancelIo,kernel32)

long WINAPI FindFirstChangeNotification(long lpPathName,long bWatchSubtree,long dwNotifyFilter);
long WINAPI FindNextChangeNotification(long hChangeHandle);
long WINAPI FindCloseChangeNotification(long hChangeHandle);
long WINAPI VirtualLock(long lpAddress,long dwSize);
long WINAPI VirtualUnlock(long lpAddress,long dwSize);
long WINAPI MapViewOfFileEx(long hFileMappingObject,long dwDesiredAccess,long dwFileOffsetHigh,long dwFileOffsetLow,long dwNumberOfBytesToMap,long lpBaseAddress);
long WINAPI SetPriorityClass(long hProcess,long dwPriorityClass);
long WINAPI GetPriorityClass(long hProcess);
long WINAPI IsBadReadPtr(long lp,long ucb);
long WINAPI IsBadWritePtr(long lp,long ucb);
long WINAPI IsBadHugeReadPtr(long lp,long ucb);
long WINAPI IsBadHugeWritePtr(long lp,long ucb);
long WINAPI IsBadCodePtr(long lpfn);
long WINAPI IsBadStringPtr(long lpsz,long ucchMax);
long WINAPI BuildCommDCB(long lpDef,long lpDCB);
long WINAPI BuildCommDCBAndTimeouts(long lpDef,long lpDCB,long lpCommTimeouts);
long WINAPI CommConfigDialog(long lpszName,long hWnd,long lpCC);
long WINAPI GetDefaultCommConfig(long lpszName,long lpCC,long lpdwSize);
long WINAPI SetDefaultCommConfig(long lpszName,long lpCC,long dwSize);
long WINAPI GetComputerName(long lpBuffer,long nSize);
long WINAPI SetComputerName(long lpComputerName);
long WINAPI QueryPerformanceCounter(long lpPerformanceCount);
long WINAPI QueryPerformanceFrequency(long lpFrequency);
long WINAPI GetVersionEx(long lpVersionInformation);
//long WINAPI VirtualAllocVlm(long hProcess,long lpAddress,long ullSize,long flAllocationType,long flProtect);
//long WINAPI VirtualFreeVlm(long hProcess,long lpAddress,long ullSize,long dwFreeType);
//long WINAPI VirtualProtectVlm(long hProcess,long lpAddress,long ullSize,long flNewProtect,long lpflOldProtect);
//long WINAPI VirtualQueryVlm(long hProcess,long lpAddress,long lpBuffer,long dwLength);
//VOID WINAPI GlobalMemoryStatusVlm(long lpBuffer);
//long WINAPI ReadProcessMemoryVlm(long hProcess,long lpBaseAddress,long lpBuffer,long nSize,long lpNumberOfBytesRead);
//long WINAPI WriteProcessMemoryVlm(long hProcess,long lpBaseAddress,long lpBuffer,long nSize,long lpNumberOfBytesWritten);
//long WINAPI ReadFileVlm(long hFile,long lpBuffer,long nNumberOfBytesToRead,long lpReserved,long lpOverlapped);
//long WINAPI WriteFileVlm(long hFile,long lpBuffer,long nNumberOfBytesToWrite,long lpReserved,long lpOverlapped);

long WINAPI CreateJobObject(long lpJobAttributes,long lpName);
long WINAPI OpenJobObject(long dwDesiredAccess,long bInheritHandle,long lpName);
long WINAPI AssignProcessToJobObject(long hJob,long hProcess);
long WINAPI TerminateJobObject(long hJob,long uExitCode);
//long WINAPI QueryInformationJobObject(long hJob,long JobObjectInformationClass,long lpJobObjectInformation,long cbJobObjectInformationLength,long lpReturnLength);
//long WINAPI SetInformationJobObject(long hJob,long JobObjectInformationClass,long lpJobObjectInformation,long cbJobObjectInformationLength);

API(AssignProcessToJobObject,kernel32)
APIA(CreateJobObject,kernel32)
APIA(OpenJobObject,kernel32)
API(TerminateJobObject,kernel32)

long WINAPI DuplicateTokenEx(long ,long ,long ,long ,long ,long );
long WINAPI CreateRestrictedToken(long ,long ,long ,long ,long ,long ,long ,long ,long );
API(CreateRestrictedToken,advapi32)

BOOL WINAPI AllocConsole();
BOOL WINAPI FreeConsole();
BOOL WINAPI SetConsoleTitle(char* lpConsoleTitle);

long WINAPI DeviceCapabilities(long,long,long,long,long);
APIA(DeviceCapabilities,winspool.drv)

API(InitCommonControls,comctl32)

API(InterlockedIncrement,kernel32)
API(InterlockedDecrement,kernel32)
API(InterlockedExchange,kernel32)
API(InterlockedExchangeAdd,kernel32)
API(InterlockedCompareExchange,kernel32)
APIA(GetModuleFileName,kernel32)
APIA(GetModuleHandle,kernel32)
APIA(CreateProcess,kernel32)
APIA(FatalAppExit,kernel32)
APIA(GetStartupInfo,kernel32)
APIA(GetCommandLine,kernel32)
APIA(GetEnvironmentVariable,kernel32)
APIA(SetEnvironmentVariable,kernel32)
APIA(ExpandEnvironmentStrings,kernel32)
APIA(LoadLibrary,kernel32)
APIA(LoadLibraryEx,kernel32)
API(LoadModule,kernel32)
API(FreeLibrary,kernel32)
API(WinExec,kernel32)
API(DebugBreak,kernel32)
API(ContinueDebugEvent,kernel32)
API(WaitForDebugEvent,kernel32)
API(DebugActiveProcess,kernel32)
API(InitializeCriticalSection,kernel32)
API(EnterCriticalSection,kernel32)
API(LeaveCriticalSection,kernel32)
API(DeleteCriticalSection,kernel32)
API(InitializeCriticalSectionAndSpinCount,kernel32)
API(SetCriticalSectionSpinCount,kernel32)
API(TryEnterCriticalSection,kernel32)
API(SetEvent,kernel32)
API(ResetEvent,kernel32)
API(PulseEvent,kernel32)
API(ReleaseSemaphore,kernel32)
API(ReleaseMutex,kernel32)
API(WaitForSingleObject,kernel32)
API(WaitForMultipleObjects,kernel32)
API(Sleep,kernel32)
APIA(OutputDebugString,kernel32)
API(GetVersion,kernel32)
API(OpenFile,kernel32)
APIA(GetTempFileName,kernel32)
API(SetHandleCount,kernel32)
API(GetLogicalDrives,kernel32)
API(LockFile,kernel32)
API(UnlockFile,kernel32)
API(LockFileEx,kernel32)
API(UnlockFileEx,kernel32)
API(GetFileInformationByHandle,kernel32)
API(GetFileType,kernel32)
API(GetFileSize,kernel32)
API(GetStdHandle,kernel32)
API(SetStdHandle,kernel32)
API(WriteFile,kernel32)
API(ReadFile,kernel32)
API(FlushFileBuffers,kernel32)
API(DeviceIoControl,kernel32)
API(SetEndOfFile,kernel32)
API(SetFilePointer,kernel32)
API(FindClose,kernel32)
API(GetFileTime,kernel32)
API(SetFileTime,kernel32)
API(CloseHandle,kernel32)
API(DuplicateHandle,kernel32)
APIA(GetDriveType,kernel32)

API(GetLastError,kernel32)
API(SetLastError,kernel32)
API(SetLastErrorEx,user32)
API(GetOverlappedResult,kernel32)
API(SetDebugErrorLevel,user32)
API(SetErrorMode,kernel32)
API(ReadProcessMemory,kernel32)
API(WriteProcessMemory,kernel32)
API(GetThreadContext,kernel32)
API(SetThreadContext,kernel32)
API(SuspendThread,kernel32)
API(ResumeThread,kernel32)
APIA(FindResource,kernel32)
APIA(FindResourceEx,kernel32)
APIA(BeginUpdateResource,kernel32)
APIA(UpdateResource,kernel32)
APIA(EndUpdateResource,kernel32)
API(LoadResource,kernel32)
API(LockResource,kernel32)
API(SizeofResource,kernel32)

APIA(ClearEventLog,advapi32)
APIA(BackupEventLog,advapi32)
API(CloseEventLog,advapi32)
API(DeregisterEventSource,advapi32)
API(GetNumberOfEventLogRecords,advapi32)
API(GetOldestEventLogRecord,advapi32)
APIA(OpenEventLog,advapi32)
APIA(RegisterEventSource,advapi32)
APIA(OpenBackupEventLog,advapi32)
APIA(ReadEventLog,advapi32)
APIA(ReportEvent,advapi32)
API(DuplicateToken,advapi32)
API(GetKernelObjectSecurity,advapi32)
API(ImpersonateNamedPipeClient,advapi32)
API(ImpersonateSelf,advapi32)
API(RevertToSelf,advapi32)
API(OpenProcessToken,advapi32)
API(OpenThreadToken,advapi32)
API(GetTokenInformation,advapi32)
API(SetTokenInformation,advapi32)
API(AdjustTokenPrivileges,advapi32)
API(AdjustTokenGroups,advapi32)
API(PrivilegeCheck,advapi32)
APIA(ObjectOpenAuditAlarm,kernel32)
APIA(ObjectPrivilegeAuditAlarm,advapi32)
APIA(ObjectOpenAuditAlarm,advapi32)
APIA(ObjectCloseAuditAlarm,advapi32)
APIA(ObjectDeleteAuditAlarm,advapi32)
APIA(PrivilegedServiceAuditAlarm,advapi32)
API(IsValidSid,advapi32)
API(EqualSid,advapi32)
API(EqualPrefixSid,advapi32)
API(GetSidLengthRequired,advapi32)
API(AllocateAndInitializeSid,advapi32)
API(FreeSid,advapi32)
API(InitializeSid,advapi32)
API(GetSidIdentifierAuthority,advapi32)
API(GetSidSubAuthority,advapi32)
API(GetSidSubAuthorityCount,advapi32)
API(GetLengthSid,advapi32)
API(CopySid,advapi32)
API(AreAllAccessesGranted,advapi32)
API(AreAnyAccessesGranted,advapi32)
API(MapGenericMask,advapi32)
API(IsValidAcl,advapi32)
API(InitializeAcl,advapi32)
API(GetAclInformation,advapi32)
API(SetAclInformation,advapi32)
API(AddAce,advapi32)
API(DeleteAce,advapi32)
API(GetAce,advapi32)
API(AddAccessAllowedAce,advapi32)
API(AddAccessDeniedAce,advapi32)
API(AddAuditAccessAce,advapi32)
API(FindFirstFreeAce,advapi32)
API(InitializeSecurityDescriptor,advapi32)
API(IsValidSecurityDescriptor,advapi32)
API(GetSecurityDescriptorLength,advapi32)
API(SetSecurityDescriptorControl,advapi32)
API(GetSecurityDescriptorControl,advapi32)
API(SetSecurityDescriptorDacl,advapi32)
API(GetSecurityDescriptorDacl,advapi32)
API(SetSecurityDescriptorSacl,advapi32)
API(GetSecurityDescriptorSacl,advapi32)
API(SetSecurityDescriptorOwner,advapi32)
API(GetSecurityDescriptorOwner,advapi32)
API(SetSecurityDescriptorGroup,advapi32)
API(GetSecurityDescriptorGroup,advapi32)
API(CreatePrivateObjectSecurity,advapi32)
API(SetPrivateObjectSecurity,advapi32)
API(SetPrivateObjectSecurityEx,advapi32)
API(GetPrivateObjectSecurity,advapi32)
API(DestroyPrivateObjectSecurity,advapi32)
API(MakeSelfRelativeSD,advapi32)
API(MakeAbsoluteSD,advapi32)
APIA(SetFileSecurity,advapi32)
APIA(GetFileSecurity,advapi32)
API(SetKernelObjectSecurity,advapi32)

APIA(FindFirstChangeNotification,kernel32)
API(FindNextChangeNotification,kernel32)
API(FindCloseChangeNotification,kernel32)
API(VirtualLock,kernel32)
API(VirtualUnlock,kernel32)
API(MapViewOfFileEx,kernel32)
API(SetPriorityClass,kernel32)
API(GetPriorityClass,kernel32)
API(FatalExit,kernel32)
APIA(GetEnvironmentStrings,kernel32)
API(RaiseException,kernel32)
API(UnhandledExceptionFilter,kernel32)

API(SetCommState,kernel32)
API(SetCommTimeouts,kernel32)
API(GetCommState,kernel32)
API(GetCommTimeouts,kernel32)
API(PurgeComm,kernel32)
APIA(BuildCommDCB,kernel32)
APIA(BuildCommDCBAndTimeouts,kernel32)
API(TransmitCommChar,kernel32)
API(SetCommBreak,kernel32)
API(SetCommMask,kernel32)
API(ClearCommBreak,kernel32)
API(ClearCommError,kernel32)
API(SetupComm,kernel32)
API(EscapeCommFunction,kernel32)
API(GetCommMask,kernel32)
API(GetCommProperties,kernel32)
API(GetCommModemStatus,kernel32)
API(WaitCommEvent,kernel32)
API(SetTapePosition,kernel32)
API(GetTapePosition,kernel32)
API(PrepareTape,kernel32)
API(EraseTape,kernel32)
API(CreateTapePartition,kernel32)
API(WriteTapemark,kernel32)
API(GetTapeStatus,kernel32)
API(GetTapeParameters,kernel32)
API(SetTapeParameters,kernel32)
API(Beep,kernel32)
API(MulDiv,kernel32)

APIA(FormatMessage,kernel32)
API(CreatePipe,kernel32)
API(ConnectNamedPipe,kernel32)
API(DisconnectNamedPipe,kernel32)
API(SetNamedPipeHandleState,kernel32)
API(GetNamedPipeInfo,kernel32)
API(PeekNamedPipe,kernel32)
API(TransactNamedPipe,kernel32)
APIA(CreateMailslot,kernel32)
API(GetMailslotInfo,kernel32)
API(SetMailslotInfo,kernel32)
API(MapViewOfFile,kernel32)
API(FlushViewOfFile,kernel32)
API(UnmapViewOfFile,kernel32)
//API(UnmapViewOfFileVlm,kernel32)

APIA(lstrcmp,kernel32)
APIA(lstrcmpi,kernel32)
APIA(lstrlen,kernel32)
//lopen;kernel32!_lopen
//lclose;kernel32!_lclose
//lcreat;kernel32!_lcreat
//llseek;kernel32!_llseek
//lread;kernel32!_lread
//lwrite;kernel32!_lwrite
//hread;kernel32!_hread
//hwrite;kernel32!_hwrite

API(TlsAlloc,kernel32)
API(TlsGetValue,kernel32)
API(TlsSetValue,kernel32)
API(TlsFree,kernel32)
API(SleepEx,kernel32)
API(WaitForSingleObjectEx,kernel32)
API(WaitForMultipleObjectsEx,kernel32)
API(BackupRead,kernel32)
API(BackupSeek,kernel32)
API(BackupWrite,kernel32)
APIA(CreateMutex,kernel32)
APIA(OpenMutex,kernel32)
APIA(CreateEvent,kernel32)
APIA(OpenEvent,kernel32)
APIA(CreateSemaphore,kernel32)
APIA(OpenSemaphore,kernel32)
APIA(CreateFileMapping,kernel32)
APIA(OpenFileMapping,kernel32)
APIA(GetLogicalDriveStrings,kernel32)
API(IsBadReadPtr,kernel32)
API(IsBadWritePtr,kernel32)
APIA(IsBadStringPtr,kernel32)
API(IsBadHugeReadPtr,kernel32)
API(IsBadHugeWritePtr,kernel32)
APIA(LookupAccountSid,advapi32)
APIA(LookupAccountName,advapi32)
APIA(LookupPrivilegeValue,advapi32)
APIA(LookupPrivilegeName,advapi32)
APIA(LookupPrivilegeDisplayName,advapi32)
API(AllocateLocallyUniqueId,advapi32)
APIA(GetComputerName,kernel32)
APIA(SetComputerName,kernel32)
APIA(GetUserName,advapi32)
API(QueryPerformanceCounter,kernel32)
API(QueryPerformanceFrequency,kernel32)
API(IsValidCodePage,kernel32)
API(GetACP,kernel32)
API(GetOEMCP,kernel32)
API(GetCPInfo,kernel32)
API(IsDBCSLeadByte,kernel32)
API(MultiByteToWideChar,kernel32)
API(WideCharToMultiByte,kernel32)
APIA(CompareString,kernel32)
APIA(LCMapString,kernel32)
APIA(GetLocaleInfo,kernel32)
APIA(GetTimeFormat,kernel32)
APIA(GetDateFormat,kernel32)
API(SetThreadLocale,kernel32)
API(GetSystemDefaultLangID,kernel32)
API(GetUserDefaultLangID,kernel32)
API(GetSystemDefaultLCID,kernel32)
API(GetUserDefaultLCID,kernel32)
API(GetStringTypeA,kernel32)
APIA(FoldString,kernel32)
API(EnumTimeFormats,KERNEL32)
API(EnumDateFormats,KERNEL32)
API(IsValidLocale,KERNEL32)
API(ConvertDefaultLocale,KERNEL32)
API(GetThreadLocale,KERNEL32)
API(EnumSystemLocales,KERNEL32)
API(EnumSystemCodePages,KERNEL32)
APIA(ReadConsoleOutput,kernel32)
APIA(WriteConsoleOutput,kernel32)
APIA(ReadConsoleOutputCharacter,kernel32)
API(ReadConsoleOutputAttribute,kernel32)
APIA(WriteConsoleOutputCharacter,kernel32)
API(WriteConsoleOutputAttribute,kernel32)
APIA(FillConsoleOutputCharacter,kernel32)
API(FillConsoleOutputAttribute,kernel32)
API(GetConsoleMode,kernel32)
API(GetNumberOfConsoleInputEvents,kernel32)
API(GetConsoleScreenBufferInfo,kernel32)
API(GetLargestConsoleWindowSize,kernel32)
API(GetConsoleCursorInfo,kernel32)
API(GetNumberOfConsoleMouseButtons,kernel32)
API(SetConsoleMode,kernel32)
API(SetConsoleActiveScreenBuffer,kernel32)
API(FlushConsoleInputBuffer,kernel32)
API(SetConsoleScreenBufferSize,kernel32)
API(SetConsoleCursorPosition,kernel32)
API(SetConsoleCursorInfo,kernel32)
APIA(ScrollConsoleScreenBuffer,kernel32)
API(SetConsoleWindowInfo,kernel32)
API(SetConsoleTextAttribute,kernel32)
API(SetConsoleCtrlHandler,kernel32)
API(GenerateConsoleCtrlEvent,kernel32)
API(AllocConsole,kernel32)
API(FreeConsole,kernel32)
APIA(GetConsoleTitle,kernel32)
APIA(SetConsoleTitle,kernel32)
APIA(ReadConsole,kernel32)
APIA(WriteConsole,kernel32)
API(CreateConsoleScreenBuffer,kernel32)
API(GetConsoleCP,kernel32)
API(SetConsoleCP,kernel32)
API(GetConsoleOutputCP,kernel32)
API(SetConsoleOutputCP,kernel32)

API(SetFocus,user32)
API(GetFocus,user32)
API(GetActiveWindow,user32)
API(GetKBCodePage,user32)
API(GetKeyState,user32)
API(GetAsyncKeyState,user32)
API(GetKeyboardState,user32)
API(SetKeyboardState,user32)
API(GetKeyboardType,user32)
APIA(GetKeyNameText,user32)
API(ToAscii,user32)
API(ToUnicode,user32)
API(OemKeyScan,user32)
APIA(VkKeyScan,user32)
API(keybd_event,user32)
API(mouse_event,user32)
APIA(MapVirtualKey,user32)
API(GetInputState,user32)
API(GetQueueStatus,user32)
API(GetCapture,user32)
API(SetCapture,user32)
API(ReleaseCapture,user32)
API(MsgWaitForMultipleObjects,user32)
API(MsgWaitForMultipleObjectsEx,user32)
API(KillTimer,user32)
API(IsWindowUnicode,user32)
API(EnableWindow,user32)
API(IsWindowEnabled,user32)
APIA(LoadAccelerators,user32)
APIA(CreateAcceleratorTable,user32)
API(DestroyAcceleratorTable,user32)
APIA(CopyAcceleratorTable,user32)
APIA(TranslateAccelerator,user32)
API(GetSystemMetrics,user32)
APIA(LoadMenu,user32)
APIA(LoadMenuIndirect,user32)
API(GetMenu,user32)
API(SetMenu,user32)
API(HiliteMenuItem,user32)
APIA(GetMenuString,user32)
API(GetMenuState,user32)
API(DrawMenuBar,user32)
API(GetSystemMenu,user32)
API(CreateMenu,user32)
API(CreatePopupMenu,user32)
API(DestroyMenu,user32)
API(CheckMenuItem,user32)
API(EnableMenuItem,user32)
API(GetSubMenu,user32)
API(GetMenuItemID,user32)
API(GetMenuItemCount,user32)
APIA(InsertMenu,user32)
APIA(AppendMenu,user32)
APIA(ModifyMenu,user32)
API(RemoveMenu,user32)
API(DeleteMenu,user32)
API(SetMenuItemBitmaps,user32)
API(GetMenuCheckMarkDimensions,user32)
API(TrackPopupMenu,user32)
API(DrawIcon,user32)
APIA(DrawText,user32)
APIA(TabbedTextOut,user32)
APIA(GetTabbedTextExtent,user32)
API(UpdateWindow,user32)
API(SetActiveWindow,user32)
API(GetForegroundWindow,user32)
API(SetForegroundWindow,user32)
API(WindowFromDC,user32)
API(GetDC,user32)
API(GetDCEx,user32)
API(GetWindowDC,user32)
API(ReleaseDC,user32)
API(BeginPaint,user32)
API(EndPaint,user32)
API(GetUpdateRect,user32)
API(GetUpdateRgn,user32)
API(ExcludeUpdateRgn,user32)
API(InvalidateRect,user32)
API(ValidateRect,user32)
API(InvalidateRgn,user32)
API(ValidateRgn,user32)
API(RedrawWindow,user32)
API(LockWindowUpdate,user32)
API(ScrollWindow,user32)
API(ScrollDC,user32)
API(ScrollWindowEx,user32)
API(SetScrollPos,user32)
API(GetScrollPos,user32)
API(SetScrollRange,user32)
API(GetScrollRange,user32)
API(ShowScrollBar,user32)
API(EnableScrollBar,user32)
APIA(SetProp,user32)
APIA(GetProp,user32)
APIA(RemoveProp,user32)
APIA(SetWindowText,user32)
APIA(GetWindowText,user32)
APIA(GetWindowTextLength,user32)
API(GetClientRect,user32)
API(GetWindowRect,user32)
API(AdjustWindowRect,user32)
API(AdjustWindowRectEx,user32)
APIA(MessageBox,user32)
APIA(MessageBoxEx,user32)
API(MessageBeep,user32)
API(ShowCursor,user32)
API(SetCursorPos,user32)
API(SetCursor,user32)
API(GetCursorPos,user32)
API(ClipCursor,user32)
API(GetCursor,user32)
API(GetClipCursor,user32)
API(CreateCaret,user32)
API(GetCaretBlinkTime,user32)
API(SetCaretBlinkTime,user32)
API(DestroyCaret,user32)
API(HideCaret,user32)
API(ShowCaret,user32)
API(SetCaretPos,user32)
API(GetCaretPos,user32)
API(ClientToScreen,user32)
API(ScreenToClient,user32)
API(MapWindowPoints,user32)
API(WindowFromPoint,user32)
API(ChildWindowFromPoint,user32)
API(GetSysColor,user32)
API(SetSysColors,user32)
API(DrawFocusRect,user32)
API(FillRect,user32)
API(FrameRect,user32)
API(InvertRect,user32)
API(SetRect,user32)
API(SetRectEmpty,user32)
API(CopyRect,user32)
API(InflateRect,user32)
API(IntersectRect,user32)
API(UnionRect,user32)
API(SubtractRect,user32)
API(OffsetRect,user32)
API(IsRectEmpty,user32)
API(EqualRect,user32)
API(PtInRect,user32)
API(GetWindowWord,user32)
API(SetWindowWord,user32)
APIA(GetWindowLong,user32)
APIA(SetWindowLong,user32)
API(GetClassWord,user32)
API(SetClassWord,user32)
APIA(GetClassLong,user32)
APIA(SetClassLong,user32)
API(GetDesktopWindow,user32)
API(GetParent,user32)
API(SetParent,user32)
APIA(FindWindow,user32)
APIA(GetClassName,user32)
API(GetTopWindow,user32)
API(GetNextWindow,user32)
API(GetWindowThreadProcessId,user32)
API(GetLastActivePopup,user32)
API(GetWindow,user32)
API(UnhookWindowsHookEx,user32)
API(CallNextHookEx,user32)

APIA(LoadString,user32)
APIA(IsDialogMessage,user32)
API(MapDialogRect,user32)
APIA(DlgDirList,user32)
APIA(DlgDirSelectEx,user32)
APIA(DlgDirListComboBox,user32)
APIA(DlgDirSelectComboBoxEx,user32)
APIA(DefFrameProc,user32)
APIA(DefMDIChildProc,user32)
API(TranslateMDISysAccel,user32)
API(ArrangeIconicWindows,user32)
APIA(CreateMDIWindow,user32)
APIA(WinHelp,user32)
APIA(SystemParametersInfo,user32)
API(DdeSetQualityOfService,user32)
API(ImpersonateDdeClientWindow,user32)
API(PackDDElParam,user32)
API(UnpackDDElParam,user32)
API(FreeDDElParam,user32)
API(ReuseDDElParam,user32)
API(DdeUninitialize,user32)
API(DdeConnectList,user32)
API(DdeQueryNextServer,user32)
API(DdeDisconnectList,user32)
API(DdeConnect,user32)
API(DdeDisconnect,user32)
API(DdeReconnect,user32)
API(DdeQueryConvInfo,user32)
API(DdeSetUserHandle,user32)
API(DdeAbandonTransaction,user32)
API(DdePostAdvise,user32)
API(DdeEnableCallback,user32)
API(DdeImpersonateClient,user32)
API(DdeNameService,user32)
API(DdeClientTransaction,user32)
API(DdeCreateDataHandle,user32)
APIA(DdeAddData,user32)
APIA(DdeGetData,user32)
APIA(DdeAccessData,user32)
APIA(DdeUnaccessData,user32)
API(DdeFreeDataHandle,user32)
API(DdeGetLastError,user32)
APIA(DdeCreateStringHandle,user32)
APIA(DdeQueryString,user32)
API(DdeFreeStringHandle,user32)
API(DdeKeepStringHandle,user32)
API(DdeCmpStringHandles,user32)

API(mixerGetNumDevs,winmm)
APIA(mixerGetDevCaps,winmm)
API(mixerOpen,winmm)
API(mixerClose,winmm)
API(mixerMessage,winmm)
APIA(mixerGetLineInfo,winmm)
API(mixerGetID,winmm)
APIA(mixerGetLineControls,winmm)
APIA(mixerGetControlDetails,winmm)
API(mixerSetControlDetails,winmm)

API(joyGetPos,winmm)
API(joyGetPosEx,winmm)

API(midiStreamOpen,winmm)
API(midiStreamClose,winmm)
API(midiStreamProperty,winmm)
API(midiStreamPosition,winmm)
API(midiStreamOut,winmm)
API(midiStreamPause,winmm)
API(midiStreamRestart,winmm)
API(midiStreamStop,winmm)
API(midiConnect,winmm)
API(midiDisconnect,winmm)
API(CloseDriver,winmm)
API(OpenDriver,winmm)
API(SendDriverMessage,winmm)
API(DrvGetModuleHandle,winmm)
API(GetDriverModuleHandle,winmm)
API(DefDriverProc,winmm)
API(mmsystemGetVersion,winmm)
API(OutputDebugStr,winmm)
APIA(sndPlaySound,winmm)
APIA(PlaySound,winmm)
API(waveOutGetNumDevs,winmm)
APIA(waveOutGetDevCaps,winmm)
API(waveOutGetVolume,winmm)
API(waveOutSetVolume,winmm)
APIA(waveOutGetErrorText,winmm)
API(waveOutOpen,winmm)
API(waveOutClose,winmm)
API(waveOutPrepareHeader,winmm)
API(waveOutUnprepareHeader,winmm)
API(waveOutWrite,winmm)
API(waveOutPause,winmm)
API(waveOutRestart,winmm)
API(waveOutReset,winmm)
API(waveOutBreakLoop,winmm)
API(waveOutGetPosition,winmm)
API(waveOutGetPitch,winmm)
API(waveOutSetPitch,winmm)
API(waveOutGetPlaybackRate,winmm)
API(waveOutSetPlaybackRate,winmm)
API(waveOutGetID,winmm)
API(waveOutMessage,winmm)
API(waveInGetNumDevs,winmm)
APIA(waveInGetDevCaps,winmm)
APIA(waveInGetErrorText,winmm)
API(waveInOpen,winmm)
API(waveInClose,winmm)
API(waveInPrepareHeader,winmm)
API(waveInUnprepareHeader,winmm)
API(waveInAddBuffer,winmm)
API(waveInStart,winmm)
API(waveInStop,winmm)
API(waveInReset,winmm)
API(waveInGetPosition,winmm)
API(waveInGetID,winmm)
API(waveInMessage,winmm)

APIA(midiOutGetDevCaps,winmm)
API(midiOutGetVolume,winmm)
API(midiOutSetVolume,winmm)
APIA(midiOutGetErrorText,winmm)
API(midiOutOpen,winmm)
API(midiOutClose,winmm)
API(midiOutPrepareHeader,winmm)
API(midiOutUnprepareHeader,winmm)
API(midiOutShortMsg,winmm)
API(midiOutLongMsg,winmm)
API(midiOutReset,winmm)
API(midiOutCachePatches,winmm)
API(midiOutCacheDrumPatches,winmm)
API(midiOutGetID,winmm)
API(midiOutMessage,winmm)
API(midiInGetNumDevs,winmm)
APIA(midiInGetDevCaps,winmm)
APIA(midiInGetErrorText,winmm)
API(midiInOpen,winmm)
API(midiInClose,winmm)
API(midiInPrepareHeader,winmm)
API(midiInUnprepareHeader,winmm)
API(midiInAddBuffer,winmm)
API(midiInStart,winmm)
API(midiInStop,winmm)
API(midiInReset,winmm)
API(midiInGetID,winmm)
API(midiInMessage,winmm)

API(auxGetNumDevs,winmm)
APIA(auxGetDevCaps,winmm)
API(auxSetVolume,winmm)
API(auxGetVolume,winmm)
API(auxOutMessage,winmm)

API(timeGetSystemTime,winmm)
API(timeGetTime,winmm)
API(timeSetEvent,winmm)
API(timeKillEvent,winmm)
API(timeGetDevCaps,winmm)
API(timeBeginPeriod,winmm)
API(timeEndPeriod,winmm)

APIA(joyGetDevCaps,winmm)
API(joyGetNumDevs,winmm)
API(joyGetThreshold,winmm)
API(joyReleaseCapture,winmm)
API(joySetCapture,winmm)
API(joySetThreshold,winmm)

APIA(mmioStringToFOURCC,winmm)
APIA(mmioOpen,winmm)
APIA(mmioRename,winmm)
API(mmioClose,winmm)
API(mmioRead,winmm)
API(mmioWrite,winmm)
API(mmioSeek,winmm)
API(mmioGetInfo,winmm)
API(mmioSetInfo,winmm)
API(mmioSetBuffer,winmm)
API(mmioFlush,winmm)
API(mmioAdvance,winmm)
API(mmioSendMessage,winmm)
API(mmioDescend,winmm)
API(mmioAscend,winmm)
API(mmioCreateChunk,winmm)

APIA(mciSendCommand,winmm)
APIA(mciSendString,winmm)
API(mciGetCreatorTask,winmm)
APIA(mciGetDeviceID,winmm)
APIA(mciGetDeviceIDFromElementID,winmm)
APIA(mciGetErrorString,winmm)
API(mciExecute,winmm)

APIA(WNetAddConnection,mpr)
APIA(WNetAddConnection2,mpr)
APIA(WNetCancelConnection,mpr)
APIA(WNetCancelConnection2,mpr)
APIA(WNetGetConnection,mpr)
APIA(WNetOpenEnum,mpr)
APIA(WNetEnumResource,mpr)
API(WNetCloseEnum,mpr)
APIA(WNetGetUser,mpr)
API(WNetConnectionDialog,mpr)
API(WNetDisconnectDialog,mpr)
APIA(WNetGetLastError,mpr)
APIA(WNetAddConnection2,mpr)
APIA(WNetOpenEnum,mpr)
APIA(WNetEnumResource,mpr)
API(WNetCloseEnum,mpr)

API(Netbios,netapi32)
API(NetUserChangePassword,Netapi32.dll)
API(NetUserGetInfo,Netapi32.dll)
API(NetUserGetGroups,Netapi32.dll)
API(NetUserGetLocalGroups,Netapi32.dll)
API(NetUserAdd,netapi32)
API(NetWkstaGetInfo,Netapi32.dll)
API(NetWkstaUserGetInfo,Netapi32.dll)
API(NetApiBufferFree,Netapi32.dll)
API(NetRemoteTOD,Netapi32.dll)
APIA(GetUserName,advapi32)
API(GetUserNameW,advapi32.dll)

APIA(GetComputerName,kernel32)

API(RegCloseKey,advapi32)
APIA(RegConnectRegistry,advapi32)
APIA(RegCreateKey,advapi32)
APIA(RegCreateKeyEx,advapi32)
APIA(RegDeleteKey,advapi32)
APIA(RegDeleteValue,advapi32)
APIA(RegEnumKey,advapi32)
APIA(RegEnumKeyEx,advapi32)
APIA(RegEnumValue,advapi32)
API(RegFlushKey,advapi32)
API(RegGetKeySecurity,advapi32)
APIA(RegLoadKey,advapi32)
API(RegNotifyChangeKeyValue,advapi32)
APIA(RegOpenKey,advapi32)
APIA(RegOpenKeyEx,advapi32)
APIA(RegQueryInfoKey,advapi32)
APIA(RegQueryValue,advapi32)
APIA(RegQueryValueEx,advapi32)
APIA(RegReplaceKey,advapi32)
APIA(RegRestoreKey,advapi32)
APIA(RegSaveKey,advapi32)
API(RegSetKeySecurity,advapi32)
APIA(RegSetValue,advapi32)
APIA(RegSetValueEx,advapi32)
APIA(RegUnLoadKey,advapi32)
APIA(InitiateSystemShutdown,advapi32)
APIA(AbortSystemShutdown,advapi32)
APIA(ChangeServiceConfig,advapi32)
API(CloseServiceHandle,advapi32)
API(ControlService,advapi32)
APIA(CreateService,advapi32)
API(DeleteService,advapi32)
APIA(EnumDependentServices,advapi32)
APIA(EnumServicesStatus,advapi32)
APIA(GetServiceKeyName,advapi32)
APIA(GetServiceDisplayName,advapi32)
API(LockServiceDatabase,advapi32)
API(NotifyBootConfigStatus,advapi32)
APIA(OpenSCManager,advapi32)
APIA(OpenService,advapi32)
APIA(QueryServiceConfig,advapi32)
APIA(QueryServiceLockStatus,advapi32)
API(QueryServiceObjectSecurity,advapi32)
API(QueryServiceStatus,advapi32)
APIA(RegisterServiceCtrlHandler,advapi32)
API(SetServiceObjectSecurity,advapi32)
API(SetServiceStatus,advapi32)
APIA(StartServiceCtrlDispatcher,advapi32)
APIA(StartService,advapi32)
API(UnlockServiceDatabase,advapi32)

API(LZCopy,lz32)
API(LZInit,lz32)
APIA(GetExpandedName,lz32)
APIA(LZOpenFile,lz32)
API(LZSeek,lz32)
API(LZRead,lz32)
API(LZClose,lz32)

APIA(ImmInstallIME,imm32)
API(ImmGetDefaultIMEWnd,imm32)
APIA(ImmGetDescription,imm32)
APIA(ImmGetIMEFileName,imm32)
API(ImmGetProperty,imm32)
API(ImmIsIME,imm32)
API(ImmSimulateHotKey,imm32)
API(ImmCreateContext,imm32)
API(ImmDestroyContext,imm32)
API(ImmGetContext,imm32)
API(ImmReleaseContext,imm32)
API(ImmAssociateContext,imm32)
APIA(ImmGetCompositionString,imm32)
APIA(ImmSetCompositionString,imm32)
APIA(ImmGetCandidateListCount,imm32)
APIA(ImmGetCandidateList,imm32)
APIA(ImmGetGuideLine,imm32)
API(ImmGetConversionStatus,imm32)
API(ImmSetConversionStatus,imm32)
API(ImmGetOpenStatus,imm32)
API(ImmSetOpenStatus,imm32)
APIA(ImmGetCompositionFont,imm32)
APIA(ImmSetCompositionFont,imm32)
API(ImmConfigureIME,imm32)
APIA(ImmEscape,imm32)
APIA(ImmGetConversionList,imm32)
API(ImmNotifyIME,imm32)
API(ImmGetStatusWindowPos,imm32)
API(ImmSetStatusWindowPos,imm32)
API(ImmGetCompositionWindow,imm32)
API(ImmSetCompositionWindow,imm32)
API(ImmGetCandidateWindow,imm32)
API(ImmSetCandidateWindow,imm32)
APIA(ImmIsUIMessage,imm32)
API(ImmGetVirtualKey,imm32)
APIA(ImmRegisterWord,imm32)
APIA(ImmUnregisterWord,imm32)
APIA(ImmGetRegisterWordStyle,imm32)
APIA(ImmEnumRegisterWord,imm32)

APIA(DragQueryFile,shell32)
API(DragQueryPoint,shell32)
API(DragFinish,shell32)
API(DragAcceptFiles,shell32)
APIA(ShellExecute,shell32)
APIA(FindExecutable,shell32)
APIA(ShellAbout,shell32)
API(DuplicateIcon,shell32)
APIA(ExtractAssociatedIcon,shell32)
APIA(ExtractIcon,shell32)
API(SHAppBarMessage,shell32)
APIA(DoEnvironmentSubst,shell32)
APIA(FindEnvironmentString,shell32)
APIA(ExtractIconEx,shell32)
APIA(SHFileOperation,shell32)
API(SHFreeNameMappings,shell32)
APIA(WinExecError,shell32)
APIA(Shell_NotifyIcon,shell32)
APIA(SHGetFileInfo,shell32)
APIA(SHGetNewLinkInfo,shell32)
APIA(VerFindFile,version)
APIA(VerInstallFile,version)
APIA(GetFileVersionInfoSize,version)
APIA(GetFileVersionInfo,version)
APIA(VerLanguageName,kernel32)
API(VerQueryValue,version)

APIA(GetBinaryType,kernel32)
APIA(GetShortPathName,kernel32)
//APIA(LogonUser,kernel32)
//API(ImpersonateLoggedOnUser,kernel32)
APIA(CreateProcessAsUser,advapi32)
APIA(GetVersionEx,kernel32)
API(GetSystemPowerStatus,kernel32)
API(SetSystemPowerState,kernel32)
APIA(GetFileTitle,comdlg32)
APIA(FindText,comdlg32)
APIA(ReplaceText,comdlg32)
APIA(ChooseFont,comdlg32)
APIA(PrintDlg,comdlg32)
API(CommDlgExtendedError,comdlg32)
APIA(PageSetupDlg,comdlg32)

APIA(DdeInitialize,user32)

API(SetServiceBits,advapi32)

API(CopyLZFile,lz32)
API(LZStart,lz32)
API(LZDone,lz32)

API(mciGetYieldProc,winmm)
API(mciSetYieldProc,winmm)
API(midiOutGetNumDevs,winmm)
API(mmioInstallIOProcA,winmm)

API(IsTextUnicode,advapi32)
API(NotifyChangeEventLog,advapi32)
API(SetThreadToken,advapi32)

APIA(CommConfigDialog,kernel32)
API(CreateIoCompletionPort,kernel32)
API(DisableThreadLibraryCalls,kernel32)
APIA(EnumResourceLanguages,kernel32)
APIA(EnumResourceNames,kernel32)
APIA(EnumResourceTypes,kernel32)
APIA(FreeEnvironmentStrings,kernel32)
API(FreeLibraryAndExitThread,kernel32)
API(FreeResource,kernel32)
API(GetCommConfig,kernel32)
APIA(GetCompressedFileSize,kernel32)
APIA(GetDefaultCommConfig,kernel32)
API(GetHandleInformation,kernel32)
API(GetProcessWorkingSetSize,kernel32)
API(GetQueuedCompletionStatus,kernel32)
API(PostQueuedCompletionStatus,kernel32)
API(GetSystemTimeAdjustment,kernel32)
API(GlobalCompact,kernel32)
API(GlobalFix,kernel32)
API(GlobalUnfix,kernel32)
API(GlobalWire,kernel32)
API(GlobalUnWire,kernel32)
API(IsBadCodePtr,kernel32)
API(LocalCompact,kernel32)
API(LocalShrink,kernel32)
API(ReadFileEx,kernel32)
API(SetCommConfig,kernel32)
APIA(SetDefaultCommConfig,kernel32)
API(SetFileApisToANSI,kernel32)
API(SetHandleInformation,kernel32)
API(SetProcessWorkingSetSize,kernel32)
APIA(lstrcat,kernel32)
APIA(lstrcpyn,kernel32)
APIA(lstrcpy,kernel32)
API(SetSystemTimeAdjustment,kernel32)
API(SetThreadAffinityMask,kernel32)
API(SetUnhandledExceptionFilter,kernel32)
API(SystemTimeToTzSpecificLocalTime,kernel32)
API(WriteFileEx,kernel32)
API(ChoosePixelFormat,gdi32)
API(CreateDIBSection,gdi32)
API(DescribePixelFormat,gdi32)
API(EndDoc,gdi32)
APIA(EnumFonts,gdi32)
API(EnumMetaFile,gdi32)
API(EnumObjects,gdi32)
API(FixBrushOrgEx,gdi32)
API(GetBrushOrgEx,gdi32)
API(GetDIBColorTable,gdi32)
API(GetPixelFormat,gdi32)
//API(LineDDA,gdi32)
API(SetAbortProc,gdi32)
API(SetDIBColorTable,gdi32)
API(SetPixelFormat,gdi32)
API(SwapBuffers,gdi32)
APIA(EnumCalendarInfo,kernel32)
APIA(GetCurrencyFormat,kernel32)
APIA(GetNumberFormat,kernel32)
APIA(GetStringTypeEx,kernel32)
API(GetStringTypeW,kernel32)
APIA(SetLocaleInfo,kernel32)

API(BroadcastSystemMessage,user32)
APIA(CallWindowProc,user32)
API(CascadeWindows,user32)
APIA(ChangeMenu,user32)
API(CheckMenuRadioItem,user32)
API(ChildWindowFromPoint,user32)
API(ChildWindowFromPointEx,user32)
API(CopyImage,user32)
APIA(CreateDialogIndirectParam,user32)
APIA(CreateDialogParam,user32)
API(CreateIconFromResource,user32)
APIA(DialogBoxIndirectParam,user32)
API(DragDetect,user32)
API(DragObject,user32)

API(EnumChildWindows,user32)
APIA(EnumPropsEx,user32)
APIA(EnumProps,user32)
API(EnumThreadWindows,user32)
APIA(EnumWindowStations,user32)
APIA(FindWindowEx,user32)
API(GetKeyboardLayoutList,user32)
API(GetKeyboardLayout,user32)
API(GetMenuContextHelpId,user32)
API(GetMenuDefaultItem,user32)
APIA(GetMenuItemInfo,user32)
API(GetMenuItemRect,user32)
API(GetScrollInfo,user32)
API(GetSysColorBrush,user32)
API(GetWindowContextHelpId,user32)
API(GetWindowRgn,user32)
APIA(GrayString,user32)
APIA(InsertMenuItem,user32)
APIA(LoadCursorFromFile,user32)
APIA(LoadImage,user32)
API(LookupIconIdFromDirectoryEx,user32)
APIA(MapVirtualKeyEx,user32)
API(MenuItemFromPoint,user32)
APIA(MessageBoxIndirect,user32)
API(PaintDesktop,user32)
APIA(RegisterClassEx,user32)
API(SetMenuContextHelpId,user32)
API(SetMenuDefaultItem,user32)
APIA(SetMenuItemInfo,user32)
API(SetMessageExtraInfo,user32)
API(SetMessageQueue,user32)
API(SetScrollInfo,user32)
API(SetSystemCursor,user32)
API(SetTimer,user32)
API(SetWindowContextHelpId,user32)
API(SetWindowRgn,user32)
APIA(SetWindowsHook,user32)
APIA(SetWindowsHookEx,user32)
API(ShowWindowAsync,user32)
API(TileWindows,user32)
API(ToAsciiEx,user32)
API(TrackPopupMenuEx,user32)
API(UnhookWindowsHook,user32)
APIA(VkKeyScanEx,user32)
APIA(WNetGetUniversalName,mpr)

API(BSTR_UserFree,oleaut32)
API(BSTR_UserMarshal,oleaut32)
API(BSTR_UserSize,oleaut32)
API(BSTR_UserUnmarshal,oleaut32)
API(BstrFromVector,oleaut32)
API(ClearCustData,oleaut32)
API(CreateDispTypeInfo,oleaut32)
API(CreateErrorInfo,oleaut32)
API(CreateStdDispatch,oleaut32)
API(CreateTypeLib,oleaut32)
API(CreateTypeLib2,oleaut32)
API(DispCallFunc,oleaut32)
API(DispGetIDsOfNames,oleaut32)
API(DispGetParam,oleaut32)
API(DispInvoke,oleaut32)
API(DllCanUnloadNow,oleaut32)
API(DllGetClassObject,oleaut32)
API(DllRegisterServer,oleaut32)
API(DllUnregisterServer,oleaut32)
API(DosDateTimeToVariantTime,oleaut32)
API(GetActiveObject,oleaut32)
API(GetAltMonthNames,oleaut32)
API(GetErrorInfo,oleaut32)
API(GetRecordInfoFromGuids,oleaut32)
API(GetRecordInfoFromTypeInfo,oleaut32)
API(GetVarConversionLocaleSetting,oleaut32)
API(LHashValOfNameSys,oleaut32)
API(LHashValOfNameSysA,oleaut32)
API(LoadRegTypeLib,oleaut32)
API(LoadTypeLib,oleaut32)
API(LoadTypeLibEx,oleaut32)
API(LPSAFEARRAY_Marshal,oleaut32)
API(LPSAFEARRAY_Size,oleaut32)
API(LPSAFEARRAY_Unmarshal,oleaut32)
API(LPSAFEARRAY_UserFree,oleaut32)
API(LPSAFEARRAY_UserMarshal,oleaut32)
API(LPSAFEARRAY_UserSize,oleaut32)
API(LPSAFEARRAY_UserUnmarshal,oleaut32)
API(OaBuildVersion,oleaut32)
API(OACreateTypeLib2,oleaut32)
API(OleCreateFontIndirect,oleaut32)
API(OleCreatePictureIndirect,oleaut32)
API(OleCreatePropertyFrame,oleaut32)
API(OleCreatePropertyFrameIndirect,oleaut32)
API(OleIconToCursor,oleaut32)
API(OleLoadPicture,oleaut32)
API(OleLoadPictureEx,oleaut32)
API(OleLoadPictureFile,oleaut32)
API(OleLoadPictureFileEx,oleaut32)
API(OleLoadPicturePath,oleaut32)
API(OleSavePictureFile,oleaut32)
API(OleTranslateColor,oleaut32)

API(QueryPathOfRegTypeLib,oleaut32)
API(RegisterActiveObject,oleaut32)
API(RegisterTypeLib,oleaut32)
API(RevokeActiveObject,oleaut32)
API(SafeArrayAccessData,oleaut32)
API(SafeArrayAllocData,oleaut32)
API(SafeArrayAllocDescriptor,oleaut32)
API(SafeArrayAllocDescriptorEx,oleaut32)
API(SafeArrayCopy,oleaut32)
API(SafeArrayCopyData,oleaut32)
API(SafeArrayCreate,oleaut32)
API(SafeArrayCreateEx,oleaut32)
API(SafeArrayCreateVector,oleaut32)
API(SafeArrayCreateVectorEx,oleaut32)
API(SafeArrayDestroy,oleaut32)
API(SafeArrayDestroyData,oleaut32)
API(SafeArrayDestroyDescriptor,oleaut32)
API(SafeArrayGetDim,oleaut32)
API(SafeArrayGetElement,oleaut32)
API(SafeArrayGetElemsize,oleaut32)
API(SafeArrayGetIID,oleaut32)
API(SafeArrayGetLBound,oleaut32)
API(SafeArrayGetRecordInfo,oleaut32)
API(SafeArrayGetUBound,oleaut32)
API(SafeArrayGetVartype,oleaut32)
API(SafeArrayLock,oleaut32)
API(SafeArrayPtrOfIndex,oleaut32)
API(SafeArrayPutElement,oleaut32)
API(SafeArrayRedim,oleaut32)
API(SafeArraySetIID,oleaut32)
API(SafeArraySetRecordInfo,oleaut32)
API(SafeArrayUnaccessData,oleaut32)
API(SafeArrayUnlock,oleaut32)
API(SetErrorInfo,oleaut32)
API(SetVarConversionLocaleSetting,oleaut32)
API(SysAllocString,oleaut32)
API(SysAllocStringByteLen,oleaut32)
API(SysAllocStringLen,oleaut32)
API(SysFreeString,oleaut32)
API(SysReAllocString,oleaut32)
API(SysReAllocStringLen,oleaut32)
API(SysStringByteLen,oleaut32)
API(SysStringLen,oleaut32)
API(SystemTimeToVariantTime,oleaut32)
API(UnRegisterTypeLib,oleaut32)

//UserBSTR_free_inst;oleaut32!UserBSTR_free_inst
//UserBSTR_free_local;oleaut32!UserBSTR_free_local
//UserBSTR_from_local;oleaut32!UserBSTR_from_local
//UserBSTR_to_local;oleaut32!UserBSTR_to_local
//UserEXCEPINFO_free_inst;oleaut32!UserEXCEPINFO_free_inst
//UserEXCEPINFO_free_local;oleaut32!UserEXCEPINFO_free_local
//UserEXCEPINFO_from_local;oleaut32!UserEXCEPINFO_from_local
//UserEXCEPINFO_to_local;oleaut32!UserEXCEPINFO_to_local
//UserHWND_free_inst;oleaut32!UserHWND_free_inst
//UserHWND_free_local;oleaut32!UserHWND_free_local
//UserHWND_from_local;oleaut32!UserHWND_from_local
//UserHWND_to_local;oleaut32!UserHWND_to_local
//UserMSG_free_inst;oleaut32!UserMSG_free_inst
//UserMSG_free_local;oleaut32!UserMSG_free_local
//UserMSG_from_local;oleaut32!UserMSG_from_local
//UserMSG_to_local;oleaut32!UserMSG_to_local
//UserVARIANT_free_inst;oleaut32!UserVARIANT_free_inst
//UserVARIANT_free_local;oleaut32!UserVARIANT_free_local
//UserVARIANT_from_local;oleaut32!UserVARIANT_from_local
//UserVARIANT_to_local;oleaut32!UserVARIANT_to_local

API(VarAbs,oleaut32)
API(VarAdd,oleaut32)
API(VarAnd,oleaut32)
API(VarBoolFromCy,oleaut32)
API(VarBoolFromDate,oleaut32)
API(VarBoolFromDec,oleaut32)
API(VarBoolFromDisp,oleaut32)
API(VarBoolFromI1,oleaut32)
API(VarBoolFromI2,oleaut32)
API(VarBoolFromI4,oleaut32)
API(VarBoolFromR4,oleaut32)
API(VarBoolFromR8,oleaut32)
API(VarBoolFromStr,oleaut32)
API(VarBoolFromUI1,oleaut32)
API(VarBoolFromUI2,oleaut32)
API(VarBoolFromUI4,oleaut32)
API(VarBstrCat,oleaut32)
API(VarBstrCmp,oleaut32)
API(VarBstrFromBool,oleaut32)
API(VarBstrFromCy,oleaut32)
API(VarBstrFromDate,oleaut32)
API(VarBstrFromDec,oleaut32)
API(VarBstrFromDisp,oleaut32)
API(VarBstrFromI1,oleaut32)
API(VarBstrFromI2,oleaut32)
API(VarBstrFromI4,oleaut32)
API(VarBstrFromR4,oleaut32)
API(VarBstrFromR8,oleaut32)
API(VarBstrFromUI1,oleaut32)
API(VarBstrFromUI2,oleaut32)
API(VarBstrFromUI4,oleaut32)
API(VarCat,oleaut32)
API(VarCmp,oleaut32)
API(VarCyAbs,oleaut32)
API(VarCyAdd,oleaut32)
API(VarCyCmp,oleaut32)
API(VarCyCmpR8,oleaut32)
API(VarCyFix,oleaut32)
API(VarCyFromBool,oleaut32)
API(VarCyFromDate,oleaut32)
API(VarCyFromDec,oleaut32)
API(VarCyFromDisp,oleaut32)
API(VarCyFromI1,oleaut32)
API(VarCyFromI2,oleaut32)
API(VarCyFromI4,oleaut32)
API(VarCyFromR4,oleaut32)
API(VarCyFromR8,oleaut32)
API(VarCyFromStr,oleaut32)
API(VarCyFromUI1,oleaut32)
API(VarCyFromUI2,oleaut32)
API(VarCyFromUI4,oleaut32)
API(VarCyInt,oleaut32)
API(VarCyMul,oleaut32)
API(VarCyMulI4,oleaut32)
API(VarCyNeg,oleaut32)
API(VarCyRound,oleaut32)
API(VarCySub,oleaut32)
API(VarDateFromBool,oleaut32)
API(VarDateFromCy,oleaut32)
API(VarDateFromDec,oleaut32)
API(VarDateFromDisp,oleaut32)
API(VarDateFromI1,oleaut32)
API(VarDateFromI2,oleaut32)
API(VarDateFromI4,oleaut32)
API(VarDateFromR4,oleaut32)
API(VarDateFromR8,oleaut32)
API(VarDateFromStr,oleaut32)
API(VarDateFromUdate,oleaut32)
API(VarDateFromUdateEx,oleaut32)
API(VarDateFromUI1,oleaut32)
API(VarDateFromUI2,oleaut32)
API(VarDateFromUI4,oleaut32)
API(VarDecAbs,oleaut32)
API(VarDecAdd,oleaut32)
API(VarDecCmp,oleaut32)
API(VarDecCmpR8,oleaut32)
API(VarDecDiv,oleaut32)
API(VarDecFix,oleaut32)
API(VarDecFromBool,oleaut32)
API(VarDecFromCy,oleaut32)
API(VarDecFromDate,oleaut32)
API(VarDecFromDisp,oleaut32)
API(VarDecFromI1,oleaut32)
API(VarDecFromI2,oleaut32)
API(VarDecFromI4,oleaut32)
API(VarDecFromR4,oleaut32)
API(VarDecFromR8,oleaut32)
API(VarDecFromStr,oleaut32)
API(VarDecFromUI1,oleaut32)
API(VarDecFromUI2,oleaut32)
API(VarDecFromUI4,oleaut32)
API(VarDecInt,oleaut32)
API(VarDecMul,oleaut32)
API(VarDecNeg,oleaut32)
API(VarDecRound,oleaut32)
API(VarDecSub,oleaut32)
API(VarDiv,oleaut32)
API(VarEqv,oleaut32)
API(VarFix,oleaut32)
API(VarFormat,oleaut32)
API(VarFormatCurrency,oleaut32)
API(VarFormatDateTime,oleaut32)
API(VarFormatFromTokens,oleaut32)
API(VarFormatNumber,oleaut32)
API(VarFormatPercent,oleaut32)
API(VarI1FromBool,oleaut32)
API(VarI1FromCy,oleaut32)
API(VarI1FromDate,oleaut32)
API(VarI1FromDec,oleaut32)
API(VarI1FromDisp,oleaut32)
API(VarI1FromI2,oleaut32)
API(VarI1FromI4,oleaut32)
API(VarI1FromR4,oleaut32)
API(VarI1FromR8,oleaut32)
API(VarI1FromStr,oleaut32)
API(VarI1FromUI1,oleaut32)
API(VarI1FromUI2,oleaut32)
API(VarI1FromUI4,oleaut32)
API(VarI2FromBool,oleaut32)
API(VarI2FromCy,oleaut32)
API(VarI2FromDate,oleaut32)
API(VarI2FromDec,oleaut32)
API(VarI2FromDisp,oleaut32)
API(VarI2FromI1,oleaut32)
API(VarI2FromI4,oleaut32)
API(VarI2FromR4,oleaut32)
API(VarI2FromR8,oleaut32)
API(VarI2FromStr,oleaut32)
API(VarI2FromUI1,oleaut32)
API(VarI2FromUI2,oleaut32)
API(VarI2FromUI4,oleaut32)
API(VarI4FromBool,oleaut32)
API(VarI4FromCy,oleaut32)
API(VarI4FromDate,oleaut32)
API(VarI4FromDec,oleaut32)
API(VarI4FromDisp,oleaut32)
API(VarI4FromI1,oleaut32)
API(VarI4FromI2,oleaut32)
API(VarI4FromR4,oleaut32)
API(VarI4FromR8,oleaut32)
API(VarI4FromStr,oleaut32)
API(VarI4FromUI1,oleaut32)
API(VarI4FromUI2,oleaut32)
API(VarI4FromUI4,oleaut32)
API(VARIANT_UserFree,oleaut32)
API(VARIANT_UserMarshal,oleaut32)
API(VARIANT_UserSize,oleaut32)
API(VARIANT_UserUnmarshal,oleaut32)
API(VariantChangeType,oleaut32)
API(VariantChangeTypeEx,oleaut32)
API(VariantClear,oleaut32)
API(VariantCopy,oleaut32)
API(VariantCopyInd,oleaut32)
API(VariantInit,oleaut32)
API(VariantTimeToDosDateTime,oleaut32)
API(VariantTimeToSystemTime,oleaut32)
API(VarIdiv,oleaut32)
API(VarImp,oleaut32)
API(VarInt,oleaut32)
API(VarMod,oleaut32)
API(VarMonthName,oleaut32)
API(VarMul,oleaut32)
API(VarNeg,oleaut32)
API(VarNot,oleaut32)
API(VarNumFromParseNum,oleaut32)
API(VarOr,oleaut32)
API(VarParseNumFromStr,oleaut32)
API(VarPow,oleaut32)
API(VarR4CmpR8,oleaut32)
API(VarR4FromBool,oleaut32)
API(VarR4FromCy,oleaut32)
API(VarR4FromDate,oleaut32)
API(VarR4FromDec,oleaut32)
API(VarR4FromDisp,oleaut32)
API(VarR4FromI1,oleaut32)
API(VarR4FromI2,oleaut32)
API(VarR4FromI4,oleaut32)
API(VarR4FromR8,oleaut32)
API(VarR4FromStr,oleaut32)
API(VarR4FromUI1,oleaut32)
API(VarR4FromUI2,oleaut32)
API(VarR4FromUI4,oleaut32)
API(VarR8FromBool,oleaut32)
API(VarR8FromCy,oleaut32)
API(VarR8FromDate,oleaut32)
API(VarR8FromDec,oleaut32)
API(VarR8FromDisp,oleaut32)
API(VarR8FromI1,oleaut32)
API(VarR8FromI2,oleaut32)
API(VarR8FromI4,oleaut32)
API(VarR8FromR4,oleaut32)
API(VarR8FromStr,oleaut32)
API(VarR8FromUI1,oleaut32)
API(VarR8FromUI2,oleaut32)
API(VarR8FromUI4,oleaut32)
API(VarR8Pow,oleaut32)
API(VarR8Round,oleaut32)
API(VarRound,oleaut32)
API(VarSub,oleaut32)
API(VarTokenizeFormatString,oleaut32)
API(VarUdateFromDate,oleaut32)
API(VarUI1FromBool,oleaut32)
API(VarUI1FromCy,oleaut32)
API(VarUI1FromDate,oleaut32)
API(VarUI1FromDec,oleaut32)
API(VarUI1FromDisp,oleaut32)
API(VarUI1FromI1,oleaut32)
API(VarUI1FromI2,oleaut32)
API(VarUI1FromI4,oleaut32)
API(VarUI1FromR4,oleaut32)
API(VarUI1FromR8,oleaut32)
API(VarUI1FromStr,oleaut32)
API(VarUI1FromUI2,oleaut32)
API(VarUI1FromUI4,oleaut32)
API(VarUI2FromBool,oleaut32)
API(VarUI2FromCy,oleaut32)
API(VarUI2FromDate,oleaut32)
API(VarUI2FromDec,oleaut32)
API(VarUI2FromDisp,oleaut32)
API(VarUI2FromI1,oleaut32)
API(VarUI2FromI2,oleaut32)
API(VarUI2FromI4,oleaut32)
API(VarUI2FromR4,oleaut32)
API(VarUI2FromR8,oleaut32)
API(VarUI2FromStr,oleaut32)
API(VarUI2FromUI1,oleaut32)
API(VarUI2FromUI4,oleaut32)
API(VarUI4FromBool,oleaut32)
API(VarUI4FromCy,oleaut32)
API(VarUI4FromDate,oleaut32)
API(VarUI4FromDec,oleaut32)
API(VarUI4FromDisp,oleaut32)
API(VarUI4FromI1,oleaut32)
API(VarUI4FromI2,oleaut32)
API(VarUI4FromI4,oleaut32)
API(VarUI4FromR4,oleaut32)
API(VarUI4FromR8,oleaut32)
API(VarUI4FromStr,oleaut32)
API(VarUI4FromUI1,oleaut32)
API(VarUI4FromUI2,oleaut32)
API(VarWeekdayName,oleaut32)
API(VarXor,oleaut32)
API(VectorFromBstr,oleaut32)

API(BindMoniker,ole32)
//CLIPFORMAT_UserFree;ole32!CLIPFORMAT_UserFree
//CLIPFORMAT_UserMarshal;ole32!CLIPFORMAT_UserMarshal
//CLIPFORMAT_UserSize;ole32!CLIPFORMAT_UserSize
//CLIPFORMAT_UserUnmarshal;ole32!CLIPFORMAT_UserUnmarshal
API(CLSIDFromProgID,ole32)
API(CLSIDFromString,ole32)
API(CoAddRefServerProcess,ole32)
API(CoBuildVersion,ole32)
API(CoCopyProxy,ole32)
API(CoCreateFreeThreadedMarshaler,ole32)
API(CoCreateGuid,ole32)
API(CoCreateInstance,ole32)
API(CoCreateInstanceEx,ole32)
API(CoDisconnectObject,ole32)
API(CoDosDateTimeToFileTime,ole32)
API(CoFileTimeNow,ole32)
API(CoFileTimeToDosDateTime,ole32)
API(CoFreeAllLibraries,ole32)
API(CoFreeLibrary,ole32)
API(CoFreeUnusedLibraries,ole32)
API(CoGetCallContext,ole32)
API(CoGetCallerTID,ole32)
API(CoGetClassObject,ole32)
API(CoGetCurrentLogicalThreadId,ole32)
API(CoGetCurrentProcess,ole32)
API(CoGetInstanceFromFile,ole32)
API(CoGetInstanceFromIStorage,ole32)
API(CoGetInterfaceAndReleaseStream,ole32)
API(CoGetMalloc,ole32)
API(CoGetMarshalSizeMax,ole32)
API(CoGetObject,ole32)
API(CoGetPSClsid,ole32)
API(CoGetStandardMarshal,ole32)
//CoGetState;ole32!CoGetState
//CoGetTIDFromIPID;ole32!CoGetTIDFromIPID
API(CoGetTreatAsClass,ole32)
API(CoImpersonateClient,ole32)
API(CoInitialize,ole32)
API(CoInitializeEx,ole32)
API(CoInitializeSecurity,ole32)
//CoInitializeWOW;ole32!CoInitializeWOW
API(CoIsHandlerConnected,ole32)
API(CoIsOle1Class,ole32)
API(CoLoadLibrary,ole32)
API(CoLockObjectExternal,ole32)
API(CoMarshalHresult,ole32)
API(CoMarshalInterface,ole32)
API(CoMarshalInterThreadInterfaceInStream,ole32)
API(CoQueryAuthenticationServices,ole32)
API(CoQueryClientBlanket,ole32)
API(CoQueryProxyBlanket,ole32)
API(CoQueryReleaseObject,ole32)
API(CoRegisterChannelHook,ole32)
API(CoRegisterClassObject,ole32)
API(CoRegisterMallocSpy,ole32)
API(CoRegisterMessageFilter,ole32)
API(CoRegisterPSClsid,ole32)
API(CoRegisterSurrogate,ole32)
API(CoReleaseMarshalData,ole32)
API(CoReleaseServerProcess,ole32)
API(CoResumeClassObjects,ole32)
API(CoRevertToSelf,ole32)
API(CoRevokeClassObject,ole32)
API(CoRevokeMallocSpy,ole32)
API(CoSetProxyBlanket,ole32)
API(CoSetState,ole32)
API(CoSuspendClassObjects,ole32)
API(CoSwitchCallContext,ole32)
API(CoTaskMemAlloc,ole32)
API(CoTaskMemFree,ole32)
API(CoTaskMemRealloc,ole32)
API(CoTreatAsClass,ole32)
API(CoUninitialize,ole32)

//CoUnloadingWOW;ole32!CoUnloadingWOW
API(CoUnmarshalHresult,ole32)
API(CoUnmarshalInterface,ole32)
API(CreateAntiMoniker,ole32)
API(CreateBindCtx,ole32)
API(CreateClassMoniker,ole32)
API(CreateDataAdviseHolder,ole32)
API(CreateDataCache,ole32)
API(CreateErrorInfo,ole32)
API(CreateFileMoniker,ole32)
API(CreateGenericComposite,ole32)
API(CreateILockBytesOnHGlobal,ole32)
API(CreateItemMoniker,ole32)
API(CreateObjrefMoniker,ole32)
API(CreateOleAdviseHolder,ole32)
API(CreatePointerMoniker,ole32)
API(CreateStreamOnHGlobal,ole32)
//DllDebugObjectRPCHook;ole32!DllDebugObjectRPCHook
//DllGetClassObject;ole32!DllGetClassObject
//DllGetClassObjectWOW;ole32!DllGetClassObjectWOW
//DllRegisterServer;ole32!DllRegisterServer
//DoDragDrop;ole32!DoDragDrop
//EnableHookObject;ole32!EnableHookObject
API(FreePropVariantArray,ole32)
API(GetClassFile,ole32)
API(GetConvertStg,ole32)
//GetDocumentBitStg;ole32!GetDocumentBitStg
API(GetErrorInfo,ole32)
//GetHGlobalFromILockBytes;ole32!GetHGlobalFromILockBytes
//GetHGlobalFromStream;ole32!GetHGlobalFromStream
//GetHookInterface;ole32!GetHookInterface
//GetRunningObjectTable;ole32!GetRunningObjectTable
//HACCEL_UserFree;ole32!HACCEL_UserFree
//HACCEL_UserMarshal;ole32!HACCEL_UserMarshal
//HACCEL_UserSize;ole32!HACCEL_UserSize
//HACCEL_UserUnmarshal;ole32!HACCEL_UserUnmarshal
//HBITMAP_UserFree;ole32!HBITMAP_UserFree
//HBITMAP_UserMarshal;ole32!HBITMAP_UserMarshal
//HBITMAP_UserSize;ole32!HBITMAP_UserSize
//HBITMAP_UserUnmarshal;ole32!HBITMAP_UserUnmarshal
//HBRUSH_UserFree;ole32!HBRUSH_UserFree
//HBRUSH_UserMarshal;ole32!HBRUSH_UserMarshal
//HBRUSH_UserSize;ole32!HBRUSH_UserSize
//HBRUSH_UserUnmarshal;ole32!HBRUSH_UserUnmarshal
//HENHMETAFILE_UserFree;ole32!HENHMETAFILE_UserFree
//HENHMETAFILE_UserMarshal;ole32!HENHMETAFILE_UserMarshal
//HENHMETAFILE_UserSize;ole32!HENHMETAFILE_UserSize
//HENHMETAFILE_UserUnmarshal;ole32!HENHMETAFILE_UserUnmarshal
//HGLOBAL_UserFree;ole32!HGLOBAL_UserFree
//HGLOBAL_UserMarshal;ole32!HGLOBAL_UserMarshal
//HGLOBAL_UserSize;ole32!HGLOBAL_UserSize
//HGLOBAL_UserUnmarshal;ole32!HGLOBAL_UserUnmarshal
//HMENU_UserFree;ole32!HMENU_UserFree
//HMENU_UserMarshal;ole32!HMENU_UserMarshal
//HMENU_UserSize;ole32!HMENU_UserSize
//HMENU_UserUnmarshal;ole32!HMENU_UserUnmarshal
//HMETAFILE_UserFree;ole32!HMETAFILE_UserFree
//HMETAFILE_UserMarshal;ole32!HMETAFILE_UserMarshal
//HMETAFILE_UserSize;ole32!HMETAFILE_UserSize
//HMETAFILE_UserUnmarshal;ole32!HMETAFILE_UserUnmarshal
//HMETAFILEPICT_UserFree;ole32!HMETAFILEPICT_UserFree
//HMETAFILEPICT_UserMarshal;ole32!HMETAFILEPICT_UserMarshal
//HMETAFILEPICT_UserSize;ole32!HMETAFILEPICT_UserSize
//HMETAFILEPICT_UserUnmarshal;ole32!HMETAFILEPICT_UserUnmarshal
//HPALETTE_UserFree;ole32!HPALETTE_UserFree
//HPALETTE_UserMarshal;ole32!HPALETTE_UserMarshal
//HPALETTE_UserSize;ole32!HPALETTE_UserSize
//HPALETTE_UserUnmarshal;ole32!HPALETTE_UserUnmarshal
//HWND_UserFree;ole32!HWND_UserFree
//HWND_UserMarshal;ole32!HWND_UserMarshal
//HWND_UserSize;ole32!HWND_UserSize
//HWND_UserUnmarshal;ole32!HWND_UserUnmarshal
//I_RemoteMain;ole32!I_RemoteMain
API(IIDFromString,ole32)
API(IsAccelerator,ole32)
API(IsEqualGUID,ole32)
API(IsValidIid,ole32)
API(IsValidInterface,ole32)
API(IsValidPtrIn,ole32)
API(IsValidPtrOut,ole32)
API(MkParseDisplayName,ole32)
API(MonikerCommonPrefixWith,ole32)
API(MonikerRelativePathTo,ole32)

API(OleBuildVersion,ole32)
API(OleConvertIStorageToOLESTREAM,ole32)
API(OleConvertIStorageToOLESTREAMEx,ole32)
API(OleConvertOLESTREAMToIStorage,ole32)
API(OleConvertOLESTREAMToIStorageEx,ole32)
API(OleCreate,ole32)
API(OleCreateDefaultHandler,ole32)
API(OleCreateEmbeddingHelper,ole32)
API(OleCreateEx,ole32)
API(OleCreateFromData,ole32)
API(OleCreateFromDataEx,ole32)
API(OleCreateFromFile,ole32)
API(OleCreateFromFileEx,ole32)
API(OleCreateLink,ole32)
API(OleCreateLinkEx,ole32)
API(OleCreateLinkFromData,ole32)
API(OleCreateLinkFromDataEx,ole32)
API(OleCreateLinkToFile,ole32)
API(OleCreateLinkToFileEx,ole32)
API(OleCreateMenuDescriptor,ole32)
API(OleCreateStaticFromData,ole32)
API(OleDestroyMenuDescriptor,ole32)
API(OleDoAutoConvert,ole32)
API(OleDraw,ole32)
API(OleDuplicateData,ole32)
API(OleFlushClipboard,ole32)
API(OleGetAutoConvert,ole32)
API(OleGetClipboard,ole32)
API(OleGetIconOfClass,ole32)
API(OleGetIconOfFile,ole32)
API(OleInitialize,ole32)
API(OleInitializeWOW,ole32)
API(OleIsCurrentClipboard,ole32)
API(OleIsRunning,ole32)
API(OleLoad,ole32)
API(OleLoadFromStream,ole32)
API(OleLockRunning,ole32)
API(OleMetafilePictFromIconAndLabel,ole32)
API(OleNoteObjectVisible,ole32)
API(OleQueryCreateFromData,ole32)
API(OleQueryLinkFromData,ole32)
API(OleRegEnumFormatEtc,ole32)
API(OleRegEnumVerbs,ole32)
API(OleRegGetMiscStatus,ole32)
API(OleRegGetUserType,ole32)
API(OleRun,ole32)
API(OleSave,ole32)
API(OleSaveToStream,ole32)
API(OleSetAutoConvert,ole32)
API(OleSetClipboard,ole32)
API(OleSetContainedObject,ole32)
API(OleSetMenuDescriptor,ole32)
API(OleTranslateAccelerator,ole32)
API(OleUninitialize,ole32)

API(OpenOrCreateStream,ole32)
API(ProgIDFromCLSID,ole32)
API(PropSysAllocString,ole32)
API(PropSysFreeString,ole32)
API(PropVariantClear,ole32)
API(PropVariantCopy,ole32)
API(ReadClassStg,ole32)
API(ReadClassStm,ole32)
API(ReadFmtUserTypeStg,ole32)
API(ReadOleStg,ole32)
API(ReadStringStream,ole32)
API(RegisterDragDrop,ole32)
API(ReleaseStgMedium,ole32)
API(RevokeDragDrop,ole32)
API(SetConvertStg,ole32)
API(SetDocumentBitStg,ole32)
API(SetErrorInfo,ole32)
//SNB_UserFree;ole32!SNB_UserFree
//SNB_UserMarshal;ole32!SNB_UserMarshal
//SNB_UserSize;ole32!SNB_UserSize
//SNB_UserUnmarshal;ole32!SNB_UserUnmarshal
API(StgCreateDocfile,ole32)
API(StgCreateDocfileOnILockBytes,ole32)
API(StgCreateStorageEx,ole32)
API(StgGetIFillLockBytesOnFile,ole32)
API(StgGetIFillLockBytesOnILockBytes,ole32)
API(StgIsStorageFile,ole32)
API(StgIsStorageILockBytes,ole32)
//STGMEDIUM_UserFree;ole32!STGMEDIUM_UserFree
//STGMEDIUM_UserMarshal;ole32!STGMEDIUM_UserMarshal
//STGMEDIUM_UserSize;ole32!STGMEDIUM_UserSize
//STGMEDIUM_UserUnmarshal;ole32!STGMEDIUM_UserUnmarshal
API(StgOpenAsyncDocfileOnIFillLockBytes,ole32)
API(StgOpenStorage,ole32)
API(StgOpenStorageEx,ole32)
API(StgOpenStorageOnILockBytes,ole32)
API(StgSetTimes,ole32)
API(StringFromCLSID,ole32)
API(StringFromGUID2,ole32)
API(StringFromIID,ole32)
API(UpdateDCOMSettings,ole32)
//UtConvertDvtd16toDvtd32;ole32!UtConvertDvtd16toDvtd32
//UtConvertDvtd32toDvtd16;ole32!UtConvertDvtd32toDvtd16
//UtGetDvtd16Info;ole32!UtGetDvtd16Info
//UtGetDvtd32Info;ole32!UtGetDvtd32Info
//WdtpInterfacePointer_UserFree;ole32!WdtpInterfacePointer_UserFree
//WdtpInterfacePointer_UserMarshal;ole32!WdtpInterfacePointer_UserMarshal
//WdtpInterfacePointer_UserSize;ole32!WdtpInterfacePointer_UserSize
//WdtpInterfacePointer_UserUnmarshal;ole32!WdtpInterfacePointer_UserUnmarshal
API(WriteClassStg,ole32)
API(WriteClassStm,ole32)
API(WriteFmtUserTypeStg,ole32)
//WriteOleStg;ole32!WriteOleStg
//WriteStringStream;ole32!WriteStringStream


//////////////////////////////////////////////////////////////

typedef struct tagPIXELFORMATDESCRIPTOR { // pfd
    WORD  nSize;
    WORD  nVersion;
    DWORD dwFlags;
    BYTE  iPixelType;
    BYTE  cColorBits;
    BYTE  cRedBits;
    BYTE  cRedShift;
    BYTE  cGreenBits;
    BYTE  cGreenShift;
    BYTE  cBlueBits;
    BYTE  cBlueShift;
    BYTE  cAlphaBits;
    BYTE  cAlphaShift;
    BYTE  cAccumBits;
    BYTE  cAccumRedBits;
    BYTE  cAccumGreenBits;
    BYTE  cAccumBlueBits;
    BYTE  cAccumAlphaBits;
    BYTE  cDepthBits;
    BYTE  cStencilBits;
    BYTE  cAuxBuffers;
    BYTE  iLayerType;
    BYTE  bReserved;
    DWORD dwLayerMask;
    DWORD dwVisibleMask;
    DWORD dwDamageMask;
} PIXELFORMATDESCRIPTOR;

/* pixel types */
#define PFD_TYPE_RGBA        0
#define PFD_TYPE_COLORINDEX  1

/* layer types */
#define PFD_MAIN_PLANE       0
#define PFD_OVERLAY_PLANE    1
#define PFD_UNDERLAY_PLANE   (-1)

/* PIXELFORMATDESCRIPTOR flags */
#define PFD_DOUBLEBUFFER            0x00000001
#define PFD_STEREO                  0x00000002
#define PFD_DRAW_TO_WINDOW          0x00000004
#define PFD_DRAW_TO_BITMAP          0x00000008
#define PFD_SUPPORT_GDI             0x00000010
#define PFD_SUPPORT_OPENGL          0x00000020
#define PFD_GENERIC_FORMAT          0x00000040
#define PFD_NEED_PALETTE            0x00000080
#define PFD_NEED_SYSTEM_PALETTE     0x00000100
#define PFD_SWAP_EXCHANGE           0x00000200
#define PFD_SWAP_COPY               0x00000400
#define PFD_SWAP_LAYER_BUFFERS      0x00000800
#define PFD_GENERIC_ACCELERATED     0x00001000
#define PFD_SUPPORT_DIRECTDRAW      0x00002000

/* PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only */
#define PFD_DEPTH_DONTCARE          0x20000000
#define PFD_DOUBLEBUFFER_DONTCARE   0x40000000
#define PFD_STEREO_DONTCARE         0x80000000

/////////////////////////////////////////////////////////////////
typedef DWORD COLORREF;
typedef struct CHOOSECOLOR {
    long lStructSize;
    long hwndOwner;
    long hInstance;
    COLORREF rgbResult;
    COLORREF *lpCustColors;
    long Flags;
    long lCustData;
    long lpfnHook;
    char* lpTemplateName;
} CHOOSECOLOR;

#define RGB(r,g,b) ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
#define GetRValue(rgb)      ((BYTE)(rgb))
#define GetGValue(rgb)      ((BYTE)(((WORD)(rgb)) >> 8))
#define GetBValue(rgb)      ((BYTE)((rgb)>>16))

BOOL WINAPI ChooseColor(CHOOSECOLOR* lpcc);
#define PRAGMA_API ChooseColor;comdlg32!ChooseColorA

// Import API functions (additionally to api.def) ///////////////

#define PRAGMA_API GetOpenFileName;comdlg32!GetOpenFileNameA
#define PRAGMA_API GetSaveFileName;comdlg32!GetSaveFileNameA

/////////////////////////////////////////////////////////////////
#define LOWORD(l) ((WORD)(l))
#define HIWORD(l) ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define HILOWORD(h,l) ( (((WORD)(h))<<16) | ((WORD)(l)) )

#define PRAGMA_WARN ON

#endif // windows_h
